const attachFile = (editor, file) => {

  const getBlob = file => {
    if (!file || !file.type) {
      return false;
    }
    return new Blob([file], { type: file.type });
  };

  const attach = file => {
    const blob = getBlob(file);
    let blobId;
    try {
      const url = URL.createObjectURL(blob);
      blobId = new URL(url.split('blob:').join('')).pathname.split('/').join('');
    } catch(exception) {
      blobId = 1;
    }
    const fileId = 'file_' + blobId;

    // const sel = editor.selection.getSel();
    // const focusOffset = sel.focusOffset;
    // const selectedOffset = sel.anchorOffset;
    // const selectedNodeText = editor.selection.getNode().innerHTML;
    //
    //
    // let bookmark;
    //
    // const hasLeadingSpace = selectedNodeText[selectedOffset] === ' ' ? true : false;
    // const isSliced = selectedOffset !== selectedNodeText.length ? true : false; // 이거 로직 바꿔야함
    //
    //
    // bookmark = editor.dom.create('span', {'data-ke-bookmark':'file', 'data-ke-leadingSpace':hasLeadingSpace, 'data-ke-isSliced':isSliced}, '&#65279;');
    // // if(selectedNodeText[selectedOffset] === ' ') {
    // //   bookmark = editor.dom.create('span', {'data-ke-bookmark':'file', 'data-ke-leadingSpace':true}, '&#65279;');
    // // }
    // // else {
    // //   bookmark = editor.dom.create('span', {'data-ke-bookmark':'file', 'data-ke-leadingSpace':false}, '&#65279;');
    // // }
    // //
    // // if(selectedOffset === selectedNodeText.length) {
    // //   console.log("not sliced");
    // //   editor.dom.setAttrib(bookmark, 'data-ke-isSliced':false);
    // // }
    // // else {
    // //   console.log("sliced");
    // //   editor.dom.setAttrib(bookmark, 'data-ke-isSliced':true);
    // // }
    //
    // editor.insertContent(bookmark.outerHTML);

    const fileItemString = editor.dom.create('a', { id: fileId, href: "#", 'data-ke-type': 'a-file' }, file.name);
    const wrapElement = editor.dom.create('figure', { 'data-ke-type': 'file' });
    let fileElementString = editor.dom.add(wrapElement, fileItemString);

    editor.insertContent(wrapElement.outerHTML);
    return fileId;
  };

  return attach(file);
};

export default attachFile;
