import DataModel from './components/DataModel'
const DOMUtils = tinymce.dom.DOMUtils

const plugin = (editor) => {
  const getWindowMinWidth = () => {
    return editor.getParam('code_dialog_width', 800);
  }

  const getWindowMinHeight = () => {
    return editor.getParam('code_dialog_height', Math.min(DOMUtils.DOM.getViewPort().h - 200, 600));
  }

  const dataModelCodeOpen = function () {
    const dataModel = new DataModel(editor.getContent({format: 'tree'}))
    const kDataObject = dataModel.getData()

    const minWidth = getWindowMinWidth()
    const minHeight = getWindowMinHeight()
    const win = editor.windowManager.open({
      title: 'kData model',
      body: {
        type: 'textbox',
        name: 'kDataModelCode',
        multiline: true,
        minWidth: minWidth,
        minHeight: minHeight,
        spellcheck: false,
        style: 'direction: ltr; text-align: left'
      },
      // onSubmit: function (e) {
      //   $_8uqjeh93jd09evmm.setContent(editor, e.data.code);
      // }
    });
    win.find('#kDataModelCode').value(JSON.stringify(kDataObject.contents, undefined, 2));
  };

  // editor.addButton('kData', {
  //   icon: 'code',
  //   tooltip: 'Data Model Console',
  //   onclick: () => {
  //     dataModelCodeOpen()
  //   }
  // })

  editor._getkData = () => {
    return new DataModel(editor.getContent({format: 'tree'})).getData()
  }
};

export default plugin;