import Buttons from '../components/ui/Buttons'

class FloatAction {
  constructor(editor) {
    this.editor = editor
    const commendOjbect = {
      kImageFloatLeft: this.float.bind(this, 'left'),
      kImageFloatCenter: this.float.bind(this, 'center'),
      kImageFloatRight: this.float.bind(this, 'right')
    }
    for (let cmd in commendOjbect) {
      this.editor.addCommand(cmd, commendOjbect[cmd])
    }
  }

  getFigureNode() {
    let selectionNode = this.editor.selection.getNode()
    const $figureNode = this.editor.$(selectionNode).closest('figure[data-ke-type="image"]')
    if ($figureNode && $figureNode[0]) {
      return $figureNode
    } else {
      return null
    }
  }

  float(floatingValue) {
    const $imageFigure = this.getFigureNode()
    if ($imageFigure) {
      const nowFloatValue = $imageFigure.css('float')
      const nowAlignValue = $imageFigure.css('text-align')
      let state = null
      if (nowFloatValue == floatingValue || nowAlignValue == floatingValue) {
        $imageFigure.css('float', null)
        $imageFigure.css('display', null)
        $imageFigure.css('text-align', null)
      } else {
        state = floatingValue
        if (floatingValue == 'center') {
          $imageFigure.css('float', null)
          $imageFigure.css('display', 'block')
          $imageFigure.css('text-align', 'center')
        } else {
          $imageFigure.css('float', floatingValue)
          $imageFigure.css('display', null)
          $imageFigure.css('text-align', null)
        }
      }
    }
  }
}

const register = (editor, contextToolbar) => {
  new FloatAction(editor)
  Buttons.register(editor, contextToolbar)
}

export default {
  register
}