const attachLocalImage = (editor, file, settings) => {
  const getBlobData = (file) => {
    if (!file || !file.type) {
      return false;
    }
    const blob = new Blob([file], { type: file.type })
    const blobUrl = URL.createObjectURL(blob);
    const blobUrlUrlArray = blobUrl.split('blob:').join('').split('/')
    const blobId = 'imageId' + blobUrlUrlArray[blobUrlUrlArray.length - 1]
    return { blobId, blobUrl };
  }

  const attach = (file) => {
    const blobData = getBlobData(file);
    let imageElementString;
    const imageElement = editor.dom.create('img', { id: blobData.blobId, src: blobData.blobUrl });
    const wrapElement = editor.dom.create('figure', { 'data-ke-type': 'image' });
    editor.dom.add(wrapElement, imageElement)
    if (settings.is_caption) {
      const captionElement = editor.dom.create('figcaption')
      editor.dom.add(wrapElement, captionElement)
    }
    imageElementString = wrapElement.outerHTML;
    editor.undoManager.ignore(() => {
      editor.insertContent(imageElementString);
    })
    return blobData.blobId;
  }
  return attach(file);
}

export default attachLocalImage;
