import autobind from 'autobind-decorator'

class caption {
  constructor(editor) {
    this.editor = editor
    this.selectedNode = undefined
    this.init()
  }

  init() {
    this.editor.on('Click', e => {
      const clickNode = e.target
      tinymce.util.Delay.setTimeout(() => {
        this.removeCaption()
      }, 100)
      
      if (clickNode && clickNode.nodeName == 'IMG') {
        tinymce.util.Delay.setTimeout(() => {
          this.makeCaption(clickNode)
        }, 100)
      }
    })

    this.editor.on('Keyup', e => {
      if (e.keyCode == 8 || e.keyCode == 46) {
        const selectedNode = this.editor.selection.getNode()
        if (selectedNode.nodeName == 'FIGCAPTION' && selectedNode.textContent == "") {
          selectedNode.innerHTML == '';
          if (selectedNode.firstChild) {
            selectedNode.removeChild(selectedNode.firstChild);
          }
        }
      }
    })
  }

  makeCaption(imageElement) {
    this.editor.undoManager.ignore(() => {
      let figureElement, figcaptionElement
      const $ = this.editor.$, dom = this.editor.dom
      const parentNode = imageElement.parentNode
      if (parentNode.nodeName == 'FIGURE' && parentNode.lastChild.nodeName != 'FIGCAPTION') {
        figureElement = parentNode
        figcaptionElement = dom.create('figcaption')
        figureElement.append(figcaptionElement)
      }
    })
  }

  removeCaption() {
    const $ = this.editor.$
    const selectionElement = this.editor.selection.getNode()
    const $captions = $('figcaption:empty')
    for (let i = 0, l = $captions.length; i < l; i++) {
      if (selectionElement != $captions[i] && selectionElement.parentNode.lastChild != $captions[i]) {
        $captions[i].parentNode.removeChild($captions[i])
      }
    }
  }
}

export default caption