const register = (editor, contextToolbar) => {
  const getImageFigure = element => {
    const $figureNode = editor.$(element).closest('figure[data-ke-type="image"]')
    if ($figureNode && $figureNode[0]) {
      return $figureNode 
    } else {
      return null
    }
  }

  // 이상하게 onpostrender 이벤트에는 arrowFunction으로 지정하면 this를 받아 오지 못함
  const postrender = function() {
    const control = this
    let $figureNode, floatValue, textAlignValue, state
    $figureNode = getImageFigure(editor.selection.getNode())

    const toggleActive = ($element) => {
      floatValue = $figureNode.css('float')
      textAlignValue = $figureNode.css('text-align')
      state = floatValue == 'none' && textAlignValue == 'center' ? 'center' : floatValue
      control.active(control.settings.activestate == state)
    }
    
    if ($figureNode) {
      toggleActive($figureNode)
    }

    editor.on('nodeChange', e => {
      $figureNode = getImageFigure(e.element)
      if ($figureNode) {
        toggleActive($figureNode)
      }
    })
  }


  const getSelector = floatValue => {
    return 'figure[data-mce-style="display:block;text-align:center;"]'
  }

  editor.addButton('kImageFloatLeft', {
    title: 'Align left',
    cmd: 'kImageFloatLeft',
    icon: 'alignleft',
    activestate: 'left',
    onpostrender: postrender,
  })
  contextToolbar.add('kImageFloatLeft')

  editor.addButton('kImageFloatCenter', {
    title: 'Align center',
    cmd: 'kImageFloatCenter',
    icon: 'aligncenter',
    activestate: 'center',
    onpostrender: postrender
  })
  contextToolbar.add('kImageFloatCenter')

  editor.addButton('kImageFloatRight', {
    title: 'Align right',
    cmd: 'kImageFloatRight',
    icon: 'alignright',
    activestate: 'right',
    onpostrender: postrender
  })
  contextToolbar.add('kImageFloatRight')
}

export default {
  register
}