const isPlainText = text => {
  return regexString.isPlainText.test(text);
};

const isUrlInText = text => {
  return regexString.isUrlInText.test(text);
}

const isUrlOnly = text => {
  return regexString.isUrlOnly.test(text);
}

const isMSWord = text => {
  return regexString.isMSWord.test(text);
}

const msWordContent = text => {
  return /<!--StartFragment-->((.|\n|\r)*)<!--EndFragment-->/gi.exec(text);
}

const regexString = {
  isPlainText: !/<(?:\/?(?!(?:div|p|br|span)>)\w+|(?:(?!(?:span style="white-space:\s?pre;?">)|br\s?\/>))\w+\s[^>]+)>/gi,
  isUrlInText: /(https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*))/gi,
  isUrl: /(https?:\/\/[www\.]?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b[-a-zA-Z0-9@:%_\+.~#?&\/\/=]*)/g,
  isUrlOnly: /^(https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*))$/i,
  isMSWord: /(class=\"?Mso|style=\"[^\"]*\bmso\-|w:WordDocument)/gi,
}

export default {
  isPlainText,
  isUrlInText,
  isUrlOnly,
  isMSWord,
  msWordContent,
  regexString
}
