import rm from './safeRemove';

const relocateCursor = editor => {

  const sel = editor.selection.getSel();
  let fOffset = sel.focusOffset;
  sel.collapseToEnd();
  const targetNode = tinymce.dom.DomQuery(editor.selection.getNode()).closest('body > *')[0] || sel.focusNode.childNodes[fOffset-1];
  if(targetNode && ['P', 'H1', 'H2', 'H3'].includes(targetNode.nodeName)) {
    return targetNode.nodeName;
  }
  insertParagraph(editor, targetNode);
}

const insertParagraph = (editor, node) => {
  editor.undoManager.ignore(function() {
    const p = document.createElement('p');
    if(!node) {
      p.id = 'blankSelectorElement'
      editor.insertContent(p.outerHTML);
      rm(editor.$('#blankSelectorElement'));
    }
    else {
      editor.dom.insertAfter(p, node);
      editor.selection.select(p);
      rm(p);
    }
  })
}

export default relocateCursor;
