(() => {
  const noop = function () {
    const x = [];
    for (let _i = 0; _i < arguments.length; _i++) {
      x[_i] = arguments[_i];
    }
  };
  const noarg = f => function () {
    const x = [];
    for (let _i = 0; _i < arguments.length; _i++) {
      x[_i] = arguments[_i];
    }
    return f();
  };
  const compose = (fa, fb) => function () {
    const x = [];
    for (let _i = 0; _i < arguments.length; _i++) {
      x[_i] = arguments[_i];
    }
    return fa(fb(...arguments));
  };
  const constant = value => () => value;
  const identity = x => x;
  const tripleEquals = (a, b) => a === b;
  const curry = function (f) {
    const x = [];
    for (let _i = 1; _i < arguments.length; _i++) {
      x[_i - 1] = arguments[_i];
    }
    const args = new Array(arguments.length - 1);
    for (let i = 1; i < arguments.length; i++)
      args[i - 1] = arguments[i];
    return function () {
      const x = [];
      for (let _i = 0; _i < arguments.length; _i++) {
        x[_i] = arguments[_i];
      }
      const newArgs = new Array(arguments.length);
      for (let j = 0; j < newArgs.length; j++)
        newArgs[j] = arguments[j];
      const all = args.concat(newArgs);
      return f(...all);
    };
  };
  const not = f => function () {
    const x = [];
    for (let _i = 0; _i < arguments.length; _i++) {
      x[_i] = arguments[_i];
    }
    return !f(...arguments);
  };
  const die = msg => () => {
    throw new Error(msg);
  };
  const apply = f => f();
  const call = f => {
    f();
  };
  const never = constant(false);
  const always = constant(true);
  const $_2vokfcwwjfuw8tb4 = {
    noop,
    noarg,
    compose,
    constant,
    identity,
    tripleEquals,
    curry,
    not,
    die,
    apply,
    call,
    never,
    always
  };

  const typeOf = x => {
    if (x === null)
      return 'null';
    const t = typeof x;
    if (t === 'object' && Array.prototype.isPrototypeOf(x))
      return 'array';
    if (t === 'object' && String.prototype.isPrototypeOf(x))
      return 'string';
    return t;
  };
  const isType = type => value => typeOf(value) === type;
  const $_8aqeo3wyjfuw8tb8 = {
    isString: isType('string'),
    isObject: isType('object'),
    isArray: isType('array'),
    isNull: isType('null'),
    isBoolean: isType('boolean'),
    isUndefined: isType('undefined'),
    isFunction: isType('function'),
    isNumber: isType('number')
  };

  const shallow = (old, nu) => nu;
  const deep = (old, nu) => {
    const bothObjects = $_8aqeo3wyjfuw8tb8.isObject(old) && $_8aqeo3wyjfuw8tb8.isObject(nu);
    return bothObjects ? deepMerge(old, nu) : nu;
  };
  const baseMerge = merger => function () {
    const objects = new Array(arguments.length);
    for (let i = 0; i < objects.length; i++)
      objects[i] = arguments[i];
    if (objects.length === 0)
      throw new Error('Can\'t merge zero objects');
    const ret = {};

    for (const curObject of objects) {
      for (const key in curObject)
        if (curObject.hasOwnProperty(key)) {
          ret[key] = merger(ret[key], curObject[key]);
        }
    }

    return ret;
  };
  var deepMerge = baseMerge(deep);
  const merge = baseMerge(shallow);
  const $_3jctjywxjfuw8tb6 = {
    deepMerge,
    merge
  };

  const never$1 = $_2vokfcwwjfuw8tb4.never;
  const always$1 = $_2vokfcwwjfuw8tb4.always;
  const none = () => NONE;
  var NONE = (() => {
    const eq = o => o.isNone();
    const call = thunk => thunk();
    const id = n => n;
    const noop = () => {
    };
    const me = {
      fold(n, s) {
        return n();
      },
      is: never$1,
      isSome: never$1,
      isNone: always$1,
      getOr: id,
      getOrThunk: call,
      getOrDie(msg) {
        throw new Error(msg || 'error: getOrDie called on none.');
      },
      or: id,
      orThunk: call,
      map: none,
      ap: none,
      each: noop,
      bind: none,
      flatten: none,
      exists: never$1,
      forall: always$1,
      filter: none,
      equals: eq,
      equals_: eq,
      toArray() {
        return [];
      },
      toString: $_2vokfcwwjfuw8tb4.constant('none()')
    };
    if (Object.freeze)
      Object.freeze(me);
    return me;
  })();
  const some = a => {
    const constant_a = () => a;
    const self = () => me;
    const map = f => some(f(a));
    const bind = f => f(a);
    var me = {
      fold(n, s) {
        return s(a);
      },
      is(v) {
        return a === v;
      },
      isSome: always$1,
      isNone: never$1,
      getOr: constant_a,
      getOrThunk: constant_a,
      getOrDie: constant_a,
      or: self,
      orThunk: self,
      map,
      ap(optfab) {
        return optfab.fold(none, fab => some(fab(a)));
      },
      each(f) {
        f(a);
      },
      bind,
      flatten: constant_a,
      exists: bind,
      forall: bind,
      filter(f) {
        return f(a) ? me : NONE;
      },
      equals(o) {
        return o.is(a);
      },
      equals_(o, elementEq) {
        return o.fold(never$1, b => elementEq(a, b));
      },
      toArray() {
        return [a];
      },
      toString() {
        return `some(${a})`;
      }
    };
    return me;
  };
  const from = value => value === null || value === undefined ? NONE : some(value);
  const Option = {
    some,
    none,
    from
  };

  const keys = (() => {
    const fastKeys = Object.keys;
    const slowKeys = o => {
      const r = [];
      for (const i in o) {
        if (o.hasOwnProperty(i)) {
          r.push(i);
        }
      }
      return r;
    };
    return fastKeys === undefined ? slowKeys : fastKeys;
  })();
  const each = (obj, f) => {
    const props = keys(obj);
    for (let k = 0, len = props.length; k < len; k++) {
      const i = props[k];
      const x = obj[i];
      f(x, i, obj);
    }
  };
  const objectMap = (obj, f) => tupleMap(obj, (x, i, obj) => ({
    k: i,
    v: f(x, i, obj)
  }));
  var tupleMap = (obj, f) => {
    const r = {};
    each(obj, (x, i) => {
      const tuple = f(x, i, obj);
      r[tuple.k] = tuple.v;
    });
    return r;
  };
  const bifilter = (obj, pred) => {
    const t = {};
    const f = {};
    each(obj, (x, i) => {
      const branch = pred(x, i) ? t : f;
      branch[i] = x;
    });
    return {
      t,
      f
    };
  };
  const mapToArray = (obj, f) => {
    const r = [];
    each(obj, (value, name) => {
      r.push(f(value, name));
    });
    return r;
  };
  const find = (obj, pred) => {
    const props = keys(obj);
    for (let k = 0, len = props.length; k < len; k++) {
      const i = props[k];
      const x = obj[i];
      if (pred(x, i, obj)) {
        return Option.some(x);
      }
    }
    return Option.none();
  };
  const values = obj => mapToArray(obj, v => v);
  const size = obj => values(obj).length;
  const $_8qu224wzjfuw8tb9 = {
    bifilter,
    each,
    map: objectMap,
    mapToArray,
    tupleMap,
    find,
    keys,
    values,
    size
  };

  const contextmenu = $_2vokfcwwjfuw8tb4.constant('contextmenu');
  const touchstart = $_2vokfcwwjfuw8tb4.constant('touchstart');
  const touchmove = $_2vokfcwwjfuw8tb4.constant('touchmove');
  const touchend = $_2vokfcwwjfuw8tb4.constant('touchend');
  const gesturestart = $_2vokfcwwjfuw8tb4.constant('gesturestart');
  const mousedown = $_2vokfcwwjfuw8tb4.constant('mousedown');
  const mousemove = $_2vokfcwwjfuw8tb4.constant('mousemove');
  const mouseout = $_2vokfcwwjfuw8tb4.constant('mouseout');
  const mouseup = $_2vokfcwwjfuw8tb4.constant('mouseup');
  const mouseover = $_2vokfcwwjfuw8tb4.constant('mouseover');
  const focusin = $_2vokfcwwjfuw8tb4.constant('focusin');
  const keydown = $_2vokfcwwjfuw8tb4.constant('keydown');
  const input = $_2vokfcwwjfuw8tb4.constant('input');
  const change = $_2vokfcwwjfuw8tb4.constant('change');
  const focus = $_2vokfcwwjfuw8tb4.constant('focus');
  const click = $_2vokfcwwjfuw8tb4.constant('click');
  const transitionend = $_2vokfcwwjfuw8tb4.constant('transitionend');
  const selectstart = $_2vokfcwwjfuw8tb4.constant('selectstart');

  const cached = f => {
    let called = false;
    let r;
    return function () {
      if (!called) {
        called = true;
        r = f(...arguments);
      }
      return r;
    };
  };
  const $_ctj1zwx4jfuw8tbw = { cached };

  const firstMatch = (regexes, s) => {
    for (const x of regexes) {
      if (x.test(s))
        return x;
    }

    return undefined;
  };
  const find$1 = (regexes, agent) => {
    const r = firstMatch(regexes, agent);
    if (!r)
      return {
        major: 0,
        minor: 0
      };
    const group = i => Number(agent.replace(r, `$${i}`));
    return nu(group(1), group(2));
  };
  const detect = (versionRegexes, agent) => {
    const cleanedAgent = String(agent).toLowerCase();
    if (versionRegexes.length === 0)
      return unknown();
    return find$1(versionRegexes, cleanedAgent);
  };
  var unknown = () => nu(0, 0);
  var nu = (major, minor) => ({
    major,
    minor
  });
  const $_f9maalx7jfuw8tc7 = {
    nu,
    detect,
    unknown
  };

  const edge = 'Edge';
  const chrome = 'Chrome';
  const ie = 'IE';
  const opera = 'Opera';
  const firefox = 'Firefox';
  const safari = 'Safari';
  const isBrowser = (name, current) => () => current === name;
  const unknown$1 = () => nu$1({
    current: undefined,
    version: $_f9maalx7jfuw8tc7.unknown()
  });
  var nu$1 = info => {
    const current = info.current;
    const version = info.version;
    return {
      current,
      version,
      isEdge: isBrowser(edge, current),
      isChrome: isBrowser(chrome, current),
      isIE: isBrowser(ie, current),
      isOpera: isBrowser(opera, current),
      isFirefox: isBrowser(firefox, current),
      isSafari: isBrowser(safari, current)
    };
  };
  const $_3i1kz1x6jfuw8tc4 = {
    unknown: unknown$1,
    nu: nu$1,
    edge: $_2vokfcwwjfuw8tb4.constant(edge),
    chrome: $_2vokfcwwjfuw8tb4.constant(chrome),
    ie: $_2vokfcwwjfuw8tb4.constant(ie),
    opera: $_2vokfcwwjfuw8tb4.constant(opera),
    firefox: $_2vokfcwwjfuw8tb4.constant(firefox),
    safari: $_2vokfcwwjfuw8tb4.constant(safari)
  };

  const windows = 'Windows';
  const ios = 'iOS';
  const android = 'Android';
  const linux = 'Linux';
  const osx = 'OSX';
  const solaris = 'Solaris';
  const freebsd = 'FreeBSD';
  const isOS = (name, current) => () => current === name;
  const unknown$2 = () => nu$2({
    current: undefined,
    version: $_f9maalx7jfuw8tc7.unknown()
  });
  var nu$2 = info => {
    const current = info.current;
    const version = info.version;
    return {
      current,
      version,
      isWindows: isOS(windows, current),
      isiOS: isOS(ios, current),
      isAndroid: isOS(android, current),
      isOSX: isOS(osx, current),
      isLinux: isOS(linux, current),
      isSolaris: isOS(solaris, current),
      isFreeBSD: isOS(freebsd, current)
    };
  };
  const $_5birgjx8jfuw8tc9 = {
    unknown: unknown$2,
    nu: nu$2,
    windows: $_2vokfcwwjfuw8tb4.constant(windows),
    ios: $_2vokfcwwjfuw8tb4.constant(ios),
    android: $_2vokfcwwjfuw8tb4.constant(android),
    linux: $_2vokfcwwjfuw8tb4.constant(linux),
    osx: $_2vokfcwwjfuw8tb4.constant(osx),
    solaris: $_2vokfcwwjfuw8tb4.constant(solaris),
    freebsd: $_2vokfcwwjfuw8tb4.constant(freebsd)
  };

  function DeviceType (os, browser, userAgent) {
    const isiPad = os.isiOS() && /ipad/i.test(userAgent) === true;
    const isiPhone = os.isiOS() && !isiPad;
    const isAndroid3 = os.isAndroid() && os.version.major === 3;
    const isAndroid4 = os.isAndroid() && os.version.major === 4;
    const isTablet = isiPad || isAndroid3 || isAndroid4 && /mobile/i.test(userAgent) === true;
    const isTouch = os.isiOS() || os.isAndroid();
    const isPhone = isTouch && !isTablet;
    const iOSwebview = browser.isSafari() && os.isiOS() && /safari/i.test(userAgent) === false;
    return {
      isiPad: $_2vokfcwwjfuw8tb4.constant(isiPad),
      isiPhone: $_2vokfcwwjfuw8tb4.constant(isiPhone),
      isTablet: $_2vokfcwwjfuw8tb4.constant(isTablet),
      isPhone: $_2vokfcwwjfuw8tb4.constant(isPhone),
      isTouch: $_2vokfcwwjfuw8tb4.constant(isTouch),
      isAndroid: os.isAndroid,
      isiOS: os.isiOS,
      isWebView: $_2vokfcwwjfuw8tb4.constant(iOSwebview)
    };
  }

  const rawIndexOf = (() => {
    const pIndexOf = Array.prototype.indexOf;
    const fastIndex = (xs, x) => pIndexOf.call(xs, x);
    const slowIndex = (xs, x) => slowIndexOf(xs, x);
    return pIndexOf === undefined ? slowIndex : fastIndex;
  })();
  const indexOf = (xs, x) => {
    const r = rawIndexOf(xs, x);
    return r === -1 ? Option.none() : Option.some(r);
  };
  const contains = (xs, x) => rawIndexOf(xs, x) > -1;
  const exists = (xs, pred) => findIndex(xs, pred).isSome();
  const range = (num, f) => {
    const r = [];
    for (let i = 0; i < num; i++) {
      r.push(f(i));
    }
    return r;
  };
  const chunk = (array, size) => {
    const r = [];
    for (let i = 0; i < array.length; i += size) {
      const s = array.slice(i, i + size);
      r.push(s);
    }
    return r;
  };
  const map = (xs, f) => {
    const len = xs.length;
    const r = new Array(len);
    for (let i = 0; i < len; i++) {
      const x = xs[i];
      r[i] = f(x, i, xs);
    }
    return r;
  };
  const each$1 = (xs, f) => {
    for (let i = 0, len = xs.length; i < len; i++) {
      const x = xs[i];
      f(x, i, xs);
    }
  };
  const eachr = (xs, f) => {
    for (let i = xs.length - 1; i >= 0; i--) {
      const x = xs[i];
      f(x, i, xs);
    }
  };
  const partition = (xs, pred) => {
    const pass = [];
    const fail = [];
    for (let i = 0, len = xs.length; i < len; i++) {
      const x = xs[i];
      const arr = pred(x, i, xs) ? pass : fail;
      arr.push(x);
    }
    return {
      pass,
      fail
    };
  };
  const filter = (xs, pred) => {
    const r = [];
    for (let i = 0, len = xs.length; i < len; i++) {
      const x = xs[i];
      if (pred(x, i, xs)) {
        r.push(x);
      }
    }
    return r;
  };
  const groupBy = (xs, f) => {
    if (xs.length === 0) {
      return [];
    } else {
      let wasType = f(xs[0]);
      const r = [];
      let group = [];
      for (let i = 0, len = xs.length; i < len; i++) {
        const x = xs[i];
        const type = f(x);
        if (type !== wasType) {
          r.push(group);
          group = [];
        }
        wasType = type;
        group.push(x);
      }
      if (group.length !== 0) {
        r.push(group);
      }
      return r;
    }
  };
  const foldr = (xs, f, acc) => {
    eachr(xs, x => {
      acc = f(acc, x);
    });
    return acc;
  };
  const foldl = (xs, f, acc) => {
    each$1(xs, x => {
      acc = f(acc, x);
    });
    return acc;
  };
  const find$2 = (xs, pred) => {
    for (let i = 0, len = xs.length; i < len; i++) {
      const x = xs[i];
      if (pred(x, i, xs)) {
        return Option.some(x);
      }
    }
    return Option.none();
  };
  var findIndex = (xs, pred) => {
    for (let i = 0, len = xs.length; i < len; i++) {
      const x = xs[i];
      if (pred(x, i, xs)) {
        return Option.some(i);
      }
    }
    return Option.none();
  };
  var slowIndexOf = (xs, x) => {
    for (let i = 0, len = xs.length; i < len; ++i) {
      if (xs[i] === x) {
        return i;
      }
    }
    return -1;
  };
  const push = Array.prototype.push;
  const flatten = xs => {
    const r = [];
    for (let i = 0, len = xs.length; i < len; ++i) {
      if (!Array.prototype.isPrototypeOf(xs[i]))
        throw new Error(`Arr.flatten item ${i} was not an array, input: ${xs}`);
      push.apply(r, xs[i]);
    }
    return r;
  };
  const bind = (xs, f) => {
    const output = map(xs, f);
    return flatten(output);
  };
  const forall = (xs, pred) => {
    for (let i = 0, len = xs.length; i < len; ++i) {
      const x = xs[i];
      if (pred(x, i, xs) !== true) {
        return false;
      }
    }
    return true;
  };
  const equal = (a1, a2) => a1.length === a2.length && forall(a1, (x, i) => x === a2[i]);
  const slice = Array.prototype.slice;
  const reverse = xs => {
    const r = slice.call(xs, 0);
    r.reverse();
    return r;
  };
  const difference = (a1, a2) => filter(a1, x => !contains(a2, x));
  const mapToObject = (xs, f) => {
    const r = {};
    for (let i = 0, len = xs.length; i < len; i++) {
      const x = xs[i];
      r[String(x)] = f(x, i);
    }
    return r;
  };
  const pure = x => [x];
  const sort = (xs, comparator) => {
    const copy = slice.call(xs, 0);
    copy.sort(comparator);
    return copy;
  };
  const head = xs => xs.length === 0 ? Option.none() : Option.some(xs[0]);
  const last = xs => xs.length === 0 ? Option.none() : Option.some(xs[xs.length - 1]);
  const from$1 = $_8aqeo3wyjfuw8tb8.isFunction(Array.from) ? Array.from : x => slice.call(x);
  const $_efmt4zxbjfuw8tcj = {
    map,
    each: each$1,
    eachr,
    partition,
    filter,
    groupBy,
    indexOf,
    foldr,
    foldl,
    find: find$2,
    findIndex,
    flatten,
    bind,
    forall,
    exists,
    contains,
    equal,
    reverse,
    chunk,
    difference,
    mapToObject,
    pure,
    sort,
    range,
    head,
    last,
    from: from$1
  };

  const detect$1 = (candidates, userAgent) => {
    const agent = String(userAgent).toLowerCase();
    return $_efmt4zxbjfuw8tcj.find(candidates, candidate => candidate.search(agent));
  };
  const detectBrowser = (browsers, userAgent) => detect$1(browsers, userAgent).map(browser => {
    const version = $_f9maalx7jfuw8tc7.detect(browser.versionRegexes, userAgent);
    return {
      current: browser.name,
      version
    };
  });
  const detectOs = (oses, userAgent) => detect$1(oses, userAgent).map(os => {
    const version = $_f9maalx7jfuw8tc7.detect(os.versionRegexes, userAgent);
    return {
      current: os.name,
      version
    };
  });
  const $_890032xajfuw8tcf = {
    detectBrowser,
    detectOs
  };

  const addToStart = (str, prefix) => prefix + str;
  const addToEnd = (str, suffix) => str + suffix;
  const removeFromStart = (str, numChars) => str.substring(numChars);
  const removeFromEnd = (str, numChars) => str.substring(0, str.length - numChars);
  const $_frzopdxejfuw8tcx = {
    addToStart,
    addToEnd,
    removeFromStart,
    removeFromEnd
  };

  const first = (str, count) => str.substr(0, count);
  const last$1 = (str, count) => str.substr(str.length - count, str.length);
  const head$1 = str => str === '' ? Option.none() : Option.some(str.substr(0, 1));
  const tail = str => str === '' ? Option.none() : Option.some(str.substring(1));
  const $_g4g7dwxfjfuw8tcy = {
    first,
    last: last$1,
    head: head$1,
    tail
  };

  const checkRange = (str, substr, start) => {
    if (substr === '')
      return true;
    if (str.length < substr.length)
      return false;
    const x = str.substr(start, start + substr.length);
    return x === substr;
  };
  const supplant = (str, obj) => {
    const isStringOrNumber = a => {
      const t = typeof a;
      return t === 'string' || t === 'number';
    };
    return str.replace(/\${([^{}]*)}/g, (a, b) => {
      const value = obj[b];
      return isStringOrNumber(value) ? value : a;
    });
  };
  const removeLeading = (str, prefix) => startsWith(str, prefix) ? $_frzopdxejfuw8tcx.removeFromStart(str, prefix.length) : str;
  const removeTrailing = (str, prefix) => endsWith(str, prefix) ? $_frzopdxejfuw8tcx.removeFromEnd(str, prefix.length) : str;
  const ensureLeading = (str, prefix) => startsWith(str, prefix) ? str : $_frzopdxejfuw8tcx.addToStart(str, prefix);
  const ensureTrailing = (str, prefix) => endsWith(str, prefix) ? str : $_frzopdxejfuw8tcx.addToEnd(str, prefix);
  const contains$1 = (str, substr) => str.includes(substr);
  const capitalize = str => $_g4g7dwxfjfuw8tcy.head(str).bind(head => $_g4g7dwxfjfuw8tcy.tail(str).map(tail => head.toUpperCase() + tail)).getOr(str);
  var startsWith = (str, prefix) => checkRange(str, prefix, 0);
  var endsWith = (str, suffix) => checkRange(str, suffix, str.length - suffix.length);
  const trim = str => str.replace(/^\s+|\s+$/g, '');
  const lTrim = str => str.replace(/^\s+/g, '');
  const rTrim = str => str.replace(/\s+$/g, '');
  const $_b463kaxdjfuw8tcv = {
    supplant,
    startsWith,
    removeLeading,
    removeTrailing,
    ensureLeading,
    ensureTrailing,
    endsWith,
    contains: contains$1,
    trim,
    lTrim,
    rTrim,
    capitalize
  };

  const normalVersionRegex = /.*?version\/\ ?([0-9]+)\.([0-9]+).*/;
  const checkContains = target => uastring => $_b463kaxdjfuw8tcv.contains(uastring, target);
  const browsers = [
    {
      name: 'Edge',
      versionRegexes: [/.*?edge\/ ?([0-9]+)\.([0-9]+)$/],
      search(uastring) {
        const monstrosity = $_b463kaxdjfuw8tcv.contains(uastring, 'edge/') && $_b463kaxdjfuw8tcv.contains(uastring, 'chrome') && $_b463kaxdjfuw8tcv.contains(uastring, 'safari') && $_b463kaxdjfuw8tcv.contains(uastring, 'applewebkit');
        return monstrosity;
      }
    },
    {
      name: 'Chrome',
      versionRegexes: [
        /.*?chrome\/([0-9]+)\.([0-9]+).*/,
        normalVersionRegex
      ],
      search(uastring) {
        return $_b463kaxdjfuw8tcv.contains(uastring, 'chrome') && !$_b463kaxdjfuw8tcv.contains(uastring, 'chromeframe');
      }
    },
    {
      name: 'IE',
      versionRegexes: [
        /.*?msie\ ?([0-9]+)\.([0-9]+).*/,
        /.*?rv:([0-9]+)\.([0-9]+).*/
      ],
      search(uastring) {
        return $_b463kaxdjfuw8tcv.contains(uastring, 'msie') || $_b463kaxdjfuw8tcv.contains(uastring, 'trident');
      }
    },
    {
      name: 'Opera',
      versionRegexes: [
        normalVersionRegex,
        /.*?opera\/([0-9]+)\.([0-9]+).*/
      ],
      search: checkContains('opera')
    },
    {
      name: 'Firefox',
      versionRegexes: [/.*?firefox\/\ ?([0-9]+)\.([0-9]+).*/],
      search: checkContains('firefox')
    },
    {
      name: 'Safari',
      versionRegexes: [
        normalVersionRegex,
        /.*?cpu os ([0-9]+)_([0-9]+).*/
      ],
      search(uastring) {
        return ($_b463kaxdjfuw8tcv.contains(uastring, 'safari') || $_b463kaxdjfuw8tcv.contains(uastring, 'mobile/')) && $_b463kaxdjfuw8tcv.contains(uastring, 'applewebkit');
      }
    }
  ];
  const oses = [
    {
      name: 'Windows',
      search: checkContains('win'),
      versionRegexes: [/.*?windows\ nt\ ?([0-9]+)\.([0-9]+).*/]
    },
    {
      name: 'iOS',
      search(uastring) {
        return $_b463kaxdjfuw8tcv.contains(uastring, 'iphone') || $_b463kaxdjfuw8tcv.contains(uastring, 'ipad');
      },
      versionRegexes: [
        /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
        /.*cpu os ([0-9]+)_([0-9]+).*/,
        /.*cpu iphone os ([0-9]+)_([0-9]+).*/
      ]
    },
    {
      name: 'Android',
      search: checkContains('android'),
      versionRegexes: [/.*?android\ ?([0-9]+)\.([0-9]+).*/]
    },
    {
      name: 'OSX',
      search: checkContains('os x'),
      versionRegexes: [/.*?os\ x\ ?([0-9]+)_([0-9]+).*/]
    },
    {
      name: 'Linux',
      search: checkContains('linux'),
      versionRegexes: []
    },
    {
      name: 'Solaris',
      search: checkContains('sunos'),
      versionRegexes: []
    },
    {
      name: 'FreeBSD',
      search: checkContains('freebsd'),
      versionRegexes: []
    }
  ];
  const $_dv3nc1xcjfuw8tcp = {
    browsers: $_2vokfcwwjfuw8tb4.constant(browsers),
    oses: $_2vokfcwwjfuw8tb4.constant(oses)
  };

  const detect$2 = userAgent => {
    const browsers = $_dv3nc1xcjfuw8tcp.browsers();
    const oses = $_dv3nc1xcjfuw8tcp.oses();
    const browser = $_890032xajfuw8tcf.detectBrowser(browsers, userAgent).fold($_3i1kz1x6jfuw8tc4.unknown, $_3i1kz1x6jfuw8tc4.nu);
    const os = $_890032xajfuw8tcf.detectOs(oses, userAgent).fold($_5birgjx8jfuw8tc9.unknown, $_5birgjx8jfuw8tc9.nu);
    const deviceType = DeviceType(os, browser, userAgent);
    return {
      browser,
      os,
      deviceType
    };
  };
  const $_d4qyxjx5jfuw8tc3 = { detect: detect$2 };

  const detect$3 = $_ctj1zwx4jfuw8tbw.cached(() => {
    const userAgent = navigator.userAgent;
    return $_d4qyxjx5jfuw8tc3.detect(userAgent);
  });
  const $_5reqwox3jfuw8tbu = { detect: detect$3 };

  const alloy = { tap: $_2vokfcwwjfuw8tb4.constant('alloy.tap') };
  const focus$1 = $_2vokfcwwjfuw8tb4.constant('alloy.focus');
  const postBlur = $_2vokfcwwjfuw8tb4.constant('alloy.blur.post');
  const receive = $_2vokfcwwjfuw8tb4.constant('alloy.receive');
  const execute = $_2vokfcwwjfuw8tb4.constant('alloy.execute');
  const focusItem = $_2vokfcwwjfuw8tb4.constant('alloy.focus.item');
  const tap = alloy.tap;
  const tapOrClick = $_5reqwox3jfuw8tbu.detect().deviceType.isTouch() ? alloy.tap : click;
  const longpress = $_2vokfcwwjfuw8tb4.constant('alloy.longpress');
  const sandboxClose = $_2vokfcwwjfuw8tb4.constant('alloy.sandbox.close');
  const systemInit = $_2vokfcwwjfuw8tb4.constant('alloy.system.init');
  const windowScroll = $_2vokfcwwjfuw8tb4.constant('alloy.system.scroll');
  const attachedToDom = $_2vokfcwwjfuw8tb4.constant('alloy.system.attached');
  const detachedFromDom = $_2vokfcwwjfuw8tb4.constant('alloy.system.detached');
  const changeTab = $_2vokfcwwjfuw8tb4.constant('alloy.change.tab');
  const dismissTab = $_2vokfcwwjfuw8tb4.constant('alloy.dismiss.tab');

  const emit = (component, event) => {
    dispatchWith(component, component.element(), event, {});
  };
  const emitWith = (component, event, properties) => {
    dispatchWith(component, component.element(), event, properties);
  };
  const emitExecute = component => {
    emit(component, execute());
  };
  const dispatch = (component, target, event) => {
    dispatchWith(component, target, event, {});
  };
  var dispatchWith = (component, target, event, properties) => {
    const data = $_3jctjywxjfuw8tb6.deepMerge({ target }, properties);
    component.getSystem().triggerEvent(event, target, $_8qu224wzjfuw8tb9.map(data, $_2vokfcwwjfuw8tb4.constant));
  };
  const dispatchEvent = (component, target, event, simulatedEvent) => {
    component.getSystem().triggerEvent(event, target, simulatedEvent.event());
  };
  const dispatchFocus = (component, target) => {
    component.getSystem().triggerFocus(target, component.element());
  };

  const fromHtml = (html, scope) => {
    const doc = scope || document;
    const div = doc.createElement('div');
    div.innerHTML = html;
    if (!div.hasChildNodes() || div.childNodes.length > 1) {
      console.error('HTML does not have a single root node', html);
      throw 'HTML must have a single root node';
    }
    return fromDom(div.childNodes[0]);
  };
  const fromTag = (tag, scope) => {
    const doc = scope || document;
    const node = doc.createElement(tag);
    return fromDom(node);
  };
  const fromText = (text, scope) => {
    const doc = scope || document;
    const node = doc.createTextNode(text);
    return fromDom(node);
  };
  var fromDom = node => {
    if (node === null || node === undefined)
      throw new Error('Node cannot be null or undefined');
    return { dom: $_2vokfcwwjfuw8tb4.constant(node) };
  };
  const fromPoint = (doc, x, y) => Option.from(doc.dom().elementFromPoint(x, y)).map(fromDom);
  const $_bwdnu0xijfuw8tdo = {
    fromHtml,
    fromTag,
    fromText,
    fromDom,
    fromPoint
  };

  const $_dh9i2rxkjfuw8tdu = {
    ATTRIBUTE: 2,
    CDATA_SECTION: 4,
    COMMENT: 8,
    DOCUMENT: 9,
    DOCUMENT_TYPE: 10,
    DOCUMENT_FRAGMENT: 11,
    ELEMENT: 1,
    TEXT: 3,
    PROCESSING_INSTRUCTION: 7,
    ENTITY_REFERENCE: 5,
    ENTITY: 6,
    NOTATION: 12
  };

  const name = element => {
    const r = element.dom().nodeName;
    return r.toLowerCase();
  };
  const type = element => element.dom().nodeType;
  const value = element => element.dom().nodeValue;
  const isType$1 = t => element => type(element) === t;
  const isComment = element => type(element) === $_dh9i2rxkjfuw8tdu.COMMENT || name(element) === '#comment';
  const isElement = isType$1($_dh9i2rxkjfuw8tdu.ELEMENT);
  const isText = isType$1($_dh9i2rxkjfuw8tdu.TEXT);
  const isDocument = isType$1($_dh9i2rxkjfuw8tdu.DOCUMENT);
  const $_74lhjaxjjfuw8tdt = {
    name,
    type,
    value,
    isElement,
    isText,
    isDocument,
    isComment
  };

  const inBody = element => {
    const dom = $_74lhjaxjjfuw8tdt.isText(element) ? element.dom().parentNode : element.dom();
    return dom !== undefined && dom !== null && dom.ownerDocument.body.contains(dom);
  };
  const body = $_ctj1zwx4jfuw8tbw.cached(() => getBody($_bwdnu0xijfuw8tdo.fromDom(document)));
  var getBody = doc => {
    const body = doc.dom().body;
    if (body === null || body === undefined)
      throw 'Body is not available yet';
    return $_bwdnu0xijfuw8tdo.fromDom(body);
  };
  const $_8634tqxhjfuw8tdl = {
    body,
    getBody,
    inBody
  };

  function Immutable () {
    const fields = [];
    for (let _i = 0; _i < arguments.length; _i++) {
      fields[_i] = arguments[_i];
    }
    return function () {
      const values = [];
      for (let _i = 0; _i < arguments.length; _i++) {
        values[_i] = arguments[_i];
      }
      if (fields.length !== values.length) {
        throw new Error(`Wrong number of arguments to struct. Expected "[${fields.length}]", got ${values.length} arguments`);
      }
      const struct = {};
      $_efmt4zxbjfuw8tcj.each(fields, (name, i) => {
        struct[name] = $_2vokfcwwjfuw8tb4.constant(values[i]);
      });
      return struct;
    };
  }

  const sort$1 = arr => arr.slice(0).sort();
  const reqMessage = (required, keys) => {
    throw new Error(`All required keys (${sort$1(required).join(', ')}) were not specified. Specified keys were: ${sort$1(keys).join(', ')}.`);
  };
  const unsuppMessage = unsupported => {
    throw new Error(`Unsupported keys for object: ${sort$1(unsupported).join(', ')}`);
  };
  const validateStrArr = (label, array) => {
    if (!$_8aqeo3wyjfuw8tb8.isArray(array))
      throw new Error(`The ${label} fields must be an array. Was: ${array}.`);
    $_efmt4zxbjfuw8tcj.each(array, a => {
      if (!$_8aqeo3wyjfuw8tb8.isString(a))
        throw new Error(`The value ${a} in the ${label} fields was not a string.`);
    });
  };
  const invalidTypeMessage = (incorrect, type) => {
    throw new Error(`All values need to be of type: ${type}. Keys (${sort$1(incorrect).join(', ')}) were not.`);
  };
  const checkDupes = everything => {
    const sorted = sort$1(everything);
    const dupe = $_efmt4zxbjfuw8tcj.find(sorted, (s, i) => i < sorted.length - 1 && s === sorted[i + 1]);
    dupe.each(d => {
      throw new Error(`The field: ${d} occurs more than once in the combined fields: [${sorted.join(', ')}].`);
    });
  };
  const $_fpmdlsxqjfuw8teg = {
    sort: sort$1,
    reqMessage,
    unsuppMessage,
    validateStrArr,
    invalidTypeMessage,
    checkDupes
  };

  function MixedBag (required, optional) {
    const everything = required.concat(optional);
    if (everything.length === 0)
      throw new Error('You must specify at least one required or optional field.');
    $_fpmdlsxqjfuw8teg.validateStrArr('required', required);
    $_fpmdlsxqjfuw8teg.validateStrArr('optional', optional);
    $_fpmdlsxqjfuw8teg.checkDupes(everything);
    return obj => {
      const keys = $_8qu224wzjfuw8tb9.keys(obj);
      const allReqd = $_efmt4zxbjfuw8tcj.forall(required, req => $_efmt4zxbjfuw8tcj.contains(keys, req));
      if (!allReqd)
        $_fpmdlsxqjfuw8teg.reqMessage(required, keys);
      const unsupported = $_efmt4zxbjfuw8tcj.filter(keys, key => !$_efmt4zxbjfuw8tcj.contains(everything, key));
      if (unsupported.length > 0)
        $_fpmdlsxqjfuw8teg.unsuppMessage(unsupported);
      const r = {};
      $_efmt4zxbjfuw8tcj.each(required, req => {
        r[req] = $_2vokfcwwjfuw8tb4.constant(obj[req]);
      });
      $_efmt4zxbjfuw8tcj.each(optional, opt => {
        r[opt] = $_2vokfcwwjfuw8tb4.constant(Object.prototype.hasOwnProperty.call(obj, opt) ? Option.some(obj[opt]) : Option.none());
      });
      return r;
    };
  }

  const $_4xhupwxnjfuw8tea = {
    immutable: Immutable,
    immutableBag: MixedBag
  };

  const toArray = (target, f) => {
    const r = [];
    const recurse = e => {
      r.push(e);
      return f(e);
    };
    let cur = f(target);
    do {
      cur = cur.bind(recurse);
    } while (cur.isSome());
    return r;
  };
  const $_e6izy8xrjfuw8tei = { toArray };

  const global = typeof window !== 'undefined' ? window : Function('return this;')();

  const path = (parts, scope) => {
    let o = scope !== undefined && scope !== null ? scope : global;
    for (let i = 0; i < parts.length && o !== undefined && o !== null; ++i)
      o = o[parts[i]];
    return o;
  };
  const resolve = (p, scope) => {
    const parts = p.split('.');
    return path(parts, scope);
  };
  const step = (o, part) => {
    if (o[part] === undefined || o[part] === null)
      o[part] = {};
    return o[part];
  };
  const forge = (parts, target) => {
    let o = target !== undefined ? target : global;
    for (let i = 0; i < parts.length; ++i)
      o = step(o, parts[i]);
    return o;
  };
  const namespace = (name, target) => {
    const parts = name.split('.');
    return forge(parts, target);
  };
  const $_15p0q3xvjfuw8tew = {
    path,
    resolve,
    forge,
    namespace
  };

  const unsafe = (name, scope) => $_15p0q3xvjfuw8tew.resolve(name, scope);
  const getOrDie = (name, scope) => {
    const actual = unsafe(name, scope);
    if (actual === undefined || actual === null)
      throw `${name} not available on this browser`;
    return actual;
  };
  const $_dxyj33xujfuw8tet = { getOrDie };

  const node = () => {
    const f = $_dxyj33xujfuw8tet.getOrDie('Node');
    return f;
  };
  const compareDocumentPosition = (a, b, match) => (a.compareDocumentPosition(b) & match) !== 0;
  const documentPositionPreceding = (a, b) => compareDocumentPosition(a, b, node().DOCUMENT_POSITION_PRECEDING);
  const documentPositionContainedBy = (a, b) => compareDocumentPosition(a, b, node().DOCUMENT_POSITION_CONTAINED_BY);
  const $_c0dwknxtjfuw8tes = {
    documentPositionPreceding,
    documentPositionContainedBy
  };

  const ELEMENT = $_dh9i2rxkjfuw8tdu.ELEMENT;
  const DOCUMENT = $_dh9i2rxkjfuw8tdu.DOCUMENT;
  const is = (element, selector) => {
    const elem = element.dom();
    if (elem.nodeType !== ELEMENT)
      return false;
    else if (elem.matches !== undefined)
      return elem.matches(selector);
    else if (elem.msMatchesSelector !== undefined)
      return elem.msMatchesSelector(selector);
    else if (elem.webkitMatchesSelector !== undefined)
      return elem.webkitMatchesSelector(selector);
    else if (elem.mozMatchesSelector !== undefined)
      return elem.mozMatchesSelector(selector);
    else
      throw new Error('Browser lacks native selectors');
  };
  const bypassSelector = dom => dom.nodeType !== ELEMENT && dom.nodeType !== DOCUMENT || dom.childElementCount === 0;
  const all = (selector, scope) => {
    const base = scope === undefined ? document : scope.dom();
    return bypassSelector(base) ? [] : $_efmt4zxbjfuw8tcj.map(base.querySelectorAll(selector), $_bwdnu0xijfuw8tdo.fromDom);
  };
  const one = (selector, scope) => {
    const base = scope === undefined ? document : scope.dom();
    return bypassSelector(base) ? Option.none() : Option.from(base.querySelector(selector)).map($_bwdnu0xijfuw8tdo.fromDom);
  };
  const $_gem9gixxjfuw8tey = {
    all,
    is,
    one
  };

  const eq = (e1, e2) => e1.dom() === e2.dom();
  const isEqualNode = (e1, e2) => e1.dom().isEqualNode(e2.dom());
  const member = (element, elements) => $_efmt4zxbjfuw8tcj.exists(elements, $_2vokfcwwjfuw8tb4.curry(eq, element));
  const regularContains = (e1, e2) => {
    const d1 = e1.dom();
    const d2 = e2.dom();
    return d1 === d2 ? false : d1.contains(d2);
  };
  const ieContains = (e1, e2) => $_c0dwknxtjfuw8tes.documentPositionContainedBy(e1.dom(), e2.dom());
  const browser = $_5reqwox3jfuw8tbu.detect().browser;
  const contains$2 = browser.isIE() ? ieContains : regularContains;
  const $_4867a0xsjfuw8tej = {
    eq,
    isEqualNode,
    member,
    contains: contains$2,
    is: $_gem9gixxjfuw8tey.is
  };

  const owner = element => $_bwdnu0xijfuw8tdo.fromDom(element.dom().ownerDocument);
  const documentElement = element => {
    const doc = owner(element);
    return $_bwdnu0xijfuw8tdo.fromDom(doc.dom().documentElement);
  };
  const defaultView = element => {
    const el = element.dom();
    const defaultView = el.ownerDocument.defaultView;
    return $_bwdnu0xijfuw8tdo.fromDom(defaultView);
  };
  const parent = element => {
    const dom = element.dom();
    return Option.from(dom.parentNode).map($_bwdnu0xijfuw8tdo.fromDom);
  };
  const findIndex$1 = element => parent(element).bind(p => {
    const kin = children(p);
    return $_efmt4zxbjfuw8tcj.findIndex(kin, elem => $_4867a0xsjfuw8tej.eq(element, elem));
  });
  const parents = (element, isRoot) => {
    const stop = $_8aqeo3wyjfuw8tb8.isFunction(isRoot) ? isRoot : $_2vokfcwwjfuw8tb4.constant(false);
    let dom = element.dom();
    const ret = [];
    while (dom.parentNode !== null && dom.parentNode !== undefined) {
      const rawParent = dom.parentNode;
      const parent = $_bwdnu0xijfuw8tdo.fromDom(rawParent);
      ret.push(parent);
      if (stop(parent) === true)
        break;
      else
        dom = rawParent;
    }
    return ret;
  };
  const siblings = element => {
    const filterSelf = elements => $_efmt4zxbjfuw8tcj.filter(elements, x => !$_4867a0xsjfuw8tej.eq(element, x));
    return parent(element).map(children).map(filterSelf).getOr([]);
  };
  const offsetParent = element => {
    const dom = element.dom();
    return Option.from(dom.offsetParent).map($_bwdnu0xijfuw8tdo.fromDom);
  };
  const prevSibling = element => {
    const dom = element.dom();
    return Option.from(dom.previousSibling).map($_bwdnu0xijfuw8tdo.fromDom);
  };
  const nextSibling = element => {
    const dom = element.dom();
    return Option.from(dom.nextSibling).map($_bwdnu0xijfuw8tdo.fromDom);
  };
  const prevSiblings = element => $_efmt4zxbjfuw8tcj.reverse($_e6izy8xrjfuw8tei.toArray(element, prevSibling));
  const nextSiblings = element => $_e6izy8xrjfuw8tei.toArray(element, nextSibling);
  var children = element => {
    const dom = element.dom();
    return $_efmt4zxbjfuw8tcj.map(dom.childNodes, $_bwdnu0xijfuw8tdo.fromDom);
  };
  const child = (element, index) => {
    const children = element.dom().childNodes;
    return Option.from(children[index]).map($_bwdnu0xijfuw8tdo.fromDom);
  };
  const firstChild = element => child(element, 0);
  const lastChild = element => child(element, element.dom().childNodes.length - 1);
  const childNodesCount = element => element.dom().childNodes.length;
  const hasChildNodes = element => element.dom().hasChildNodes();
  const spot = $_4xhupwxnjfuw8tea.immutable('element', 'offset');
  const leaf = (element, offset) => {
    const cs = children(element);
    return cs.length > 0 && offset < cs.length ? spot(cs[offset], 0) : spot(element, offset);
  };
  const $_aff64dxmjfuw8tdx = {
    owner,
    defaultView,
    documentElement,
    parent,
    findIndex: findIndex$1,
    parents,
    siblings,
    prevSibling,
    offsetParent,
    prevSiblings,
    nextSibling,
    nextSiblings,
    children,
    child,
    firstChild,
    lastChild,
    childNodesCount,
    hasChildNodes,
    leaf
  };

  const before = (marker, element) => {
    const parent = $_aff64dxmjfuw8tdx.parent(marker);
    parent.each(v => {
      v.dom().insertBefore(element.dom(), marker.dom());
    });
  };
  const after = (marker, element) => {
    const sibling = $_aff64dxmjfuw8tdx.nextSibling(marker);
    sibling.fold(() => {
      const parent = $_aff64dxmjfuw8tdx.parent(marker);
      parent.each(v => {
        append(v, element);
      });
    }, v => {
      before(v, element);
    });
  };
  const prepend = (parent, element) => {
    const firstChild = $_aff64dxmjfuw8tdx.firstChild(parent);
    firstChild.fold(() => {
      append(parent, element);
    }, v => {
      parent.dom().insertBefore(element.dom(), v.dom());
    });
  };
  var append = (parent, element) => {
    parent.dom().appendChild(element.dom());
  };
  const appendAt = (parent, element, index) => {
    $_aff64dxmjfuw8tdx.child(parent, index).fold(() => {
      append(parent, element);
    }, v => {
      before(v, element);
    });
  };
  const wrap = (element, wrapper) => {
    before(element, wrapper);
    append(wrapper, element);
  };
  const $_cwa5ncxljfuw8tdv = {
    before,
    after,
    prepend,
    append,
    appendAt,
    wrap
  };

  const before$1 = (marker, elements) => {
    $_efmt4zxbjfuw8tcj.each(elements, x => {
      $_cwa5ncxljfuw8tdv.before(marker, x);
    });
  };
  const after$1 = (marker, elements) => {
    $_efmt4zxbjfuw8tcj.each(elements, (x, i) => {
      const e = i === 0 ? marker : elements[i - 1];
      $_cwa5ncxljfuw8tdv.after(e, x);
    });
  };
  const prepend$1 = (parent, elements) => {
    $_efmt4zxbjfuw8tcj.each(elements.slice().reverse(), x => {
      $_cwa5ncxljfuw8tdv.prepend(parent, x);
    });
  };
  const append$1 = (parent, elements) => {
    $_efmt4zxbjfuw8tcj.each(elements, x => {
      $_cwa5ncxljfuw8tdv.append(parent, x);
    });
  };
  const $_g8n2ewxzjfuw8tf7 = {
    before: before$1,
    after: after$1,
    prepend: prepend$1,
    append: append$1
  };

  const empty = element => {
    element.dom().textContent = '';
    $_efmt4zxbjfuw8tcj.each($_aff64dxmjfuw8tdx.children(element), rogue => {
      remove(rogue);
    });
  };
  var remove = element => {
    const dom = element.dom();
    if (dom.parentNode !== null)
      dom.parentNode.removeChild(dom);
  };
  const unwrap = wrapper => {
    const children = $_aff64dxmjfuw8tdx.children(wrapper);
    if (children.length > 0)
      $_g8n2ewxzjfuw8tf7.before(wrapper, children);
    remove(wrapper);
  };
  const $_138z6jxyjfuw8tf4 = {
    empty,
    remove,
    unwrap
  };

  const fireDetaching = component => {
    emit(component, detachedFromDom());
    const children = component.components();
    $_efmt4zxbjfuw8tcj.each(children, fireDetaching);
  };
  const fireAttaching = component => {
    const children = component.components();
    $_efmt4zxbjfuw8tcj.each(children, fireAttaching);
    emit(component, attachedToDom());
  };
  const attach = (parent, child) => {
    attachWith(parent, child, $_cwa5ncxljfuw8tdv.append);
  };
  var attachWith = (parent, child, insertion) => {
    parent.getSystem().addToWorld(child);
    insertion(parent.element(), child.element());
    if ($_8634tqxhjfuw8tdl.inBody(parent.element())) {
      fireAttaching(child);
    }
    parent.syncComponents();
  };
  const doDetach = component => {
    fireDetaching(component);
    $_138z6jxyjfuw8tf4.remove(component.element());
    component.getSystem().removeFromWorld(component);
  };
  const detach = component => {
    const parent = $_aff64dxmjfuw8tdx.parent(component.element()).bind(p => component.getSystem().getByDom(p).fold(Option.none, Option.some));
    doDetach(component);
    parent.each(p => {
      p.syncComponents();
    });
  };
  const detachChildren = component => {
    const subs = component.components();
    $_efmt4zxbjfuw8tcj.each(subs, doDetach);
    $_138z6jxyjfuw8tf4.empty(component.element());
    component.syncComponents();
  };
  const attachSystem = (element, guiSystem) => {
    $_cwa5ncxljfuw8tdv.append(element, guiSystem.element());
    const children = $_aff64dxmjfuw8tdx.children(guiSystem.element());
    $_efmt4zxbjfuw8tcj.each(children, child => {
      guiSystem.getByDom(child).each(fireAttaching);
    });
  };

  const value$1 = o => {
    const is = v => o === v;
    const or = opt => value$1(o);
    const orThunk = f => value$1(o);
    const map = f => value$1(f(o));
    const each = f => {
      f(o);
    };
    const bind = f => f(o);
    const fold = (_, onValue) => onValue(o);
    const exists = f => f(o);
    const forall = f => f(o);
    const toOption = () => Option.some(o);
    return {
      is,
      isValue: $_2vokfcwwjfuw8tb4.always,
      isError: $_2vokfcwwjfuw8tb4.never,
      getOr: $_2vokfcwwjfuw8tb4.constant(o),
      getOrThunk: $_2vokfcwwjfuw8tb4.constant(o),
      getOrDie: $_2vokfcwwjfuw8tb4.constant(o),
      or,
      orThunk,
      fold,
      map,
      each,
      bind,
      exists,
      forall,
      toOption
    };
  };
  const error = message => {
    const getOrThunk = f => f();
    const getOrDie = () => $_2vokfcwwjfuw8tb4.die(String(message))();
    const or = opt => opt;
    const orThunk = f => f();
    const map = f => error(message);
    const bind = f => error(message);
    const fold = (onError, _) => onError(message);
    return {
      is: $_2vokfcwwjfuw8tb4.never,
      isValue: $_2vokfcwwjfuw8tb4.never,
      isError: $_2vokfcwwjfuw8tb4.always,
      getOr: $_2vokfcwwjfuw8tb4.identity,
      getOrThunk,
      getOrDie,
      or,
      orThunk,
      fold,
      map,
      each: $_2vokfcwwjfuw8tb4.noop,
      bind,
      exists: $_2vokfcwwjfuw8tb4.never,
      forall: $_2vokfcwwjfuw8tb4.always,
      toOption: Option.none
    };
  };
  const Result = {
    value: value$1,
    error
  };

  const generate = cases => {
    if (!$_8aqeo3wyjfuw8tb8.isArray(cases)) {
      throw new Error('cases must be an array');
    }
    if (cases.length === 0) {
      throw new Error('there must be at least one case');
    }
    const constructors = [];
    const adt = {};
    $_efmt4zxbjfuw8tcj.each(cases, (acase, count) => {
      const keys = $_8qu224wzjfuw8tb9.keys(acase);
      if (keys.length !== 1) {
        throw new Error('one and only one name per case');
      }
      const key = keys[0];
      const value = acase[key];
      if (adt[key] !== undefined) {
        throw new Error(`duplicate key detected:${key}`);
      } else if (key === 'cata') {
        throw new Error('cannot have a case named cata (sorry)');
      } else if (!$_8aqeo3wyjfuw8tb8.isArray(value)) {
        throw new Error('case arguments must be an array');
      }
      constructors.push(key);
      adt[key] = function () {
        const argLength = arguments.length;
        if (argLength !== value.length) {
          throw new Error(`Wrong number of arguments to case ${key}. Expected ${value.length} (${value}), got ${argLength}`);
        }
        const args = new Array(argLength);
        for (let i = 0; i < args.length; i++)
          args[i] = arguments[i];
        const match = branches => {
          const branchKeys = $_8qu224wzjfuw8tb9.keys(branches);
          if (constructors.length !== branchKeys.length) {
            throw new Error(`Wrong number of arguments to match. Expected: ${constructors.join(',')}\nActual: ${branchKeys.join(',')}`);
          }
          const allReqd = $_efmt4zxbjfuw8tcj.forall(constructors, reqKey => $_efmt4zxbjfuw8tcj.contains(branchKeys, reqKey));
          if (!allReqd)
            throw new Error(`Not all branches were specified when using match. Specified: ${branchKeys.join(', ')}\nRequired: ${constructors.join(', ')}`);
          return branches[key].apply(null, args);
        };
        return {
          fold() {
            if (arguments.length !== cases.length) {
              throw new Error(`Wrong number of arguments to fold. Expected ${cases.length}, got ${arguments.length}`);
            }
            const target = arguments[count];
            return target(...args);
          },
          match,
          log(label) {
            console.log(label, {
              constructors,
              constructor: key,
              params: args
            });
          }
        };
      };
    });
    return adt;
  };
  const $_dldkf4y5jfuw8tgp = { generate };

  const adt = $_dldkf4y5jfuw8tgp.generate([
    { strict: [] },
    { defaultedThunk: ['fallbackThunk'] },
    { asOption: [] },
    { asDefaultedOptionThunk: ['fallbackThunk'] },
    { mergeWithThunk: ['baseThunk'] }
  ]);
  const defaulted = fallback => adt.defaultedThunk($_2vokfcwwjfuw8tb4.constant(fallback));
  const mergeWith = base => adt.mergeWithThunk($_2vokfcwwjfuw8tb4.constant(base));
  const strict = adt.strict;
  const asOption = adt.asOption;
  const defaultedThunk = adt.defaultedThunk;
  const asDefaultedOptionThunk = adt.asDefaultedOptionThunk;
  const mergeWithThunk = adt.mergeWithThunk;

  const comparison = $_dldkf4y5jfuw8tgp.generate([
    {
      bothErrors: [
        'error1',
        'error2'
      ]
    },
    {
      firstError: [
        'error1',
        'value2'
      ]
    },
    {
      secondError: [
        'value1',
        'error2'
      ]
    },
    {
      bothValues: [
        'value1',
        'value2'
      ]
    }
  ]);
  const partition$1 = results => {
    const errors = [];
    const values = [];
    $_efmt4zxbjfuw8tcj.each(results, result => {
      result.fold(err => {
        errors.push(err);
      }, value => {
        values.push(value);
      });
    });
    return {
      errors,
      values
    };
  };
  const compare = (result1, result2) => result1.fold(err1 => result2.fold(err2 => comparison.bothErrors(err1, err2), val2 => comparison.firstError(err1, val2)), val1 => result2.fold(err2 => comparison.secondError(val1, err2), val2 => comparison.bothValues(val1, val2)));
  const $_7v02bqy9jfuw8thf = {
    partition: partition$1,
    compare
  };

  const mergeValues = (values, base) => Result.value($_3jctjywxjfuw8tb6.deepMerge.apply(undefined, [base].concat(values)));
  const mergeErrors = errors => $_2vokfcwwjfuw8tb4.compose(Result.error, $_efmt4zxbjfuw8tcj.flatten)(errors);
  const consolidateObj = (objects, base) => {
    const partitions = $_7v02bqy9jfuw8thf.partition(objects);
    return partitions.errors.length > 0 ? mergeErrors(partitions.errors) : mergeValues(partitions.values, base);
  };
  const consolidateArr = objects => {
    const partitions = $_7v02bqy9jfuw8thf.partition(objects);
    return partitions.errors.length > 0 ? mergeErrors(partitions.errors) : Result.value(partitions.values);
  };
  const ResultCombine = {
    consolidateObj,
    consolidateArr
  };

  const narrow = (obj, fields) => {
    const r = {};
    $_efmt4zxbjfuw8tcj.each(fields, field => {
      if (obj[field] !== undefined && obj.hasOwnProperty(field)) {
        r[field] = obj[field];
      }
    });
    return r;
  };
  const exclude = (obj, fields) => {
    const r = {};
    $_8qu224wzjfuw8tb9.each(obj, (v, k) => {
      if (!$_efmt4zxbjfuw8tcj.contains(fields, k)) {
        r[k] = v;
      }
    });
    return r;
  };

  const readOpt = key => obj => obj.hasOwnProperty(key) ? Option.from(obj[key]) : Option.none();
  const readOr = (key, fallback) => obj => readOpt(key)(obj).getOr(fallback);
  const readOptFrom = (obj, key) => readOpt(key)(obj);
  const hasKey = (obj, key) => obj.hasOwnProperty(key) && obj[key] !== undefined && obj[key] !== null;

  const wrap$1 = (key, value) => {
    const r = {};
    r[key] = value;
    return r;
  };
  const wrapAll = keyvalues => {
    const r = {};
    $_efmt4zxbjfuw8tcj.each(keyvalues, kv => {
      r[kv.key] = kv.value;
    });
    return r;
  };

  const narrow$1 = (obj, fields) => narrow(obj, fields);
  const exclude$1 = (obj, fields) => exclude(obj, fields);
  const readOpt$1 = key => readOpt(key);
  const readOr$1 = (key, fallback) => readOr(key, fallback);
  const readOptFrom$1 = (obj, key) => readOptFrom(obj, key);
  const wrap$2 = (key, value) => wrap$1(key, value);
  const wrapAll$1 = keyvalues => wrapAll(keyvalues);
  const consolidate = (objs, base) => ResultCombine.consolidateObj(objs, base);
  const hasKey$1 = (obj, key) => hasKey(obj, key);

  const typeAdt = $_dldkf4y5jfuw8tgp.generate([
    {
      setOf: [
        'validator',
        'valueType'
      ]
    },
    { arrOf: ['valueType'] },
    { objOf: ['fields'] },
    { itemOf: ['validator'] },
    {
      choiceOf: [
        'key',
        'branches'
      ]
    },
    { thunk: ['description'] },
    {
      func: [
        'args',
        'outputSchema'
      ]
    }
  ]);
  const fieldAdt = $_dldkf4y5jfuw8tgp.generate([
    {
      field: [
        'name',
        'presence',
        'type'
      ]
    },
    { state: ['name'] }
  ]);

  const json = () => $_dxyj33xujfuw8tet.getOrDie('JSON');
  const parse = obj => json().parse(obj);
  const stringify = (obj, replacer, space) => json().stringify(obj, replacer, space);
  const $_6s9vvgygjfuw8ti8 = {
    parse,
    stringify
  };

  const formatObj = input => $_8aqeo3wyjfuw8tb8.isObject(input) && $_8qu224wzjfuw8tb9.keys(input).length > 100 ? ' removed due to size' : $_6s9vvgygjfuw8ti8.stringify(input, null, 2);
  const formatErrors = errors => {
    const es = errors.length > 10 ? errors.slice(0, 10).concat([{
        path: [],
        getErrorInfo() {
          return '... (only showing first ten failures)';
        }
      }]) : errors;
    return $_efmt4zxbjfuw8tcj.map(es, e => `Failed path: (${e.path.join(' > ')})\n${e.getErrorInfo()}`);
  };

  const nu$3 = (path, getErrorInfo) => Result.error([{
      path,
      getErrorInfo
    }]);
  const missingStrict = (path, key, obj) => nu$3(path, () => `Could not find valid *strict* value for "${key}" in ${formatObj(obj)}`);
  const missingKey = (path, key) => nu$3(path, () => `Choice schema did not contain choice key: "${key}"`);
  const missingBranch = (path, branches, branch) => nu$3(path, () => `The chosen schema: "${branch}" did not exist in branches: ${formatObj(branches)}`);
  const unsupportedFields = (path, unsupported) => nu$3(path, () => `There are unsupported fields: [${unsupported.join(', ')}] specified`);
  const custom = (path, err) => nu$3(path, () => err);

  const adt$1 = $_dldkf4y5jfuw8tgp.generate([
    {
      field: [
        'key',
        'okey',
        'presence',
        'prop'
      ]
    },
    {
      state: [
        'okey',
        'instantiator'
      ]
    }
  ]);
  const strictAccess = (path, obj, key) => readOptFrom(obj, key).fold(() => missingStrict(path, key, obj), Result.value);
  const fallbackAccess = (obj, key, fallbackThunk) => {
    const v = readOptFrom(obj, key).fold(() => fallbackThunk(obj), $_2vokfcwwjfuw8tb4.identity);
    return Result.value(v);
  };
  const optionAccess = (obj, key) => Result.value(readOptFrom(obj, key));
  const optionDefaultedAccess = (obj, key, fallback) => {
    const opt = readOptFrom(obj, key).map(val => val === true ? fallback(obj) : val);
    return Result.value(opt);
  };
  const cExtractOne = (path, obj, field, strength) => field.fold((key, okey, presence, prop) => {
    const bundle = av => prop.extract(path.concat([key]), strength, av).map(res => wrap$1(okey, strength(res)));
    const bundleAsOption = optValue => optValue.fold(() => {
      const outcome = wrap$1(okey, strength(Option.none()));
      return Result.value(outcome);
    }, ov => prop.extract(path.concat([key]), strength, ov).map(res => wrap$1(okey, strength(Option.some(res)))));
    return (() => presence.fold(() => strictAccess(path, obj, key).bind(bundle), fallbackThunk => fallbackAccess(obj, key, fallbackThunk).bind(bundle), () => optionAccess(obj, key).bind(bundleAsOption), fallbackThunk => optionDefaultedAccess(obj, key, fallbackThunk).bind(bundleAsOption), baseThunk => {
      const base = baseThunk(obj);
      return fallbackAccess(obj, key, $_2vokfcwwjfuw8tb4.constant({})).map(v => $_3jctjywxjfuw8tb6.deepMerge(base, v)).bind(bundle);
    }))();
  }, (okey, instantiator) => {
    const state = instantiator(obj);
    return Result.value(wrap$1(okey, strength(state)));
  });
  const cExtract = (path, obj, fields, strength) => {
    const results = $_efmt4zxbjfuw8tcj.map(fields, field => cExtractOne(path, obj, field, strength));
    return ResultCombine.consolidateObj(results, {});
  };
  const value$2 = validator => {
    const extract = (path, strength, val) => validator(val, strength).fold(err => custom(path, err), Result.value);
    const toString$$1 = () => 'val';
    const toDsl = () => typeAdt.itemOf(validator);
    return {
      extract,
      toString: toString$$1,
      toDsl
    };
  };
  const getSetKeys = obj => {
    const keys = $_8qu224wzjfuw8tb9.keys(obj);
    return $_efmt4zxbjfuw8tcj.filter(keys, k => hasKey$1(obj, k));
  };
  const objOfOnly = fields => {
    const delegate = objOf(fields);
    const fieldNames = $_efmt4zxbjfuw8tcj.foldr(fields, (acc, f) => f.fold(key => $_3jctjywxjfuw8tb6.deepMerge(acc, wrap$2(key, true)), $_2vokfcwwjfuw8tb4.constant(acc)), {});
    const extract = (path, strength, o) => {
      const keys = $_8aqeo3wyjfuw8tb8.isBoolean(o) ? [] : getSetKeys(o);
      const extra = $_efmt4zxbjfuw8tcj.filter(keys, k => !hasKey$1(fieldNames, k));
      return extra.length === 0 ? delegate.extract(path, strength, o) : unsupportedFields(path, extra);
    };
    return {
      extract,
      toString: delegate.toString,
      toDsl: delegate.toDsl
    };
  };
  var objOf = fields => {
    const extract = (path, strength, o) => cExtract(path, o, fields, strength);
    const toString$$1 = () => {
      const fieldStrings = $_efmt4zxbjfuw8tcj.map(fields, field => field.fold((key, okey, presence, prop) => `${key} -> ${prop.toString()}`, (okey, instantiator) => `state(${okey})`));
      return `obj{\n${fieldStrings.join('\n')}}`;
    };
    const toDsl = () => typeAdt.objOf($_efmt4zxbjfuw8tcj.map(fields, f => f.fold((key, okey, presence, prop) => fieldAdt.field(key, presence, prop), (okey, instantiator) => fieldAdt.state(okey))));
    return {
      extract,
      toString: toString$$1,
      toDsl
    };
  };
  const arrOf = prop => {
    const extract = (path, strength, array) => {
      const results = $_efmt4zxbjfuw8tcj.map(array, (a, i) => prop.extract(path.concat([`[${i}]`]), strength, a));
      return ResultCombine.consolidateArr(results);
    };
    const toString$$1 = () => `array(${prop.toString()})`;
    const toDsl = () => typeAdt.arrOf(prop);
    return {
      extract,
      toString: toString$$1,
      toDsl
    };
  };
  const setOf = (validator, prop) => {
    const validateKeys = (path, keys) => arrOf(value$2(validator)).extract(path, $_2vokfcwwjfuw8tb4.identity, keys);
    const extract = (path, strength, o) => {
      const keys = $_8qu224wzjfuw8tb9.keys(o);
      return validateKeys(path, keys).bind(validKeys => {
        const schema = $_efmt4zxbjfuw8tcj.map(validKeys, vk => adt$1.field(vk, vk, strict(), prop));
        return objOf(schema).extract(path, strength, o);
      });
    };
    const toString$$1 = () => `setOf(${prop.toString()})`;
    const toDsl = () => typeAdt.setOf(validator, prop);
    return {
      extract,
      toString: toString$$1,
      toDsl
    };
  };
  const anyValue = $_2vokfcwwjfuw8tb4.constant(value$2(Result.value));
  const arrOfObj = $_2vokfcwwjfuw8tb4.compose(arrOf, objOf);
  const state = adt$1.state;
  const field = adt$1.field;

  const strict$1 = key => field(key, key, strict(), anyValue());
  const strictOf = (key, schema) => field(key, key, strict(), schema);
  const strictFunction = key => field(key, key, strict(), value$2(f => $_8aqeo3wyjfuw8tb8.isFunction(f) ? Result.value(f) : Result.error('Not a function')));
  const forbid = (key, message) => field(key, key, asOption(), value$2(v => Result.error(`The field: ${key} is forbidden. ${message}`)));
  const strictObjOf = (key, objSchema) => field(key, key, strict(), objOf(objSchema));
  const option = key => field(key, key, asOption(), anyValue());
  const optionOf = (key, schema) => field(key, key, asOption(), schema);
  const optionObjOf = (key, objSchema) => field(key, key, asOption(), objOf(objSchema));
  const optionObjOfOnly = (key, objSchema) => field(key, key, asOption(), objOfOnly(objSchema));
  const defaulted$1 = (key, fallback) => field(key, key, defaulted(fallback), anyValue());
  const defaultedOf = (key, fallback, schema) => field(key, key, defaulted(fallback), schema);
  const defaultedObjOf = (key, fallback, objSchema) => field(key, key, defaulted(fallback), objOf(objSchema));
  const state$1 = (okey, instantiator) => state(okey, instantiator);

  const chooseFrom = (path, strength, input, branches, ch) => {
    const fields = readOptFrom$1(branches, ch);
    return fields.fold(() => missingBranch(path, branches, ch), fs => objOf(fs).extract(path.concat([`branch: ${ch}`]), strength, input));
  };
  const choose = (key, branches) => {
    const extract = (path, strength, input) => {
      const choice = readOptFrom$1(input, key);
      return choice.fold(() => missingKey(path, key), chosen => chooseFrom(path, strength, input, branches, chosen));
    };
    const toString$$1 = () => `chooseOn(${key}). Possible values: ${$_8qu224wzjfuw8tb9.keys(branches)}`;
    const toDsl = () => typeAdt.choiceOf(key, branches);
    return {
      extract,
      toString: toString$$1,
      toDsl
    };
  };

  const _anyValue = value$2(Result.value);
  const valueOf = validator => value$2(v => validator(v));
  const extract = (label, prop, strength, obj) => prop.extract([label], strength, obj).fold(errs => Result.error({
    input: obj,
    errors: errs
  }), Result.value);
  const asStruct = (label, prop, obj) => extract(label, prop, $_2vokfcwwjfuw8tb4.constant, obj);
  const asRaw = (label, prop, obj) => extract(label, prop, $_2vokfcwwjfuw8tb4.identity, obj);
  const getOrDie$1 = extraction => extraction.fold(errInfo => {
    throw new Error(formatError(errInfo));
  }, $_2vokfcwwjfuw8tb4.identity);
  const asRawOrDie = (label, prop, obj) => getOrDie$1(asRaw(label, prop, obj));
  const asStructOrDie = (label, prop, obj) => getOrDie$1(asStruct(label, prop, obj));
  var formatError = errInfo => `Errors: \n${formatErrors(errInfo.errors)}\n\nInput object: ${formatObj(errInfo.input)}`;
  const choose$1 = (key, branches) => choose(key, branches);
  const anyValue$1 = $_2vokfcwwjfuw8tb4.constant(_anyValue);

  const isSource = (component, simulatedEvent) => $_4867a0xsjfuw8tej.eq(component.element(), simulatedEvent.event().target());

  const nu$4 = parts => {
    if (!hasKey$1(parts, 'can') && !hasKey$1(parts, 'abort') && !hasKey$1(parts, 'run')) {
      throw new Error(`EventHandler defined by: ${$_6s9vvgygjfuw8ti8.stringify(parts, null, 2)} does not have can, abort, or run!`);
    }
    return asRawOrDie('Extracting event.handler', objOfOnly([
      defaulted$1('can', $_2vokfcwwjfuw8tb4.constant(true)),
      defaulted$1('abort', $_2vokfcwwjfuw8tb4.constant(false)),
      defaulted$1('run', $_2vokfcwwjfuw8tb4.noop)
    ]), parts);
  };
  const all$1 = (handlers, f) => function () {
    const args = Array.prototype.slice.call(arguments, 0);
    return $_efmt4zxbjfuw8tcj.foldl(handlers, (acc, handler) => acc && f(handler).apply(undefined, args), true);
  };
  const any = (handlers, f) => function () {
    const args = Array.prototype.slice.call(arguments, 0);
    return $_efmt4zxbjfuw8tcj.foldl(handlers, (acc, handler) => acc || f(handler).apply(undefined, args), false);
  };
  const read = handler => $_8aqeo3wyjfuw8tb8.isFunction(handler) ? {
    can: $_2vokfcwwjfuw8tb4.constant(true),
    abort: $_2vokfcwwjfuw8tb4.constant(false),
    run: handler
  } : handler;
  const fuse = handlers => {
    const can = all$1(handlers, handler => handler.can);
    const abort = any(handlers, handler => handler.abort);
    const run = function () {
      const args = Array.prototype.slice.call(arguments, 0);
      $_efmt4zxbjfuw8tcj.each(handlers, handler => {
        handler.run.apply(undefined, args);
      });
    };
    return nu$4({
      can,
      abort,
      run
    });
  };

  const derive = wrapAll$1;
  const abort = (name, predicate) => ({
    key: name,
    value: nu$4({ abort: predicate })
  });
  const can = (name, predicate) => ({
    key: name,
    value: nu$4({ can: predicate })
  });
  const run = (name, handler) => ({
    key: name,
    value: nu$4({ run: handler })
  });
  const runActionExtra = (name, action, extra) => ({
    key: name,

    value: nu$4({
      run(component) {
        action(...[component].concat(extra));
      }
    })
  });
  const runOnName = name => handler => run(name, handler);
  const runOnSourceName = name => handler => ({
    key: name,

    value: nu$4({
      run(component, simulatedEvent) {
        if (isSource(component, simulatedEvent)) {
          handler(component, simulatedEvent);
        }
      }
    })
  });
  const redirectToUid = (name, uid) => run(name, (component, simulatedEvent) => {
    component.getSystem().getByUid(uid).each(redirectee => {
      dispatchEvent(redirectee, redirectee.element(), name, simulatedEvent);
    });
  });
  const redirectToPart = (name, detail, partName) => {
    const uid = detail.partUids()[partName];
    return redirectToUid(name, uid);
  };
  const runWithTarget = (name, f) => run(name, (component, simulatedEvent) => {
    component.getSystem().getByDom(simulatedEvent.event().target()).each(target => {
      f(component, target, simulatedEvent);
    });
  });
  const cutter = name => run(name, (component, simulatedEvent) => {
    simulatedEvent.cut();
  });
  const stopper = name => run(name, (component, simulatedEvent) => {
    simulatedEvent.stop();
  });
  const runOnAttached = runOnSourceName(attachedToDom());
  const runOnDetached = runOnSourceName(detachedFromDom());
  const runOnInit = runOnSourceName(systemInit());
  const runOnExecute = runOnName(execute());

  const markAsBehaviourApi = (f, apiName, apiFunction) => f;
  const markAsExtraApi = (f, extraName) => f;
  const markAsSketchApi = (f, apiFunction) => f;

  const nu$5 = $_4xhupwxnjfuw8tea.immutableBag(['tag'], [
    'classes',
    'attributes',
    'styles',
    'value',
    'innerHtml',
    'domChildren',
    'defChildren'
  ]);
  const defToStr = defn => {
    const raw = defToRaw(defn);
    return $_6s9vvgygjfuw8ti8.stringify(raw, null, 2);
  };
  var defToRaw = defn => ({
    tag: defn.tag(),
    classes: defn.classes().getOr([]),
    attributes: defn.attributes().getOr({}),
    styles: defn.styles().getOr({}),
    value: defn.value().getOr('<none>'),
    innerHtml: defn.innerHtml().getOr('<none>'),
    defChildren: defn.defChildren().getOr('<none>'),
    domChildren: defn.domChildren().fold(() => '<none>', children => children.length === 0 ? '0 children, but still specified' : String(children.length))
  });

  const fields = [
    'classes',
    'attributes',
    'styles',
    'value',
    'innerHtml',
    'defChildren',
    'domChildren'
  ];
  const nu$6 = $_4xhupwxnjfuw8tea.immutableBag([], fields);
  const clashingOptArrays = (key, oArr1, oArr2) => oArr1.fold(() => oArr2.fold(() => ({}), arr2 => wrap$2(key, arr2)), arr1 => oArr2.fold(() => wrap$2(key, arr1), arr2 => wrap$2(key, arr2)));
  const merge$1 = (defnA, mod) => {
    const raw = $_3jctjywxjfuw8tb6.deepMerge({
      tag: defnA.tag(),
      classes: mod.classes().getOr([]).concat(defnA.classes().getOr([])),
      attributes: $_3jctjywxjfuw8tb6.merge(defnA.attributes().getOr({}), mod.attributes().getOr({})),
      styles: $_3jctjywxjfuw8tb6.merge(defnA.styles().getOr({}), mod.styles().getOr({}))
    }, mod.innerHtml().or(defnA.innerHtml()).map(innerHtml => wrap$2('innerHtml', innerHtml)).getOr({}), clashingOptArrays('domChildren', mod.domChildren(), defnA.domChildren()), clashingOptArrays('defChildren', mod.defChildren(), defnA.defChildren()), mod.value().or(defnA.value()).map(value => wrap$2('value', value)).getOr({}));
    return nu$5(raw);
  };

  const executeEvent = (bConfig, bState, executor) => runOnExecute(component => {
    executor(component, bConfig, bState);
  });
  const loadEvent = (bConfig, bState, f) => runOnInit((component, simulatedEvent) => {
    f(component, bConfig, bState);
  });
  const create = (schema, name, active, apis, extra, state) => {
    const configSchema = objOfOnly(schema);
    const schemaSchema = optionObjOf(name, [optionObjOfOnly('config', schema)]);
    return doCreate(configSchema, schemaSchema, name, active, apis, extra, state);
  };
  const createModes = (modes, name, active, apis, extra, state) => {
    const configSchema = modes;
    const schemaSchema = optionObjOf(name, [optionOf('config', modes)]);
    return doCreate(configSchema, schemaSchema, name, active, apis, extra, state);
  };
  const wrapApi = (bName, apiFunction, apiName) => {
    const f = function (component) {
      const args = arguments;
      return component.config({ name: $_2vokfcwwjfuw8tb4.constant(bName) }).fold(() => {
        throw new Error(`We could not find any behaviour configuration for: ${bName}. Using API: ${apiName}`);
      }, info => {
        const rest = Array.prototype.slice.call(args, 1);
        return apiFunction(...[
          component,
          info.config,
          info.state
        ].concat(rest));
      });
    };
    return markAsBehaviourApi(f, apiName, apiFunction);
  };
  const revokeBehaviour = name => ({
    key: name,
    value: undefined
  });
  var doCreate = (configSchema, schemaSchema, name, active, apis, extra, state) => {
    const getConfig = info => hasKey$1(info, name) ? info[name]() : Option.none();
    const wrappedApis = $_8qu224wzjfuw8tb9.map(apis, (apiF, apiName) => wrapApi(name, apiF, apiName));
    const wrappedExtra = $_8qu224wzjfuw8tb9.map(extra, (extraF, extraName) => markAsExtraApi(extraF, extraName));
    const me = $_3jctjywxjfuw8tb6.deepMerge(wrappedExtra, wrappedApis, {
      revoke: $_2vokfcwwjfuw8tb4.curry(revokeBehaviour, name),
      config(spec) {
        const prepared = asStructOrDie(`${name}-config`, configSchema, spec);
        return {
          key: name,
          value: {
            config: prepared,
            me,
            configAsRaw: $_ctj1zwx4jfuw8tbw.cached(() => asRawOrDie(`${name}-config`, configSchema, spec)),
            initialConfig: spec,
            state
          }
        };
      },
      schema() {
        return schemaSchema;
      },
      exhibit(info, base) {
        return getConfig(info).bind(behaviourInfo => readOptFrom$1(active, 'exhibit').map(exhibitor => exhibitor(base, behaviourInfo.config, behaviourInfo.state))).getOr(nu$6({}));
      },
      name() {
        return name;
      },
      handlers(info) {
        return getConfig(info).bind(behaviourInfo => readOptFrom$1(active, 'events').map(events => events(behaviourInfo.config, behaviourInfo.state))).getOr({});
      }
    });
    return me;
  };

  const base = (handleUnsupported, required) => baseWith(handleUnsupported, required, {
    validate: $_8aqeo3wyjfuw8tb8.isFunction,
    label: 'function'
  });
  var baseWith = (handleUnsupported, required, pred) => {
    if (required.length === 0)
      throw new Error('You must specify at least one required field.');
    $_fpmdlsxqjfuw8teg.validateStrArr('required', required);
    $_fpmdlsxqjfuw8teg.checkDupes(required);
    return obj => {
      const keys = $_8qu224wzjfuw8tb9.keys(obj);
      const allReqd = $_efmt4zxbjfuw8tcj.forall(required, req => $_efmt4zxbjfuw8tcj.contains(keys, req));
      if (!allReqd)
        $_fpmdlsxqjfuw8teg.reqMessage(required, keys);
      handleUnsupported(required, keys);
      const invalidKeys = $_efmt4zxbjfuw8tcj.filter(required, key => !pred.validate(obj[key], key));
      if (invalidKeys.length > 0)
        $_fpmdlsxqjfuw8teg.invalidTypeMessage(invalidKeys, pred.label);
      return obj;
    };
  };
  const handleExact = (required, keys) => {
    const unsupported = $_efmt4zxbjfuw8tcj.filter(keys, key => !$_efmt4zxbjfuw8tcj.contains(required, key));
    if (unsupported.length > 0)
      $_fpmdlsxqjfuw8teg.unsuppMessage(unsupported);
  };
  const allowExtra = $_2vokfcwwjfuw8tb4.noop;
  const $_2cliu2ysjfuw8tkr = {
    exactly: $_2vokfcwwjfuw8tb4.curry(base, handleExact),
    ensure: $_2vokfcwwjfuw8tb4.curry(base, allowExtra),
    ensureWith: $_2vokfcwwjfuw8tb4.curry(baseWith, allowExtra)
  };

  const BehaviourState = $_2cliu2ysjfuw8tkr.ensure(['readState']);

  const init = () => BehaviourState({
    readState() {
      return 'No State required';
    }
  });


  const NoState = Object.freeze({
    init
  });

  const derive$2 = capabilities => wrapAll$1(capabilities);
  const simpleSchema = objOfOnly([
    strict$1('fields'),
    strict$1('name'),
    defaulted$1('active', {}),
    defaulted$1('apis', {}),
    defaulted$1('extra', {}),
    defaulted$1('state', NoState)
  ]);
  const create$1 = data => {
    const value = asRawOrDie(`Creating behaviour: ${data.name}`, simpleSchema, data);
    return create(value.fields, value.name, value.active, value.apis, value.extra, value.state);
  };
  const modeSchema = objOfOnly([
    strict$1('branchKey'),
    strict$1('branches'),
    strict$1('name'),
    defaulted$1('active', {}),
    defaulted$1('apis', {}),
    defaulted$1('extra', {}),
    defaulted$1('state', NoState)
  ]);
  const createModes$1 = data => {
    const value = asRawOrDie(`Creating behaviour: ${data.name}`, modeSchema, data);
    return createModes(choose$1(value.branchKey, value.branches), value.name, value.active, value.apis, value.extra, value.state);
  };
  const revoke = $_2vokfcwwjfuw8tb4.constant(undefined);
  const noActive = $_2vokfcwwjfuw8tb4.constant({});
  const noApis = $_2vokfcwwjfuw8tb4.constant({});
  const noExtra = $_2vokfcwwjfuw8tb4.constant({});
  const noState = $_2vokfcwwjfuw8tb4.constant(NoState);

  function Toggler (turnOff, turnOn, initial) {
    let active = initial || false;
    const on = () => {
      turnOn();
      active = true;
    };
    const off = () => {
      turnOff();
      active = false;
    };
    const toggle = () => {
      const f = active ? off : on;
      f();
    };
    const isOn = () => active;
    return {
      on,
      off,
      toggle,
      isOn
    };
  }

  const rawSet = (dom, key, value) => {
    if ($_8aqeo3wyjfuw8tb8.isString(value) || $_8aqeo3wyjfuw8tb8.isBoolean(value) || $_8aqeo3wyjfuw8tb8.isNumber(value)) {
      dom.setAttribute(key, `${value}`);
    } else {
      console.error('Invalid call to Attr.set. Key ', key, ':: Value ', value, ':: Element ', dom);
      throw new Error('Attribute value was not simple');
    }
  };
  const set = (element, key, value) => {
    rawSet(element.dom(), key, value);
  };
  const setAll = (element, attrs) => {
    const dom = element.dom();
    $_8qu224wzjfuw8tb9.each(attrs, (v, k) => {
      rawSet(dom, k, v);
    });
  };
  const get = (element, key) => {
    const v = element.dom().getAttribute(key);
    return v === null ? undefined : v;
  };
  const has = (element, key) => {
    const dom = element.dom();
    return dom && dom.hasAttribute ? dom.hasAttribute(key) : false;
  };
  const remove$1 = (element, key) => {
    element.dom().removeAttribute(key);
  };
  const hasNone = element => {
    const attrs = element.dom().attributes;
    return attrs === undefined || attrs === null || attrs.length === 0;
  };
  const clone = element => $_efmt4zxbjfuw8tcj.foldl(element.dom().attributes, (acc, attr) => {
    acc[attr.name] = attr.value;
    return acc;
  }, {});
  const transferOne = (source, destination, attr) => {
    if (has(source, attr) && !has(destination, attr))
      set(destination, attr, get(source, attr));
  };
  const transfer = (source, destination, attrs) => {
    if (!$_74lhjaxjjfuw8tdt.isElement(source) || !$_74lhjaxjjfuw8tdt.isElement(destination))
      return;
    $_efmt4zxbjfuw8tcj.each(attrs, attr => {
      transferOne(source, destination, attr);
    });
  };
  const $_47adx7ywjfuw8tl3 = {
    clone,
    set,
    setAll,
    get,
    has,
    remove: remove$1,
    hasNone,
    transfer
  };

  const read$1 = (element, attr) => {
    const value = $_47adx7ywjfuw8tl3.get(element, attr);
    return value === undefined || value === '' ? [] : value.split(' ');
  };
  const add = (element, attr, id) => {
    const old = read$1(element, attr);
    const nu = old.concat([id]);
    $_47adx7ywjfuw8tl3.set(element, attr, nu.join(' '));
  };
  const remove$2 = (element, attr, id) => {
    const nu = $_efmt4zxbjfuw8tcj.filter(read$1(element, attr), v => v !== id);
    if (nu.length > 0)
      $_47adx7ywjfuw8tl3.set(element, attr, nu.join(' '));
    else
      $_47adx7ywjfuw8tl3.remove(element, attr);
  };
  const $_2ym1c3yyjfuw8tlg = {
    read: read$1,
    add,
    remove: remove$2
  };

  const supports = element => element.dom().classList !== undefined;
  const get$1 = element => $_2ym1c3yyjfuw8tlg.read(element, 'class');
  const add$1 = (element, clazz) => $_2ym1c3yyjfuw8tlg.add(element, 'class', clazz);
  const remove$3 = (element, clazz) => $_2ym1c3yyjfuw8tlg.remove(element, 'class', clazz);
  const toggle = (element, clazz) => {
    if ($_efmt4zxbjfuw8tcj.contains(get$1(element), clazz)) {
      remove$3(element, clazz);
    } else {
      add$1(element, clazz);
    }
  };
  const $_bxqp80yxjfuw8tlc = {
    get: get$1,
    add: add$1,
    remove: remove$3,
    toggle,
    supports
  };

  const add$2 = (element, clazz) => {
    if ($_bxqp80yxjfuw8tlc.supports(element))
      element.dom().classList.add(clazz);
    else
      $_bxqp80yxjfuw8tlc.add(element, clazz);
  };
  const cleanClass = element => {
    const classList = $_bxqp80yxjfuw8tlc.supports(element) ? element.dom().classList : $_bxqp80yxjfuw8tlc.get(element);
    if (classList.length === 0) {
      $_47adx7ywjfuw8tl3.remove(element, 'class');
    }
  };
  const remove$4 = (element, clazz) => {
    if ($_bxqp80yxjfuw8tlc.supports(element)) {
      const classList = element.dom().classList;
      classList.remove(clazz);
    } else
      $_bxqp80yxjfuw8tlc.remove(element, clazz);
    cleanClass(element);
  };
  const toggle$1 = (element, clazz) => $_bxqp80yxjfuw8tlc.supports(element) ? element.dom().classList.toggle(clazz) : $_bxqp80yxjfuw8tlc.toggle(element, clazz);
  const toggler = (element, clazz) => {
    const hasClasslist = $_bxqp80yxjfuw8tlc.supports(element);
    const classList = element.dom().classList;
    const off = () => {
      if (hasClasslist)
        classList.remove(clazz);
      else
        $_bxqp80yxjfuw8tlc.remove(element, clazz);
    };
    const on = () => {
      if (hasClasslist)
        classList.add(clazz);
      else
        $_bxqp80yxjfuw8tlc.add(element, clazz);
    };
    return Toggler(off, on, has$1(element, clazz));
  };
  var has$1 = (element, clazz) => $_bxqp80yxjfuw8tlc.supports(element) && element.dom().classList.contains(clazz);
  const $_6po7jxyujfuw8tl0 = {
    add: add$2,
    remove: remove$4,
    toggle: toggle$1,
    toggler,
    has: has$1
  };

  const swap = (element, addCls, removeCls) => {
    $_6po7jxyujfuw8tl0.remove(element, removeCls);
    $_6po7jxyujfuw8tl0.add(element, addCls);
  };
  const toAlpha = (component, swapConfig, swapState) => {
    swap(component.element(), swapConfig.alpha(), swapConfig.omega());
  };
  const toOmega = (component, swapConfig, swapState) => {
    swap(component.element(), swapConfig.omega(), swapConfig.alpha());
  };
  const clear = (component, swapConfig, swapState) => {
    $_6po7jxyujfuw8tl0.remove(component.element(), swapConfig.alpha());
    $_6po7jxyujfuw8tl0.remove(component.element(), swapConfig.omega());
  };
  const isAlpha = (component, swapConfig, swapState) => $_6po7jxyujfuw8tl0.has(component.element(), swapConfig.alpha());
  const isOmega = (component, swapConfig, swapState) => $_6po7jxyujfuw8tl0.has(component.element(), swapConfig.omega());


  const SwapApis = Object.freeze({
    toAlpha,
    toOmega,
    isAlpha,
    isOmega,
    clear
  });

  const SwapSchema = [
    strict$1('alpha'),
    strict$1('omega')
  ];

  const Swapping = create$1({
    fields: SwapSchema,
    name: 'swapping',
    apis: SwapApis
  });

  const Cell = initial => {
    let value = initial;
    const get = () => value;
    const set = v => {
      value = v;
    };
    const clone = () => Cell(get());
    return {
      get,
      set,
      clone
    };
  };

  function ClosestOrAncestor (is, ancestor, scope, a, isRoot) {
    return is(scope, a) ? Option.some(scope) : $_8aqeo3wyjfuw8tb8.isFunction(isRoot) && isRoot(scope) ? Option.none() : ancestor(scope, a, isRoot);
  }

  const first$1 = predicate => descendant($_8634tqxhjfuw8tdl.body(), predicate);
  const ancestor = (scope, predicate, isRoot) => {
    let element = scope.dom();
    const stop = $_8aqeo3wyjfuw8tb8.isFunction(isRoot) ? isRoot : $_2vokfcwwjfuw8tb4.constant(false);
    while (element.parentNode) {
      element = element.parentNode;
      const el = $_bwdnu0xijfuw8tdo.fromDom(element);
      if (predicate(el))
        return Option.some(el);
      else if (stop(el))
        break;
    }
    return Option.none();
  };
  const closest = (scope, predicate, isRoot) => {
    const is = scope => predicate(scope);
    return ClosestOrAncestor(is, ancestor, scope, predicate, isRoot);
  };
  const sibling = (scope, predicate) => {
    const element = scope.dom();
    if (!element.parentNode)
      return Option.none();
    return child$1($_bwdnu0xijfuw8tdo.fromDom(element.parentNode), x => !$_4867a0xsjfuw8tej.eq(scope, x) && predicate(x));
  };
  var child$1 = (scope, predicate) => {
    const result = $_efmt4zxbjfuw8tcj.find(scope.dom().childNodes, $_2vokfcwwjfuw8tb4.compose(predicate, $_bwdnu0xijfuw8tdo.fromDom));
    return result.map($_bwdnu0xijfuw8tdo.fromDom);
  };
  var descendant = (scope, predicate) => {
    const descend = element => {
      for (let i = 0; i < element.childNodes.length; i++) {
        if (predicate($_bwdnu0xijfuw8tdo.fromDom(element.childNodes[i])))
          return Option.some($_bwdnu0xijfuw8tdo.fromDom(element.childNodes[i]));
        const res = descend(element.childNodes[i]);
        if (res.isSome())
          return res;
      }
      return Option.none();
    };
    return descend(scope.dom());
  };
  const $_d0h9pzz3jfuw8tlv = {
    first: first$1,
    ancestor,
    closest,
    sibling,
    child: child$1,
    descendant
  };

  const any$1 = predicate => $_d0h9pzz3jfuw8tlv.first(predicate).isSome();
  const ancestor$1 = (scope, predicate, isRoot) => $_d0h9pzz3jfuw8tlv.ancestor(scope, predicate, isRoot).isSome();
  const closest$1 = (scope, predicate, isRoot) => $_d0h9pzz3jfuw8tlv.closest(scope, predicate, isRoot).isSome();
  const sibling$1 = (scope, predicate) => $_d0h9pzz3jfuw8tlv.sibling(scope, predicate).isSome();
  const child$2 = (scope, predicate) => $_d0h9pzz3jfuw8tlv.child(scope, predicate).isSome();
  const descendant$1 = (scope, predicate) => $_d0h9pzz3jfuw8tlv.descendant(scope, predicate).isSome();
  const $_baqdvvz2jfuw8tlu = {
    any: any$1,
    ancestor: ancestor$1,
    closest: closest$1,
    sibling: sibling$1,
    child: child$2,
    descendant: descendant$1
  };

  const focus$2 = element => {
    element.dom().focus();
  };
  const blur = element => {
    element.dom().blur();
  };
  const hasFocus = element => {
    const doc = $_aff64dxmjfuw8tdx.owner(element).dom();
    return element.dom() === doc.activeElement;
  };
  const active = _doc => {
    const doc = _doc !== undefined ? _doc.dom() : document;
    return Option.from(doc.activeElement).map($_bwdnu0xijfuw8tdo.fromDom);
  };
  const focusInside = element => {
    const doc = $_aff64dxmjfuw8tdx.owner(element);
    const inside = active(doc).filter(a => $_baqdvvz2jfuw8tlu.closest(a, $_2vokfcwwjfuw8tb4.curry($_4867a0xsjfuw8tej.eq, element)));
    inside.fold(() => {
      focus$2(element);
    }, $_2vokfcwwjfuw8tb4.noop);
  };
  const search = element => active($_aff64dxmjfuw8tdx.owner(element)).filter(e => element.dom().contains(e.dom()));
  const $_f15fvwz1jfuw8tlo = {
    hasFocus,
    focus: focus$2,
    blur,
    active,
    search,
    focusInside
  };

  const global$1 = tinymce.util.Tools.resolve('tinymce.dom.DOMUtils');

  const global$2 = tinymce.util.Tools.resolve('tinymce.ThemeManager');

  const openLink = target => {
    const link = document.createElement('a');
    link.target = '_blank';
    link.href = target.href;
    link.rel = 'noreferrer noopener';
    const nuEvt = document.createEvent('MouseEvents');
    nuEvt.initMouseEvent('click', true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
    document.body.appendChild(link);
    link.dispatchEvent(nuEvt);
    document.body.removeChild(link);
  };
  const $_5567t9z7jfuw8tmd = { openLink };

  const isSkinDisabled = editor => editor.settings.skin === false;
  const readOnlyOnInit = editor => false;

  const formatChanged = 'formatChanged';
  const orientationChanged = 'orientationChanged';
  const dropupDismissed = 'dropupDismissed';
  const $_9e19stz9jfuw8tmf = {
    formatChanged: $_2vokfcwwjfuw8tb4.constant(formatChanged),
    orientationChanged: $_2vokfcwwjfuw8tb4.constant(orientationChanged),
    dropupDismissed: $_2vokfcwwjfuw8tb4.constant(dropupDismissed)
  };

  const fromHtml$1 = (html, scope) => {
    const doc = scope || document;
    const div = doc.createElement('div');
    div.innerHTML = html;
    return $_aff64dxmjfuw8tdx.children($_bwdnu0xijfuw8tdo.fromDom(div));
  };
  const fromTags = (tags, scope) => $_efmt4zxbjfuw8tcj.map(tags, x => $_bwdnu0xijfuw8tdo.fromTag(x, scope));
  const fromText$1 = (texts, scope) => $_efmt4zxbjfuw8tcj.map(texts, x => $_bwdnu0xijfuw8tdo.fromText(x, scope));
  const fromDom$1 = nodes => $_efmt4zxbjfuw8tcj.map(nodes, $_bwdnu0xijfuw8tdo.fromDom);
  const $_g5aj5lzgjfuw8tnm = {
    fromHtml: fromHtml$1,
    fromTags,
    fromText: fromText$1,
    fromDom: fromDom$1
  };

  const get$2 = element => element.dom().innerHTML;
  const set$1 = (element, content) => {
    const owner = $_aff64dxmjfuw8tdx.owner(element);
    const docDom = owner.dom();
    const fragment = $_bwdnu0xijfuw8tdo.fromDom(docDom.createDocumentFragment());
    const contentElements = $_g5aj5lzgjfuw8tnm.fromHtml(content, docDom);
    $_g8n2ewxzjfuw8tf7.append(fragment, contentElements);
    $_138z6jxyjfuw8tf4.empty(element);
    $_cwa5ncxljfuw8tdv.append(element, fragment);
  };
  const getOuter = element => {
    const container = $_bwdnu0xijfuw8tdo.fromTag('div');
    const clone = $_bwdnu0xijfuw8tdo.fromDom(element.dom().cloneNode(true));
    $_cwa5ncxljfuw8tdv.append(container, clone);
    return get$2(container);
  };
  const $_2dunqqzfjfuw8tnk = {
    get: get$2,
    set: set$1,
    getOuter
  };

  const clone$1 = (original, deep) => $_bwdnu0xijfuw8tdo.fromDom(original.dom().cloneNode(deep));
  const shallow$1 = original => clone$1(original, false);
  const deep$1 = original => clone$1(original, true);
  const shallowAs = (original, tag) => {
    const nu = $_bwdnu0xijfuw8tdo.fromTag(tag);
    const attributes = $_47adx7ywjfuw8tl3.clone(original);
    $_47adx7ywjfuw8tl3.setAll(nu, attributes);
    return nu;
  };
  const copy = (original, tag) => {
    const nu = shallowAs(original, tag);
    const cloneChildren = $_aff64dxmjfuw8tdx.children(deep$1(original));
    $_g8n2ewxzjfuw8tf7.append(nu, cloneChildren);
    return nu;
  };
  const mutate = (original, tag) => {
    const nu = shallowAs(original, tag);
    $_cwa5ncxljfuw8tdv.before(original, nu);
    const children = $_aff64dxmjfuw8tdx.children(original);
    $_g8n2ewxzjfuw8tf7.append(nu, children);
    $_138z6jxyjfuw8tf4.remove(original);
    return nu;
  };
  const $_2mjfk7zhjfuw8tnq = {
    shallow: shallow$1,
    shallowAs,
    deep: deep$1,
    copy,
    mutate
  };

  const getHtml = element => {
    const clone = $_2mjfk7zhjfuw8tnq.shallow(element);
    return $_2dunqqzfjfuw8tnk.getOuter(clone);
  };

  const element = elem => getHtml(elem);

  const chooseChannels = (channels, message) => message.universal() ? channels : $_efmt4zxbjfuw8tcj.filter(channels, ch => $_efmt4zxbjfuw8tcj.contains(message.channels(), ch));
  const events = receiveConfig => derive([run(receive(), (component, message) => {
      const channelMap = receiveConfig.channels();
      const channels = $_8qu224wzjfuw8tb9.keys(channelMap);
      const targetChannels = chooseChannels(channels, message);
      $_efmt4zxbjfuw8tcj.each(targetChannels, ch => {
        const channelInfo = channelMap[ch]();
        const channelSchema = channelInfo.schema();
        const data = asStructOrDie(`channel[${ch}] data\nReceiver: ${element(component.element())}`, channelSchema, message.data());
        channelInfo.onReceive()(component, data);
      });
    })]);


  const ActiveReceiving = Object.freeze({
    events
  });

  const cat = arr => {
    const r = [];
    const push = x => {
      r.push(x);
    };
    for (let i = 0; i < arr.length; i++) {
      arr[i].each(push);
    }
    return r;
  };
  const findMap = (arr, f) => {
    for (let i = 0; i < arr.length; i++) {
      const r = f(arr[i], i);
      if (r.isSome()) {
        return r;
      }
    }
    return Option.none();
  };
  const liftN = (arr, f) => {
    const r = [];

    for (const x of arr) {
      if (x.isSome()) {
        r.push(x.getOrDie());
      } else {
        return Option.none();
      }
    }

    return Option.some(f(...r));
  };
  const $_e8fwikzljfuw8tp3 = {
    cat,
    findMap,
    liftN
  };

  const unknown$3 = 'unknown';
  const debugging = true;
  const eventsMonitored = [];
  const path$1 = [
    'alloy/data/Fields',
    'alloy/debugging/Debugging'
  ];
  const getTrace = () => {
    if (debugging === false) {
      return unknown$3;
    }
    const err = new Error();
    if (err.stack !== undefined) {
      const lines = err.stack.split('\n');
      return $_efmt4zxbjfuw8tcj.find(lines, line => line.indexOf('alloy') > 0 && !$_efmt4zxbjfuw8tcj.exists(path$1, p => line.includes(p))).getOr(unknown$3);
    } else {
      return unknown$3;
    }
  };
  const ignoreEvent = {
    logEventCut: $_2vokfcwwjfuw8tb4.noop,
    logEventStopped: $_2vokfcwwjfuw8tb4.noop,
    logNoParent: $_2vokfcwwjfuw8tb4.noop,
    logEventNoHandlers: $_2vokfcwwjfuw8tb4.noop,
    logEventResponse: $_2vokfcwwjfuw8tb4.noop,
    write: $_2vokfcwwjfuw8tb4.noop
  };
  const monitorEvent = (eventName, initialTarget, f) => {
    const logger = debugging && (eventsMonitored === '*' || $_efmt4zxbjfuw8tcj.contains(eventsMonitored, eventName)) ? (() => {
      const sequence = [];
      return {
        logEventCut(name, target, purpose) {
          sequence.push({
            outcome: 'cut',
            target,
            purpose
          });
        },
        logEventStopped(name, target, purpose) {
          sequence.push({
            outcome: 'stopped',
            target,
            purpose
          });
        },
        logNoParent(name, target, purpose) {
          sequence.push({
            outcome: 'no-parent',
            target,
            purpose
          });
        },
        logEventNoHandlers(name, target) {
          sequence.push({
            outcome: 'no-handlers-left',
            target
          });
        },
        logEventResponse(name, target, purpose) {
          sequence.push({
            outcome: 'response',
            purpose,
            target
          });
        },
        write() {
          if ($_efmt4zxbjfuw8tcj.contains([
              'mousemove',
              'mouseover',
              'mouseout',
              systemInit()
            ], eventName)) {
            return;
          }
          console.log(eventName, {
            event: eventName,
            target: initialTarget.dom(),
            sequence: $_efmt4zxbjfuw8tcj.map(sequence, s => {
              if (!$_efmt4zxbjfuw8tcj.contains([
                  'cut',
                  'stopped',
                  'response'
                ], s.outcome)) {
                return s.outcome;
              } else {
                return `{${s.purpose}} ${s.outcome} at (${element(s.target)})`;
              }
            })
          });
        }
      };
    })() : ignoreEvent;
    const output = f(logger);
    logger.write();
    return output;
  };
  const noLogger = $_2vokfcwwjfuw8tb4.constant(ignoreEvent);
  const isDebugging = $_2vokfcwwjfuw8tb4.constant(debugging);

  const menuFields = $_2vokfcwwjfuw8tb4.constant([
    strict$1('menu'),
    strict$1('selectedMenu')
  ]);
  const itemFields = $_2vokfcwwjfuw8tb4.constant([
    strict$1('item'),
    strict$1('selectedItem')
  ]);
  const schema = $_2vokfcwwjfuw8tb4.constant(objOfOnly(itemFields().concat(menuFields())));
  const itemSchema = $_2vokfcwwjfuw8tb4.constant(objOfOnly(itemFields()));

  const _initSize = strictObjOf('initSize', [
    strict$1('numColumns'),
    strict$1('numRows')
  ]);
  const itemMarkers = () => strictOf('markers', itemSchema());
  const tieredMenuMarkers = () => strictObjOf('markers', [strict$1('backgroundMenu')].concat(menuFields()).concat(itemFields()));
  const markers = required => strictObjOf('markers', $_efmt4zxbjfuw8tcj.map(required, strict$1));
  const onPresenceHandler = (label, fieldName, presence) => {
    const trace = getTrace();
    return field(fieldName, fieldName, presence, valueOf(f => Result.value(function () {
      return f(...arguments);
    })));
  };
  const onHandler = fieldName => onPresenceHandler('onHandler', fieldName, defaulted($_2vokfcwwjfuw8tb4.noop));
  const onKeyboardHandler = fieldName => onPresenceHandler('onKeyboardHandler', fieldName, defaulted(Option.none));
  const onStrictHandler = fieldName => onPresenceHandler('onHandler', fieldName, strict());
  const onStrictKeyboardHandler = fieldName => onPresenceHandler('onKeyboardHandler', fieldName, strict());
  const output$1 = (name, value) => state$1(name, $_2vokfcwwjfuw8tb4.constant(value));
  const snapshot$1 = name => state$1(name, $_2vokfcwwjfuw8tb4.identity);
  const initSize = $_2vokfcwwjfuw8tb4.constant(_initSize);

  const ReceivingSchema = [strictOf('channels', setOf(Result.value, objOfOnly([
      onStrictHandler('onReceive'),
      defaulted$1('schema', anyValue$1())
    ])))];

  const Receiving = create$1({
    fields: ReceivingSchema,
    name: 'receiving',
    active: ActiveReceiving
  });

  const updateAriaState = (component, toggleConfig) => {
    const pressed = isOn(component, toggleConfig);
    const ariaInfo = toggleConfig.aria();
    ariaInfo.update()(component, ariaInfo, pressed);
  };
  const toggle$2 = (component, toggleConfig, toggleState) => {
    $_6po7jxyujfuw8tl0.toggle(component.element(), toggleConfig.toggleClass());
    updateAriaState(component, toggleConfig);
  };
  const on = (component, toggleConfig, toggleState) => {
    $_6po7jxyujfuw8tl0.add(component.element(), toggleConfig.toggleClass());
    updateAriaState(component, toggleConfig);
  };
  const off = (component, toggleConfig, toggleState) => {
    $_6po7jxyujfuw8tl0.remove(component.element(), toggleConfig.toggleClass());
    updateAriaState(component, toggleConfig);
  };
  var isOn = (component, toggleConfig) => $_6po7jxyujfuw8tl0.has(component.element(), toggleConfig.toggleClass());
  const onLoad = (component, toggleConfig, toggleState) => {
    const api = toggleConfig.selected() ? on : off;
    api(component, toggleConfig, toggleState);
  };


  const ToggleApis = Object.freeze({
    onLoad,
    toggle: toggle$2,
    isOn,
    on,
    off
  });

  const exhibit = (base, toggleConfig, toggleState) => nu$6({});
  const events$1 = (toggleConfig, toggleState) => {
    const execute = executeEvent(toggleConfig, toggleState, toggle$2);
    const load = loadEvent(toggleConfig, toggleState, onLoad);
    return derive($_efmt4zxbjfuw8tcj.flatten([
      toggleConfig.toggleOnExecute() ? [execute] : [],
      [load]
    ]));
  };


  const ActiveToggle = Object.freeze({
    exhibit,
    events: events$1
  });

  const updatePressed = (component, ariaInfo, status) => {
    $_47adx7ywjfuw8tl3.set(component.element(), 'aria-pressed', status);
    if (ariaInfo.syncWithExpanded()) {
      updateExpanded(component, ariaInfo, status);
    }
  };
  const updateSelected = (component, ariaInfo, status) => {
    $_47adx7ywjfuw8tl3.set(component.element(), 'aria-selected', status);
  };
  const updateChecked = (component, ariaInfo, status) => {
    $_47adx7ywjfuw8tl3.set(component.element(), 'aria-checked', status);
  };
  var updateExpanded = (component, ariaInfo, status) => {
    $_47adx7ywjfuw8tl3.set(component.element(), 'aria-expanded', status);
  };

  const ToggleSchema = [
    defaulted$1('selected', false),
    strict$1('toggleClass'),
    defaulted$1('toggleOnExecute', true),
    defaultedOf('aria', { mode: 'none' }, choose$1('mode', {
      pressed: [
        defaulted$1('syncWithExpanded', false),
        output$1('update', updatePressed)
      ],
      checked: [output$1('update', updateChecked)],
      expanded: [output$1('update', updateExpanded)],
      selected: [output$1('update', updateSelected)],
      none: [output$1('update', $_2vokfcwwjfuw8tb4.noop)]
    }))
  ];

  const Toggling = create$1({
    fields: ToggleSchema,
    name: 'toggling',
    active: ActiveToggle,
    apis: ToggleApis
  });

  const format = (command, update) => Receiving.config({
    channels: wrap$2($_9e19stz9jfuw8tmf.formatChanged(), {
      onReceive(button, data) {
        if (data.command === command) {
          update(button, data.state);
        }
      }
    })
  });
  const orientation = onReceive => Receiving.config({ channels: wrap$2($_9e19stz9jfuw8tmf.orientationChanged(), { onReceive }) });
  const receive$1 = (channel, onReceive) => ({
    key: channel,
    value: { onReceive }
  });
  const $_9de9iyzsjfuw8tqa = {
    format,
    orientation,
    receive: receive$1
  };

  const prefix = 'tinymce-mobile';
  const resolve$1 = p => `${prefix}-${p}`;
  const $_2fp9skztjfuw8tqe = {
    resolve: resolve$1,
    prefix: $_2vokfcwwjfuw8tb4.constant(prefix)
  };

  const events$2 = optAction => {
    const executeHandler = action => run(execute(), (component, simulatedEvent) => {
      action(component);
      simulatedEvent.stop();
    });
    const onClick = (component, simulatedEvent) => {
      simulatedEvent.stop();
      emitExecute(component);
    };
    const onMousedown = (component, simulatedEvent) => {
      simulatedEvent.cut();
    };
    const pointerEvents = $_5reqwox3jfuw8tbu.detect().deviceType.isTouch() ? [run(tap(), onClick)] : [
      run(click(), onClick),
      run(mousedown(), onMousedown)
    ];
    return derive($_efmt4zxbjfuw8tcj.flatten([
      optAction.map(executeHandler).toArray(),
      pointerEvents
    ]));
  };

  const focus$3 = (component, focusConfig) => {
    if (!focusConfig.ignore()) {
      $_f15fvwz1jfuw8tlo.focus(component.element());
      focusConfig.onFocus()(component);
    }
  };
  const blur$1 = (component, focusConfig) => {
    if (!focusConfig.ignore()) {
      $_f15fvwz1jfuw8tlo.blur(component.element());
    }
  };
  const isFocused = component => $_f15fvwz1jfuw8tlo.hasFocus(component.element());


  const FocusApis = Object.freeze({
    focus: focus$3,
    blur: blur$1,
    isFocused
  });

  const exhibit$1 = (base, focusConfig) => {
    if (focusConfig.ignore()) {
      return nu$6({});
    } else {
      return nu$6({ attributes: { tabindex: '-1' } });
    }
  };
  const events$3 = focusConfig => derive([run(focus$1(), (component, simulatedEvent) => {
      focus$3(component, focusConfig);
      simulatedEvent.stop();
    })]);


  const ActiveFocus = Object.freeze({
    exhibit: exhibit$1,
    events: events$3
  });

  const FocusSchema = [
    onHandler('onFocus'),
    defaulted$1('ignore', false)
  ];

  const Focusing = create$1({
    fields: FocusSchema,
    name: 'focusing',
    active: ActiveFocus,
    apis: FocusApis
  });

  const isSupported = dom => dom.style !== undefined;
  const $_9wm1ea107jfuw8tss = { isSupported };

  const internalSet = (dom, property, value) => {
    if (!$_8aqeo3wyjfuw8tb8.isString(value)) {
      console.error('Invalid call to CSS.set. Property ', property, ':: Value ', value, ':: Element ', dom);
      throw new Error(`CSS value must be a string: ${value}`);
    }
    if ($_9wm1ea107jfuw8tss.isSupported(dom))
      dom.style.setProperty(property, value);
  };
  const internalRemove = (dom, property) => {
    if ($_9wm1ea107jfuw8tss.isSupported(dom))
      dom.style.removeProperty(property);
  };
  const set$2 = (element, property, value) => {
    const dom = element.dom();
    internalSet(dom, property, value);
  };
  const setAll$1 = (element, css) => {
    const dom = element.dom();
    $_8qu224wzjfuw8tb9.each(css, (v, k) => {
      internalSet(dom, k, v);
    });
  };
  const setOptions = (element, css) => {
    const dom = element.dom();
    $_8qu224wzjfuw8tb9.each(css, (v, k) => {
      v.fold(() => {
        internalRemove(dom, k);
      }, value => {
        internalSet(dom, k, value);
      });
    });
  };
  const get$3 = (element, property) => {
    const dom = element.dom();
    const styles = window.getComputedStyle(dom);
    const r = styles.getPropertyValue(property);
    const v = r === '' && !$_8634tqxhjfuw8tdl.inBody(element) ? getUnsafeProperty(dom, property) : r;
    return v === null ? undefined : v;
  };
  var getUnsafeProperty = (dom, property) => $_9wm1ea107jfuw8tss.isSupported(dom) ? dom.style.getPropertyValue(property) : '';
  const getRaw = (element, property) => {
    const dom = element.dom();
    const raw = getUnsafeProperty(dom, property);
    return Option.from(raw).filter(r => r.length > 0);
  };
  const getAllRaw = element => {
    const css = {};
    const dom = element.dom();
    if ($_9wm1ea107jfuw8tss.isSupported(dom)) {
      for (let i = 0; i < dom.style.length; i++) {
        const ruleName = dom.style.item(i);
        css[ruleName] = dom.style[ruleName];
      }
    }
    return css;
  };
  const isValidValue = (tag, property, value) => {
    const element = $_bwdnu0xijfuw8tdo.fromTag(tag);
    set$2(element, property, value);
    const style = getRaw(element, property);
    return style.isSome();
  };
  const remove$5 = (element, property) => {
    const dom = element.dom();
    internalRemove(dom, property);
    if ($_47adx7ywjfuw8tl3.has(element, 'style') && $_b463kaxdjfuw8tcv.trim($_47adx7ywjfuw8tl3.get(element, 'style')) === '') {
      $_47adx7ywjfuw8tl3.remove(element, 'style');
    }
  };
  const preserve = (element, f) => {
    const oldStyles = $_47adx7ywjfuw8tl3.get(element, 'style');
    const result = f(element);
    const restore = oldStyles === undefined ? $_47adx7ywjfuw8tl3.remove : $_47adx7ywjfuw8tl3.set;
    restore(element, 'style', oldStyles);
    return result;
  };
  const copy$1 = (source, target) => {
    const sourceDom = source.dom();
    const targetDom = target.dom();
    if ($_9wm1ea107jfuw8tss.isSupported(sourceDom) && $_9wm1ea107jfuw8tss.isSupported(targetDom)) {
      targetDom.style.cssText = sourceDom.style.cssText;
    }
  };
  const reflow = e => e.dom().offsetWidth;
  const transferOne$1 = (source, destination, style) => {
    getRaw(source, style).each(value => {
      if (getRaw(destination, style).isNone())
        set$2(destination, style, value);
    });
  };
  const transfer$1 = (source, destination, styles) => {
    if (!$_74lhjaxjjfuw8tdt.isElement(source) || !$_74lhjaxjjfuw8tdt.isElement(destination))
      return;
    $_efmt4zxbjfuw8tcj.each(styles, style => {
      transferOne$1(source, destination, style);
    });
  };
  const $_aag5ti106jfuw8tse = {
    copy: copy$1,
    set: set$2,
    preserve,
    setAll: setAll$1,
    setOptions,
    remove: remove$5,
    get: get$3,
    getRaw,
    getAllRaw,
    isValidValue,
    reflow,
    transfer: transfer$1
  };

  function Dimension (name, getOffset) {
    const set = (element, h) => {
      if (!$_8aqeo3wyjfuw8tb8.isNumber(h) && !h.match(/^[0-9]+$/))
        throw `${name}.set accepts only positive integer values. Value was ${h}`;
      const dom = element.dom();
      if ($_9wm1ea107jfuw8tss.isSupported(dom))
        dom.style[name] = `${h}px`;
    };
    const get = element => {
      const r = getOffset(element);
      if (r <= 0 || r === null) {
        const css = $_aag5ti106jfuw8tse.get(element, name);
        return parseFloat(css) || 0;
      }
      return r;
    };
    const getOuter = get;
    const aggregate = (element, properties) => $_efmt4zxbjfuw8tcj.foldl(properties, (acc, property) => {
      const val = $_aag5ti106jfuw8tse.get(element, property);
      const value = val === undefined ? 0 : parseInt(val, 10);
      return isNaN(value) ? acc : acc + value;
    }, 0);
    const max = (element, value, properties) => {
      const cumulativeInclusions = aggregate(element, properties);
      const absoluteMax = value > cumulativeInclusions ? value - cumulativeInclusions : 0;
      return absoluteMax;
    };
    return {
      set,
      get,
      getOuter,
      aggregate,
      max
    };
  }

  const api = Dimension('height', element => $_8634tqxhjfuw8tdl.inBody(element) ? element.dom().getBoundingClientRect().height : element.dom().offsetHeight);
  const set$3 = (element, h) => {
    api.set(element, h);
  };
  const get$4 = element => api.get(element);
  const getOuter$1 = element => api.getOuter(element);
  const setMax = (element, value) => {
    const inclusions = [
      'margin-top',
      'border-top-width',
      'padding-top',
      'padding-bottom',
      'border-bottom-width',
      'margin-bottom'
    ];
    const absMax = api.max(element, value, inclusions);
    $_aag5ti106jfuw8tse.set(element, 'max-height', `${absMax}px`);
  };
  const $_sgteu105jfuw8tsc = {
    set: set$3,
    get: get$4,
    getOuter: getOuter$1,
    setMax
  };

  const all$2 = predicate => descendants($_8634tqxhjfuw8tdl.body(), predicate);
  const ancestors = (scope, predicate, isRoot) => $_efmt4zxbjfuw8tcj.filter($_aff64dxmjfuw8tdx.parents(scope, isRoot), predicate);
  const siblings$1 = (scope, predicate) => $_efmt4zxbjfuw8tcj.filter($_aff64dxmjfuw8tdx.siblings(scope), predicate);
  const children$1 = (scope, predicate) => $_efmt4zxbjfuw8tcj.filter($_aff64dxmjfuw8tdx.children(scope), predicate);
  var descendants = (scope, predicate) => {
    let result = [];
    $_efmt4zxbjfuw8tcj.each($_aff64dxmjfuw8tdx.children(scope), x => {
      if (predicate(x)) {
        result = result.concat([x]);
      }
      result = result.concat(descendants(x, predicate));
    });
    return result;
  };
  const $_94lmux10ajfuw8tt4 = {
    all: all$2,
    ancestors,
    siblings: siblings$1,
    children: children$1,
    descendants
  };

  const all$3 = selector => $_gem9gixxjfuw8tey.all(selector);
  const ancestors$1 = (scope, selector, isRoot) => $_94lmux10ajfuw8tt4.ancestors(scope, e => $_gem9gixxjfuw8tey.is(e, selector), isRoot);
  const siblings$2 = (scope, selector) => $_94lmux10ajfuw8tt4.siblings(scope, e => $_gem9gixxjfuw8tey.is(e, selector));
  const children$2 = (scope, selector) => $_94lmux10ajfuw8tt4.children(scope, e => $_gem9gixxjfuw8tey.is(e, selector));
  const descendants$1 = (scope, selector) => $_gem9gixxjfuw8tey.all(selector, scope);
  const $_951f03109jfuw8tt3 = {
    all: all$3,
    ancestors: ancestors$1,
    siblings: siblings$2,
    children: children$2,
    descendants: descendants$1
  };

  const first$2 = selector => $_gem9gixxjfuw8tey.one(selector);
  const ancestor$2 = (scope, selector, isRoot) => $_d0h9pzz3jfuw8tlv.ancestor(scope, e => $_gem9gixxjfuw8tey.is(e, selector), isRoot);
  const sibling$2 = (scope, selector) => $_d0h9pzz3jfuw8tlv.sibling(scope, e => $_gem9gixxjfuw8tey.is(e, selector));
  const child$3 = (scope, selector) => $_d0h9pzz3jfuw8tlv.child(scope, e => $_gem9gixxjfuw8tey.is(e, selector));
  const descendant$2 = (scope, selector) => $_gem9gixxjfuw8tey.one(selector, scope);
  const closest$2 = (scope, selector, isRoot) => ClosestOrAncestor($_gem9gixxjfuw8tey.is, ancestor$2, scope, selector, isRoot);
  const $_c8lemt10bjfuw8tt8 = {
    first: first$2,
    ancestor: ancestor$2,
    sibling: sibling$2,
    child: child$3,
    descendant: descendant$2,
    closest: closest$2
  };

  const $_cy6bab10cjfuw8tt9 = {
    BACKSPACE: $_2vokfcwwjfuw8tb4.constant([8]),
    TAB: $_2vokfcwwjfuw8tb4.constant([9]),
    ENTER: $_2vokfcwwjfuw8tb4.constant([13]),
    SHIFT: $_2vokfcwwjfuw8tb4.constant([16]),
    CTRL: $_2vokfcwwjfuw8tb4.constant([17]),
    ALT: $_2vokfcwwjfuw8tb4.constant([18]),
    CAPSLOCK: $_2vokfcwwjfuw8tb4.constant([20]),
    ESCAPE: $_2vokfcwwjfuw8tb4.constant([27]),
    SPACE: $_2vokfcwwjfuw8tb4.constant([32]),
    PAGEUP: $_2vokfcwwjfuw8tb4.constant([33]),
    PAGEDOWN: $_2vokfcwwjfuw8tb4.constant([34]),
    END: $_2vokfcwwjfuw8tb4.constant([35]),
    HOME: $_2vokfcwwjfuw8tb4.constant([36]),
    LEFT: $_2vokfcwwjfuw8tb4.constant([37]),
    UP: $_2vokfcwwjfuw8tb4.constant([38]),
    RIGHT: $_2vokfcwwjfuw8tb4.constant([39]),
    DOWN: $_2vokfcwwjfuw8tb4.constant([40]),
    INSERT: $_2vokfcwwjfuw8tb4.constant([45]),
    DEL: $_2vokfcwwjfuw8tb4.constant([46]),
    META: $_2vokfcwwjfuw8tb4.constant([
      91,
      93,
      224
    ]),
    F10: $_2vokfcwwjfuw8tb4.constant([121])
  };

  const cyclePrev = (values, index, predicate) => {
    const before = $_efmt4zxbjfuw8tcj.reverse(values.slice(0, index));
    const after = $_efmt4zxbjfuw8tcj.reverse(values.slice(index + 1));
    return $_efmt4zxbjfuw8tcj.find(before.concat(after), predicate);
  };
  const tryPrev = (values, index, predicate) => {
    const before = $_efmt4zxbjfuw8tcj.reverse(values.slice(0, index));
    return $_efmt4zxbjfuw8tcj.find(before, predicate);
  };
  const cycleNext = (values, index, predicate) => {
    const before = values.slice(0, index);
    const after = values.slice(index + 1);
    return $_efmt4zxbjfuw8tcj.find(after.concat(before), predicate);
  };
  const tryNext = (values, index, predicate) => {
    const after = values.slice(index + 1);
    return $_efmt4zxbjfuw8tcj.find(after, predicate);
  };

  const inSet = keys => event => $_efmt4zxbjfuw8tcj.contains(keys, event.raw().which);
  const and = preds => event => $_efmt4zxbjfuw8tcj.forall(preds, pred => pred(event));
  const isShift = event => event.raw().shiftKey === true;
  const isControl = event => event.raw().ctrlKey === true;
  const isNotControl = $_2vokfcwwjfuw8tb4.not(isControl);
  const isNotShift = $_2vokfcwwjfuw8tb4.not(isShift);

  const rule = (matches, action) => ({
    matches,
    classification: action
  });
  const choose$2 = (transitions, event) => {
    const transition = $_efmt4zxbjfuw8tcj.find(transitions, t => t.matches(event));
    return transition.map(t => t.classification);
  };

  const cycleBy = (value, delta, min, max) => {
    const r = value + delta;
    if (r > max) {
      return min;
    } else {
      return r < min ? max : r;
    }
  };
  const cap = (value, min, max) => {
    if (value <= min) {
      return min;
    } else {
      return value >= max ? max : value;
    }
  };

  const dehighlightAll = (component, hConfig, hState) => {
    const highlighted = $_951f03109jfuw8tt3.descendants(component.element(), `.${hConfig.highlightClass()}`);
    $_efmt4zxbjfuw8tcj.each(highlighted, h => {
      $_6po7jxyujfuw8tl0.remove(h, hConfig.highlightClass());
      component.getSystem().getByDom(h).each(target => {
        hConfig.onDehighlight()(component, target);
      });
    });
  };
  const dehighlight = (component, hConfig, hState, target) => {
    const wasHighlighted = isHighlighted(component, hConfig, hState, target);
    $_6po7jxyujfuw8tl0.remove(target.element(), hConfig.highlightClass());
    if (wasHighlighted) {
      hConfig.onDehighlight()(component, target);
    }
  };
  const highlight = (component, hConfig, hState, target) => {
    const wasHighlighted = isHighlighted(component, hConfig, hState, target);
    dehighlightAll(component, hConfig, hState);
    $_6po7jxyujfuw8tl0.add(target.element(), hConfig.highlightClass());
    if (!wasHighlighted) {
      hConfig.onHighlight()(component, target);
    }
  };
  const highlightFirst = (component, hConfig, hState) => {
    getFirst(component, hConfig, hState).each(firstComp => {
      highlight(component, hConfig, hState, firstComp);
    });
  };
  const highlightLast = (component, hConfig, hState) => {
    getLast(component, hConfig, hState).each(lastComp => {
      highlight(component, hConfig, hState, lastComp);
    });
  };
  const highlightAt = (component, hConfig, hState, index) => {
    getByIndex(component, hConfig, hState, index).fold(err => {
      throw new Error(err);
    }, firstComp => {
      highlight(component, hConfig, hState, firstComp);
    });
  };
  const highlightBy = (component, hConfig, hState, predicate) => {
    const items = $_951f03109jfuw8tt3.descendants(component.element(), `.${hConfig.itemClass()}`);
    const itemComps = $_e8fwikzljfuw8tp3.cat($_efmt4zxbjfuw8tcj.map(items, i => component.getSystem().getByDom(i).toOption()));
    const targetComp = $_efmt4zxbjfuw8tcj.find(itemComps, predicate);
    targetComp.each(c => {
      highlight(component, hConfig, hState, c);
    });
  };
  var isHighlighted = (component, hConfig, hState, queryTarget) => $_6po7jxyujfuw8tl0.has(queryTarget.element(), hConfig.highlightClass());
  const getHighlighted = (component, hConfig, hState) => $_c8lemt10bjfuw8tt8.descendant(component.element(), `.${hConfig.highlightClass()}`).bind(component.getSystem().getByDom);
  var getByIndex = (component, hConfig, hState, index) => {
    const items = $_951f03109jfuw8tt3.descendants(component.element(), `.${hConfig.itemClass()}`);
    return Option.from(items[index]).fold(() => Result.error(`No element found with index ${index}`), component.getSystem().getByDom);
  };
  var getFirst = (component, hConfig, hState) => $_c8lemt10bjfuw8tt8.descendant(component.element(), `.${hConfig.itemClass()}`).bind(component.getSystem().getByDom);
  var getLast = (component, hConfig, hState) => {
    const items = $_951f03109jfuw8tt3.descendants(component.element(), `.${hConfig.itemClass()}`);
    const last = items.length > 0 ? Option.some(items[items.length - 1]) : Option.none();
    return last.bind(component.getSystem().getByDom);
  };
  const getDelta = (component, hConfig, hState, delta) => {
    const items = $_951f03109jfuw8tt3.descendants(component.element(), `.${hConfig.itemClass()}`);
    const current = $_efmt4zxbjfuw8tcj.findIndex(items, item => $_6po7jxyujfuw8tl0.has(item, hConfig.highlightClass()));
    return current.bind(selected => {
      const dest = cycleBy(selected, delta, 0, items.length - 1);
      return component.getSystem().getByDom(items[dest]);
    });
  };
  const getPrevious = (component, hConfig, hState) => getDelta(component, hConfig, hState, -1);
  const getNext = (component, hConfig, hState) => getDelta(component, hConfig, hState, +1);


  const HighlightApis = Object.freeze({
    dehighlightAll,
    dehighlight,
    highlight,
    highlightFirst,
    highlightLast,
    highlightAt,
    highlightBy,
    isHighlighted,
    getHighlighted,
    getFirst,
    getLast,
    getPrevious,
    getNext
  });

  const HighlightSchema = [
    strict$1('highlightClass'),
    strict$1('itemClass'),
    onHandler('onHighlight'),
    onHandler('onDehighlight')
  ];

  const Highlighting = create$1({
    fields: HighlightSchema,
    name: 'highlighting',
    apis: HighlightApis
  });

  const dom = () => {
    const get = component => $_f15fvwz1jfuw8tlo.search(component.element());
    const set = (component, focusee) => {
      component.getSystem().triggerFocus(focusee, component.element());
    };
    return {
      get,
      set
    };
  };
  const highlights = () => {
    const get = component => Highlighting.getHighlighted(component).map(item => item.element());
    const set = (component, element) => {
      component.getSystem().getByDom(element).fold($_2vokfcwwjfuw8tb4.noop, item => {
        Highlighting.highlight(component, item);
      });
    };
    return {
      get,
      set
    };
  };

  const typical = (infoSchema, stateInit, getRules, getEvents, getApis, optFocusIn) => {
    const schema = () => infoSchema.concat([
      defaulted$1('focusManager', dom()),
      output$1('handler', me),
      output$1('state', stateInit)
    ]);
    const processKey = (component, simulatedEvent, keyingConfig, keyingState) => {
      const rules = getRules(component, simulatedEvent, keyingConfig, keyingState);
      return choose$2(rules, simulatedEvent.event()).bind(rule$$1 => rule$$1(component, simulatedEvent, keyingConfig, keyingState));
    };
    const toEvents = (keyingConfig, keyingState) => {
      const otherEvents = getEvents(keyingConfig, keyingState);
      const keyEvents = derive(optFocusIn.map(focusIn => run(focus$1(), (component, simulatedEvent) => {
        focusIn(component, keyingConfig, keyingState, simulatedEvent);
        simulatedEvent.stop();
      })).toArray().concat([run(keydown(), (component, simulatedEvent) => {
          processKey(component, simulatedEvent, keyingConfig, keyingState).each(_ => {
            simulatedEvent.stop();
          });
        })]));
      return $_3jctjywxjfuw8tb6.deepMerge(otherEvents, keyEvents);
    };
    var me = {
      schema,
      processKey,
      toEvents,
      toApis: getApis
    };
    return me;
  };

  const create$2 = cyclicField => {
    const schema = [
      option('onEscape'),
      option('onEnter'),
      defaulted$1('selector', '[data-alloy-tabstop="true"]'),
      defaulted$1('firstTabstop', 0),
      defaulted$1('useTabstopAt', $_2vokfcwwjfuw8tb4.constant(true)),
      option('visibilitySelector')
    ].concat([cyclicField]);
    const isVisible = (tabbingConfig, element) => {
      const target = tabbingConfig.visibilitySelector().bind(sel => $_c8lemt10bjfuw8tt8.closest(element, sel)).getOr(element);
      return $_sgteu105jfuw8tsc.get(target) > 0;
    };
    const findInitial = (component, tabbingConfig) => {
      const tabstops = $_951f03109jfuw8tt3.descendants(component.element(), tabbingConfig.selector());
      const visibles = $_efmt4zxbjfuw8tcj.filter(tabstops, elem => isVisible(tabbingConfig, elem));
      return Option.from(visibles[tabbingConfig.firstTabstop()]);
    };
    const findCurrent = (component, tabbingConfig) => tabbingConfig.focusManager().get(component).bind(elem => $_c8lemt10bjfuw8tt8.closest(elem, tabbingConfig.selector()));
    const isTabstop = (tabbingConfig, element) => isVisible(tabbingConfig, element) && tabbingConfig.useTabstopAt()(element);
    const focusIn = (component, tabbingConfig, tabbingState) => {
      findInitial(component, tabbingConfig).each(target => {
        tabbingConfig.focusManager().set(component, target);
      });
    };
    const goFromTabstop = (component, tabstops, stopIndex, tabbingConfig, cycle) => cycle(tabstops, stopIndex, elem => isTabstop(tabbingConfig, elem)).fold(() => tabbingConfig.cyclic() ? Option.some(true) : Option.none(), target => {
      tabbingConfig.focusManager().set(component, target);
      return Option.some(true);
    });
    const go = (component, simulatedEvent, tabbingConfig, cycle) => {
      const tabstops = $_951f03109jfuw8tt3.descendants(component.element(), tabbingConfig.selector());
      return findCurrent(component, tabbingConfig).bind(tabstop => {
        const optStopIndex = $_efmt4zxbjfuw8tcj.findIndex(tabstops, $_2vokfcwwjfuw8tb4.curry($_4867a0xsjfuw8tej.eq, tabstop));
        return optStopIndex.bind(stopIndex => goFromTabstop(component, tabstops, stopIndex, tabbingConfig, cycle));
      });
    };
    const goBackwards = (component, simulatedEvent, tabbingConfig, tabbingState) => {
      const navigate = tabbingConfig.cyclic() ? cyclePrev : tryPrev;
      return go(component, simulatedEvent, tabbingConfig, navigate);
    };
    const goForwards = (component, simulatedEvent, tabbingConfig, tabbingState) => {
      const navigate = tabbingConfig.cyclic() ? cycleNext : tryNext;
      return go(component, simulatedEvent, tabbingConfig, navigate);
    };
    const execute = (component, simulatedEvent, tabbingConfig, tabbingState) => tabbingConfig.onEnter().bind(f => f(component, simulatedEvent));
    const exit = (component, simulatedEvent, tabbingConfig, tabbingState) => tabbingConfig.onEscape().bind(f => f(component, simulatedEvent));
    const getRules = $_2vokfcwwjfuw8tb4.constant([
      rule(and([
        isShift,
        inSet($_cy6bab10cjfuw8tt9.TAB())
      ]), goBackwards),
      rule(inSet($_cy6bab10cjfuw8tt9.TAB()), goForwards),
      rule(inSet($_cy6bab10cjfuw8tt9.ESCAPE()), exit),
      rule(and([
        isNotShift,
        inSet($_cy6bab10cjfuw8tt9.ENTER())
      ]), execute)
    ]);
    const getEvents = $_2vokfcwwjfuw8tb4.constant({});
    const getApis = $_2vokfcwwjfuw8tb4.constant({});
    return typical(schema, init, getRules, getEvents, getApis, Option.some(focusIn));
  };

  const AcyclicType = create$2(state$1('cyclic', $_2vokfcwwjfuw8tb4.constant(false)));

  const CyclicType = create$2(state$1('cyclic', $_2vokfcwwjfuw8tb4.constant(true)));

  const inside = target => $_74lhjaxjjfuw8tdt.name(target) === 'input' && $_47adx7ywjfuw8tl3.get(target, 'type') !== 'radio' || $_74lhjaxjjfuw8tdt.name(target) === 'textarea';

  const doDefaultExecute = (component, simulatedEvent, focused) => {
    dispatch(component, focused, execute());
    return Option.some(true);
  };
  const defaultExecute = (component, simulatedEvent, focused) => inside(focused) && inSet($_cy6bab10cjfuw8tt9.SPACE())(simulatedEvent.event()) ? Option.none() : doDefaultExecute(component, simulatedEvent, focused);

  const schema$1 = [
    defaulted$1('execute', defaultExecute),
    defaulted$1('useSpace', false),
    defaulted$1('useEnter', true),
    defaulted$1('useControlEnter', false),
    defaulted$1('useDown', false)
  ];
  const execute$1 = (component, simulatedEvent, executeConfig, executeState) => executeConfig.execute()(component, simulatedEvent, component.element());
  const getRules = (component, simulatedEvent, executeConfig, executeState) => {
    const spaceExec = executeConfig.useSpace() && !inside(component.element()) ? $_cy6bab10cjfuw8tt9.SPACE() : [];
    const enterExec = executeConfig.useEnter() ? $_cy6bab10cjfuw8tt9.ENTER() : [];
    const downExec = executeConfig.useDown() ? $_cy6bab10cjfuw8tt9.DOWN() : [];
    const execKeys = spaceExec.concat(enterExec).concat(downExec);
    return [rule(inSet(execKeys), execute$1)].concat(executeConfig.useControlEnter() ? [rule(and([
        isControl,
        inSet($_cy6bab10cjfuw8tt9.ENTER())
      ]), execute$1)] : []);
  };
  const getEvents = $_2vokfcwwjfuw8tb4.constant({});
  const getApis = $_2vokfcwwjfuw8tb4.constant({});
  const ExecutionType = typical(schema$1, init, getRules, getEvents, getApis, Option.none());

  const flatgrid = spec => {
    const dimensions = Cell(Option.none());
    const setGridSize = (numRows, numColumns) => {
      dimensions.set(Option.some({
        numRows: $_2vokfcwwjfuw8tb4.constant(numRows),
        numColumns: $_2vokfcwwjfuw8tb4.constant(numColumns)
      }));
    };
    const getNumRows = () => dimensions.get().map(d => d.numRows());
    const getNumColumns = () => dimensions.get().map(d => d.numColumns());
    return BehaviourState({
      readState: $_2vokfcwwjfuw8tb4.constant({}),
      setGridSize,
      getNumRows,
      getNumColumns
    });
  };
  const init$1 = spec => spec.state()(spec);


  const KeyingState = Object.freeze({
    flatgrid,
    init: init$1
  });

  const onDirection = (isLtr, isRtl) => element => getDirection(element) === 'rtl' ? isRtl : isLtr;
  var getDirection = element => $_aag5ti106jfuw8tse.get(element, 'direction') === 'rtl' ? 'rtl' : 'ltr';
  const $_7wrg0f10tjfuw8tw7 = {
    onDirection,
    getDirection
  };

  const useH = movement => (component, simulatedEvent, config, state) => {
    const move = movement(component.element());
    return use(move, component, simulatedEvent, config, state);
  };
  const west = (moveLeft, moveRight) => {
    const movement = $_7wrg0f10tjfuw8tw7.onDirection(moveLeft, moveRight);
    return useH(movement);
  };
  const east = (moveLeft, moveRight) => {
    const movement = $_7wrg0f10tjfuw8tw7.onDirection(moveRight, moveLeft);
    return useH(movement);
  };
  const useV = move => (component, simulatedEvent, config, state) => use(move, component, simulatedEvent, config, state);
  var use = (move, component, simulatedEvent, config, state) => {
    const outcome = config.focusManager().get(component).bind(focused => move(component.element(), focused, config, state));
    return outcome.map(newFocus => {
      config.focusManager().set(component, newFocus);
      return true;
    });
  };
  const north = useV;
  const south = useV;
  const move = useV;

  const visibilityToggler = (element, property, hiddenValue, visibleValue) => {
    let initial = $_aag5ti106jfuw8tse.get(element, property);
    if (initial === undefined)
      initial = '';
    const value = initial === hiddenValue ? visibleValue : hiddenValue;
    const off = $_2vokfcwwjfuw8tb4.curry($_aag5ti106jfuw8tse.set, element, property, initial);
    const on = $_2vokfcwwjfuw8tb4.curry($_aag5ti106jfuw8tse.set, element, property, value);
    return Toggler(off, on, false);
  };
  const toggler$1 = element => visibilityToggler(element, 'visibility', 'hidden', 'visible');
  const displayToggler = (element, value) => visibilityToggler(element, 'display', 'none', value);
  const isHidden = dom => dom.offsetWidth <= 0 && dom.offsetHeight <= 0;
  const isVisible = element => {
    const dom = element.dom();
    return !isHidden(dom);
  };
  const $_cdppfu10vjfuw8twl = {
    toggler: toggler$1,
    displayToggler,
    isVisible
  };

  const indexInfo = $_4xhupwxnjfuw8tea.immutableBag([
    'index',
    'candidates'
  ], []);
  const locate = (candidates, predicate) => $_efmt4zxbjfuw8tcj.findIndex(candidates, predicate).map(index => indexInfo({
    index,
    candidates
  }));

  const locateVisible = (container, current, selector) => {
    const filter = $_cdppfu10vjfuw8twl.isVisible;
    return locateIn(container, current, selector, filter);
  };
  var locateIn = (container, current, selector, filter) => {
    const predicate = $_2vokfcwwjfuw8tb4.curry($_4867a0xsjfuw8tej.eq, current);
    const candidates = $_951f03109jfuw8tt3.descendants(container, selector);
    const visible = $_efmt4zxbjfuw8tcj.filter(candidates, $_cdppfu10vjfuw8twl.isVisible);
    return locate(visible, predicate);
  };
  const findIndex$2 = (elements, target) => $_efmt4zxbjfuw8tcj.findIndex(elements, elem => $_4867a0xsjfuw8tej.eq(target, elem));

  const withGrid = (values, index, numCols, f) => {
    const oldRow = Math.floor(index / numCols);
    const oldColumn = index % numCols;
    return f(oldRow, oldColumn).bind(address => {
      const newIndex = address.row() * numCols + address.column();
      return newIndex >= 0 && newIndex < values.length ? Option.some(values[newIndex]) : Option.none();
    });
  };
  const cycleHorizontal = (values, index, numRows, numCols, delta) => withGrid(values, index, numCols, (oldRow, oldColumn) => {
    const onLastRow = oldRow === numRows - 1;
    const colsInRow = onLastRow ? values.length - oldRow * numCols : numCols;
    const newColumn = cycleBy(oldColumn, delta, 0, colsInRow - 1);
    return Option.some({
      row: $_2vokfcwwjfuw8tb4.constant(oldRow),
      column: $_2vokfcwwjfuw8tb4.constant(newColumn)
    });
  });
  const cycleVertical = (values, index, numRows, numCols, delta) => withGrid(values, index, numCols, (oldRow, oldColumn) => {
    const newRow = cycleBy(oldRow, delta, 0, numRows - 1);
    const onLastRow = newRow === numRows - 1;
    const colsInRow = onLastRow ? values.length - newRow * numCols : numCols;
    const newCol = cap(oldColumn, 0, colsInRow - 1);
    return Option.some({
      row: $_2vokfcwwjfuw8tb4.constant(newRow),
      column: $_2vokfcwwjfuw8tb4.constant(newCol)
    });
  });
  const cycleRight = (values, index, numRows, numCols) => cycleHorizontal(values, index, numRows, numCols, +1);
  const cycleLeft = (values, index, numRows, numCols) => cycleHorizontal(values, index, numRows, numCols, -1);
  const cycleUp = (values, index, numRows, numCols) => cycleVertical(values, index, numRows, numCols, -1);
  const cycleDown = (values, index, numRows, numCols) => cycleVertical(values, index, numRows, numCols, +1);

  const schema$2 = [
    strict$1('selector'),
    defaulted$1('execute', defaultExecute),
    onKeyboardHandler('onEscape'),
    defaulted$1('captureTab', false),
    initSize()
  ];
  const focusIn = (component, gridConfig, gridState) => {
    $_c8lemt10bjfuw8tt8.descendant(component.element(), gridConfig.selector()).each(first => {
      gridConfig.focusManager().set(component, first);
    });
  };
  const findCurrent = (component, gridConfig) => gridConfig.focusManager().get(component).bind(elem => $_c8lemt10bjfuw8tt8.closest(elem, gridConfig.selector()));
  const execute$2 = (component, simulatedEvent, gridConfig, gridState) => findCurrent(component, gridConfig).bind(focused => gridConfig.execute()(component, simulatedEvent, focused));
  const doMove = cycle => (element, focused, gridConfig, gridState) => locateVisible(element, focused, gridConfig.selector()).bind(identified => cycle(identified.candidates(), identified.index(), gridState.getNumRows().getOr(gridConfig.initSize().numRows()), gridState.getNumColumns().getOr(gridConfig.initSize().numColumns())));
  const handleTab = (component, simulatedEvent, gridConfig, gridState) => gridConfig.captureTab() ? Option.some(true) : Option.none();
  const doEscape = (component, simulatedEvent, gridConfig, gridState) => gridConfig.onEscape()(component, simulatedEvent);
  const moveLeft = doMove(cycleLeft);
  const moveRight = doMove(cycleRight);
  const moveNorth = doMove(cycleUp);
  const moveSouth = doMove(cycleDown);
  const getRules$1 = $_2vokfcwwjfuw8tb4.constant([
    rule(inSet($_cy6bab10cjfuw8tt9.LEFT()), west(moveLeft, moveRight)),
    rule(inSet($_cy6bab10cjfuw8tt9.RIGHT()), east(moveLeft, moveRight)),
    rule(inSet($_cy6bab10cjfuw8tt9.UP()), north(moveNorth)),
    rule(inSet($_cy6bab10cjfuw8tt9.DOWN()), south(moveSouth)),
    rule(and([
      isShift,
      inSet($_cy6bab10cjfuw8tt9.TAB())
    ]), handleTab),
    rule(and([
      isNotShift,
      inSet($_cy6bab10cjfuw8tt9.TAB())
    ]), handleTab),
    rule(inSet($_cy6bab10cjfuw8tt9.ESCAPE()), doEscape),
    rule(inSet($_cy6bab10cjfuw8tt9.SPACE().concat($_cy6bab10cjfuw8tt9.ENTER())), execute$2)
  ]);
  const getEvents$1 = $_2vokfcwwjfuw8tb4.constant({});
  const getApis$1 = {};
  const FlatgridType = typical(schema$2, flatgrid, getRules$1, getEvents$1, getApis$1, Option.some(focusIn));

  const horizontal = (container, selector, current, delta) => locateVisible(container, current, selector).bind(identified => {
    const index = identified.index();
    const candidates = identified.candidates();
    const newIndex = cycleBy(index, delta, 0, candidates.length - 1);
    return Option.from(candidates[newIndex]);
  });

  const schema$3 = [
    strict$1('selector'),
    defaulted$1('getInitial', Option.none),
    defaulted$1('execute', defaultExecute),
    defaulted$1('executeOnMove', false)
  ];
  const findCurrent$1 = (component, flowConfig) => flowConfig.focusManager().get(component).bind(elem => $_c8lemt10bjfuw8tt8.closest(elem, flowConfig.selector()));
  const execute$3 = (component, simulatedEvent, flowConfig) => findCurrent$1(component, flowConfig).bind(focused => flowConfig.execute()(component, simulatedEvent, focused));
  const focusIn$1 = (component, flowConfig) => {
    flowConfig.getInitial()(component).or($_c8lemt10bjfuw8tt8.descendant(component.element(), flowConfig.selector())).each(first => {
      flowConfig.focusManager().set(component, first);
    });
  };
  const moveLeft$1 = (element, focused, info) => horizontal(element, info.selector(), focused, -1);
  const moveRight$1 = (element, focused, info) => horizontal(element, info.selector(), focused, +1);
  const doMove$1 = movement => (component, simulatedEvent, flowConfig) => movement(component, simulatedEvent, flowConfig).bind(() => flowConfig.executeOnMove() ? execute$3(component, simulatedEvent, flowConfig) : Option.some(true));
  const getRules$2 = _ => [
    rule(inSet($_cy6bab10cjfuw8tt9.LEFT().concat($_cy6bab10cjfuw8tt9.UP())), doMove$1(west(moveLeft$1, moveRight$1))),
    rule(inSet($_cy6bab10cjfuw8tt9.RIGHT().concat($_cy6bab10cjfuw8tt9.DOWN())), doMove$1(east(moveLeft$1, moveRight$1))),
    rule(inSet($_cy6bab10cjfuw8tt9.ENTER()), execute$3),
    rule(inSet($_cy6bab10cjfuw8tt9.SPACE()), execute$3)
  ];
  const getEvents$2 = $_2vokfcwwjfuw8tb4.constant({});
  const getApis$2 = $_2vokfcwwjfuw8tb4.constant({});
  const FlowType = typical(schema$3, init, getRules$2, getEvents$2, getApis$2, Option.some(focusIn$1));

  const outcome = $_4xhupwxnjfuw8tea.immutableBag([
    'rowIndex',
    'columnIndex',
    'cell'
  ], []);
  const toCell = (matrix, rowIndex, columnIndex) => Option.from(matrix[rowIndex]).bind(row => Option.from(row[columnIndex]).map(cell => outcome({
    rowIndex,
    columnIndex,
    cell
  })));
  const cycleHorizontal$1 = (matrix, rowIndex, startCol, deltaCol) => {
    const row = matrix[rowIndex];
    const colsInRow = row.length;
    const newColIndex = cycleBy(startCol, deltaCol, 0, colsInRow - 1);
    return toCell(matrix, rowIndex, newColIndex);
  };
  const cycleVertical$1 = (matrix, colIndex, startRow, deltaRow) => {
    const nextRowIndex = cycleBy(startRow, deltaRow, 0, matrix.length - 1);
    const colsInNextRow = matrix[nextRowIndex].length;
    const nextColIndex = cap(colIndex, 0, colsInNextRow - 1);
    return toCell(matrix, nextRowIndex, nextColIndex);
  };
  const moveHorizontal = (matrix, rowIndex, startCol, deltaCol) => {
    const row = matrix[rowIndex];
    const colsInRow = row.length;
    const newColIndex = cap(startCol + deltaCol, 0, colsInRow - 1);
    return toCell(matrix, rowIndex, newColIndex);
  };
  const moveVertical = (matrix, colIndex, startRow, deltaRow) => {
    const nextRowIndex = cap(startRow + deltaRow, 0, matrix.length - 1);
    const colsInNextRow = matrix[nextRowIndex].length;
    const nextColIndex = cap(colIndex, 0, colsInNextRow - 1);
    return toCell(matrix, nextRowIndex, nextColIndex);
  };
  const cycleRight$1 = (matrix, startRow, startCol) => cycleHorizontal$1(matrix, startRow, startCol, +1);
  const cycleLeft$1 = (matrix, startRow, startCol) => cycleHorizontal$1(matrix, startRow, startCol, -1);
  const cycleUp$1 = (matrix, startRow, startCol) => cycleVertical$1(matrix, startCol, startRow, -1);
  const cycleDown$1 = (matrix, startRow, startCol) => cycleVertical$1(matrix, startCol, startRow, +1);
  const moveLeft$2 = (matrix, startRow, startCol) => moveHorizontal(matrix, startRow, startCol, -1);
  const moveRight$2 = (matrix, startRow, startCol) => moveHorizontal(matrix, startRow, startCol, +1);
  const moveUp = (matrix, startRow, startCol) => moveVertical(matrix, startCol, startRow, -1);
  const moveDown = (matrix, startRow, startCol) => moveVertical(matrix, startCol, startRow, +1);

  const schema$4 = [
    strictObjOf('selectors', [
      strict$1('row'),
      strict$1('cell')
    ]),
    defaulted$1('cycles', true),
    defaulted$1('previousSelector', Option.none),
    defaulted$1('execute', defaultExecute)
  ];
  const focusIn$2 = (component, matrixConfig) => {
    const focused = matrixConfig.previousSelector()(component).orThunk(() => {
      const selectors = matrixConfig.selectors();
      return $_c8lemt10bjfuw8tt8.descendant(component.element(), selectors.cell());
    });
    focused.each(cell => {
      matrixConfig.focusManager().set(component, cell);
    });
  };
  const execute$4 = (component, simulatedEvent, matrixConfig) => $_f15fvwz1jfuw8tlo.search(component.element()).bind(focused => matrixConfig.execute()(component, simulatedEvent, focused));
  const toMatrix = (rows, matrixConfig) => $_efmt4zxbjfuw8tcj.map(rows, row => $_951f03109jfuw8tt3.descendants(row, matrixConfig.selectors().cell()));
  const doMove$2 = (ifCycle, ifMove) => (element, focused, matrixConfig) => {
    const move$$1 = matrixConfig.cycles() ? ifCycle : ifMove;
    return $_c8lemt10bjfuw8tt8.closest(focused, matrixConfig.selectors().row()).bind(inRow => {
      const cellsInRow = $_951f03109jfuw8tt3.descendants(inRow, matrixConfig.selectors().cell());
      return findIndex$2(cellsInRow, focused).bind(colIndex => {
        const allRows = $_951f03109jfuw8tt3.descendants(element, matrixConfig.selectors().row());
        return findIndex$2(allRows, inRow).bind(rowIndex => {
          const matrix = toMatrix(allRows, matrixConfig);
          return move$$1(matrix, rowIndex, colIndex).map(next => next.cell());
        });
      });
    });
  };
  const moveLeft$3 = doMove$2(cycleLeft$1, moveLeft$2);
  const moveRight$3 = doMove$2(cycleRight$1, moveRight$2);
  const moveNorth$1 = doMove$2(cycleUp$1, moveUp);
  const moveSouth$1 = doMove$2(cycleDown$1, moveDown);
  const getRules$3 = $_2vokfcwwjfuw8tb4.constant([
    rule(inSet($_cy6bab10cjfuw8tt9.LEFT()), west(moveLeft$3, moveRight$3)),
    rule(inSet($_cy6bab10cjfuw8tt9.RIGHT()), east(moveLeft$3, moveRight$3)),
    rule(inSet($_cy6bab10cjfuw8tt9.UP()), north(moveNorth$1)),
    rule(inSet($_cy6bab10cjfuw8tt9.DOWN()), south(moveSouth$1)),
    rule(inSet($_cy6bab10cjfuw8tt9.SPACE().concat($_cy6bab10cjfuw8tt9.ENTER())), execute$4)
  ]);
  const getEvents$3 = $_2vokfcwwjfuw8tb4.constant({});
  const getApis$3 = $_2vokfcwwjfuw8tb4.constant({});
  const MatrixType = typical(schema$4, init, getRules$3, getEvents$3, getApis$3, Option.some(focusIn$2));

  const schema$5 = [
    strict$1('selector'),
    defaulted$1('execute', defaultExecute),
    defaulted$1('moveOnTab', false)
  ];
  const execute$5 = (component, simulatedEvent, menuConfig) => menuConfig.focusManager().get(component).bind(focused => menuConfig.execute()(component, simulatedEvent, focused));
  const focusIn$3 = (component, menuConfig, simulatedEvent) => {
    $_c8lemt10bjfuw8tt8.descendant(component.element(), menuConfig.selector()).each(first => {
      menuConfig.focusManager().set(component, first);
    });
  };
  const moveUp$1 = (element, focused, info) => horizontal(element, info.selector(), focused, -1);
  const moveDown$1 = (element, focused, info) => horizontal(element, info.selector(), focused, +1);
  const fireShiftTab = (component, simulatedEvent, menuConfig) => menuConfig.moveOnTab() ? move(moveUp$1)(component, simulatedEvent, menuConfig) : Option.none();
  const fireTab = (component, simulatedEvent, menuConfig) => menuConfig.moveOnTab() ? move(moveDown$1)(component, simulatedEvent, menuConfig) : Option.none();
  const getRules$4 = $_2vokfcwwjfuw8tb4.constant([
    rule(inSet($_cy6bab10cjfuw8tt9.UP()), move(moveUp$1)),
    rule(inSet($_cy6bab10cjfuw8tt9.DOWN()), move(moveDown$1)),
    rule(and([
      isShift,
      inSet($_cy6bab10cjfuw8tt9.TAB())
    ]), fireShiftTab),
    rule(and([
      isNotShift,
      inSet($_cy6bab10cjfuw8tt9.TAB())
    ]), fireTab),
    rule(inSet($_cy6bab10cjfuw8tt9.ENTER()), execute$5),
    rule(inSet($_cy6bab10cjfuw8tt9.SPACE()), execute$5)
  ]);
  const getEvents$4 = $_2vokfcwwjfuw8tb4.constant({});
  const getApis$4 = $_2vokfcwwjfuw8tb4.constant({});
  const MenuType = typical(schema$5, init, getRules$4, getEvents$4, getApis$4, Option.some(focusIn$3));

  const schema$6 = [
    onKeyboardHandler('onSpace'),
    onKeyboardHandler('onEnter'),
    onKeyboardHandler('onShiftEnter'),
    onKeyboardHandler('onLeft'),
    onKeyboardHandler('onRight'),
    onKeyboardHandler('onTab'),
    onKeyboardHandler('onShiftTab'),
    onKeyboardHandler('onUp'),
    onKeyboardHandler('onDown'),
    onKeyboardHandler('onEscape'),
    option('focusIn')
  ];
  const getRules$5 = (component, simulatedEvent, executeInfo) => [
    rule(inSet($_cy6bab10cjfuw8tt9.SPACE()), executeInfo.onSpace()),
    rule(and([
      isNotShift,
      inSet($_cy6bab10cjfuw8tt9.ENTER())
    ]), executeInfo.onEnter()),
    rule(and([
      isShift,
      inSet($_cy6bab10cjfuw8tt9.ENTER())
    ]), executeInfo.onShiftEnter()),
    rule(and([
      isShift,
      inSet($_cy6bab10cjfuw8tt9.TAB())
    ]), executeInfo.onShiftTab()),
    rule(and([
      isNotShift,
      inSet($_cy6bab10cjfuw8tt9.TAB())
    ]), executeInfo.onTab()),
    rule(inSet($_cy6bab10cjfuw8tt9.UP()), executeInfo.onUp()),
    rule(inSet($_cy6bab10cjfuw8tt9.DOWN()), executeInfo.onDown()),
    rule(inSet($_cy6bab10cjfuw8tt9.LEFT()), executeInfo.onLeft()),
    rule(inSet($_cy6bab10cjfuw8tt9.RIGHT()), executeInfo.onRight()),
    rule(inSet($_cy6bab10cjfuw8tt9.SPACE()), executeInfo.onSpace()),
    rule(inSet($_cy6bab10cjfuw8tt9.ESCAPE()), executeInfo.onEscape())
  ];
  const focusIn$4 = (component, executeInfo) => executeInfo.focusIn().bind(f => f(component, executeInfo));
  const getEvents$5 = $_2vokfcwwjfuw8tb4.constant({});
  const getApis$5 = $_2vokfcwwjfuw8tb4.constant({});
  const SpecialType = typical(schema$6, init, getRules$5, getEvents$5, getApis$5, Option.some(focusIn$4));

  const $_5g1im2102jfuw8trm = {
    acyclic: AcyclicType.schema(),
    cyclic: CyclicType.schema(),
    flow: FlowType.schema(),
    flatgrid: FlatgridType.schema(),
    matrix: MatrixType.schema(),
    execution: ExecutionType.schema(),
    menu: MenuType.schema(),
    special: SpecialType.schema()
  };

  const Keying = createModes$1({
    branchKey: 'mode',
    branches: $_5g1im2102jfuw8trm,
    name: 'keying',
    active: {
      events(keyingConfig, keyingState) {
        const handler = keyingConfig.handler();
        return handler.toEvents(keyingConfig, keyingState);
      }
    },
    apis: {
      focusIn(component) {
        component.getSystem().triggerFocus(component.element(), component.element());
      },
      setGridSize(component, keyConfig, keyState, numRows, numColumns) {
        if (!hasKey$1(keyState, 'setGridSize')) {
          console.error('Layout does not support setGridSize');
        } else {
          keyState.setGridSize(numRows, numColumns);
        }
      }
    },
    state: KeyingState
  });

  const field$1 = (name, forbidden) => defaultedObjOf(name, {}, $_efmt4zxbjfuw8tcj.map(forbidden, f => forbid(f.name(), `Cannot configure ${f.name()} for ${name}`)).concat([state$1('dump', $_2vokfcwwjfuw8tb4.identity)]));
  const get$5 = data => data.dump();

  const _placeholder = 'placeholder';
  const adt$2 = $_dldkf4y5jfuw8tgp.generate([
    {
      single: [
        'required',
        'valueThunk'
      ]
    },
    {
      multiple: [
        'required',
        'valueThunks'
      ]
    }
  ]);
  const subPlaceholder = (owner, detail, compSpec, placeholders) => {
    if (owner.exists(o => o !== compSpec.owner)) {
      return adt$2.single(true, $_2vokfcwwjfuw8tb4.constant(compSpec));
    }
    return readOptFrom$1(placeholders, compSpec.name).fold(() => {
      throw new Error(`Unknown placeholder component: ${compSpec.name}\nKnown: [${$_8qu224wzjfuw8tb9.keys(placeholders)}]\nNamespace: ${owner.getOr('none')}\nSpec: ${$_6s9vvgygjfuw8ti8.stringify(compSpec, null, 2)}`);
    }, newSpec => newSpec.replace());
  };
  const scan = (owner, detail, compSpec, placeholders) => {
    if (compSpec.uiType === _placeholder) {
      return subPlaceholder(owner, detail, compSpec, placeholders);
    } else {
      return adt$2.single(false, $_2vokfcwwjfuw8tb4.constant(compSpec));
    }
  };
  const substitute = (owner, detail, compSpec, placeholders) => {
    const base = scan(owner, detail, compSpec, placeholders);
    return base.fold((req, valueThunk) => {
      const value = valueThunk(detail, compSpec.config, compSpec.validated);
      const childSpecs = readOptFrom$1(value, 'components').getOr([]);
      const substituted = $_efmt4zxbjfuw8tcj.bind(childSpecs, c => substitute(owner, detail, c, placeholders));
      return [$_3jctjywxjfuw8tb6.deepMerge(value, { components: substituted })];
    }, (req, valuesThunk) => {
      const values = valuesThunk(detail, compSpec.config, compSpec.validated);
      return values;
    });
  };
  const substituteAll = (owner, detail, components, placeholders) => $_efmt4zxbjfuw8tcj.bind(components, c => substitute(owner, detail, c, placeholders));
  const oneReplace = (label, replacements) => {
    let called = false;
    const used = () => called;
    const replace = () => {
      if (called === true) {
        throw new Error(`Trying to use the same placeholder more than once: ${label}`);
      }
      called = true;
      return replacements;
    };
    const required = () => replacements.fold((req, _) => req, (req, _) => req);
    return {
      name: $_2vokfcwwjfuw8tb4.constant(label),
      required,
      used,
      replace
    };
  };
  const substitutePlaces = (owner, detail, components, placeholders) => {
    const ps = $_8qu224wzjfuw8tb9.map(placeholders, (ph, name) => oneReplace(name, ph));
    const outcome = substituteAll(owner, detail, components, ps);
    $_8qu224wzjfuw8tb9.each(ps, p => {
      if (p.used() === false && p.required()) {
        throw new Error(`Placeholder: ${p.name()} was not found in components list\nNamespace: ${owner.getOr('none')}\nComponents: ${$_6s9vvgygjfuw8ti8.stringify(detail.components(), null, 2)}`);
      }
    });
    return outcome;
  };
  const single = adt$2.single;
  const multiple = adt$2.multiple;
  const placeholder = $_2vokfcwwjfuw8tb4.constant(_placeholder);

  let unique = 0;
  const generate$1 = prefix => {
    const date = new Date();
    const time = date.getTime();
    const random = Math.floor(Math.random() * 1000000000);
    unique++;
    return `${prefix}_${random}${unique}${String(time)}`;
  };
  const $_5j06su11ajfuw8u1p = { generate: generate$1 };

  const adt$3 = $_dldkf4y5jfuw8tgp.generate([
    { required: ['data'] },
    { external: ['data'] },
    { optional: ['data'] },
    { group: ['data'] }
  ]);
  const fFactory = defaulted$1('factory', { sketch: $_2vokfcwwjfuw8tb4.identity });
  const fSchema = defaulted$1('schema', []);
  const fName = strict$1('name');
  const fPname = field('pname', 'pname', defaultedThunk(typeSpec => `<alloy.${$_5j06su11ajfuw8u1p.generate(typeSpec.name)}>`), anyValue$1());
  const fDefaults = defaulted$1('defaults', $_2vokfcwwjfuw8tb4.constant({}));
  const fOverrides = defaulted$1('overrides', $_2vokfcwwjfuw8tb4.constant({}));
  const requiredSpec = objOf([
    fFactory,
    fSchema,
    fName,
    fPname,
    fDefaults,
    fOverrides
  ]);
  const externalSpec = objOf([
    fFactory,
    fSchema,
    fName,
    fDefaults,
    fOverrides
  ]);
  const optionalSpec = objOf([
    fFactory,
    fSchema,
    fName,
    fPname,
    fDefaults,
    fOverrides
  ]);
  const groupSpec = objOf([
    fFactory,
    fSchema,
    fName,
    strict$1('unit'),
    fPname,
    fDefaults,
    fOverrides
  ]);
  const asNamedPart = part => part.fold(Option.some, Option.none, Option.some, Option.some);
  const name$1 = part => {
    const get = data => data.name();
    return part.fold(get, get, get, get);
  };
  const convert = (adtConstructor, partSpec) => spec => {
    const data = asStructOrDie('Converting part type', partSpec, spec);
    return adtConstructor(data);
  };
  const required = convert(adt$3.required, requiredSpec);
  const external = convert(adt$3.external, externalSpec);
  const optional = convert(adt$3.optional, optionalSpec);
  const group = convert(adt$3.group, groupSpec);
  const original = $_2vokfcwwjfuw8tb4.constant('entirety');

  const combine = (detail, data, partSpec, partValidated) => {
    const spec = partSpec;
    return $_3jctjywxjfuw8tb6.deepMerge(data.defaults()(detail, partSpec, partValidated), partSpec, { uid: detail.partUids()[data.name()] }, data.overrides()(detail, partSpec, partValidated), { 'debug.sketcher': wrap$2(`part-${data.name()}`, spec) });
  };
  const subs = (owner, detail, parts) => {
    const internals = {};
    const externals = {};
    $_efmt4zxbjfuw8tcj.each(parts, part => {
      part.fold(data => {
        internals[data.pname()] = single(true, (detail, partSpec, partValidated) => data.factory().sketch(combine(detail, data, partSpec, partValidated)));
      }, data => {
        const partSpec = detail.parts()[data.name()]();
        externals[data.name()] = $_2vokfcwwjfuw8tb4.constant(combine(detail, data, partSpec[original()]()));
      }, data => {
        internals[data.pname()] = single(false, (detail, partSpec, partValidated) => data.factory().sketch(combine(detail, data, partSpec, partValidated)));
      }, data => {
        internals[data.pname()] = multiple(true, (detail, _partSpec, _partValidated) => {
          const units = detail[data.name()]();
          return $_efmt4zxbjfuw8tcj.map(units, u => data.factory().sketch($_3jctjywxjfuw8tb6.deepMerge(data.defaults()(detail, u), u, data.overrides()(detail, u))));
        });
      });
    });
    return {
      internals: $_2vokfcwwjfuw8tb4.constant(internals),
      externals: $_2vokfcwwjfuw8tb4.constant(externals)
    };
  };

  const generate$2 = (owner, parts) => {
    const r = {};
    $_efmt4zxbjfuw8tcj.each(parts, part => {
      asNamedPart(part).each(np => {
        const g = doGenerateOne(owner, np.pname());
        r[np.name()] = config => {
          const validated = asRawOrDie(`Part: ${np.name()} in ${owner}`, objOf(np.schema()), config);
          return $_3jctjywxjfuw8tb6.deepMerge(g, {
            config,
            validated
          });
        };
      });
    });
    return r;
  };
  var doGenerateOne = (owner, pname) => ({
    uiType: placeholder(),
    owner,
    name: pname
  });
  const generateOne = (owner, pname, config) => ({
    uiType: placeholder(),
    owner,
    name: pname,
    config,
    validated: {}
  });
  const schemas = parts => $_efmt4zxbjfuw8tcj.bind(parts, part => part.fold(Option.none, Option.some, Option.none, Option.none).map(data => strictObjOf(data.name(), data.schema().concat([snapshot$1(original())]))).toArray());
  const names = parts => $_efmt4zxbjfuw8tcj.map(parts, name$1);
  const substitutes = (owner, detail, parts) => subs(owner, detail, parts);
  const components = (owner, detail, internals) => substitutePlaces(Option.some(owner), detail, detail.components(), internals);
  const getPart = (component, detail, partKey) => {
    const uid = detail.partUids()[partKey];
    return component.getSystem().getByUid(uid).toOption();
  };
  const getPartOrDie = (component, detail, partKey) => getPart(component, detail, partKey).getOrDie(`Could not find part: ${partKey}`);
  const getAllParts = (component, detail) => {
    const system = component.getSystem();
    return $_8qu224wzjfuw8tb9.map(detail.partUids(), (pUid, k) => $_2vokfcwwjfuw8tb4.constant(system.getByUid(pUid)));
  };
  const defaultUids = (baseUid, partTypes) => {
    const partNames = names(partTypes);
    return wrapAll$1($_efmt4zxbjfuw8tcj.map(partNames, pn => ({
      key: pn,
      value: `${baseUid}-${pn}`
    })));
  };
  const defaultUidsSchema = partTypes => field('partUids', 'partUids', mergeWithThunk(spec => defaultUids(spec.uid, partTypes)), anyValue$1());

  const premadeTag = $_5j06su11ajfuw8u1p.generate('alloy-premade');
  const _apiConfig = $_5j06su11ajfuw8u1p.generate('api');
  const premade = comp => wrap$2(premadeTag, comp);
  const getPremade = spec => readOptFrom$1(spec, premadeTag);
  const makeApi = f => markAsSketchApi(function (component) {
    const args = Array.prototype.slice.call(arguments, 0);
    const spi = component.config(_apiConfig);
    return f(...[spi].concat(args));
  }, f);
  const apiConfig = $_2vokfcwwjfuw8tb4.constant(_apiConfig);

  const prefix$1 = $_2vokfcwwjfuw8tb4.constant('alloy-id-');
  const idAttr = $_2vokfcwwjfuw8tb4.constant('data-alloy-id');

  const prefix$2 = prefix$1();
  const idAttr$1 = idAttr();
  const write = (label, elem) => {
    const id = $_5j06su11ajfuw8u1p.generate(prefix$2 + label);
    $_47adx7ywjfuw8tl3.set(elem, idAttr$1, id);
    return id;
  };
  const writeOnly = (elem, uid) => {
    $_47adx7ywjfuw8tl3.set(elem, idAttr$1, uid);
  };
  const read$2 = elem => {
    const id = $_74lhjaxjjfuw8tdt.isElement(elem) ? $_47adx7ywjfuw8tl3.get(elem, idAttr$1) : null;
    return Option.from(id);
  };
  const generate$3 = prefix => $_5j06su11ajfuw8u1p.generate(prefix);
  const attribute = $_2vokfcwwjfuw8tb4.constant(idAttr$1);

  const base$1 = (label, partSchemas, partUidsSchemas, spec) => {
    const ps = partSchemas.length > 0 ? [strictObjOf('parts', partSchemas)] : [];
    return ps.concat([
      strict$1('uid'),
      defaulted$1('dom', {}),
      defaulted$1('components', []),
      snapshot$1('originalSpec'),
      defaulted$1('debug.sketcher', {})
    ]).concat(partUidsSchemas);
  };
  const asStructOrDie$1 = (label, schema, spec, partSchemas, partUidsSchemas) => {
    const baseS = base$1(label, partSchemas, partUidsSchemas, spec);
    return asStructOrDie(`${label} [SpecSchema]`, objOfOnly(baseS.concat(schema)), spec);
  };

  const single$1 = (owner, schema, factory, spec) => {
    const specWithUid = supplyUid(spec);
    const detail = asStructOrDie$1(owner, schema, specWithUid, [], []);
    return $_3jctjywxjfuw8tb6.deepMerge(factory(detail, specWithUid), { 'debug.sketcher': wrap$2(owner, spec) });
  };
  const composite = (owner, schema, partTypes, factory, spec) => {
    const specWithUid = supplyUid(spec);
    const partSchemas = schemas(partTypes);
    const partUidsSchema = defaultUidsSchema(partTypes);
    const detail = asStructOrDie$1(owner, schema, specWithUid, partSchemas, [partUidsSchema]);
    const subs = substitutes(owner, detail, partTypes);
    const components$$1 = components(owner, detail, subs.internals());
    return $_3jctjywxjfuw8tb6.deepMerge(factory(detail, components$$1, specWithUid, subs.externals()), { 'debug.sketcher': wrap$2(owner, spec) });
  };
  var supplyUid = spec => $_3jctjywxjfuw8tb6.deepMerge({ uid: generate$3('uid') }, spec);

  function isSketchSpec(spec) {
    return spec.uid !== undefined;
  }
  const singleSchema = objOfOnly([
    strict$1('name'),
    strict$1('factory'),
    strict$1('configFields'),
    defaulted$1('apis', {}),
    defaulted$1('extraApis', {})
  ]);
  const compositeSchema = objOfOnly([
    strict$1('name'),
    strict$1('factory'),
    strict$1('configFields'),
    strict$1('partFields'),
    defaulted$1('apis', {}),
    defaulted$1('extraApis', {})
  ]);
  const single$2 = rawConfig => {
    const config = asRawOrDie(`Sketcher for ${rawConfig.name}`, singleSchema, rawConfig);
    const sketch = spec => single$1(config.name, config.configFields, config.factory, spec);
    const apis = $_8qu224wzjfuw8tb9.map(config.apis, makeApi);
    const extraApis = $_8qu224wzjfuw8tb9.map(config.extraApis, (f, k) => markAsExtraApi(f, k));
    return $_3jctjywxjfuw8tb6.deepMerge({
      name: $_2vokfcwwjfuw8tb4.constant(config.name),
      partFields: $_2vokfcwwjfuw8tb4.constant([]),
      configFields: $_2vokfcwwjfuw8tb4.constant(config.configFields),
      sketch
    }, apis, extraApis);
  };
  const composite$1 = rawConfig => {
    const config = asRawOrDie(`Sketcher for ${rawConfig.name}`, compositeSchema, rawConfig);
    const sketch = spec => composite(config.name, config.configFields, config.partFields, config.factory, spec);
    const parts = generate$2(config.name, config.partFields);
    const apis = $_8qu224wzjfuw8tb9.map(config.apis, makeApi);
    const extraApis = $_8qu224wzjfuw8tb9.map(config.extraApis, (f, k) => markAsExtraApi(f, k));
    return $_3jctjywxjfuw8tb6.deepMerge({
      name: $_2vokfcwwjfuw8tb4.constant(config.name),
      partFields: $_2vokfcwwjfuw8tb4.constant(config.partFields),
      configFields: $_2vokfcwwjfuw8tb4.constant(config.configFields),
      sketch,
      parts: $_2vokfcwwjfuw8tb4.constant(parts)
    }, apis, extraApis);
  };

  const factory = (detail, spec) => {
    const events = events$2(detail.action());
    const optType = readOptFrom$1(detail.dom(), 'attributes').bind(readOpt$1('type'));
    const optTag = readOptFrom$1(detail.dom(), 'tag');
    return {
      uid: detail.uid(),
      dom: detail.dom(),
      components: detail.components(),
      events,
      behaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2([
        Focusing.config({}),
        Keying.config({
          mode: 'execution',
          useSpace: true,
          useEnter: true
        })
      ]), get$5(detail.buttonBehaviours())),
      domModification: {
        attributes: $_3jctjywxjfuw8tb6.deepMerge(optType.fold(() => optTag.is('button') ? { type: 'button' } : {}, t => ({})), { role: detail.role().getOr('button') })
      },
      eventOrder: detail.eventOrder()
    };
  };
  const Button = single$2({
    name: 'Button',
    factory,
    configFields: [
      defaulted$1('uid', undefined),
      strict$1('dom'),
      defaulted$1('components', []),
      field$1('buttonBehaviours', [
        Focusing,
        Keying
      ]),
      option('action'),
      option('role'),
      defaulted$1('eventOrder', {})
    ]
  });

  const exhibit$2 = (base, unselectConfig) => nu$6({
    styles: {
      '-webkit-user-select': 'none',
      'user-select': 'none',
      '-ms-user-select': 'none',
      '-moz-user-select': '-moz-none'
    },
    attributes: { unselectable: 'on' }
  });
  const events$4 = unselectConfig => derive([abort(selectstart(), $_2vokfcwwjfuw8tb4.constant(true))]);


  const ActiveUnselecting = Object.freeze({
    events: events$4,
    exhibit: exhibit$2
  });

  const Unselecting = create$1({
    fields: [],
    name: 'unselecting',
    active: ActiveUnselecting
  });

  const getAttrs = elem => {
    const attributes = elem.dom().attributes !== undefined ? elem.dom().attributes : [];
    return $_efmt4zxbjfuw8tcj.foldl(attributes, (b, attr) => {
      if (attr.name === 'class') {
        return b;
      } else {
        return $_3jctjywxjfuw8tb6.deepMerge(b, wrap$2(attr.name, attr.value));
      }
    }, {});
  };
  const getClasses = elem => Array.prototype.slice.call(elem.dom().classList, 0);
  const fromHtml$2 = html => {
    const elem = $_bwdnu0xijfuw8tdo.fromHtml(html);
    const children = $_aff64dxmjfuw8tdx.children(elem);
    const attrs = getAttrs(elem);
    const classes = getClasses(elem);
    const contents = children.length === 0 ? {} : { innerHtml: $_2dunqqzfjfuw8tnk.get(elem) };
    return $_3jctjywxjfuw8tb6.deepMerge({
      tag: $_74lhjaxjjfuw8tdt.name(elem),
      classes,
      attributes: attrs
    }, contents);
  };

  const dom$1 = rawHtml => {
    const html = $_b463kaxdjfuw8tcv.supplant(rawHtml, { prefix: $_2fp9skztjfuw8tqe.prefix() });
    return fromHtml$2(html);
  };
  const spec = rawHtml => {
    const sDom = dom$1(rawHtml);
    return { dom: sDom };
  };

  const forToolbarCommand = (editor, command) => forToolbar(command, () => {
    editor.execCommand(command);
  }, {});
  const getToggleBehaviours = command => derive$2([
    Toggling.config({
      toggleClass: $_2fp9skztjfuw8tqe.resolve('toolbar-button-selected'),
      toggleOnExecute: false,
      aria: { mode: 'pressed' }
    }),
    $_9de9iyzsjfuw8tqa.format(command, (button, status) => {
      const toggle = status ? Toggling.on : Toggling.off;
      toggle(button);
    })
  ]);
  const forToolbarStateCommand = (editor, command) => {
    const extraBehaviours = getToggleBehaviours(command);
    return forToolbar(command, () => {
      editor.execCommand(command);
    }, extraBehaviours);
  };
  const forToolbarStateAction = (editor, clazz, command, action) => {
    const extraBehaviours = getToggleBehaviours(command);
    return forToolbar(clazz, action, extraBehaviours);
  };
  var forToolbar = (clazz, action, extraBehaviours) => Button.sketch({
    dom: dom$1(`<span class="${prefix}-toolbar-button ${prefix}-icon-${clazz} ${prefix}-icon"></span>`),
    action,
    buttonBehaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2([Unselecting.config({})]), extraBehaviours)
  });
  const $_44weuozujfuw8tqh = {
    forToolbar,
    forToolbarCommand,
    forToolbarStateAction,
    forToolbarStateCommand
  };

  const reduceBy = (value, min, max, step) => {
    if (value < min) {
      return value;
    } else if (value > max) {
      return max;
    } else if (value === min) {
      return min - 1;
    } else {
      return Math.max(min, value - step);
    }
  };
  const increaseBy = (value, min, max, step) => {
    if (value > max) {
      return value;
    } else if (value < min) {
      return min;
    } else if (value === max) {
      return max + 1;
    } else {
      return Math.min(max, value + step);
    }
  };
  const capValue = (value, min, max) => Math.max(min, Math.min(max, value));
  const snapValueOfX = (bounds, value, min, max, step, snapStart) => snapStart.fold(() => {
    const initValue = value - min;
    const extraValue = Math.round(initValue / step) * step;
    return capValue(min + extraValue, min - 1, max + 1);
  }, start => {
    const remainder = (value - start) % step;
    const adjustment = Math.round(remainder / step);
    const rawSteps = Math.floor((value - start) / step);
    const maxSteps = Math.floor((max - start) / step);
    const numSteps = Math.min(maxSteps, rawSteps + adjustment);
    const r = start + numSteps * step;
    return Math.max(start, r);
  });
  const findValueOfX = (bounds, min, max, xValue, step, snapToGrid, snapStart) => {
    const range = max - min;
    if (xValue < bounds.left) {
      return min - 1;
    } else if (xValue > bounds.right) {
      return max + 1;
    } else {
      const xOffset = Math.min(bounds.right, Math.max(xValue, bounds.left)) - bounds.left;
      const newValue = capValue(xOffset / bounds.width * range + min, min - 1, max + 1);
      const roundedValue = Math.round(newValue);
      return snapToGrid && newValue >= min && newValue <= max ? snapValueOfX(bounds, newValue, min, max, step, snapStart) : roundedValue;
    }
  };

  const _changeEvent = 'slider.change.value';
  const isTouch = $_5reqwox3jfuw8tbu.detect().deviceType.isTouch();
  const getEventSource = simulatedEvent => {
    const evt = simulatedEvent.event().raw();
    if (isTouch && evt.touches !== undefined && evt.touches.length === 1) {
      return Option.some(evt.touches[0]);
    } else if (isTouch && evt.touches !== undefined) {
      return Option.none();
    } else if (!isTouch && evt.clientX !== undefined) {
      return Option.some(evt);
    } else {
      return Option.none();
    }
  };
  const getEventX = simulatedEvent => {
    const spot = getEventSource(simulatedEvent);
    return spot.map(s => s.clientX);
  };
  const fireChange = (component, value) => {
    emitWith(component, _changeEvent, { value });
  };
  const setToRedge = (redge, detail) => {
    fireChange(redge, detail.max() + 1);
  };
  const setToLedge = (ledge, detail) => {
    fireChange(ledge, detail.min() - 1);
  };
  const setToX = (spectrum, spectrumBounds, detail, xValue) => {
    const value = findValueOfX(spectrumBounds, detail.min(), detail.max(), xValue, detail.stepSize(), detail.snapToGrid(), detail.snapStart());
    fireChange(spectrum, value);
  };
  const setXFromEvent = (spectrum, detail, spectrumBounds, simulatedEvent) => getEventX(simulatedEvent).map(xValue => {
    setToX(spectrum, spectrumBounds, detail, xValue);
    return xValue;
  });
  const moveLeft$4 = (spectrum, detail) => {
    const newValue = reduceBy(detail.value().get(), detail.min(), detail.max(), detail.stepSize());
    fireChange(spectrum, newValue);
  };
  const moveRight$4 = (spectrum, detail) => {
    const newValue = increaseBy(detail.value().get(), detail.min(), detail.max(), detail.stepSize());
    fireChange(spectrum, newValue);
  };
  const changeEvent = $_2vokfcwwjfuw8tb4.constant(_changeEvent);

  const platform = $_5reqwox3jfuw8tbu.detect();
  const isTouch$1 = platform.deviceType.isTouch();
  const edgePart = (name, action) => optional({
    name: `${name}-edge`,
    overrides(detail) {
      const touchEvents = derive([runActionExtra(touchstart(), action, [detail])]);
      const mouseEvents = derive([
        runActionExtra(mousedown(), action, [detail]),
        runActionExtra(mousemove(), (l, det) => {
          if (det.mouseIsDown().get()) {
            action(l, det);
          }
        }, [detail])
      ]);
      return { events: isTouch$1 ? touchEvents : mouseEvents };
    }
  });
  const ledgePart = edgePart('left', setToLedge);
  const redgePart = edgePart('right', setToRedge);
  const thumbPart = required({
    name: 'thumb',
    defaults: $_2vokfcwwjfuw8tb4.constant({ dom: { styles: { position: 'absolute' } } }),
    overrides(detail) {
      return {
        events: derive([
          redirectToPart(touchstart(), detail, 'spectrum'),
          redirectToPart(touchmove(), detail, 'spectrum'),
          redirectToPart(touchend(), detail, 'spectrum')
        ])
      };
    }
  });
  const spectrumPart = required({
    schema: [state$1('mouseIsDown', () => Cell(false))],
    name: 'spectrum',
    overrides(detail) {
      const moveToX = (spectrum, simulatedEvent) => {
        const spectrumBounds = spectrum.element().dom().getBoundingClientRect();
        setXFromEvent(spectrum, detail, spectrumBounds, simulatedEvent);
      };
      const touchEvents = derive([
        run(touchstart(), moveToX),
        run(touchmove(), moveToX)
      ]);
      const mouseEvents = derive([
        run(mousedown(), moveToX),
        run(mousemove(), (spectrum, se) => {
          if (detail.mouseIsDown().get()) {
            moveToX(spectrum, se);
          }
        })
      ]);
      return {
        behaviours: derive$2(isTouch$1 ? [] : [
          Keying.config({
            mode: 'special',
            onLeft(spectrum) {
              moveLeft$4(spectrum, detail);
              return Option.some(true);
            },
            onRight(spectrum) {
              moveRight$4(spectrum, detail);
              return Option.some(true);
            }
          }),
          Focusing.config({})
        ]),
        events: isTouch$1 ? touchEvents : mouseEvents
      };
    }
  });
  const SliderParts = [
    ledgePart,
    redgePart,
    thumbPart,
    spectrumPart
  ];

  const onLoad$1 = (component, repConfig, repState) => {
    repConfig.store().manager().onLoad(component, repConfig, repState);
  };
  const onUnload = (component, repConfig, repState) => {
    repConfig.store().manager().onUnload(component, repConfig, repState);
  };
  const setValue = (component, repConfig, repState, data) => {
    repConfig.store().manager().setValue(component, repConfig, repState, data);
  };
  const getValue = (component, repConfig, repState) => repConfig.store().manager().getValue(component, repConfig, repState);


  const RepresentApis = Object.freeze({
    onLoad: onLoad$1,
    onUnload,
    setValue,
    getValue
  });

  const events$5 = (repConfig, repState) => {
    const es = repConfig.resetOnDom() ? [
      runOnAttached((comp, se) => {
        onLoad$1(comp, repConfig, repState);
      }),
      runOnDetached((comp, se) => {
        onUnload(comp, repConfig, repState);
      })
    ] : [loadEvent(repConfig, repState, onLoad$1)];
    return derive(es);
  };


  const ActiveRepresenting = Object.freeze({
    events: events$5
  });

  const memory = () => {
    const data = Cell(null);
    const readState = () => ({
      mode: 'memory',
      value: data.get()
    });
    const isNotSet = () => data.get() === null;
    const clear = () => {
      data.set(null);
    };
    return BehaviourState({
      set: data.set,
      get: data.get,
      isNotSet,
      clear,
      readState
    });
  };
  const manual = () => {
    const readState = () => {
    };
    return BehaviourState({ readState });
  };
  const dataset = () => {
    const data = Cell({});
    const readState = () => ({
      mode: 'dataset',
      dataset: data.get()
    });
    return BehaviourState({
      readState,
      set: data.set,
      get: data.get
    });
  };
  const init$2 = spec => spec.store().manager().state(spec);


  const RepresentState = Object.freeze({
    memory,
    dataset,
    manual,
    init: init$2
  });

  const setValue$1 = (component, repConfig, repState, data) => {
    const dataKey = repConfig.store().getDataKey();
    repState.set({});
    repConfig.store().setData()(component, data);
    repConfig.onSetValue()(component, data);
  };
  const getValue$1 = (component, repConfig, repState) => {
    const key = repConfig.store().getDataKey()(component);
    const dataset$$1 = repState.get();
    return readOptFrom$1(dataset$$1, key).fold(() => repConfig.store().getFallbackEntry()(key), data => data);
  };
  const onLoad$2 = (component, repConfig, repState) => {
    repConfig.store().initialValue().each(data => {
      setValue$1(component, repConfig, repState, data);
    });
  };
  const onUnload$1 = (component, repConfig, repState) => {
    repState.set({});
  };
  const DatasetStore = [
    option('initialValue'),
    strict$1('getFallbackEntry'),
    strict$1('getDataKey'),
    strict$1('setData'),
    output$1('manager', {
      setValue: setValue$1,
      getValue: getValue$1,
      onLoad: onLoad$2,
      onUnload: onUnload$1,
      state: dataset
    })
  ];

  const getValue$2 = (component, repConfig, repState) => repConfig.store().getValue()(component);
  const setValue$2 = (component, repConfig, repState, data) => {
    repConfig.store().setValue()(component, data);
    repConfig.onSetValue()(component, data);
  };
  const onLoad$3 = (component, repConfig, repState) => {
    repConfig.store().initialValue().each(data => {
      repConfig.store().setValue()(component, data);
    });
  };
  const ManualStore = [
    strict$1('getValue'),
    defaulted$1('setValue', $_2vokfcwwjfuw8tb4.noop),
    option('initialValue'),
    output$1('manager', {
      setValue: setValue$2,
      getValue: getValue$2,
      onLoad: onLoad$3,
      onUnload: $_2vokfcwwjfuw8tb4.noop,
      state: init
    })
  ];

  const setValue$3 = (component, repConfig, repState, data) => {
    repState.set(data);
    repConfig.onSetValue()(component, data);
  };
  const getValue$3 = (component, repConfig, repState) => repState.get();
  const onLoad$4 = (component, repConfig, repState) => {
    repConfig.store().initialValue().each(initVal => {
      if (repState.isNotSet()) {
        repState.set(initVal);
      }
    });
  };
  const onUnload$2 = (component, repConfig, repState) => {
    repState.clear();
  };
  const MemoryStore = [
    option('initialValue'),
    output$1('manager', {
      setValue: setValue$3,
      getValue: getValue$3,
      onLoad: onLoad$4,
      onUnload: onUnload$2,
      state: memory
    })
  ];

  const RepresentSchema = [
    defaultedOf('store', { mode: 'memory' }, choose$1('mode', {
      memory: MemoryStore,
      manual: ManualStore,
      dataset: DatasetStore
    })),
    onHandler('onSetValue'),
    defaulted$1('resetOnDom', false)
  ];

  const Representing = create$1({
    fields: RepresentSchema,
    name: 'representing',
    active: ActiveRepresenting,
    apis: RepresentApis,
    extra: {
      setValueFrom(component, source) {
        const value = Representing.getValue(source);
        Representing.setValue(component, value);
      }
    },
    state: RepresentState
  });

  const isTouch$2 = $_5reqwox3jfuw8tbu.detect().deviceType.isTouch();
  const SliderSchema = [
    strict$1('min'),
    strict$1('max'),
    defaulted$1('stepSize', 1),
    defaulted$1('onChange', $_2vokfcwwjfuw8tb4.noop),
    defaulted$1('onInit', $_2vokfcwwjfuw8tb4.noop),
    defaulted$1('onDragStart', $_2vokfcwwjfuw8tb4.noop),
    defaulted$1('onDragEnd', $_2vokfcwwjfuw8tb4.noop),
    defaulted$1('snapToGrid', false),
    option('snapStart'),
    strict$1('getInitialValue'),
    field$1('sliderBehaviours', [
      Keying,
      Representing
    ]),
    state$1('value', spec => Cell(spec.min))
  ].concat(!isTouch$2 ? [state$1('mouseIsDown', () => Cell(false))] : []);

  const api$1 = Dimension('width', element => element.dom().offsetWidth);
  const set$4 = (element, h) => {
    api$1.set(element, h);
  };
  const get$6 = element => api$1.get(element);
  const getOuter$2 = element => api$1.getOuter(element);
  const setMax$1 = (element, value) => {
    const inclusions = [
      'margin-left',
      'border-left-width',
      'padding-left',
      'padding-right',
      'border-right-width',
      'margin-right'
    ];
    const absMax = api$1.max(element, value, inclusions);
    $_aag5ti106jfuw8tse.set(element, 'max-width', `${absMax}px`);
  };
  const $_dsj1h711zjfuw8u73 = {
    set: set$4,
    get: get$6,
    getOuter: getOuter$2,
    setMax: setMax$1
  };

  const isTouch$3 = $_5reqwox3jfuw8tbu.detect().deviceType.isTouch();
  const sketch$1 = (detail, components$$1, spec, externals) => {
    const range = detail.max() - detail.min();
    const getXCentre = component => {
      const rect = component.element().dom().getBoundingClientRect();
      return (rect.left + rect.right) / 2;
    };
    const getThumb = component => getPartOrDie(component, detail, 'thumb');
    const getXOffset = (slider, spectrumBounds, detail) => {
      const v = detail.value().get();
      if (v < detail.min()) {
        return getPart(slider, detail, 'left-edge').fold(() => 0, ledge => getXCentre(ledge) - spectrumBounds.left);
      } else if (v > detail.max()) {
        return getPart(slider, detail, 'right-edge').fold(() => spectrumBounds.width, redge => getXCentre(redge) - spectrumBounds.left);
      } else {
        return (detail.value().get() - detail.min()) / range * spectrumBounds.width;
      }
    };
    const getXPos = slider => {
      const spectrum = getPartOrDie(slider, detail, 'spectrum');
      const spectrumBounds = spectrum.element().dom().getBoundingClientRect();
      const sliderBounds = slider.element().dom().getBoundingClientRect();
      const xOffset = getXOffset(slider, spectrumBounds, detail);
      return spectrumBounds.left - sliderBounds.left + xOffset;
    };
    const refresh = component => {
      const pos = getXPos(component);
      const thumb = getThumb(component);
      const thumbRadius = $_dsj1h711zjfuw8u73.get(thumb.element()) / 2;
      $_aag5ti106jfuw8tse.set(thumb.element(), 'left', `${pos - thumbRadius}px`);
    };
    const changeValue = (component, newValue) => {
      const oldValue = detail.value().get();
      const thumb = getThumb(component);
      if (oldValue !== newValue || $_aag5ti106jfuw8tse.getRaw(thumb.element(), 'left').isNone()) {
        detail.value().set(newValue);
        refresh(component);
        detail.onChange()(component, thumb, newValue);
        return Option.some(true);
      } else {
        return Option.none();
      }
    };
    const resetToMin = slider => {
      changeValue(slider, detail.min());
    };
    const resetToMax = slider => {
      changeValue(slider, detail.max());
    };
    const uiEventsArr = isTouch$3 ? [
      run(touchstart(), (slider, simulatedEvent) => {
        detail.onDragStart()(slider, getThumb(slider));
      }),
      run(touchend(), (slider, simulatedEvent) => {
        detail.onDragEnd()(slider, getThumb(slider));
      })
    ] : [
      run(mousedown(), (slider, simulatedEvent) => {
        simulatedEvent.stop();
        detail.onDragStart()(slider, getThumb(slider));
        detail.mouseIsDown().set(true);
      }),
      run(mouseup(), (slider, simulatedEvent) => {
        detail.onDragEnd()(slider, getThumb(slider));
        detail.mouseIsDown().set(false);
      })
    ];
    return {
      uid: detail.uid(),
      dom: detail.dom(),
      components: components$$1,
      behaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2($_efmt4zxbjfuw8tcj.flatten([
        !isTouch$3 ? [Keying.config({
            mode: 'special',
            focusIn(slider) {
              return getPart(slider, detail, 'spectrum').map(Keying.focusIn).map($_2vokfcwwjfuw8tb4.constant(true));
            }
          })] : [],
        [Representing.config({
            store: {
              mode: 'manual',
              getValue(_) {
                return detail.value().get();
              }
            }
          })]
      ])), get$5(detail.sliderBehaviours())),
      events: derive([
        run(changeEvent(), (slider, simulatedEvent) => {
          changeValue(slider, simulatedEvent.event().value());
        }),
        runOnAttached((slider, simulatedEvent) => {
          detail.value().set(detail.getInitialValue()());
          const thumb = getThumb(slider);
          refresh(slider);
          detail.onInit()(slider, thumb, detail.value().get());
        })
      ].concat(uiEventsArr)),
      apis: {
        resetToMin,
        resetToMax,
        refresh
      },
      domModification: { styles: { position: 'relative' } }
    };
  };

  const Slider = composite$1({
    name: 'Slider',
    configFields: SliderSchema,
    partFields: SliderParts,
    factory: sketch$1,
    apis: {
      resetToMin(apis, slider) {
        apis.resetToMin(slider);
      },
      resetToMax(apis, slider) {
        apis.resetToMax(slider);
      },
      refresh(apis, slider) {
        apis.refresh(slider);
      }
    }
  });

  const button = (realm, clazz, makeItems) => $_44weuozujfuw8tqh.forToolbar(clazz, () => {
    const items = makeItems();
    realm.setContextToolbar([{
        label: `${clazz} group`,
        items
      }]);
  }, {});

  const BLACK = -1;
  const makeSlider = spec$$1 => {
    const getColor = hue => {
      if (hue < 0) {
        return 'black';
      } else if (hue > 360) {
        return 'white';
      } else {
        return `hsl(${hue}, 100%, 50%)`;
      }
    };
    const onInit = (slider, thumb, value) => {
      const color = getColor(value);
      $_aag5ti106jfuw8tse.set(thumb.element(), 'background-color', color);
    };
    const onChange = (slider, thumb, value) => {
      const color = getColor(value);
      $_aag5ti106jfuw8tse.set(thumb.element(), 'background-color', color);
      spec$$1.onChange(slider, thumb, color);
    };
    return Slider.sketch({
      dom: dom$1('<div class="${prefix}-slider ${prefix}-hue-slider-container"></div>'),
      components: [
        Slider.parts()['left-edge'](spec('<div class="${prefix}-hue-slider-black"></div>')),
        Slider.parts().spectrum({
          dom: dom$1('<div class="${prefix}-slider-gradient-container"></div>'),
          components: [spec('<div class="${prefix}-slider-gradient"></div>')],
          behaviours: derive$2([Toggling.config({ toggleClass: $_2fp9skztjfuw8tqe.resolve('thumb-active') })])
        }),
        Slider.parts()['right-edge'](spec('<div class="${prefix}-hue-slider-white"></div>')),
        Slider.parts().thumb({
          dom: dom$1('<div class="${prefix}-slider-thumb"></div>'),
          behaviours: derive$2([Toggling.config({ toggleClass: $_2fp9skztjfuw8tqe.resolve('thumb-active') })])
        })
      ],
      onChange,
      onDragStart(slider, thumb) {
        Toggling.on(thumb);
      },
      onDragEnd(slider, thumb) {
        Toggling.off(thumb);
      },
      onInit,
      stepSize: 10,
      min: 0,
      max: 360,
      getInitialValue: spec$$1.getInitialValue,
      sliderBehaviours: derive$2([$_9de9iyzsjfuw8tqa.orientation(Slider.refresh)])
    });
  };
  const makeItems = spec$$1 => [makeSlider(spec$$1)];
  const sketch$2 = (realm, editor) => {
    const spec$$1 = {
      onChange(slider, thumb, color) {
        editor.undoManager.transact(() => {
          editor.formatter.apply('forecolor', { value: color });
          editor.nodeChanged();
        });
      },
      getInitialValue() {
        return BLACK;
      }
    };
    return button(realm, 'color', () => makeItems(spec$$1));
  };
  const $_zydxw11kjfuw8u3z = {
    makeItems,
    sketch: sketch$2
  };

  const schema$7 = objOfOnly([
    strict$1('getInitialValue'),
    strict$1('onChange'),
    strict$1('category'),
    strict$1('sizes')
  ]);
  const sketch$3 = rawSpec => {
    const spec$$1 = asRawOrDie('SizeSlider', schema$7, rawSpec);
    const isValidValue = valueIndex => valueIndex >= 0 && valueIndex < spec$$1.sizes.length;
    const onChange = (slider, thumb, valueIndex) => {
      if (isValidValue(valueIndex)) {
        spec$$1.onChange(valueIndex);
      }
    };
    return Slider.sketch({
      dom: {
        tag: 'div',
        classes: [
          $_2fp9skztjfuw8tqe.resolve(`slider-${spec$$1.category}-size-container`),
          $_2fp9skztjfuw8tqe.resolve('slider'),
          $_2fp9skztjfuw8tqe.resolve('slider-size-container')
        ]
      },
      onChange,
      onDragStart(slider, thumb) {
        Toggling.on(thumb);
      },
      onDragEnd(slider, thumb) {
        Toggling.off(thumb);
      },
      min: 0,
      max: spec$$1.sizes.length - 1,
      stepSize: 1,
      getInitialValue: spec$$1.getInitialValue,
      snapToGrid: true,
      sliderBehaviours: derive$2([$_9de9iyzsjfuw8tqa.orientation(Slider.refresh)]),
      components: [
        Slider.parts().spectrum({
          dom: dom$1('<div class="${prefix}-slider-size-container"></div>'),
          components: [spec('<div class="${prefix}-slider-size-line"></div>')]
        }),
        Slider.parts().thumb({
          dom: dom$1('<div class="${prefix}-slider-thumb"></div>'),
          behaviours: derive$2([Toggling.config({ toggleClass: $_2fp9skztjfuw8tqe.resolve('thumb-active') })])
        })
      ]
    });
  };
  const $_uk6us122jfuw8u79 = { sketch: sketch$3 };

  const ancestor$3 = (scope, transform, isRoot) => {
    let element = scope.dom();
    const stop = $_8aqeo3wyjfuw8tb8.isFunction(isRoot) ? isRoot : $_2vokfcwwjfuw8tb4.constant(false);
    while (element.parentNode) {
      element = element.parentNode;
      const el = $_bwdnu0xijfuw8tdo.fromDom(element);
      const transformed = transform(el);
      if (transformed.isSome())
        return transformed;
      else if (stop(el))
        break;
    }
    return Option.none();
  };
  const closest$3 = (scope, transform, isRoot) => {
    const current = transform(scope);
    return current.orThunk(() => isRoot(scope) ? Option.none() : ancestor$3(scope, transform, isRoot));
  };
  const $_90p555124jfuw8u81 = {
    ancestor: ancestor$3,
    closest: closest$3
  };

  const candidates = [
    '9px',
    '10px',
    '11px',
    '12px',
    '14px',
    '16px',
    '18px',
    '20px',
    '24px',
    '32px',
    '36px'
  ];
  const defaultSize = 'medium';
  const defaultIndex = 2;
  const indexToSize = index => Option.from(candidates[index]);
  const sizeToIndex = size => $_efmt4zxbjfuw8tcj.findIndex(candidates, v => v === size);
  const getRawOrComputed = (isRoot, rawStart) => {
    const optStart = $_74lhjaxjjfuw8tdt.isElement(rawStart) ? Option.some(rawStart) : $_aff64dxmjfuw8tdx.parent(rawStart);
    return optStart.map(start => {
      const inline = $_90p555124jfuw8u81.closest(start, elem => $_aag5ti106jfuw8tse.getRaw(elem, 'font-size'), isRoot);
      return inline.getOrThunk(() => $_aag5ti106jfuw8tse.get(start, 'font-size'));
    }).getOr('');
  };
  const getSize = editor => {
    const node = editor.selection.getStart();
    const elem = $_bwdnu0xijfuw8tdo.fromDom(node);
    const root = $_bwdnu0xijfuw8tdo.fromDom(editor.getBody());
    const isRoot = e => $_4867a0xsjfuw8tej.eq(root, e);
    const elemSize = getRawOrComputed(isRoot, elem);
    return $_efmt4zxbjfuw8tcj.find(candidates, size => elemSize === size).getOr(defaultSize);
  };
  const applySize = (editor, value) => {
    const currentValue = getSize(editor);
    if (currentValue !== value) {
      editor.execCommand('fontSize', false, value);
    }
  };
  const get$7 = editor => {
    const size = getSize(editor);
    return sizeToIndex(size).getOr(defaultIndex);
  };
  const apply$1 = (editor, index) => {
    indexToSize(index).each(size => {
      applySize(editor, size);
    });
  };
  const $_ek5te123jfuw8u7k = {
    candidates: $_2vokfcwwjfuw8tb4.constant(candidates),
    get: get$7,
    apply: apply$1
  };

  const sizes = $_ek5te123jfuw8u7k.candidates();
  const makeSlider$1 = spec$$1 => $_uk6us122jfuw8u79.sketch({
    onChange: spec$$1.onChange,
    sizes,
    category: 'font',
    getInitialValue: spec$$1.getInitialValue
  });
  const makeItems$1 = spec$$1 => [
    spec('<span class="${prefix}-toolbar-button ${prefix}-icon-small-font ${prefix}-icon"></span>'),
    makeSlider$1(spec$$1),
    spec('<span class="${prefix}-toolbar-button ${prefix}-icon-large-font ${prefix}-icon"></span>')
  ];
  const sketch$4 = (realm, editor) => {
    const spec$$1 = {
      onChange(value) {
        $_ek5te123jfuw8u7k.apply(editor, value);
      },
      getInitialValue() {
        return $_ek5te123jfuw8u7k.get(editor);
      }
    };
    return button(realm, 'font-size', () => makeItems$1(spec$$1));
  };

  const record = spec => {
    const uid = isSketchSpec(spec) && hasKey$1(spec, 'uid') ? spec.uid : generate$3('memento');
    const get = any => any.getSystem().getByUid(uid).getOrDie();
    const getOpt = any => any.getSystem().getByUid(uid).fold(Option.none, Option.some);
    const asSpec = () => $_3jctjywxjfuw8tb6.deepMerge(spec, { uid });
    return {
      get,
      getOpt,
      asSpec
    };
  };

  function create$3(width, height) {
    return resize(document.createElement('canvas'), width, height);
  }
  function clone$2(canvas) {
    let tCanvas;
    let ctx;
    tCanvas = create$3(canvas.width, canvas.height);
    ctx = get2dContext(tCanvas);
    ctx.drawImage(canvas, 0, 0);
    return tCanvas;
  }
  function get2dContext(canvas) {
    return canvas.getContext('2d');
  }
  function get3dContext(canvas) {
    let gl = null;
    try {
      gl = canvas.getContext('webgl') || canvas.getContext('experimental-webgl');
    } catch (e) {
    }
    if (!gl) {
      gl = null;
    }
    return gl;
  }
  function resize(canvas, width, height) {
    canvas.width = width;
    canvas.height = height;
    return canvas;
  }
  const $_3ha18t129jfuw8u9g = {
    create: create$3,
    clone: clone$2,
    resize,
    get2dContext,
    get3dContext
  };

  function getWidth(image) {
    return image.naturalWidth || image.width;
  }
  function getHeight(image) {
    return image.naturalHeight || image.height;
  }
  const $_3360ic12ajfuw8u9i = {
    getWidth,
    getHeight
  };

  const promise = () => {
    class Promise {
      constructor(fn) {
        if (typeof this !== 'object')
          throw new TypeError('Promises must be constructed via new');
        if (typeof fn !== 'function')
          throw new TypeError('not a function');
        this._state = null;
        this._value = null;
        this._deferreds = [];
        doResolve(fn, bind(resolve, this), bind(reject, this));
      }

      then(onFulfilled, onRejected) {
        const me = this;
        return new Promise((resolve, reject) => {
          handle.call(me, new Handler(onFulfilled, onRejected, resolve, reject));
        });
      }

      static all() {
        const args = Array.prototype.slice.call(arguments.length === 1 && isArray(arguments[0]) ? arguments[0] : arguments);
        return new Promise((resolve, reject) => {
          if (args.length === 0)
            return resolve([]);
          let remaining = args.length;
          function res(i, val) {
            try {
              if (val && (typeof val === 'object' || typeof val === 'function')) {
                const then = val.then;
                if (typeof then === 'function') {
                  then.call(val, val => {
                    res(i, val);
                  }, reject);
                  return;
                }
              }
              args[i] = val;
              if (--remaining === 0) {
                resolve(args);
              }
            } catch (ex) {
              reject(ex);
            }
          }
          for (let i = 0; i < args.length; i++) {
            res(i, args[i]);
          }
        });
      }

      static resolve(value) {
        if (value && typeof value === 'object' && value.constructor === Promise) {
          return value;
        }
        return new Promise(resolve => {
          resolve(value);
        });
      }

      static reject(value) {
        return new Promise((resolve, reject) => {
          reject(value);
        });
      }

      static race(values) {
        return new Promise((resolve, reject) => {
          for (let i = 0, len = values.length; i < len; i++) {
            values[i].then(resolve, reject);
          }
        });
      }
    }

    const asap = Promise.immediateFn || typeof setImmediate === 'function' && setImmediate || (fn => {
      setTimeout(fn, 1);
    });
    function bind(fn, thisArg) {
      return function () {
        fn.apply(thisArg, arguments);
      };
    }
    var isArray = Array.isArray || (value => Object.prototype.toString.call(value) === '[object Array]');
    function handle(deferred) {
      const me = this;
      if (this._state === null) {
        this._deferreds.push(deferred);
        return;
      }
      asap(() => {
        const cb = me._state ? deferred.onFulfilled : deferred.onRejected;
        if (cb === null) {
          (me._state ? deferred.resolve : deferred.reject)(me._value);
          return;
        }
        let ret;
        try {
          ret = cb(me._value);
        } catch (e) {
          deferred.reject(e);
          return;
        }
        deferred.resolve(ret);
      });
    }
    function resolve(newValue) {
      try {
        if (newValue === this)
          throw new TypeError('A promise cannot be resolved with itself.');
        if (newValue && (typeof newValue === 'object' || typeof newValue === 'function')) {
          const then = newValue.then;
          if (typeof then === 'function') {
            doResolve(bind(then, newValue), bind(resolve, this), bind(reject, this));
            return;
          }
        }
        this._state = true;
        this._value = newValue;
        finale.call(this);
      } catch (e) {
        reject.call(this, e);
      }
    }
    function reject(newValue) {
      this._state = false;
      this._value = newValue;
      finale.call(this);
    }
    function finale() {
      for (let i = 0, len = this._deferreds.length; i < len; i++) {
        handle.call(this, this._deferreds[i]);
      }
      this._deferreds = null;
    }
    function Handler(onFulfilled, onRejected, resolve, reject) {
      this.onFulfilled = typeof onFulfilled === 'function' ? onFulfilled : null;
      this.onRejected = typeof onRejected === 'function' ? onRejected : null;
      this.resolve = resolve;
      this.reject = reject;
    }
    function doResolve(fn, onFulfilled, onRejected) {
      let done = false;
      try {
        fn(value => {
          if (done)
            return;
          done = true;
          onFulfilled(value);
        }, reason => {
          if (done)
            return;
          done = true;
          onRejected(reason);
        });
      } catch (ex) {
        if (done)
          return;
        done = true;
        onRejected(ex);
      }
    }
    Promise.prototype['catch'] = function (onRejected) {
      return this.then(null, onRejected);
    };
    return Promise;
  };
  var Promise = window.Promise ? window.Promise : promise();

  function Blob (parts, properties) {
    const f = $_dxyj33xujfuw8tet.getOrDie('Blob');
    return new f(parts, properties);
  }

  function FileReader () {
    const f = $_dxyj33xujfuw8tet.getOrDie('FileReader');
    return new f();
  }

  function Uint8Array (arr) {
    const f = $_dxyj33xujfuw8tet.getOrDie('Uint8Array');
    return new f(arr);
  }

  const requestAnimationFrame = callback => {
    const f = $_dxyj33xujfuw8tet.getOrDie('requestAnimationFrame');
    f(callback);
  };
  const atob = base64 => {
    const f = $_dxyj33xujfuw8tet.getOrDie('atob');
    return f(base64);
  };
  const $_76467112fjfuw8u9q = {
    atob,
    requestAnimationFrame
  };

  function imageToBlob(image) {
    const src = image.src;
    if (src.indexOf('data:') === 0) {
      return dataUriToBlob(src);
    }
    return anyUriToBlob(src);
  }
  function blobToImage(blob) {
    return new Promise((resolve, reject) => {
      const blobUrl = URL.createObjectURL(blob);
      const image = new Image();
      const removeListeners = () => {
        image.removeEventListener('load', loaded);
        image.removeEventListener('error', error);
      };
      function loaded() {
        removeListeners();
        resolve(image);
      }
      function error() {
        removeListeners();
        reject(`Unable to load data of type ${blob.type}: ${blobUrl}`);
      }
      image.addEventListener('load', loaded);
      image.addEventListener('error', error);
      image.src = blobUrl;
      if (image.complete) {
        loaded();
      }
    });
  }
  function anyUriToBlob(url) {
    return new Promise((resolve, reject) => {
      const xhr = new XMLHttpRequest();
      xhr.open('GET', url, true);
      xhr.responseType = 'blob';
      xhr.onload = function () {
        if (this.status == 200) {
          resolve(this.response);
        }
      };
      xhr.onerror = function () {
        const _this = this;
        const corsError = () => {
          const obj = new Error('No access to download image');
          obj.code = 18;
          obj.name = 'SecurityError';
          return obj;
        };
        const genericError = () => new Error(`Error ${_this.status} downloading image`);
        reject(this.status === 0 ? corsError() : genericError());
      };
      xhr.send();
    });
  }
  function dataUriToBlobSync(uri) {
    const data = uri.split(',');
    const matches = /data:([^;]+)/.exec(data[0]);
    if (!matches)
      return Option.none();
    const mimetype = matches[1];
    const base64 = data[1];
    const sliceSize = 1024;
    const byteCharacters = $_76467112fjfuw8u9q.atob(base64);
    const bytesLength = byteCharacters.length;
    const slicesCount = Math.ceil(bytesLength / sliceSize);
    const byteArrays = new Array(slicesCount);
    for (let sliceIndex = 0; sliceIndex < slicesCount; ++sliceIndex) {
      const begin = sliceIndex * sliceSize;
      const end = Math.min(begin + sliceSize, bytesLength);
      const bytes = new Array(end - begin);
      for (let offset = begin, i = 0; offset < end; ++i, ++offset) {
        bytes[i] = byteCharacters[offset].charCodeAt(0);
      }
      byteArrays[sliceIndex] = Uint8Array(bytes);
    }
    return Option.some(Blob(byteArrays, { type: mimetype }));
  }
  function dataUriToBlob(uri) {
    return new Promise((resolve, reject) => {
      dataUriToBlobSync(uri).fold(() => {
        reject(`uri is not base64: ${uri}`);
      }, resolve);
    });
  }
  function uriToBlob(url) {
    if (url.indexOf('blob:') === 0) {
      return anyUriToBlob(url);
    }
    if (url.indexOf('data:') === 0) {
      return dataUriToBlob(url);
    }
    return null;
  }
  function canvasToBlob(canvas, type='image/png', quality) {
    if (HTMLCanvasElement.prototype.toBlob) {
      return new Promise(resolve => {
        canvas.toBlob(blob => {
          resolve(blob);
        }, type, quality);
      });
    } else {
      return dataUriToBlob(canvas.toDataURL(type, quality));
    }
  }
  function canvasToDataURL(getCanvas, type='image/png', quality) {
    return getCanvas.then(canvas => canvas.toDataURL(type, quality));
  }
  function blobToCanvas(blob) {
    return blobToImage(blob).then(image => {
      revokeImageUrl(image);
      let context;
      let canvas;
      canvas = $_3ha18t129jfuw8u9g.create($_3360ic12ajfuw8u9i.getWidth(image), $_3360ic12ajfuw8u9i.getHeight(image));
      context = $_3ha18t129jfuw8u9g.get2dContext(canvas);
      context.drawImage(image, 0, 0);
      return canvas;
    });
  }
  function blobToDataUri(blob) {
    return new Promise(resolve => {
      const reader = new FileReader();
      reader.onloadend = () => {
        resolve(reader.result);
      };
      reader.readAsDataURL(blob);
    });
  }
  function blobToArrayBuffer(blob) {
    return new Promise(resolve => {
      const reader = new FileReader();
      reader.onloadend = () => {
        resolve(reader.result);
      };
      reader.readAsArrayBuffer(blob);
    });
  }
  function blobToBase64(blob) {
    return blobToDataUri(blob).then(dataUri => dataUri.split(',')[1]);
  }
  function revokeImageUrl(image) {
    URL.revokeObjectURL(image.src);
  }
  const $_fqgkv9128jfuw8u93 = {
    blobToImage,
    imageToBlob,
    blobToArrayBuffer,
    blobToDataUri,
    blobToBase64,
    dataUriToBlobSync,
    canvasToBlob,
    canvasToDataURL,
    blobToCanvas,
    uriToBlob
  };

  const blobToImage$1 = image => $_fqgkv9128jfuw8u93.blobToImage(image);
  const imageToBlob$1 = blob => $_fqgkv9128jfuw8u93.imageToBlob(blob);
  const blobToDataUri$1 = blob => $_fqgkv9128jfuw8u93.blobToDataUri(blob);
  const blobToBase64$1 = blob => $_fqgkv9128jfuw8u93.blobToBase64(blob);
  const dataUriToBlobSync$1 = uri => $_fqgkv9128jfuw8u93.dataUriToBlobSync(uri);
  const uriToBlob$1 = uri => Option.from($_fqgkv9128jfuw8u93.uriToBlob(uri));
  const $_e0pod3127jfuw8u8y = {
    blobToImage: blobToImage$1,
    imageToBlob: imageToBlob$1,
    blobToDataUri: blobToDataUri$1,
    blobToBase64: blobToBase64$1,
    dataUriToBlobSync: dataUriToBlobSync$1,
    uriToBlob: uriToBlob$1
  };

  const addImage = (editor, blob) => {
    $_e0pod3127jfuw8u8y.blobToBase64(blob).then(base64 => {
      editor.undoManager.transact(() => {
        const cache = editor.editorUpload.blobCache;
        const info = cache.create($_5j06su11ajfuw8u1p.generate('mceu'), blob, base64);
        cache.add(info);
        const img = editor.dom.createHTML('img', { src: info.blobUri() });
        editor.insertContent(img);
      });
    });
  };
  const extractBlob = simulatedEvent => {
    const event = simulatedEvent.event();
    const files = event.raw().target.files || event.raw().dataTransfer.files;
    return Option.from(files[0]);
  };
  const sketch$5 = editor => {
    const pickerDom = {
      tag: 'input',
      attributes: {
        accept: 'image/*',
        type: 'file',
        title: ''
      },
      styles: {
        visibility: 'hidden',
        position: 'absolute'
      }
    };
    const memPicker = record({
      dom: pickerDom,
      events: derive([
        cutter(click()),
        run(change(), (picker, simulatedEvent) => {
          extractBlob(simulatedEvent).each(blob => {
            addImage(editor, blob);
          });
        })
      ])
    });
    return Button.sketch({
      dom: dom$1('<span class="${prefix}-toolbar-button ${prefix}-icon-image ${prefix}-icon"></span>'),
      components: [memPicker.asSpec()],
      action(button) {
        const picker = memPicker.get(button);
        picker.element().dom().click();
      }
    });
  };

  const get$8 = element => element.dom().textContent;
  const set$5 = (element, value) => {
    element.dom().textContent = value;
  };
  const $_eo325p12ijfuw8uaa = {
    get: get$8,
    set: set$5
  };

  const isNotEmpty = val => val.length > 0;
  const defaultToEmpty = str => str === undefined || str === null ? '' : str;
  const noLink = editor => {
    const text = editor.selection.getContent({ format: 'text' });
    return {
      url: '',
      text,
      title: '',
      target: '',
      link: Option.none()
    };
  };
  const fromLink = link => {
    const text = $_eo325p12ijfuw8uaa.get(link);
    const url = $_47adx7ywjfuw8tl3.get(link, 'href');
    const title = $_47adx7ywjfuw8tl3.get(link, 'title');
    const target = $_47adx7ywjfuw8tl3.get(link, 'target');
    return {
      url: defaultToEmpty(url),
      text: text !== url ? defaultToEmpty(text) : '',
      title: defaultToEmpty(title),
      target: defaultToEmpty(target),
      link: Option.some(link)
    };
  };
  const getInfo = editor => query(editor).fold(() => noLink(editor), link => fromLink(link));
  const wasSimple = link => {
    const prevHref = $_47adx7ywjfuw8tl3.get(link, 'href');
    const prevText = $_eo325p12ijfuw8uaa.get(link);
    return prevHref === prevText;
  };
  const getTextToApply = (link, url, info) => info.text.filter(isNotEmpty).fold(() => wasSimple(link) ? Option.some(url) : Option.none(), Option.some);
  const unlinkIfRequired = (editor, info) => {
    const activeLink = info.link.bind($_2vokfcwwjfuw8tb4.identity);
    activeLink.each(link => {
      editor.execCommand('unlink');
    });
  };
  const getAttrs$1 = (url, info) => {
    const attrs = {};
    attrs.href = url;
    info.title.filter(isNotEmpty).each(title => {
      attrs.title = title;
    });
    info.target.filter(isNotEmpty).each(target => {
      attrs.target = target;
    });
    return attrs;
  };
  const applyInfo = (editor, info) => {
    info.url.filter(isNotEmpty).fold(() => {
      unlinkIfRequired(editor, info);
    }, url => {
      const attrs = getAttrs$1(url, info);
      const activeLink = info.link.bind($_2vokfcwwjfuw8tb4.identity);
      activeLink.fold(() => {
        const text = info.text.filter(isNotEmpty).getOr(url);
        editor.insertContent(editor.dom.createHTML('a', attrs, editor.dom.encode(text)));
      }, link => {
        const text = getTextToApply(link, url, info);
        $_47adx7ywjfuw8tl3.setAll(link, attrs);
        text.each(newText => {
          $_eo325p12ijfuw8uaa.set(link, newText);
        });
      });
    });
  };
  var query = editor => {
    const start = $_bwdnu0xijfuw8tdo.fromDom(editor.selection.getStart());
    return $_c8lemt10bjfuw8tt8.closest(start, 'a');
  };
  const $_fhf8dq12hjfuw8u9y = {
    getInfo,
    applyInfo,
    query
  };

  const platform$1 = $_5reqwox3jfuw8tbu.detect();
  const preserve$1 = (f, editor) => {
    const rng = editor.selection.getRng();
    f();
    editor.selection.setRng(rng);
  };
  const forAndroid = (editor, f) => {
    const wrapper = platform$1.os.isAndroid() ? preserve$1 : $_2vokfcwwjfuw8tb4.apply;
    wrapper(f, editor);
  };
  const $_6d07m912jjfuw8uab = { forAndroid };

  const events$6 = (name, eventHandlers) => {
    const events = derive(eventHandlers);
    return create$1({
      fields: [strict$1('enabled')],
      name,
      active: { events: $_2vokfcwwjfuw8tb4.constant(events) }
    });
  };
  const config = (name, eventHandlers) => {
    const me = events$6(name, eventHandlers);
    return {
      key: name,
      value: {
        config: {},
        me,
        configAsRaw: $_2vokfcwwjfuw8tb4.constant({}),
        initialConfig: {},
        state: noState()
      }
    };
  };

  const getCurrent = (component, composeConfig, composeState) => composeConfig.find()(component);


  const ComposeApis = Object.freeze({
    getCurrent
  });

  const ComposeSchema = [strict$1('find')];

  const Composing = create$1({
    fields: ComposeSchema,
    name: 'composing',
    apis: ComposeApis
  });

  const factory$1 = (detail, spec) => ({
    uid: detail.uid(),

    dom: $_3jctjywxjfuw8tb6.deepMerge({
      tag: 'div',
      attributes: { role: 'presentation' }
    }, detail.dom()),

    components: detail.components(),
    behaviours: get$5(detail.containerBehaviours()),
    events: detail.events(),
    domModification: detail.domModification(),
    eventOrder: detail.eventOrder()
  });
  const Container = single$2({
    name: 'Container',
    factory: factory$1,
    configFields: [
      defaulted$1('components', []),
      field$1('containerBehaviours', []),
      defaulted$1('events', {}),
      defaulted$1('domModification', {}),
      defaulted$1('eventOrder', {})
    ]
  });

  const factory$2 = (detail, spec) => ({
    uid: detail.uid(),
    dom: detail.dom(),

    behaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2([
      Representing.config({
        store: {
          mode: 'memory',
          initialValue: detail.getInitialValue()()
        }
      }),
      Composing.config({ find: Option.some })
    ]), get$5(detail.dataBehaviours())),

    events: derive([runOnAttached((component, simulatedEvent) => {
        Representing.setValue(component, detail.getInitialValue()());
      })])
  });
  const DataField = single$2({
    name: 'DataField',
    factory: factory$2,
    configFields: [
      strict$1('uid'),
      strict$1('dom'),
      strict$1('getInitialValue'),
      field$1('dataBehaviours', [
        Representing,
        Composing
      ])
    ]
  });

  const get$9 = element => element.dom().value;
  const set$6 = (element, value) => {
    if (value === undefined)
      throw new Error('Value.set was undefined');
    element.dom().value = value;
  };
  const $_7340hz12tjfuw8uci = {
    set: set$6,
    get: get$9
  };

  const schema$8 = $_2vokfcwwjfuw8tb4.constant([
    option('data'),
    defaulted$1('inputAttributes', {}),
    defaulted$1('inputStyles', {}),
    defaulted$1('type', 'input'),
    defaulted$1('tag', 'input'),
    defaulted$1('inputClasses', []),
    onHandler('onSetValue'),
    defaulted$1('styles', {}),
    option('placeholder'),
    defaulted$1('eventOrder', {}),
    field$1('inputBehaviours', [
      Representing,
      Focusing
    ]),
    defaulted$1('selectOnFocus', true)
  ]);
  const behaviours = detail => $_3jctjywxjfuw8tb6.deepMerge(derive$2([
    Representing.config({
      store: {
        mode: 'manual',
        initialValue: detail.data().getOr(undefined),
        getValue(input) {
          return $_7340hz12tjfuw8uci.get(input.element());
        },
        setValue(input, data) {
          const current = $_7340hz12tjfuw8uci.get(input.element());
          if (current !== data) {
            $_7340hz12tjfuw8uci.set(input.element(), data);
          }
        }
      },
      onSetValue: detail.onSetValue()
    }),
    Focusing.config({
      onFocus: detail.selectOnFocus() === false ? $_2vokfcwwjfuw8tb4.noop : component => {
        const input = component.element();
        const value = $_7340hz12tjfuw8uci.get(input);
        input.dom().setSelectionRange(0, value.length);
      }
    })
  ]), get$5(detail.inputBehaviours()));
  const dom$2 = detail => ({
    tag: detail.tag(),

    attributes: $_3jctjywxjfuw8tb6.deepMerge(wrapAll$1([{
        key: 'type',
        value: detail.type()
      }].concat(detail.placeholder().map(pc => ({
      key: 'placeholder',
      value: pc
    })).toArray())), detail.inputAttributes()),

    styles: detail.inputStyles(),
    classes: detail.inputClasses()
  });

  const factory$3 = (detail, spec) => ({
    uid: detail.uid(),
    dom: dom$2(detail),
    components: [],
    behaviours: behaviours(detail),
    eventOrder: detail.eventOrder()
  });
  const Input = single$2({
    name: 'Input',
    configFields: schema$8(),
    factory: factory$3
  });

  const exhibit$3 = (base, tabConfig) => nu$6({
    attributes: wrapAll$1([{
        key: tabConfig.tabAttr(),
        value: 'true'
      }])
  });


  const ActiveTabstopping = Object.freeze({
    exhibit: exhibit$3
  });

  const TabstopSchema = [defaulted$1('tabAttr', 'data-alloy-tabstop')];

  const Tabstopping = create$1({
    fields: TabstopSchema,
    name: 'tabstopping',
    active: ActiveTabstopping
  });

  const clearInputBehaviour = 'input-clearing';
  const field$2 = (name, placeholder) => {
    const inputSpec = record(Input.sketch({
      placeholder,
      onSetValue(input$$1, data) {
        emit(input$$1, input());
      },
      inputBehaviours: derive$2([
        Composing.config({ find: Option.some }),
        Tabstopping.config({}),
        Keying.config({ mode: 'execution' })
      ]),
      selectOnFocus: false
    }));
    const buttonSpec = record(Button.sketch({
      dom: dom$1('<button class="${prefix}-input-container-x ${prefix}-icon-cancel-circle ${prefix}-icon"></button>'),
      action(button) {
        const input$$1 = inputSpec.get(button);
        Representing.setValue(input$$1, '');
      }
    }));
    return {
      name,
      spec: Container.sketch({
        dom: dom$1('<div class="${prefix}-input-container"></div>'),
        components: [
          inputSpec.asSpec(),
          buttonSpec.asSpec()
        ],
        containerBehaviours: derive$2([
          Toggling.config({ toggleClass: $_2fp9skztjfuw8tqe.resolve('input-container-empty') }),
          Composing.config({
            find(comp) {
              return Option.some(inputSpec.get(comp));
            }
          }),
          config(clearInputBehaviour, [run(input(), iContainer => {
              const input$$1 = inputSpec.get(iContainer);
              const val = Representing.getValue(input$$1);
              const f = val.length > 0 ? Toggling.off : Toggling.on;
              f(iContainer);
            })])
        ])
      })
    };
  };
  const hidden = name => ({
    name,

    spec: DataField.sketch({
      dom: {
        tag: 'span',
        styles: { display: 'none' }
      },
      getInitialValue() {
        return Option.none();
      }
    })
  });

  const nativeDisabled = [
    'input',
    'button',
    'textarea'
  ];
  const onLoad$5 = (component, disableConfig, disableState) => {
    if (disableConfig.disabled()) {
      disable(component, disableConfig, disableState);
    }
  };
  const hasNative = component => $_efmt4zxbjfuw8tcj.contains(nativeDisabled, $_74lhjaxjjfuw8tdt.name(component.element()));
  const nativeIsDisabled = component => $_47adx7ywjfuw8tl3.has(component.element(), 'disabled');
  const nativeDisable = component => {
    $_47adx7ywjfuw8tl3.set(component.element(), 'disabled', 'disabled');
  };
  const nativeEnable = component => {
    $_47adx7ywjfuw8tl3.remove(component.element(), 'disabled');
  };
  const ariaIsDisabled = component => $_47adx7ywjfuw8tl3.get(component.element(), 'aria-disabled') === 'true';
  const ariaDisable = component => {
    $_47adx7ywjfuw8tl3.set(component.element(), 'aria-disabled', 'true');
  };
  const ariaEnable = component => {
    $_47adx7ywjfuw8tl3.set(component.element(), 'aria-disabled', 'false');
  };
  var disable = (component, disableConfig, disableState) => {
    disableConfig.disableClass().each(disableClass => {
      $_6po7jxyujfuw8tl0.add(component.element(), disableClass);
    });
    const f = hasNative(component) ? nativeDisable : ariaDisable;
    f(component);
  };
  const enable = (component, disableConfig, disableState) => {
    disableConfig.disableClass().each(disableClass => {
      $_6po7jxyujfuw8tl0.remove(component.element(), disableClass);
    });
    const f = hasNative(component) ? nativeEnable : ariaEnable;
    f(component);
  };
  const isDisabled = component => hasNative(component) ? nativeIsDisabled(component) : ariaIsDisabled(component);


  const DisableApis = Object.freeze({
    enable,
    disable,
    isDisabled,
    onLoad: onLoad$5
  });

  const exhibit$4 = (base, disableConfig, disableState) => nu$6({ classes: disableConfig.disabled() ? disableConfig.disableClass().map($_efmt4zxbjfuw8tcj.pure).getOr([]) : [] });
  const events$7 = (disableConfig, disableState) => derive([
    abort(execute(), (component, simulatedEvent) => isDisabled(component)),
    loadEvent(disableConfig, disableState, onLoad$5)
  ]);


  const ActiveDisable = Object.freeze({
    exhibit: exhibit$4,
    events: events$7
  });

  const DisableSchema = [
    defaulted$1('disabled', false),
    option('disableClass')
  ];

  const Disabling = create$1({
    fields: DisableSchema,
    name: 'disabling',
    active: ActiveDisable,
    apis: DisableApis
  });

  const owner$1 = 'form';
  const schema$9 = [field$1('formBehaviours', [Representing])];
  const getPartName = name => `<alloy.field.${name}>`;
  const sketch$6 = fSpec => {
    const parts = (() => {
      const record = [];
      const field = (name, config) => {
        record.push(name);
        return generateOne(owner$1, getPartName(name), config);
      };
      return {
        field,
        record() {
          return record;
        }
      };
    })();
    const spec = fSpec(parts);
    const partNames = parts.record();
    const fieldParts = $_efmt4zxbjfuw8tcj.map(partNames, n => required({
      name: n,
      pname: getPartName(n)
    }));
    return composite(owner$1, schema$9, fieldParts, make, spec);
  };
  var make = (detail, components$$1, spec) => $_3jctjywxjfuw8tb6.deepMerge({
    'debug.sketcher': { Form: spec },
    'uid': detail.uid(),
    'dom': detail.dom(),
    'components': components$$1,
    'behaviours': $_3jctjywxjfuw8tb6.deepMerge(derive$2([Representing.config({
        store: {
          mode: 'manual',
          getValue(form) {
            const optPs = getAllParts(form, detail);
            return $_8qu224wzjfuw8tb9.map(optPs, (optPThunk, pName) => optPThunk().bind(Composing.getCurrent).map(Representing.getValue));
          },
          setValue(form, values) {
            $_8qu224wzjfuw8tb9.each(values, (newValue, key) => {
              getPart(form, detail, key).each(wrapper => {
                Composing.getCurrent(wrapper).each(field => {
                  Representing.setValue(field, newValue);
                });
              });
            });
          }
        }
      })]), get$5(detail.formBehaviours())),
    'apis': {
      getField(form, key) {
        return getPart(form, detail, key).bind(Composing.getCurrent);
      }
    }
  });
  const Form = {
    getField: makeApi((apis, component, key) => apis.getField(component, key)),
    sketch: sketch$6
  };

  const revocable = doRevoke => {
    const subject = Cell(Option.none());
    const revoke = () => {
      subject.get().each(doRevoke);
    };
    const clear = () => {
      revoke();
      subject.set(Option.none());
    };
    const set = s => {
      revoke();
      subject.set(Option.some(s));
    };
    const isSet = () => subject.get().isSome();
    return {
      clear,
      isSet,
      set
    };
  };
  const destroyable = () => revocable(s => {
    s.destroy();
  });
  const unbindable = () => revocable(s => {
    s.unbind();
  });
  const api$2 = () => {
    const subject = Cell(Option.none());
    const revoke = () => {
      subject.get().each(s => {
        s.destroy();
      });
    };
    const clear = () => {
      revoke();
      subject.set(Option.none());
    };
    const set = s => {
      revoke();
      subject.set(Option.some(s));
    };
    const run = f => {
      subject.get().each(f);
    };
    const isSet = () => subject.get().isSome();
    return {
      clear,
      isSet,
      set,
      run
    };
  };
  const value$3 = () => {
    const subject = Cell(Option.none());
    const clear = () => {
      subject.set(Option.none());
    };
    const set = s => {
      subject.set(Option.some(s));
    };
    const on = f => {
      subject.get().each(f);
    };
    const isSet = () => subject.get().isSome();
    return {
      clear,
      set,
      isSet,
      on
    };
  };
  const $_bh7xqm133jfuw8uet = {
    destroyable,
    unbindable,
    api: api$2,
    value: value$3
  };

  const SWIPING_LEFT = 1;
  const SWIPING_RIGHT = -1;
  const SWIPING_NONE = 0;
  const init$3 = xValue => ({
    xValue,
    points: []
  });
  const move$1 = (model, xValue) => {
    if (xValue === model.xValue) {
      return model;
    }
    const currentDirection = xValue - model.xValue > 0 ? SWIPING_LEFT : SWIPING_RIGHT;
    const newPoint = {
      direction: currentDirection,
      xValue
    };
    const priorPoints = (() => {
      if (model.points.length === 0) {
        return [];
      } else {
        const prev = model.points[model.points.length - 1];
        return prev.direction === currentDirection ? model.points.slice(0, model.points.length - 1) : model.points;
      }
    })();
    return {
      xValue,
      points: priorPoints.concat([newPoint])
    };
  };
  const complete = model => {
    if (model.points.length === 0) {
      return SWIPING_NONE;
    } else {
      const firstDirection = model.points[0].direction;
      const lastDirection = model.points[model.points.length - 1].direction;
      return firstDirection === SWIPING_RIGHT && lastDirection === SWIPING_RIGHT ? SWIPING_RIGHT : firstDirection === SWIPING_LEFT && lastDirection === SWIPING_LEFT ? SWIPING_LEFT : SWIPING_NONE;
    }
  };
  const $_f3hwqu134jfuw8uev = {
    init: init$3,
    move: move$1,
    complete
  };

  const sketch$7 = rawSpec => {
    const navigateEvent = 'navigateEvent';
    const wrapperAdhocEvents = 'serializer-wrapper-events';
    const formAdhocEvents = 'form-events';
    const schema = objOf([
      strict$1('fields'),
      defaulted$1('maxFieldIndex', rawSpec.fields.length - 1),
      strict$1('onExecute'),
      strict$1('getInitialValue'),
      state$1('state', () => ({
        dialogSwipeState: $_bh7xqm133jfuw8uet.value(),
        currentScreen: Cell(0)
      }))
    ]);
    const spec$$1 = asRawOrDie('SerialisedDialog', schema, rawSpec);
    const navigationButton = (direction, directionName, enabled) => Button.sketch({
      dom: dom$1(`<span class="${prefix}-icon-${directionName} ${prefix}-icon"></span>`),
      action(button) {
        emitWith(button, navigateEvent, { direction });
      },
      buttonBehaviours: derive$2([Disabling.config({
          disableClass: $_2fp9skztjfuw8tqe.resolve('toolbar-navigation-disabled'),
          disabled: !enabled
        })])
    });
    const reposition = (dialog, message) => {
      $_c8lemt10bjfuw8tt8.descendant(dialog.element(), `.${$_2fp9skztjfuw8tqe.resolve('serialised-dialog-chain')}`).each(parent => {
        $_aag5ti106jfuw8tse.set(parent, 'left', `${-spec$$1.state.currentScreen.get() * message.width}px`);
      });
    };
    const navigate = (dialog, direction) => {
      const screens = $_951f03109jfuw8tt3.descendants(dialog.element(), `.${$_2fp9skztjfuw8tqe.resolve('serialised-dialog-screen')}`);
      $_c8lemt10bjfuw8tt8.descendant(dialog.element(), `.${$_2fp9skztjfuw8tqe.resolve('serialised-dialog-chain')}`).each(parent => {
        if (spec$$1.state.currentScreen.get() + direction >= 0 && spec$$1.state.currentScreen.get() + direction < screens.length) {
          $_aag5ti106jfuw8tse.getRaw(parent, 'left').each(left => {
            const currentLeft = parseInt(left, 10);
            const w = $_dsj1h711zjfuw8u73.get(screens[0]);
            $_aag5ti106jfuw8tse.set(parent, 'left', `${currentLeft - direction * w}px`);
          });
          spec$$1.state.currentScreen.set(spec$$1.state.currentScreen.get() + direction);
        }
      });
    };
    const focusInput = dialog => {
      const inputs = $_951f03109jfuw8tt3.descendants(dialog.element(), 'input');
      const optInput = Option.from(inputs[spec$$1.state.currentScreen.get()]);
      optInput.each(input$$1 => {
        dialog.getSystem().getByDom(input$$1).each(inputComp => {
          dispatchFocus(dialog, inputComp.element());
        });
      });
      const dotitems = memDots.get(dialog);
      Highlighting.highlightAt(dotitems, spec$$1.state.currentScreen.get());
    };
    const resetState = () => {
      spec$$1.state.currentScreen.set(0);
      spec$$1.state.dialogSwipeState.clear();
    };
    const memForm = record(Form.sketch(parts => ({
      dom: dom$1('<div class="${prefix}-serialised-dialog"></div>'),

      components: [Container.sketch({
          dom: dom$1('<div class="${prefix}-serialised-dialog-chain" style="left: 0px; position: absolute;"></div>'),
          components: $_efmt4zxbjfuw8tcj.map(spec$$1.fields, (field$$1, i) => i <= spec$$1.maxFieldIndex ? Container.sketch({
            dom: dom$1('<div class="${prefix}-serialised-dialog-screen"></div>'),
            components: $_efmt4zxbjfuw8tcj.flatten([
              [navigationButton(-1, 'previous', i > 0)],
              [parts.field(field$$1.name, field$$1.spec)],
              [navigationButton(+1, 'next', i < spec$$1.maxFieldIndex)]
            ])
          }) : parts.field(field$$1.name, field$$1.spec))
        })],

      formBehaviours: derive$2([
        $_9de9iyzsjfuw8tqa.orientation((dialog, message) => {
          reposition(dialog, message);
        }),
        Keying.config({
          mode: 'special',
          focusIn(dialog) {
            focusInput(dialog);
          },
          onTab(dialog) {
            navigate(dialog, +1);
            return Option.some(true);
          },
          onShiftTab(dialog) {
            navigate(dialog, -1);
            return Option.some(true);
          }
        }),
        config(formAdhocEvents, [
          runOnAttached((dialog, simulatedEvent) => {
            resetState();
            const dotitems = memDots.get(dialog);
            Highlighting.highlightFirst(dotitems);
            spec$$1.getInitialValue(dialog).each(v => {
              Representing.setValue(dialog, v);
            });
          }),
          runOnExecute(spec$$1.onExecute),
          run(transitionend(), (dialog, simulatedEvent) => {
            if (simulatedEvent.event().raw().propertyName === 'left') {
              focusInput(dialog);
            }
          }),
          run(navigateEvent, (dialog, simulatedEvent) => {
            const direction = simulatedEvent.event().direction();
            navigate(dialog, direction);
          })
        ])
      ])
    })));
    var memDots = record({
      dom: dom$1('<div class="${prefix}-dot-container"></div>'),
      behaviours: derive$2([Highlighting.config({
          highlightClass: $_2fp9skztjfuw8tqe.resolve('dot-active'),
          itemClass: $_2fp9skztjfuw8tqe.resolve('dot-item')
        })]),
      components: $_efmt4zxbjfuw8tcj.bind(spec$$1.fields, (_f, i) => i <= spec$$1.maxFieldIndex ? [spec('<div class="${prefix}-dot-item ${prefix}-icon-full-dot ${prefix}-icon"></div>')] : [])
    });
    return {
      dom: dom$1('<div class="${prefix}-serializer-wrapper"></div>'),
      components: [
        memForm.asSpec(),
        memDots.asSpec()
      ],
      behaviours: derive$2([
        Keying.config({
          mode: 'special',
          focusIn(wrapper) {
            const form = memForm.get(wrapper);
            Keying.focusIn(form);
          }
        }),
        config(wrapperAdhocEvents, [
          run(touchstart(), (wrapper, simulatedEvent) => {
            spec$$1.state.dialogSwipeState.set($_f3hwqu134jfuw8uev.init(simulatedEvent.event().raw().touches[0].clientX));
          }),
          run(touchmove(), (wrapper, simulatedEvent) => {
            spec$$1.state.dialogSwipeState.on(state => {
              simulatedEvent.event().prevent();
              spec$$1.state.dialogSwipeState.set($_f3hwqu134jfuw8uev.move(state, simulatedEvent.event().raw().touches[0].clientX));
            });
          }),
          run(touchend(), wrapper => {
            spec$$1.state.dialogSwipeState.on(state => {
              const dialog = memForm.get(wrapper);
              const direction = -1 * $_f3hwqu134jfuw8uev.complete(state);
              navigate(dialog, direction);
            });
          })
        ])
      ])
    };
  };

  const getGroups = $_ctj1zwx4jfuw8tbw.cached((realm, editor) => [{
      label: 'the link group',
      items: [sketch$7({
          fields: [
            field$2('url', 'Type or paste URL'),
            field$2('text', 'Link text'),
            field$2('title', 'Link title'),
            field$2('target', 'Link target'),
            hidden('link')
          ],
          maxFieldIndex: [
            'url',
            'text',
            'title',
            'target'
          ].length - 1,
          getInitialValue() {
            return Option.some($_fhf8dq12hjfuw8u9y.getInfo(editor));
          },
          onExecute(dialog) {
            const info = Representing.getValue(dialog);
            $_fhf8dq12hjfuw8u9y.applyInfo(editor, info);
            realm.restoreToolbar();
            editor.focus();
          }
        })]
    }]);
  const sketch$8 = (realm, editor) => $_44weuozujfuw8tqh.forToolbarStateAction(editor, 'link', 'link', () => {
    const groups = getGroups(realm, editor);
    realm.setContextToolbar(groups);
    $_6d07m912jjfuw8uab.forAndroid(editor, () => {
      realm.focusToolbar();
    });
    $_fhf8dq12hjfuw8u9y.query(editor).each(link => {
      editor.selection.select(link.dom());
    });
  });

  const DefaultStyleFormats = [
    {
      title: 'Headings',
      items: [
        {
          title: 'Heading 1',
          format: 'h1'
        },
        {
          title: 'Heading 2',
          format: 'h2'
        },
        {
          title: 'Heading 3',
          format: 'h3'
        },
        {
          title: 'Heading 4',
          format: 'h4'
        },
        {
          title: 'Heading 5',
          format: 'h5'
        },
        {
          title: 'Heading 6',
          format: 'h6'
        }
      ]
    },
    {
      title: 'Inline',
      items: [
        {
          title: 'Bold',
          icon: 'bold',
          format: 'bold'
        },
        {
          title: 'Italic',
          icon: 'italic',
          format: 'italic'
        },
        {
          title: 'Underline',
          icon: 'underline',
          format: 'underline'
        },
        {
          title: 'Strikethrough',
          icon: 'strikethrough',
          format: 'strikethrough'
        },
        {
          title: 'Superscript',
          icon: 'superscript',
          format: 'superscript'
        },
        {
          title: 'Subscript',
          icon: 'subscript',
          format: 'subscript'
        },
        {
          title: 'Code',
          icon: 'code',
          format: 'code'
        }
      ]
    },
    {
      title: 'Blocks',
      items: [
        {
          title: 'Paragraph',
          format: 'p'
        },
        {
          title: 'Blockquote',
          format: 'blockquote'
        },
        {
          title: 'Div',
          format: 'div'
        },
        {
          title: 'Pre',
          format: 'pre'
        }
      ]
    },
    {
      title: 'Alignment',
      items: [
        {
          title: 'Left',
          icon: 'alignleft',
          format: 'alignleft'
        },
        {
          title: 'Center',
          icon: 'aligncenter',
          format: 'aligncenter'
        },
        {
          title: 'Right',
          icon: 'alignright',
          format: 'alignright'
        },
        {
          title: 'Justify',
          icon: 'alignjustify',
          format: 'alignjustify'
        }
      ]
    }
  ];

  const isRecursive = (component, originator, target) => $_4867a0xsjfuw8tej.eq(originator, component.element()) && !$_4867a0xsjfuw8tej.eq(originator, target);
  const $_4ab21o139jfuw8ugy = {
    events: derive([can(focus$1(), (component, simulatedEvent) => {
        const originator = simulatedEvent.event().originator();
        const target = simulatedEvent.event().target();
        if (isRecursive(component, originator, target)) {
          console.warn(`${focus$1()} did not get interpreted by the desired target. \nOriginator: ${element(originator)}\nTarget: ${element(target)}\nCheck the ${focus$1()} event handlers`);
          return false;
        } else {
          return true;
        }
      })])
  };

  const make$1 = $_2vokfcwwjfuw8tb4.identity;

  const SystemApi = $_2cliu2ysjfuw8tkr.exactly([
    'debugInfo',
    'triggerFocus',
    'triggerEvent',
    'triggerEscape',
    'addToWorld',
    'removeFromWorld',
    'addToGui',
    'removeFromGui',
    'build',
    'getByUid',
    'getByDom',
    'broadcast',
    'broadcastOn'
  ]);

  const NoContextApi = getComp => {
    const fail = event => () => {
      throw new Error(`The component must be in a context to send: ${event}\n${element(getComp().element())} is not in context.`);
    };
    return SystemApi({
      debugInfo: $_2vokfcwwjfuw8tb4.constant('fake'),
      triggerEvent: fail('triggerEvent'),
      triggerFocus: fail('triggerFocus'),
      triggerEscape: fail('triggerEscape'),
      build: fail('build'),
      addToWorld: fail('addToWorld'),
      removeFromWorld: fail('removeFromWorld'),
      addToGui: fail('addToGui'),
      removeFromGui: fail('removeFromGui'),
      getByUid: fail('getByUid'),
      getByDom: fail('getByDom'),
      broadcast: fail('broadcast'),
      broadcastOn: fail('broadcastOn')
    });
  };

  const generateFrom = (spec, all) => {
    const schema = $_efmt4zxbjfuw8tcj.map(all, a => field(a.name(), a.name(), asOption(), objOf([
      strict$1('config'),
      defaulted$1('state', NoState)
    ])));
    const validated = asStruct('component.behaviours', objOf(schema), spec.behaviours).fold(errInfo => {
      throw new Error(`${formatError(errInfo)}\nComplete spec:\n${$_6s9vvgygjfuw8ti8.stringify(spec, null, 2)}`);
    }, $_2vokfcwwjfuw8tb4.identity);
    return {
      list: all,
      data: $_8qu224wzjfuw8tb9.map(validated, blobOptionThunk => {
        const blobOption = blobOptionThunk();
        return $_2vokfcwwjfuw8tb4.constant(blobOption.map(blob => ({
          config: blob.config(),
          state: blob.state().init(blob.config())
        })));
      })
    };
  };
  const getBehaviours = bData => bData.list;
  const getData = bData => bData.data;
  const $_47y96w13ejfuw8uhv = {
    generateFrom,
    getBehaviours,
    getData
  };

  const byInnerKey = (data, tuple) => {
    const r = {};
    $_8qu224wzjfuw8tb9.each(data, (detail, key) => {
      $_8qu224wzjfuw8tb9.each(detail, (value, indexKey) => {
        const chain = readOr$1(indexKey, [])(r);
        r[indexKey] = chain.concat([tuple(key, value)]);
      });
    });
    return r;
  };

  const behaviourDom = (name, modification) => ({
    name: $_2vokfcwwjfuw8tb4.constant(name),
    modification
  });
  const concat = (chain, aspect) => {
    const values = $_efmt4zxbjfuw8tcj.bind(chain, c => c.modification().getOr([]));
    return Result.value(wrap$2(aspect, values));
  };
  const onlyOne = (chain, aspect, order) => {
    if (chain.length > 1) {
      return Result.error(`Multiple behaviours have tried to change DOM "${aspect}". The guilty behaviours are: ${$_6s9vvgygjfuw8ti8.stringify($_efmt4zxbjfuw8tcj.map(chain, b => b.name()))}. At this stage, this is not supported. Future releases might provide strategies for resolving this.`);
    } else if (chain.length === 0) {
      return Result.value({});
    } else {
      return Result.value(chain[0].modification().fold(() => ({}), m => wrap$2(aspect, m)));
    }
  };
  const duplicate = (aspect, k, obj, behaviours) => Result.error(`Mulitple behaviours have tried to change the _${k}_ "${aspect}". The guilty behaviours are: ${$_6s9vvgygjfuw8ti8.stringify($_efmt4zxbjfuw8tcj.bind(behaviours, b => b.modification().getOr({})[k] !== undefined ? [b.name()] : []), null, 2)}. This is not currently supported.`);
  const safeMerge = (chain, aspect) => {
    const y = $_efmt4zxbjfuw8tcj.foldl(chain, (acc, c) => {
      const obj = c.modification().getOr({});
      return acc.bind(accRest => {
        const parts = $_8qu224wzjfuw8tb9.mapToArray(obj, (v, k) => accRest[k] !== undefined ? duplicate(aspect, k, obj, chain) : Result.value(wrap$2(k, v)));
        return consolidate(parts, accRest);
      });
    }, Result.value({}));
    return y.map(yValue => wrap$2(aspect, yValue));
  };
  const mergeTypes = {
    classes: concat,
    attributes: safeMerge,
    styles: safeMerge,
    domChildren: onlyOne,
    defChildren: onlyOne,
    innerHtml: onlyOne,
    value: onlyOne
  };
  const combine$1 = (info, baseMod, behaviours, base) => {
    const behaviourDoms = $_3jctjywxjfuw8tb6.deepMerge({}, baseMod);
    $_efmt4zxbjfuw8tcj.each(behaviours, behaviour => {
      behaviourDoms[behaviour.name()] = behaviour.exhibit(info, base);
    });
    const byAspect = byInnerKey(behaviourDoms, behaviourDom);
    const usedAspect = $_8qu224wzjfuw8tb9.map(byAspect, (values, aspect) => $_efmt4zxbjfuw8tcj.bind(values, value => value.modification().fold(() => [], v => [value])));
    const modifications = $_8qu224wzjfuw8tb9.mapToArray(usedAspect, (values, aspect) => readOptFrom$1(mergeTypes, aspect).fold(() => Result.error(`Unknown field type: ${aspect}`), merger => merger(values, aspect)));
    const consolidated = consolidate(modifications, {});
    return consolidated.map(nu$6);
  };

  const sortKeys = (label, keyName, array, order) => {
    const sliced = array.slice(0);
    try {
      const sorted = sliced.sort((a, b) => {
        const aKey = a[keyName]();
        const bKey = b[keyName]();
        const aIndex = order.indexOf(aKey);
        const bIndex = order.indexOf(bKey);
        if (aIndex === -1) {
          throw new Error(`The ordering for ${label} does not have an entry for ${aKey}.\nOrder specified: ${$_6s9vvgygjfuw8ti8.stringify(order, null, 2)}`);
        }
        if (bIndex === -1) {
          throw new Error(`The ordering for ${label} does not have an entry for ${bKey}.\nOrder specified: ${$_6s9vvgygjfuw8ti8.stringify(order, null, 2)}`);
        }
        if (aIndex < bIndex) {
          return -1;
        } else if (bIndex < aIndex) {
          return 1;
        } else {
          return 0;
        }
      });
      return Result.value(sorted);
    } catch (err) {
      return Result.error([err]);
    }
  };
  const $_52rc8e13ijfuw8ujk = { sortKeys };

  const nu$7 = (handler, purpose) => ({
    handler,
    purpose: $_2vokfcwwjfuw8tb4.constant(purpose)
  });
  const curryArgs = (descHandler, extraArgs) => ({
    handler: $_2vokfcwwjfuw8tb4.curry.apply(undefined, [descHandler.handler].concat(extraArgs)),
    purpose: descHandler.purpose
  });
  const getHandler = descHandler => descHandler.handler;

  const behaviourTuple = (name, handler) => ({
    name: $_2vokfcwwjfuw8tb4.constant(name),
    handler: $_2vokfcwwjfuw8tb4.constant(handler)
  });
  const nameToHandlers = (behaviours, info) => {
    const r = {};
    $_efmt4zxbjfuw8tcj.each(behaviours, behaviour => {
      r[behaviour.name()] = behaviour.handlers(info);
    });
    return r;
  };
  const groupByEvents = (info, behaviours, base) => {
    const behaviourEvents = $_3jctjywxjfuw8tb6.deepMerge(base, nameToHandlers(behaviours, info));
    return byInnerKey(behaviourEvents, behaviourTuple);
  };
  const combine$2 = (info, eventOrder, behaviours, base) => {
    const byEventName = groupByEvents(info, behaviours, base);
    return combineGroups(byEventName, eventOrder);
  };
  const assemble = rawHandler => {
    const handler = read(rawHandler);
    return function (component, simulatedEvent) {
      const args = Array.prototype.slice.call(arguments, 0);
      if (handler.abort.apply(undefined, args)) {
        simulatedEvent.stop();
      } else if (handler.can.apply(undefined, args)) {
        handler.run.apply(undefined, args);
      }
    };
  };
  const missingOrderError = (eventName, tuples) => Result.error([`The event (${eventName}) has more than one behaviour that listens to it.\nWhen this occurs, you must specify an event ordering for the behaviours in your spec (e.g. [ "listing", "toggling" ]).\nThe behaviours that can trigger it are: ${$_6s9vvgygjfuw8ti8.stringify($_efmt4zxbjfuw8tcj.map(tuples, c => c.name()), null, 2)}`]);
  const fuse$1 = (tuples, eventOrder, eventName) => {
    const order = eventOrder[eventName];
    if (!order) {
      return missingOrderError(eventName, tuples);
    } else {
      return $_52rc8e13ijfuw8ujk.sortKeys(`Event: ${eventName}`, 'name', tuples, order).map(sortedTuples => {
        const handlers = $_efmt4zxbjfuw8tcj.map(sortedTuples, tuple => tuple.handler());
        return fuse(handlers);
      });
    }
  };
  var combineGroups = (byEventName, eventOrder) => {
    const r = $_8qu224wzjfuw8tb9.mapToArray(byEventName, (tuples, eventName) => {
      const combined = tuples.length === 1 ? Result.value(tuples[0].handler()) : fuse$1(tuples, eventOrder, eventName);
      return combined.map(handler => {
        const assembled = assemble(handler);
        const purpose = tuples.length > 1 ? $_efmt4zxbjfuw8tcj.filter(eventOrder, o => $_efmt4zxbjfuw8tcj.contains(tuples, t => t.name() === o)).join(' > ') : tuples[0].name();
        return wrap$2(eventName, nu$7(assembled, purpose));
      });
    });
    return consolidate(r, {});
  };

  const toInfo = spec => asStruct('custom.definition', objOfOnly([
    field('dom', 'dom', strict(), objOfOnly([
      strict$1('tag'),
      defaulted$1('styles', {}),
      defaulted$1('classes', []),
      defaulted$1('attributes', {}),
      option('value'),
      option('innerHtml')
    ])),
    strict$1('components'),
    strict$1('uid'),
    defaulted$1('events', {}),
    defaulted$1('apis', $_2vokfcwwjfuw8tb4.constant({})),
    field('eventOrder', 'eventOrder', mergeWith({
      'alloy.execute': [
        'disabling',
        'alloy.base.behaviour',
        'toggling'
      ],
      'alloy.focus': [
        'alloy.base.behaviour',
        'focusing',
        'keying'
      ],
      'alloy.system.init': [
        'alloy.base.behaviour',
        'disabling',
        'toggling',
        'representing'
      ],
      'input': [
        'alloy.base.behaviour',
        'representing',
        'streaming',
        'invalidating'
      ],
      'alloy.system.detached': [
        'alloy.base.behaviour',
        'representing'
      ]
    }), anyValue$1()),
    option('domModification'),
    snapshot$1('originalSpec'),
    defaulted$1('debug.sketcher', 'unknown')
  ]), spec);
  const getUid = info => wrap$2(idAttr(), info.uid());
  const toDefinition = info => {
    const base = {
      tag: info.dom().tag(),
      classes: info.dom().classes(),
      attributes: $_3jctjywxjfuw8tb6.deepMerge(getUid(info), info.dom().attributes()),
      styles: info.dom().styles(),
      domChildren: $_efmt4zxbjfuw8tcj.map(info.components(), comp => comp.element())
    };
    return nu$5($_3jctjywxjfuw8tb6.deepMerge(base, info.dom().innerHtml().map(h => wrap$2('innerHtml', h)).getOr({}), info.dom().value().map(h => wrap$2('value', h)).getOr({})));
  };
  const toModification = info => info.domModification().fold(() => nu$6({}), nu$6);
  const toEvents = info => info.events();

  const add$3 = (element, classes) => {
    $_efmt4zxbjfuw8tcj.each(classes, x => {
      $_6po7jxyujfuw8tl0.add(element, x);
    });
  };
  const remove$6 = (element, classes) => {
    $_efmt4zxbjfuw8tcj.each(classes, x => {
      $_6po7jxyujfuw8tl0.remove(element, x);
    });
  };
  const toggle$3 = (element, classes) => {
    $_efmt4zxbjfuw8tcj.each(classes, x => {
      $_6po7jxyujfuw8tl0.toggle(element, x);
    });
  };
  const hasAll = (element, classes) => $_efmt4zxbjfuw8tcj.forall(classes, clazz => $_6po7jxyujfuw8tl0.has(element, clazz));
  const hasAny = (element, classes) => $_efmt4zxbjfuw8tcj.exists(classes, clazz => $_6po7jxyujfuw8tl0.has(element, clazz));
  const getNative = element => {
    const classList = element.dom().classList;
    const r = new Array(classList.length);
    for (let i = 0; i < classList.length; i++) {
      r[i] = classList.item(i);
    }
    return r;
  };
  const get$10 = element => $_bxqp80yxjfuw8tlc.supports(element) ? getNative(element) : $_bxqp80yxjfuw8tlc.get(element);
  const $_c6ke2t13mjfuw8uku = {
    add: add$3,
    remove: remove$6,
    toggle: toggle$3,
    hasAll,
    hasAny,
    get: get$10
  };

  const getChildren = definition => {
    if (definition.domChildren().isSome() && definition.defChildren().isSome()) {
      throw new Error(`Cannot specify children and child specs! Must be one or the other.\nDef: ${defToStr(definition)}`);
    } else {
      return definition.domChildren().fold(() => {
        const defChildren = definition.defChildren().getOr([]);
        return $_efmt4zxbjfuw8tcj.map(defChildren, renderDef);
      }, domChildren => domChildren);
    }
  };
  const renderToDom = definition => {
    const subject = $_bwdnu0xijfuw8tdo.fromTag(definition.tag());
    $_47adx7ywjfuw8tl3.setAll(subject, definition.attributes().getOr({}));
    $_c6ke2t13mjfuw8uku.add(subject, definition.classes().getOr([]));
    $_aag5ti106jfuw8tse.setAll(subject, definition.styles().getOr({}));
    $_2dunqqzfjfuw8tnk.set(subject, definition.innerHtml().getOr(''));
    const children = getChildren(definition);
    $_g8n2ewxzjfuw8tf7.append(subject, children);
    definition.value().each(value => {
      $_7340hz12tjfuw8uci.set(subject, value);
    });
    return subject;
  };
  var renderDef = spec => {
    const definition = nu$5(spec);
    return renderToDom(definition);
  };

  const getBehaviours$1 = spec => {
    const behaviours = readOptFrom$1(spec, 'behaviours').getOr({});
    const keys = $_efmt4zxbjfuw8tcj.filter($_8qu224wzjfuw8tb9.keys(behaviours), k => behaviours[k] !== undefined);
    return $_efmt4zxbjfuw8tcj.map(keys, k => spec.behaviours[k].me);
  };
  const generateFrom$1 = (spec, all) => $_47y96w13ejfuw8uhv.generateFrom(spec, all);
  const generate$4 = spec => {
    const all = getBehaviours$1(spec);
    return generateFrom$1(spec, all);
  };

  const ComponentApi = $_2cliu2ysjfuw8tkr.exactly([
    'getSystem',
    'config',
    'hasConfigured',
    'spec',
    'connect',
    'disconnect',
    'element',
    'syncComponents',
    'readState',
    'components',
    'events'
  ]);

  const build = spec => {
    const getMe = () => me;
    const systemApi = Cell(NoContextApi(getMe));
    const info = getOrDie$1(toInfo($_3jctjywxjfuw8tb6.deepMerge(spec, { behaviours: undefined })));
    const bBlob = generate$4(spec);
    const bList = $_47y96w13ejfuw8uhv.getBehaviours(bBlob);
    const bData = $_47y96w13ejfuw8uhv.getData(bBlob);
    const definition = toDefinition(info);
    const baseModification = { 'alloy.base.modification': toModification(info) };
    const modification = combine$1(bData, baseModification, bList, definition).getOrDie();
    const modDefinition = merge$1(definition, modification);
    const item = renderToDom(modDefinition);
    const baseEvents = { 'alloy.base.behaviour': toEvents(info) };
    const events = combine$2(bData, info.eventOrder(), bList, baseEvents).getOrDie();
    const subcomponents = Cell(info.components());
    const connect = newApi => {
      systemApi.set(newApi);
    };
    const disconnect = () => {
      systemApi.set(NoContextApi(getMe));
    };
    const syncComponents = () => {
      const children = $_aff64dxmjfuw8tdx.children(item);
      const subs = $_efmt4zxbjfuw8tcj.bind(children, child => systemApi.get().getByDom(child).fold(() => [], c => [c]));
      subcomponents.set(subs);
    };
    const config = behaviour => {
      if (behaviour === apiConfig()) {
        return info.apis();
      }
      const b = bData;
      const f = $_8aqeo3wyjfuw8tb8.isFunction(b[behaviour.name()]) ? b[behaviour.name()] : () => {
        throw new Error(`Could not find ${behaviour.name()} in ${$_6s9vvgygjfuw8ti8.stringify(spec, null, 2)}`);
      };
      return f();
    };
    const hasConfigured = behaviour => $_8aqeo3wyjfuw8tb8.isFunction(bData[behaviour.name()]);
    const readState = behaviourName => bData[behaviourName]().map(b => b.state.readState()).getOr('not enabled');
    var me = ComponentApi({
      getSystem: systemApi.get,
      config,
      hasConfigured,
      spec: $_2vokfcwwjfuw8tb4.constant(spec),
      readState,
      connect,
      disconnect,
      element: $_2vokfcwwjfuw8tb4.constant(item),
      syncComponents,
      components: subcomponents.get,
      events: $_2vokfcwwjfuw8tb4.constant(events)
    });
    return me;
  };

  const buildSubcomponents = spec => {
    const components = readOr$1('components', [])(spec);
    return $_efmt4zxbjfuw8tcj.map(components, build$1);
  };
  const buildFromSpec = userSpec => {
    const spec = make$1(userSpec);
    const components = buildSubcomponents(spec);
    const completeSpec = $_3jctjywxjfuw8tb6.deepMerge($_4ab21o139jfuw8ugy, spec, wrap$2('components', components));
    return Result.value(build(completeSpec));
  };
  const text = textContent => {
    const element = $_bwdnu0xijfuw8tdo.fromText(textContent);
    return external$1({ element });
  };
  var external$1 = spec => {
    const extSpec = asStructOrDie('external.component', objOfOnly([
      strict$1('element'),
      option('uid')
    ]), spec);
    const systemApi = Cell(NoContextApi());
    const connect = newApi => {
      systemApi.set(newApi);
    };
    const disconnect = () => {
      systemApi.set(NoContextApi(() => me));
    };
    extSpec.uid().each(uid => {
      writeOnly(extSpec.element(), uid);
    });
    var me = ComponentApi({
      getSystem: systemApi.get,
      config: Option.none,
      hasConfigured: $_2vokfcwwjfuw8tb4.constant(false),
      connect,
      disconnect,
      element: $_2vokfcwwjfuw8tb4.constant(extSpec.element()),
      spec: $_2vokfcwwjfuw8tb4.constant(spec),
      readState: $_2vokfcwwjfuw8tb4.constant('No state'),
      syncComponents: $_2vokfcwwjfuw8tb4.noop,
      components: $_2vokfcwwjfuw8tb4.constant([]),
      events: $_2vokfcwwjfuw8tb4.constant({})
    });
    return premade(me);
  };
  var build$1 = rawUserSpec => getPremade(rawUserSpec).fold(() => {
    const userSpecWithUid = $_3jctjywxjfuw8tb6.deepMerge({ uid: generate$3('') }, rawUserSpec);
    return buildFromSpec(userSpecWithUid).getOrDie();
  }, prebuilt => prebuilt);
  const premade$1 = premade;

  const hoverEvent = 'alloy.item-hover';
  const focusEvent = 'alloy.item-focus';
  const onHover = item => {
    if ($_f15fvwz1jfuw8tlo.search(item.element()).isNone() || Focusing.isFocused(item)) {
      if (!Focusing.isFocused(item)) {
        Focusing.focus(item);
      }
      emitWith(item, hoverEvent, { item });
    }
  };
  const onFocus = item => {
    emitWith(item, focusEvent, { item });
  };
  const hover = $_2vokfcwwjfuw8tb4.constant(hoverEvent);
  const focus$4 = $_2vokfcwwjfuw8tb4.constant(focusEvent);

  const builder = info => ({
    dom: $_3jctjywxjfuw8tb6.deepMerge(info.dom(), { attributes: { role: info.toggling().isSome() ? 'menuitemcheckbox' : 'menuitem' } }),

    behaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2([
      info.toggling().fold(Toggling.revoke, tConfig => Toggling.config($_3jctjywxjfuw8tb6.deepMerge({ aria: { mode: 'checked' } }, tConfig))),
      Focusing.config({
        ignore: info.ignoreFocus(),
        onFocus(component) {
          onFocus(component);
        }
      }),
      Keying.config({ mode: 'execution' }),
      Representing.config({
        store: {
          mode: 'memory',
          initialValue: info.data()
        }
      })
    ]), info.itemBehaviours()),

    events: derive([
      runWithTarget(tapOrClick(), emitExecute),
      cutter(mousedown()),
      run(mouseover(), onHover),
      run(focusItem(), Focusing.focus)
    ]),

    components: info.components(),
    domModification: info.domModification()
  });
  const schema$10 = [
    strict$1('data'),
    strict$1('components'),
    strict$1('dom'),
    option('toggling'),
    defaulted$1('itemBehaviours', {}),
    defaulted$1('ignoreFocus', false),
    defaulted$1('domModification', {}),
    output$1('builder', builder)
  ];

  const builder$1 = detail => ({
    dom: detail.dom(),
    components: detail.components(),
    events: derive([stopper(focusItem())])
  });
  const schema$11 = [
    strict$1('dom'),
    strict$1('components'),
    output$1('builder', builder$1)
  ];

  const owner$2 = $_2vokfcwwjfuw8tb4.constant('item-widget');
  const parts = $_2vokfcwwjfuw8tb4.constant([required({
      name: 'widget',
      overrides(detail) {
        return {
          behaviours: derive$2([Representing.config({
              store: {
                mode: 'manual',
                getValue(component) {
                  return detail.data();
                },
                setValue() {
                }
              }
            })])
        };
      }
    })]);

  const builder$2 = info => {
    const subs = substitutes(owner$2(), info, parts());
    const components$$1 = components(owner$2(), info, subs.internals());
    const focusWidget = component => getPart(component, info, 'widget').map(widget => {
      Keying.focusIn(widget);
      return widget;
    });
    const onHorizontalArrow = (component, simulatedEvent) => inside(simulatedEvent.event().target()) ? Option.none() : (() => {
      if (info.autofocus()) {
        simulatedEvent.setSource(component.element());
        return Option.none();
      } else {
        return Option.none();
      }
    })();
    return $_3jctjywxjfuw8tb6.deepMerge({
      dom: info.dom(),
      components: components$$1,
      domModification: info.domModification(),
      events: derive([
        runOnExecute((component, simulatedEvent) => {
          focusWidget(component).each(widget => {
            simulatedEvent.stop();
          });
        }),
        run(mouseover(), onHover),
        run(focusItem(), (component, simulatedEvent) => {
          if (info.autofocus()) {
            focusWidget(component);
          } else {
            Focusing.focus(component);
          }
        })
      ]),
      behaviours: derive$2([
        Representing.config({
          store: {
            mode: 'memory',
            initialValue: info.data()
          }
        }),
        Focusing.config({
          onFocus(component) {
            onFocus(component);
          }
        }),
        Keying.config({
          mode: 'special',
          onLeft: onHorizontalArrow,
          onRight: onHorizontalArrow,
          onEscape(component, simulatedEvent) {
            if (!Focusing.isFocused(component) && !info.autofocus()) {
              Focusing.focus(component);
              return Option.some(true);
            } else if (info.autofocus()) {
              simulatedEvent.setSource(component.element());
              return Option.none();
            } else {
              return Option.none();
            }
          }
        })
      ])
    });
  };
  const schema$12 = [
    strict$1('uid'),
    strict$1('data'),
    strict$1('components'),
    strict$1('dom'),
    defaulted$1('autofocus', false),
    defaulted$1('domModification', {}),
    defaultUidsSchema(parts()),
    output$1('builder', builder$2)
  ];

  const itemSchema$1 = choose$1('type', {
    widget: schema$12,
    item: schema$10,
    separator: schema$11
  });
  const configureGrid = (detail, movementInfo) => ({
    mode: 'flatgrid',
    selector: `.${detail.markers().item()}`,

    initSize: {
      numColumns: movementInfo.initSize().numColumns(),
      numRows: movementInfo.initSize().numRows()
    },

    focusManager: detail.focusManager()
  });
  const configureMenu = (detail, movementInfo) => ({
    mode: 'menu',
    selector: `.${detail.markers().item()}`,
    moveOnTab: movementInfo.moveOnTab(),
    focusManager: detail.focusManager()
  });
  const parts$1 = $_2vokfcwwjfuw8tb4.constant([group({
      factory: {
        sketch(spec) {
          const itemInfo = asStructOrDie('menu.spec item', itemSchema$1, spec);
          return itemInfo.builder()(itemInfo);
        }
      },
      name: 'items',
      unit: 'item',
      defaults(detail, u) {
        const fallbackUid = generate$3('');
        return $_3jctjywxjfuw8tb6.deepMerge({ uid: fallbackUid }, u);
      },
      overrides(detail, u) {
        return {
          type: u.type,
          ignoreFocus: detail.fakeFocus(),
          domModification: { classes: [detail.markers().item()] }
        };
      }
    })]);
  const schema$13 = $_2vokfcwwjfuw8tb4.constant([
    strict$1('value'),
    strict$1('items'),
    strict$1('dom'),
    strict$1('components'),
    defaulted$1('eventOrder', {}),
    field$1('menuBehaviours', [
      Highlighting,
      Representing,
      Composing,
      Keying
    ]),
    defaultedOf('movement', {
      mode: 'menu',
      moveOnTab: true
    }, choose$1('mode', {
      grid: [
        initSize(),
        output$1('config', configureGrid)
      ],
      menu: [
        defaulted$1('moveOnTab', true),
        output$1('config', configureMenu)
      ]
    })),
    itemMarkers(),
    defaulted$1('fakeFocus', false),
    defaulted$1('focusManager', dom()),
    onHandler('onHighlight')
  ]);
  const name$2 = $_2vokfcwwjfuw8tb4.constant('menu');

  const focus$5 = $_2vokfcwwjfuw8tb4.constant('alloy.menu-focus');

  const make$2 = (detail, components, spec, externals) => $_3jctjywxjfuw8tb6.deepMerge({
    dom: $_3jctjywxjfuw8tb6.deepMerge(detail.dom(), { attributes: { role: 'menu' } }),
    uid: detail.uid(),
    behaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2([
      Highlighting.config({
        highlightClass: detail.markers().selectedItem(),
        itemClass: detail.markers().item(),
        onHighlight: detail.onHighlight()
      }),
      Representing.config({
        store: {
          mode: 'memory',
          initialValue: detail.value()
        }
      }),
      Composing.config({ find: $_2vokfcwwjfuw8tb4.identity }),
      Keying.config(detail.movement().config()(detail, detail.movement()))
    ]), get$5(detail.menuBehaviours())),
    events: derive([
      run(focus$4(), (menu, simulatedEvent) => {
        const event = simulatedEvent.event();
        menu.getSystem().getByDom(event.target()).each(item => {
          Highlighting.highlight(menu, item);
          simulatedEvent.stop();
          emitWith(menu, focus$5(), {
            menu,
            item
          });
        });
      }),
      run(hover(), (menu, simulatedEvent) => {
        const item = simulatedEvent.event().item();
        Highlighting.highlight(menu, item);
      })
    ]),
    components,
    eventOrder: detail.eventOrder()
  });

  const Menu = composite$1({
    name: 'Menu',
    configFields: schema$13(),
    partFields: parts$1(),
    factory: make$2
  });

  const preserve$2 = (f, container) => {
    const ownerDoc = $_aff64dxmjfuw8tdx.owner(container);
    const refocus = $_f15fvwz1jfuw8tlo.active(ownerDoc).bind(focused => {
      const hasFocus = elem => $_4867a0xsjfuw8tej.eq(focused, elem);
      return hasFocus(container) ? Option.some(container) : $_d0h9pzz3jfuw8tlv.descendant(container, hasFocus);
    });
    const result = f(container);
    refocus.each(oldFocus => {
      $_f15fvwz1jfuw8tlo.active(ownerDoc).filter(newFocus => $_4867a0xsjfuw8tej.eq(newFocus, oldFocus)).orThunk(() => {
        $_f15fvwz1jfuw8tlo.focus(oldFocus);
      });
    });
    return result;
  };

  const set$7 = (component, replaceConfig, replaceState, data) => {
    detachChildren(component);
    preserve$2(() => {
      const children = $_efmt4zxbjfuw8tcj.map(data, component.getSystem().build);
      $_efmt4zxbjfuw8tcj.each(children, l => {
        attach(component, l);
      });
    }, component.element());
  };
  const insert = (component, replaceConfig, insertion, childSpec) => {
    const child = component.getSystem().build(childSpec);
    attachWith(component, child, insertion);
  };
  const append$2 = (component, replaceConfig, replaceState, appendee) => {
    insert(component, replaceConfig, $_cwa5ncxljfuw8tdv.append, appendee);
  };
  const prepend$2 = (component, replaceConfig, replaceState, prependee) => {
    insert(component, replaceConfig, $_cwa5ncxljfuw8tdv.prepend, prependee);
  };
  const remove$7 = (component, replaceConfig, replaceState, removee) => {
    const children = contents(component, replaceConfig);
    const foundChild = $_efmt4zxbjfuw8tcj.find(children, child => $_4867a0xsjfuw8tej.eq(removee.element(), child.element()));
    foundChild.each(detach);
  };
  var contents = (component, replaceConfig) => component.components();


  const ReplaceApis = Object.freeze({
    append: append$2,
    prepend: prepend$2,
    remove: remove$7,
    set: set$7,
    contents
  });

  const Replacing = create$1({
    fields: [],
    name: 'replacing',
    apis: ReplaceApis
  });

  const transpose = obj => $_8qu224wzjfuw8tb9.tupleMap(obj, (v, k) => ({
    k: v,
    v: k
  }));
  const trace = (items, byItem, byMenu, finish) => readOptFrom$1(byMenu, finish).bind(triggerItem => readOptFrom$1(items, triggerItem).bind(triggerMenu => {
    const rest = trace(items, byItem, byMenu, triggerMenu);
    return Option.some([triggerMenu].concat(rest));
  })).getOr([]);
  const generate$5 = (menus, expansions) => {
    const items = {};
    $_8qu224wzjfuw8tb9.each(menus, (menuItems, menu) => {
      $_efmt4zxbjfuw8tcj.each(menuItems, item => {
        items[item] = menu;
      });
    });
    const byItem = expansions;
    const byMenu = transpose(expansions);
    const menuPaths = $_8qu224wzjfuw8tb9.map(byMenu, (triggerItem, submenu) => [submenu].concat(trace(items, byItem, byMenu, submenu)));
    return $_8qu224wzjfuw8tb9.map(items, path => readOptFrom$1(menuPaths, path).getOr([path]));
  };

  function LayeredState () {
    const expansions = Cell({});
    const menus = Cell({});
    const paths = Cell({});
    const primary = Cell(Option.none());
    const toItemValues = Cell($_2vokfcwwjfuw8tb4.constant([]));
    const clear = () => {
      expansions.set({});
      menus.set({});
      paths.set({});
      primary.set(Option.none());
    };
    const isClear = () => primary.get().isNone();
    const setContents = (sPrimary, sMenus, sExpansions, sToItemValues) => {
      primary.set(Option.some(sPrimary));
      expansions.set(sExpansions);
      menus.set(sMenus);
      toItemValues.set(sToItemValues);
      const menuValues = sToItemValues(sMenus);
      const sPaths = generate$5(menuValues, sExpansions);
      paths.set(sPaths);
    };
    const expand = itemValue => readOptFrom$1(expansions.get(), itemValue).map(menu => {
      const current = readOptFrom$1(paths.get(), itemValue).getOr([]);
      return [menu].concat(current);
    });
    const collapse = itemValue => readOptFrom$1(paths.get(), itemValue).bind(path => path.length > 1 ? Option.some(path.slice(1)) : Option.none());
    const refresh = itemValue => readOptFrom$1(paths.get(), itemValue);
    const lookupMenu = menuValue => readOptFrom$1(menus.get(), menuValue);
    const otherMenus = path => {
      const menuValues = toItemValues.get()(menus.get());
      return $_efmt4zxbjfuw8tcj.difference($_8qu224wzjfuw8tb9.keys(menuValues), path);
    };
    const getPrimary = () => primary.get().bind(lookupMenu);
    const getMenus = () => menus.get();
    return {
      setContents,
      expand,
      refresh,
      collapse,
      lookupMenu,
      otherMenus,
      getPrimary,
      getMenus,
      clear,
      isClear
    };
  }

  const make$3 = (detail, rawUiSpec) => {
    const buildMenus = (container, menus) => $_8qu224wzjfuw8tb9.map(menus, (spec, name) => {
      const data = Menu.sketch($_3jctjywxjfuw8tb6.deepMerge(spec, {
        value: name,
        items: spec.items,
        markers: narrow$1(rawUiSpec.markers, [
          'item',
          'selectedItem'
        ]),
        fakeFocus: detail.fakeFocus(),
        onHighlight: detail.onHighlight(),
        focusManager: detail.fakeFocus() ? highlights() : dom()
      }));
      return container.getSystem().build(data);
    });
    const state = LayeredState();
    const setup = container => {
      const componentMap = buildMenus(container, detail.data().menus());
      state.setContents(detail.data().primary(), componentMap, detail.data().expansions(), sMenus => toMenuValues(container, sMenus));
      return state.getPrimary();
    };
    const getItemValue = item => Representing.getValue(item).value;
    var toMenuValues = (container, sMenus) => $_8qu224wzjfuw8tb9.map(detail.data().menus(), (data, menuName) => $_efmt4zxbjfuw8tcj.bind(data.items, item => item.type === 'separator' ? [] : [item.data.value]));
    const setActiveMenu = (container, menu) => {
      Highlighting.highlight(container, menu);
      Highlighting.getHighlighted(menu).orThunk(() => Highlighting.getFirst(menu)).each(item => {
        dispatch(container, item.element(), focusItem());
      });
    };
    const getMenus = (state, menuValues) => $_e8fwikzljfuw8tp3.cat($_efmt4zxbjfuw8tcj.map(menuValues, state.lookupMenu));
    const updateMenuPath = (container, state, path) => Option.from(path[0]).bind(state.lookupMenu).map(activeMenu => {
      const rest = getMenus(state, path.slice(1));
      $_efmt4zxbjfuw8tcj.each(rest, r => {
        $_6po7jxyujfuw8tl0.add(r.element(), detail.markers().backgroundMenu());
      });
      if (!$_8634tqxhjfuw8tdl.inBody(activeMenu.element())) {
        Replacing.append(container, premade$1(activeMenu));
      }
      $_c6ke2t13mjfuw8uku.remove(activeMenu.element(), [detail.markers().backgroundMenu()]);
      setActiveMenu(container, activeMenu);
      const others = getMenus(state, state.otherMenus(path));
      $_efmt4zxbjfuw8tcj.each(others, o => {
        $_c6ke2t13mjfuw8uku.remove(o.element(), [detail.markers().backgroundMenu()]);
        if (!detail.stayInDom()) {
          Replacing.remove(container, o);
        }
      });
      return activeMenu;
    });
    const expandRight = (container, item) => {
      const value = getItemValue(item);
      return state.expand(value).bind(path => {
        Option.from(path[0]).bind(state.lookupMenu).each(activeMenu => {
          if (!$_8634tqxhjfuw8tdl.inBody(activeMenu.element())) {
            Replacing.append(container, premade$1(activeMenu));
          }
          detail.onOpenSubmenu()(container, item, activeMenu);
          Highlighting.highlightFirst(activeMenu);
        });
        return updateMenuPath(container, state, path);
      });
    };
    const collapseLeft = (container, item) => {
      const value = getItemValue(item);
      return state.collapse(value).bind(path => updateMenuPath(container, state, path).map(activeMenu => {
        detail.onCollapseMenu()(container, item, activeMenu);
        return activeMenu;
      }));
    };
    const updateView = (container, item) => {
      const value = getItemValue(item);
      return state.refresh(value).bind(path => updateMenuPath(container, state, path));
    };
    const onRight = (container, item) => inside(item.element()) ? Option.none() : expandRight(container, item);
    const onLeft = (container, item) => inside(item.element()) ? Option.none() : collapseLeft(container, item);
    const onEscape = (container, item) => collapseLeft(container, item).orThunk(() => detail.onEscape()(container, item));
    const keyOnItem = f => (container, simulatedEvent) => $_c8lemt10bjfuw8tt8.closest(simulatedEvent.getSource(), `.${detail.markers().item()}`).bind(target => container.getSystem().getByDom(target).bind(item => f(container, item)));
    const events = derive([
      run(focus$5(), (sandbox, simulatedEvent) => {
        const menu = simulatedEvent.event().menu();
        Highlighting.highlight(sandbox, menu);
      }),
      runOnExecute((sandbox, simulatedEvent) => {
        const target = simulatedEvent.event().target();
        return sandbox.getSystem().getByDom(target).bind(item => {
          const itemValue = getItemValue(item);
          if (itemValue.indexOf('collapse-item') === 0) {
            return collapseLeft(sandbox, item);
          }
          return expandRight(sandbox, item).orThunk(() => detail.onExecute()(sandbox, item));
        });
      }),
      runOnAttached((container, simulatedEvent) => {
        setup(container).each(primary => {
          Replacing.append(container, premade$1(primary));
          if (detail.openImmediately()) {
            setActiveMenu(container, primary);
            detail.onOpenMenu()(container, primary);
          }
        });
      })
    ].concat(detail.navigateOnHover() ? [run(hover(), (sandbox, simulatedEvent) => {
        const item = simulatedEvent.event().item();
        updateView(sandbox, item);
        expandRight(sandbox, item);
        detail.onHover()(sandbox, item);
      })] : []));
    const collapseMenuApi = container => {
      Highlighting.getHighlighted(container).each(currentMenu => {
        Highlighting.getHighlighted(currentMenu).each(currentItem => {
          collapseLeft(container, currentItem);
        });
      });
    };
    return {
      uid: detail.uid(),
      dom: detail.dom(),
      behaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2([
        Keying.config({
          mode: 'special',
          onRight: keyOnItem(onRight),
          onLeft: keyOnItem(onLeft),
          onEscape: keyOnItem(onEscape),
          focusIn(container, keyInfo) {
            state.getPrimary().each(primary => {
              dispatch(container, primary.element(), focusItem());
            });
          }
        }),
        Highlighting.config({
          highlightClass: detail.markers().selectedMenu(),
          itemClass: detail.markers().menu()
        }),
        Composing.config({
          find(container) {
            return Highlighting.getHighlighted(container);
          }
        }),
        Replacing.config({})
      ]), get$5(detail.tmenuBehaviours())),
      eventOrder: detail.eventOrder(),
      apis: { collapseMenu: collapseMenuApi },
      events
    };
  };
  const collapseItem = $_2vokfcwwjfuw8tb4.constant('collapse-item');

  const tieredData = (primary, menus, expansions) => ({
    primary,
    menus,
    expansions
  });
  const singleData = (name, menu) => ({
    primary: name,
    menus: wrap$2(name, menu),
    expansions: {}
  });
  const collapseItem$1 = text => ({
    value: $_5j06su11ajfuw8u1p.generate(collapseItem()),
    text
  });
  const TieredMenu = single$2({
    name: 'TieredMenu',
    configFields: [
      onStrictKeyboardHandler('onExecute'),
      onStrictKeyboardHandler('onEscape'),
      onStrictHandler('onOpenMenu'),
      onStrictHandler('onOpenSubmenu'),
      onHandler('onCollapseMenu'),
      defaulted$1('openImmediately', true),
      strictObjOf('data', [
        strict$1('primary'),
        strict$1('menus'),
        strict$1('expansions')
      ]),
      defaulted$1('fakeFocus', false),
      onHandler('onHighlight'),
      onHandler('onHover'),
      tieredMenuMarkers(),
      strict$1('dom'),
      defaulted$1('navigateOnHover', true),
      defaulted$1('stayInDom', false),
      field$1('tmenuBehaviours', [
        Keying,
        Highlighting,
        Composing,
        Replacing
      ]),
      defaulted$1('eventOrder', {})
    ],
    apis: {
      collapseMenu(apis, tmenu) {
        apis.collapseMenu(tmenu);
      }
    },
    factory: make$3,
    extraApis: {
      tieredData,
      singleData,
      collapseItem: collapseItem$1
    }
  });

  const findRoute = (component, transConfig, transState, route) => readOptFrom$1(transConfig.routes(), route.start()).map($_2vokfcwwjfuw8tb4.apply).bind(sConfig => readOptFrom$1(sConfig, route.destination()).map($_2vokfcwwjfuw8tb4.apply));
  const getTransition = (comp, transConfig, transState) => {
    const route = getCurrentRoute(comp, transConfig, transState);
    return route.bind(r => getTransitionOf(comp, transConfig, transState, r));
  };
  var getTransitionOf = (comp, transConfig, transState, route) => findRoute(comp, transConfig, transState, route).bind(r => r.transition().map(t => ({
    transition: $_2vokfcwwjfuw8tb4.constant(t),
    route: $_2vokfcwwjfuw8tb4.constant(r)
  })));
  const disableTransition = (comp, transConfig, transState) => {
    getTransition(comp, transConfig, transState).each(routeTransition => {
      const t = routeTransition.transition();
      $_6po7jxyujfuw8tl0.remove(comp.element(), t.transitionClass());
      $_47adx7ywjfuw8tl3.remove(comp.element(), transConfig.destinationAttr());
    });
  };
  const getNewRoute = (comp, transConfig, transState, destination) => ({
    start: $_2vokfcwwjfuw8tb4.constant($_47adx7ywjfuw8tl3.get(comp.element(), transConfig.stateAttr())),
    destination: $_2vokfcwwjfuw8tb4.constant(destination)
  });
  var getCurrentRoute = (comp, transConfig, transState) => {
    const el = comp.element();
    return $_47adx7ywjfuw8tl3.has(el, transConfig.destinationAttr()) ? Option.some({
      start: $_2vokfcwwjfuw8tb4.constant($_47adx7ywjfuw8tl3.get(comp.element(), transConfig.stateAttr())),
      destination: $_2vokfcwwjfuw8tb4.constant($_47adx7ywjfuw8tl3.get(comp.element(), transConfig.destinationAttr()))
    }) : Option.none();
  };
  const jumpTo = (comp, transConfig, transState, destination) => {
    disableTransition(comp, transConfig, transState);
    if ($_47adx7ywjfuw8tl3.has(comp.element(), transConfig.stateAttr()) && $_47adx7ywjfuw8tl3.get(comp.element(), transConfig.stateAttr()) !== destination) {
      transConfig.onFinish()(comp, destination);
    }
    $_47adx7ywjfuw8tl3.set(comp.element(), transConfig.stateAttr(), destination);
  };
  const fasttrack = (comp, transConfig, transState, destination) => {
    if ($_47adx7ywjfuw8tl3.has(comp.element(), transConfig.destinationAttr())) {
      $_47adx7ywjfuw8tl3.set(comp.element(), transConfig.stateAttr(), $_47adx7ywjfuw8tl3.get(comp.element(), transConfig.destinationAttr()));
      $_47adx7ywjfuw8tl3.remove(comp.element(), transConfig.destinationAttr());
    }
  };
  const progressTo = (comp, transConfig, transState, destination) => {
    fasttrack(comp, transConfig, transState, destination);
    const route = getNewRoute(comp, transConfig, transState, destination);
    getTransitionOf(comp, transConfig, transState, route).fold(() => {
      jumpTo(comp, transConfig, transState, destination);
    }, routeTransition => {
      disableTransition(comp, transConfig, transState);
      const t = routeTransition.transition();
      $_6po7jxyujfuw8tl0.add(comp.element(), t.transitionClass());
      $_47adx7ywjfuw8tl3.set(comp.element(), transConfig.destinationAttr(), destination);
    });
  };
  const getState = (comp, transConfig, transState) => {
    const e = comp.element();
    return $_47adx7ywjfuw8tl3.has(e, transConfig.stateAttr()) ? Option.some($_47adx7ywjfuw8tl3.get(e, transConfig.stateAttr())) : Option.none();
  };


  const TransitionApis = Object.freeze({
    findRoute,
    disableTransition,
    getCurrentRoute,
    jumpTo,
    progressTo,
    getState
  });

  const events$8 = (transConfig, transState) => derive([
    run(transitionend(), (component, simulatedEvent) => {
      const raw = simulatedEvent.event().raw();
      getCurrentRoute(component, transConfig, transState).each(route => {
        findRoute(component, transConfig, transState, route).each(rInfo => {
          rInfo.transition().each(rTransition => {
            if (raw.propertyName === rTransition.property()) {
              jumpTo(component, transConfig, transState, route.destination());
              transConfig.onTransition()(component, route);
            }
          });
        });
      });
    }),
    runOnAttached((comp, se) => {
      jumpTo(comp, transConfig, transState, transConfig.initialState());
    })
  ]);


  const ActiveTransitioning = Object.freeze({
    events: events$8
  });

  const TransitionSchema = [
    defaulted$1('destinationAttr', 'data-transitioning-destination'),
    defaulted$1('stateAttr', 'data-transitioning-state'),
    strict$1('initialState'),
    onHandler('onTransition'),
    onHandler('onFinish'),
    strictOf('routes', setOf(Result.value, setOf(Result.value, objOfOnly([optionObjOfOnly('transition', [
        strict$1('property'),
        strict$1('transitionClass')
      ])]))))
  ];

  const createRoutes = routes => {
    const r = {};
    $_8qu224wzjfuw8tb9.each(routes, (v, k) => {
      const waypoints = k.split('<->');
      r[waypoints[0]] = wrap$2(waypoints[1], v);
      r[waypoints[1]] = wrap$2(waypoints[0], v);
    });
    return r;
  };
  const createBistate = (first, second, transitions) => wrapAll$1([
    {
      key: first,
      value: wrap$2(second, transitions)
    },
    {
      key: second,
      value: wrap$2(first, transitions)
    }
  ]);
  const createTristate = (first, second, third, transitions) => wrapAll$1([
    {
      key: first,
      value: wrapAll$1([
        {
          key: second,
          value: transitions
        },
        {
          key: third,
          value: transitions
        }
      ])
    },
    {
      key: second,
      value: wrapAll$1([
        {
          key: first,
          value: transitions
        },
        {
          key: third,
          value: transitions
        }
      ])
    },
    {
      key: third,
      value: wrapAll$1([
        {
          key: first,
          value: transitions
        },
        {
          key: second,
          value: transitions
        }
      ])
    }
  ]);
  const Transitioning = create$1({
    fields: TransitionSchema,
    name: 'transitioning',
    active: ActiveTransitioning,
    apis: TransitionApis,
    extra: {
      createRoutes,
      createBistate,
      createTristate
    }
  });

  const scrollable = $_2fp9skztjfuw8tqe.resolve('scrollable');
  const register = element => {
    $_6po7jxyujfuw8tl0.add(element, scrollable);
  };
  const deregister = element => {
    $_6po7jxyujfuw8tl0.remove(element, scrollable);
  };
  const $_3pnsue149jfuw8uqb = {
    register,
    deregister,
    scrollable: $_2vokfcwwjfuw8tb4.constant(scrollable)
  };

  const getValue$4 = item => readOptFrom$1(item, 'format').getOr(item.title);
  const convert$1 = (formats, memMenuThunk) => {
    const mainMenu = makeMenu('Styles', [].concat($_efmt4zxbjfuw8tcj.map(formats.items, k => makeItem(getValue$4(k), k.title, k.isSelected(), k.getPreview(), hasKey$1(formats.expansions, getValue$4(k))))), memMenuThunk, false);
    const submenus = $_8qu224wzjfuw8tb9.map(formats.menus, (menuItems, menuName) => {
      const items = $_efmt4zxbjfuw8tcj.map(menuItems, item => makeItem(getValue$4(item), item.title, item.isSelected !== undefined ? item.isSelected() : false, item.getPreview !== undefined ? item.getPreview() : '', hasKey$1(formats.expansions, getValue$4(item))));
      return makeMenu(menuName, items, memMenuThunk, true);
    });
    const menus = $_3jctjywxjfuw8tb6.deepMerge(submenus, wrap$2('styles', mainMenu));
    const tmenu = TieredMenu.tieredData('styles', menus, formats.expansions);
    return { tmenu };
  };
  var makeItem = (value, text$$1, selected, preview, isMenu) => ({
    data: {
      value,
      text: text$$1
    },

    type: 'item',

    dom: {
      tag: 'div',
      classes: isMenu ? [$_2fp9skztjfuw8tqe.resolve('styles-item-is-menu')] : []
    },

    toggling: {
      toggleOnExecute: false,
      toggleClass: $_2fp9skztjfuw8tqe.resolve('format-matches'),
      selected
    },

    itemBehaviours: derive$2(isMenu ? [] : [$_9de9iyzsjfuw8tqa.format(value, (comp, status) => {
        const toggle = status ? Toggling.on : Toggling.off;
        toggle(comp);
      })]),

    components: [{
        dom: {
          tag: 'div',
          attributes: { style: preview },
          innerHtml: text$$1
        }
      }]
  });
  var makeMenu = (value, items, memMenuThunk, collapsable) => ({
    value,
    dom: { tag: 'div' },

    components: [
      Button.sketch({
        dom: {
          tag: 'div',
          classes: [$_2fp9skztjfuw8tqe.resolve('styles-collapser')]
        },
        components: collapsable ? [
          {
            dom: {
              tag: 'span',
              classes: [$_2fp9skztjfuw8tqe.resolve('styles-collapse-icon')]
            }
          },
          text(value)
        ] : [text(value)],
        action(item) {
          if (collapsable) {
            const comp = memMenuThunk().get(item);
            TieredMenu.collapseMenu(comp);
          }
        }
      }),
      {
        dom: {
          tag: 'div',
          classes: [$_2fp9skztjfuw8tqe.resolve('styles-menu-items-container')]
        },
        components: [Menu.parts().items({})],
        behaviours: derive$2([config('adhoc-scrollable-menu', [
            runOnAttached((component, simulatedEvent) => {
              $_aag5ti106jfuw8tse.set(component.element(), 'overflow-y', 'auto');
              $_aag5ti106jfuw8tse.set(component.element(), '-webkit-overflow-scrolling', 'touch');
              $_3pnsue149jfuw8uqb.register(component.element());
            }),
            runOnDetached(component => {
              $_aag5ti106jfuw8tse.remove(component.element(), 'overflow-y');
              $_aag5ti106jfuw8tse.remove(component.element(), '-webkit-overflow-scrolling');
              $_3pnsue149jfuw8uqb.deregister(component.element());
            })
          ])])
      }
    ],

    items,

    menuBehaviours: derive$2([Transitioning.config({
        initialState: 'after',
        routes: Transitioning.createTristate('before', 'current', 'after', {
          transition: {
            property: 'transform',
            transitionClass: 'transitioning'
          }
        })
      })])
  });
  const sketch$9 = settings => {
    const dataset = convert$1(settings.formats, () => memMenu);
    var memMenu = record(TieredMenu.sketch({
      dom: {
        tag: 'div',
        classes: [$_2fp9skztjfuw8tqe.resolve('styles-menu')]
      },
      components: [],
      fakeFocus: true,
      stayInDom: true,
      onExecute(tmenu, item) {
        const v = Representing.getValue(item);
        settings.handle(item, v.value);
      },
      onEscape() {
      },
      onOpenMenu(container, menu) {
        const w = $_dsj1h711zjfuw8u73.get(container.element());
        $_dsj1h711zjfuw8u73.set(menu.element(), w);
        Transitioning.jumpTo(menu, 'current');
      },
      onOpenSubmenu(container, item, submenu) {
        const w = $_dsj1h711zjfuw8u73.get(container.element());
        const menu = $_c8lemt10bjfuw8tt8.ancestor(item.element(), '[role="menu"]').getOrDie('hacky');
        const menuComp = container.getSystem().getByDom(menu).getOrDie();
        $_dsj1h711zjfuw8u73.set(submenu.element(), w);
        Transitioning.progressTo(menuComp, 'before');
        Transitioning.jumpTo(submenu, 'after');
        Transitioning.progressTo(submenu, 'current');
      },
      onCollapseMenu(container, item, menu) {
        const submenu = $_c8lemt10bjfuw8tt8.ancestor(item.element(), '[role="menu"]').getOrDie('hacky');
        const submenuComp = container.getSystem().getByDom(submenu).getOrDie();
        Transitioning.progressTo(submenuComp, 'after');
        Transitioning.progressTo(menu, 'current');
      },
      navigateOnHover: false,
      openImmediately: true,
      data: dataset.tmenu,
      markers: {
        backgroundMenu: $_2fp9skztjfuw8tqe.resolve('styles-background-menu'),
        menu: $_2fp9skztjfuw8tqe.resolve('styles-menu'),
        selectedMenu: $_2fp9skztjfuw8tqe.resolve('styles-selected-menu'),
        item: $_2fp9skztjfuw8tqe.resolve('styles-item'),
        selectedItem: $_2fp9skztjfuw8tqe.resolve('styles-selected-item')
      }
    }));
    return memMenu.asSpec();
  };
  const $_bf3tu6137jfuw8ufb = { sketch: sketch$9 };

  const getFromExpandingItem = item => {
    const newItem = $_3jctjywxjfuw8tb6.deepMerge(exclude$1(item, ['items']), { menu: true });
    const rest = expand(item.items);
    const newMenus = $_3jctjywxjfuw8tb6.deepMerge(rest.menus, wrap$2(item.title, rest.items));
    const newExpansions = $_3jctjywxjfuw8tb6.deepMerge(rest.expansions, wrap$2(item.title, item.title));
    return {
      item: newItem,
      menus: newMenus,
      expansions: newExpansions
    };
  };
  const getFromItem = item => hasKey$1(item, 'items') ? getFromExpandingItem(item) : {
    item,
    menus: {},
    expansions: {}
  };
  var expand = items => $_efmt4zxbjfuw8tcj.foldr(items, (acc, item) => {
    const newData = getFromItem(item);
    return {
      menus: $_3jctjywxjfuw8tb6.deepMerge(acc.menus, newData.menus),
      items: [newData.item].concat(acc.items),
      expansions: $_3jctjywxjfuw8tb6.deepMerge(acc.expansions, newData.expansions)
    };
  }, {
    menus: {},
    expansions: {},
    items: []
  });
  const $_2ogda014ajfuw8uqg = { expand };

  const register$1 = (editor, settings) => {
    const isSelectedFor = format => () => editor.formatter.match(format);
    const getPreview = format => () => {
      const styles = editor.formatter.getCssText(format);
      return styles;
    };
    const enrichSupported = item => $_3jctjywxjfuw8tb6.deepMerge(item, {
      isSelected: isSelectedFor(item.format),
      getPreview: getPreview(item.format)
    });
    const enrichMenu = item => $_3jctjywxjfuw8tb6.deepMerge(item, {
      isSelected: $_2vokfcwwjfuw8tb4.constant(false),
      getPreview: $_2vokfcwwjfuw8tb4.constant('')
    });
    const enrichCustom = item => {
      const formatName = $_5j06su11ajfuw8u1p.generate(item.title);
      const newItem = $_3jctjywxjfuw8tb6.deepMerge(item, {
        format: formatName,
        isSelected: isSelectedFor(formatName),
        getPreview: getPreview(formatName)
      });
      editor.formatter.register(formatName, newItem);
      return newItem;
    };
    const formats = readOptFrom$1(settings, 'style_formats').getOr(DefaultStyleFormats);
    const doEnrich = items => $_efmt4zxbjfuw8tcj.map(items, item => {
      if (hasKey$1(item, 'items')) {
        const newItems = doEnrich(item.items);
        return $_3jctjywxjfuw8tb6.deepMerge(enrichMenu(item), { items: newItems });
      } else if (hasKey$1(item, 'format')) {
        return enrichSupported(item);
      } else {
        return enrichCustom(item);
      }
    });
    return doEnrich(formats);
  };
  const prune = (editor, formats) => {
    const doPrune = items => $_efmt4zxbjfuw8tcj.bind(items, item => {
      if (item.items !== undefined) {
        const newItems = doPrune(item.items);
        return newItems.length > 0 ? [item] : [];
      } else {
        const keep = hasKey$1(item, 'format') ? editor.formatter.canApply(item.format) : true;
        return keep ? [item] : [];
      }
    });
    const prunedItems = doPrune(formats);
    return $_2ogda014ajfuw8uqg.expand(prunedItems);
  };
  const ui = (editor, formats, onDone) => {
    const pruned = prune(editor, formats);
    return $_bf3tu6137jfuw8ufb.sketch({
      formats: pruned,
      handle(item, value) {
        editor.undoManager.transact(() => {
          if (Toggling.isOn(item)) {
            editor.formatter.remove(value);
          } else {
            editor.formatter.apply(value);
          }
        });
        onDone();
      }
    });
  };
  const $_816rke135jfuw8uey = {
    register: register$1,
    ui
  };

  const defaults = [
    'undo',
    'bold',
    'italic',
    'link',
    'image',
    'bullist',
    'styleselect'
  ];
  const extract$1 = rawToolbar => {
    const toolbar = rawToolbar.replace(/\|/g, ' ').trim();
    return toolbar.length > 0 ? toolbar.split(/\s+/) : [];
  };
  const identifyFromArray = toolbar => $_efmt4zxbjfuw8tcj.bind(toolbar, item => $_8aqeo3wyjfuw8tb8.isArray(item) ? identifyFromArray(item) : extract$1(item));
  const identify = settings => {
    const toolbar = settings.toolbar !== undefined ? settings.toolbar : defaults;
    return $_8aqeo3wyjfuw8tb8.isArray(toolbar) ? identifyFromArray(toolbar) : extract$1(toolbar);
  };
  const setup = (realm, editor) => {
    const commandSketch = name => () => $_44weuozujfuw8tqh.forToolbarCommand(editor, name);
    const stateCommandSketch = name => () => $_44weuozujfuw8tqh.forToolbarStateCommand(editor, name);
    const actionSketch = (name, query, action) => () => $_44weuozujfuw8tqh.forToolbarStateAction(editor, name, query, action);
    const undo = commandSketch('undo');
    const redo = commandSketch('redo');
    const bold = stateCommandSketch('bold');
    const italic = stateCommandSketch('italic');
    const underline = stateCommandSketch('underline');
    const removeformat = commandSketch('removeformat');
    const link = () => sketch$8(realm, editor);
    const unlink = actionSketch('unlink', 'link', () => {
      editor.execCommand('unlink', null, false);
    });
    const image = () => sketch$5(editor);
    const bullist = actionSketch('unordered-list', 'ul', () => {
      editor.execCommand('InsertUnorderedList', null, false);
    });
    const numlist = actionSketch('ordered-list', 'ol', () => {
      editor.execCommand('InsertOrderedList', null, false);
    });
    const fontsizeselect = () => sketch$4(realm, editor);
    const forecolor = () => $_zydxw11kjfuw8u3z.sketch(realm, editor);
    const styleFormats = $_816rke135jfuw8uey.register(editor, editor.settings);
    const styleFormatsMenu = () => $_816rke135jfuw8uey.ui(editor, styleFormats, () => {
      editor.fire('scrollIntoView');
    });
    const styleselect = () => $_44weuozujfuw8tqh.forToolbar('style-formats', button => {
      editor.fire('toReading');
      realm.dropup().appear(styleFormatsMenu, Toggling.on, button);
    }, derive$2([
      Toggling.config({
        toggleClass: $_2fp9skztjfuw8tqe.resolve('toolbar-button-selected'),
        toggleOnExecute: false,
        aria: { mode: 'pressed' }
      }),
      Receiving.config({
        channels: wrapAll$1([
          $_9de9iyzsjfuw8tqa.receive($_9e19stz9jfuw8tmf.orientationChanged(), Toggling.off),
          $_9de9iyzsjfuw8tqa.receive($_9e19stz9jfuw8tmf.dropupDismissed(), Toggling.off)
        ])
      })
    ]));
    const feature = (prereq, sketch) => ({
      isSupported() {
        return prereq.forall(p => hasKey$1(editor.buttons, p));
      },

      sketch
    });
    return {
      undo: feature(Option.none(), undo),
      redo: feature(Option.none(), redo),
      bold: feature(Option.none(), bold),
      italic: feature(Option.none(), italic),
      underline: feature(Option.none(), underline),
      removeformat: feature(Option.none(), removeformat),
      link: feature(Option.none(), link),
      unlink: feature(Option.none(), unlink),
      image: feature(Option.none(), image),
      bullist: feature(Option.some('bullist'), bullist),
      numlist: feature(Option.some('numlist'), numlist),
      fontsizeselect: feature(Option.none(), fontsizeselect),
      forecolor: feature(Option.none(), forecolor),
      styleselect: feature(Option.none(), styleselect)
    };
  };
  const detect$4 = (settings, features) => {
    const itemNames = identify(settings);
    const present = {};
    return $_efmt4zxbjfuw8tcj.bind(itemNames, iName => {
      const r = !hasKey$1(present, iName) && hasKey$1(features, iName) && features[iName].isSupported() ? [features[iName].sketch()] : [];
      present[iName] = true;
      return r;
    });
  };
  const $_4419oszajfuw8tmi = {
    identify,
    setup,
    detect: detect$4
  };

  const mkEvent = (target, x, y, stop, prevent, kill, raw) => ({
    'target': $_2vokfcwwjfuw8tb4.constant(target),
    'x': $_2vokfcwwjfuw8tb4.constant(x),
    'y': $_2vokfcwwjfuw8tb4.constant(y),
    'stop': stop,
    'prevent': prevent,
    'kill': kill,
    'raw': $_2vokfcwwjfuw8tb4.constant(raw)
  });
  const handle = (filter, handler) => rawEvent => {
    if (!filter(rawEvent))
      return;
    const target = $_bwdnu0xijfuw8tdo.fromDom(rawEvent.target);
    const stop = () => {
      rawEvent.stopPropagation();
    };
    const prevent = () => {
      rawEvent.preventDefault();
    };
    const kill = $_2vokfcwwjfuw8tb4.compose(prevent, stop);
    const evt = mkEvent(target, rawEvent.clientX, rawEvent.clientY, stop, prevent, kill, rawEvent);
    handler(evt);
  };
  const binder = (element, event, filter, handler, useCapture) => {
    const wrapped = handle(filter, handler);
    element.dom().addEventListener(event, wrapped, useCapture);
    return { unbind: $_2vokfcwwjfuw8tb4.curry(unbind, element, event, wrapped, useCapture) };
  };
  const bind$1 = (element, event, filter, handler) => binder(element, event, filter, handler, false);
  const capture = (element, event, filter, handler) => binder(element, event, filter, handler, true);
  var unbind = (element, event, handler, useCapture) => {
    element.dom().removeEventListener(event, handler, useCapture);
  };
  const $_2sq5yy14djfuw8ur4 = {
    bind: bind$1,
    capture
  };

  const filter$1 = $_2vokfcwwjfuw8tb4.constant(true);
  const bind$2 = (element, event, handler) => $_2sq5yy14djfuw8ur4.bind(element, event, filter$1, handler);
  const capture$1 = (element, event, handler) => $_2sq5yy14djfuw8ur4.capture(element, event, filter$1, handler);
  const $_6cl0bk14cjfuw8uqx = {
    bind: bind$2,
    capture: capture$1
  };

  const INTERVAL = 50;
  const INSURANCE = 1000 / INTERVAL;
  const get$11 = outerWindow => {
    const isPortrait = outerWindow.matchMedia('(orientation: portrait)').matches;
    return { isPortrait: $_2vokfcwwjfuw8tb4.constant(isPortrait) };
  };
  const getActualWidth = outerWindow => {
    const isIos = $_5reqwox3jfuw8tbu.detect().os.isiOS();
    const isPortrait = get$11(outerWindow).isPortrait();
    return isIos && !isPortrait ? outerWindow.screen.height : outerWindow.screen.width;
  };
  const onChange = (outerWindow, listeners) => {
    const win = $_bwdnu0xijfuw8tdo.fromDom(outerWindow);
    let poller = null;
    const change = () => {
      clearInterval(poller);
      const orientation = get$11(outerWindow);
      listeners.onChange(orientation);
      onAdjustment(() => {
        listeners.onReady(orientation);
      });
    };
    const orientationHandle = $_6cl0bk14cjfuw8uqx.bind(win, 'orientationchange', change);
    var onAdjustment = f => {
      clearInterval(poller);
      const flag = outerWindow.innerHeight;
      let insurance = 0;
      poller = setInterval(() => {
        if (flag !== outerWindow.innerHeight) {
          clearInterval(poller);
          f(Option.some(outerWindow.innerHeight));
        } else if (insurance > INSURANCE) {
          clearInterval(poller);
          f(Option.none());
        }
        insurance++;
      }, INTERVAL);
    };
    const destroy = () => {
      orientationHandle.unbind();
    };
    return {
      onAdjustment,
      destroy
    };
  };
  const $_2v9f8x14bjfuw8uqn = {
    get: get$11,
    onChange,
    getActualWidth
  };

  function DelayedFunction (fun, delay) {
    let ref = null;
    const schedule = function () {
      const any = [];
      for (let _i = 0; _i < arguments.length; _i++) {
        any[_i] = arguments[_i];
      }
      const args = arguments;
      ref = setTimeout(() => {
        fun(...args);
        ref = null;
      }, delay);
    };
    const cancel = () => {
      if (ref !== null) {
        clearTimeout(ref);
        ref = null;
      }
    };
    return {
      cancel,
      schedule
    };
  }

  const SIGNIFICANT_MOVE = 5;
  const LONGPRESS_DELAY = 400;
  const getTouch = event => {
    if (event.raw().touches === undefined || event.raw().touches.length !== 1) {
      return Option.none();
    }
    return Option.some(event.raw().touches[0]);
  };
  const isFarEnough = (touch, data) => {
    const distX = Math.abs(touch.clientX - data.x());
    const distY = Math.abs(touch.clientY - data.y());
    return distX > SIGNIFICANT_MOVE || distY > SIGNIFICANT_MOVE;
  };
  const monitor = settings => {
    const startData = Cell(Option.none());
    const longpress$$1 = DelayedFunction(event => {
      startData.set(Option.none());
      settings.triggerEvent(longpress(), event);
    }, LONGPRESS_DELAY);
    const handleTouchstart = event => {
      getTouch(event).each(touch => {
        longpress$$1.cancel();
        const data = {
          x: $_2vokfcwwjfuw8tb4.constant(touch.clientX),
          y: $_2vokfcwwjfuw8tb4.constant(touch.clientY),
          target: event.target
        };
        longpress$$1.schedule(event);
        startData.set(Option.some(data));
      });
      return Option.none();
    };
    const handleTouchmove = event => {
      longpress$$1.cancel();
      getTouch(event).each(touch => {
        startData.get().each(data => {
          if (isFarEnough(touch, data)) {
            startData.set(Option.none());
          }
        });
      });
      return Option.none();
    };
    const handleTouchend = event => {
      longpress$$1.cancel();
      const isSame = data => $_4867a0xsjfuw8tej.eq(data.target(), event.target());
      return startData.get().filter(isSame).map(data => settings.triggerEvent(tap(), event));
    };
    const handlers = wrapAll$1([
      {
        key: touchstart(),
        value: handleTouchstart
      },
      {
        key: touchmove(),
        value: handleTouchmove
      },
      {
        key: touchend(),
        value: handleTouchend
      }
    ]);
    const fireIfReady = (event, type) => readOptFrom$1(handlers, type).bind(handler => handler(event));
    return { fireIfReady };
  };

  const monitor$1 = editorApi => {
    const tapEvent = monitor({
      triggerEvent(type, evt) {
        editorApi.onTapContent(evt);
      }
    });
    const onTouchend = () => $_6cl0bk14cjfuw8uqx.bind(editorApi.body(), 'touchend', evt => {
      tapEvent.fireIfReady(evt, 'touchend');
    });
    const onTouchmove = () => $_6cl0bk14cjfuw8uqx.bind(editorApi.body(), 'touchmove', evt => {
      tapEvent.fireIfReady(evt, 'touchmove');
    });
    const fireTouchstart = evt => {
      tapEvent.fireIfReady(evt, 'touchstart');
    };
    return {
      fireTouchstart,
      onTouchend,
      onTouchmove
    };
  };
  const $_bz8sbn14ijfuw8usd = { monitor: monitor$1 };

  const isAndroid6 = $_5reqwox3jfuw8tbu.detect().os.version.major >= 6;
  const initEvents = (editorApi, toolstrip, alloy) => {
    const tapping = $_bz8sbn14ijfuw8usd.monitor(editorApi);
    const outerDoc = $_aff64dxmjfuw8tdx.owner(toolstrip);
    const isRanged = sel => !$_4867a0xsjfuw8tej.eq(sel.start(), sel.finish()) || sel.soffset() !== sel.foffset();
    const hasRangeInUi = () => $_f15fvwz1jfuw8tlo.active(outerDoc).filter(input => $_74lhjaxjjfuw8tdt.name(input) === 'input').exists(input => input.dom().selectionStart !== input.dom().selectionEnd);
    const updateMargin = () => {
      const rangeInContent = editorApi.doc().dom().hasFocus() && editorApi.getSelection().exists(isRanged);
      alloy.getByDom(toolstrip).each((rangeInContent || hasRangeInUi()) === true ? Toggling.on : Toggling.off);
    };
    const listeners = [
      $_6cl0bk14cjfuw8uqx.bind(editorApi.body(), 'touchstart', evt => {
        editorApi.onTouchContent();
        tapping.fireTouchstart(evt);
      }),
      tapping.onTouchmove(),
      tapping.onTouchend(),
      $_6cl0bk14cjfuw8uqx.bind(toolstrip, 'touchstart', evt => {
        editorApi.onTouchToolstrip();
      }),
      editorApi.onToReading(() => {
        $_f15fvwz1jfuw8tlo.blur(editorApi.body());
      }),
      editorApi.onToEditing($_2vokfcwwjfuw8tb4.noop),
      editorApi.onScrollToCursor(tinyEvent => {
        tinyEvent.preventDefault();
        editorApi.getCursorBox().each(bounds => {
          const cWin = editorApi.win();
          const isOutside = bounds.top() > cWin.innerHeight || bounds.bottom() > cWin.innerHeight;
          const cScrollBy = isOutside ? bounds.bottom() - cWin.innerHeight + 50 : 0;
          if (cScrollBy !== 0) {
            cWin.scrollTo(cWin.pageXOffset, cWin.pageYOffset + cScrollBy);
          }
        });
      })
    ].concat(isAndroid6 === true ? [] : [
      $_6cl0bk14cjfuw8uqx.bind($_bwdnu0xijfuw8tdo.fromDom(editorApi.win()), 'blur', () => {
        alloy.getByDom(toolstrip).each(Toggling.off);
      }),
      $_6cl0bk14cjfuw8uqx.bind(outerDoc, 'select', updateMargin),
      $_6cl0bk14cjfuw8uqx.bind(editorApi.doc(), 'selectionchange', updateMargin)
    ]);
    const destroy = () => {
      $_efmt4zxbjfuw8tcj.each(listeners, l => {
        l.unbind();
      });
    };
    return { destroy };
  };
  const $_2zmd3p14hjfuw8uru = { initEvents };

  const safeParse = (element, attribute) => {
    const parsed = parseInt($_47adx7ywjfuw8tl3.get(element, attribute), 10);
    return isNaN(parsed) ? 0 : parsed;
  };
  const $_f77yow14mjfuw8ut9 = { safeParse };

  function NodeValue (is, name) {
    const get = element => {
      if (!is(element))
        throw new Error(`Can only get ${name} value of a ${name} node`);
      return getOption(element).getOr('');
    };
    const getOptionIE10 = element => {
      try {
        return getOptionSafe(element);
      } catch (e) {
        return Option.none();
      }
    };
    var getOptionSafe = element => is(element) ? Option.from(element.dom().nodeValue) : Option.none();
    const browser = $_5reqwox3jfuw8tbu.detect().browser;
    var getOption = browser.isIE() && browser.version.major === 10 ? getOptionIE10 : getOptionSafe;
    const set = (element, value) => {
      if (!is(element))
        throw new Error(`Can only set raw ${name} value of a ${name} node`);
      element.dom().nodeValue = value;
    };
    return {
      get,
      getOption,
      set
    };
  }

  const api$3 = NodeValue($_74lhjaxjjfuw8tdt.isText, 'text');
  const get$12 = element => api$3.get(element);
  const getOption = element => api$3.getOption(element);
  const set$8 = (element, value) => {
    api$3.set(element, value);
  };
  const $_18tyjl14pjfuw8utr = {
    get: get$12,
    getOption,
    set: set$8
  };

  const getEnd = element => $_74lhjaxjjfuw8tdt.name(element) === 'img' ? 1 : $_18tyjl14pjfuw8utr.getOption(element).fold(() => $_aff64dxmjfuw8tdx.children(element).length, v => v.length);
  const isEnd = (element, offset) => getEnd(element) === offset;
  const isStart = (element, offset) => offset === 0;
  const NBSP = '\xA0';
  const isTextNodeWithCursorPosition = el => $_18tyjl14pjfuw8utr.getOption(el).filter(text => text.trim().length !== 0 || text.includes(NBSP)).isSome();
  const elementsWithCursorPosition = [
    'img',
    'br'
  ];
  const isCursorPosition = elem => {
    const hasCursorPosition = isTextNodeWithCursorPosition(elem);
    return hasCursorPosition || $_efmt4zxbjfuw8tcj.contains(elementsWithCursorPosition, $_74lhjaxjjfuw8tdt.name(elem));
  };
  const $_8t9la614ojfuw8uto = {
    getEnd,
    isEnd,
    isStart,
    isCursorPosition
  };

  const adt$4 = $_dldkf4y5jfuw8tgp.generate([
    { 'before': ['element'] },
    {
      'on': [
        'element',
        'offset'
      ]
    },
    { after: ['element'] }
  ]);
  const cata = (subject, onBefore, onOn, onAfter) => subject.fold(onBefore, onOn, onAfter);
  const getStart = situ => situ.fold($_2vokfcwwjfuw8tb4.identity, $_2vokfcwwjfuw8tb4.identity, $_2vokfcwwjfuw8tb4.identity);
  const $_d45kr014sjfuw8uu3 = {
    before: adt$4.before,
    on: adt$4.on,
    after: adt$4.after,
    cata,
    getStart
  };

  const type$1 = $_dldkf4y5jfuw8tgp.generate([
    { domRange: ['rng'] },
    {
      relative: [
        'startSitu',
        'finishSitu'
      ]
    },
    {
      exact: [
        'start',
        'soffset',
        'finish',
        'foffset'
      ]
    }
  ]);
  const range$1 = $_4xhupwxnjfuw8tea.immutable('start', 'soffset', 'finish', 'foffset');
  const exactFromRange = simRange => type$1.exact(simRange.start(), simRange.soffset(), simRange.finish(), simRange.foffset());
  const getStart$1 = selection => selection.match({
    domRange(rng) {
      return $_bwdnu0xijfuw8tdo.fromDom(rng.startContainer);
    },
    relative(startSitu, finishSitu) {
      return $_d45kr014sjfuw8uu3.getStart(startSitu);
    },
    exact(start, soffset, finish, foffset) {
      return start;
    }
  });
  const getWin = selection => {
    const start = getStart$1(selection);
    return $_aff64dxmjfuw8tdx.defaultView(start);
  };
  const $_cx764414rjfuw8uty = {
    domRange: type$1.domRange,
    relative: type$1.relative,
    exact: type$1.exact,
    exactFromRange,
    range: range$1,
    getWin
  };

  const makeRange = (start, soffset, finish, foffset) => {
    const doc = $_aff64dxmjfuw8tdx.owner(start);
    const rng = doc.dom().createRange();
    rng.setStart(start.dom(), soffset);
    rng.setEnd(finish.dom(), foffset);
    return rng;
  };
  const commonAncestorContainer = (start, soffset, finish, foffset) => {
    const r = makeRange(start, soffset, finish, foffset);
    return $_bwdnu0xijfuw8tdo.fromDom(r.commonAncestorContainer);
  };
  const after$2 = (start, soffset, finish, foffset) => {
    const r = makeRange(start, soffset, finish, foffset);
    const same = $_4867a0xsjfuw8tej.eq(start, finish) && soffset === foffset;
    return r.collapsed && !same;
  };
  const $_7xrggl14ujfuw8uuf = {
    after: after$2,
    commonAncestorContainer
  };

  const fromElements = (elements, scope) => {
    const doc = scope || document;
    const fragment = doc.createDocumentFragment();
    $_efmt4zxbjfuw8tcj.each(elements, element => {
      fragment.appendChild(element.dom());
    });
    return $_bwdnu0xijfuw8tdo.fromDom(fragment);
  };
  const $_1c2i9n14vjfuw8uuh = { fromElements };

  const selectNodeContents = (win, element) => {
    const rng = win.document.createRange();
    selectNodeContentsUsing(rng, element);
    return rng;
  };
  var selectNodeContentsUsing = (rng, element) => {
    rng.selectNodeContents(element.dom());
  };
  const isWithin = (outerRange, innerRange) => innerRange.compareBoundaryPoints(outerRange.END_TO_START, outerRange) < 1 && innerRange.compareBoundaryPoints(outerRange.START_TO_END, outerRange) > -1;
  const create$4 = win => win.document.createRange();
  const setStart = (rng, situ) => {
    situ.fold(e => {
      rng.setStartBefore(e.dom());
    }, (e, o) => {
      rng.setStart(e.dom(), o);
    }, e => {
      rng.setStartAfter(e.dom());
    });
  };
  const setFinish = (rng, situ) => {
    situ.fold(e => {
      rng.setEndBefore(e.dom());
    }, (e, o) => {
      rng.setEnd(e.dom(), o);
    }, e => {
      rng.setEndAfter(e.dom());
    });
  };
  const replaceWith = (rng, fragment) => {
    deleteContents(rng);
    rng.insertNode(fragment.dom());
  };
  const relativeToNative = (win, startSitu, finishSitu) => {
    const range = win.document.createRange();
    setStart(range, startSitu);
    setFinish(range, finishSitu);
    return range;
  };
  const exactToNative = (win, start, soffset, finish, foffset) => {
    const rng = win.document.createRange();
    rng.setStart(start.dom(), soffset);
    rng.setEnd(finish.dom(), foffset);
    return rng;
  };
  var deleteContents = rng => {
    rng.deleteContents();
  };
  const cloneFragment = rng => {
    const fragment = rng.cloneContents();
    return $_bwdnu0xijfuw8tdo.fromDom(fragment);
  };
  const toRect = rect => ({
    left: $_2vokfcwwjfuw8tb4.constant(rect.left),
    top: $_2vokfcwwjfuw8tb4.constant(rect.top),
    right: $_2vokfcwwjfuw8tb4.constant(rect.right),
    bottom: $_2vokfcwwjfuw8tb4.constant(rect.bottom),
    width: $_2vokfcwwjfuw8tb4.constant(rect.width),
    height: $_2vokfcwwjfuw8tb4.constant(rect.height)
  });
  const getFirstRect = rng => {
    const rects = rng.getClientRects();
    const rect = rects.length > 0 ? rects[0] : rng.getBoundingClientRect();
    return rect.width > 0 || rect.height > 0 ? Option.some(rect).map(toRect) : Option.none();
  };
  const getBounds = rng => {
    const rect = rng.getBoundingClientRect();
    return rect.width > 0 || rect.height > 0 ? Option.some(rect).map(toRect) : Option.none();
  };
  const toString$1 = rng => rng.toString();
  const $_90n0ki14wjfuw8uuk = {
    create: create$4,
    replaceWith,
    selectNodeContents,
    selectNodeContentsUsing,
    relativeToNative,
    exactToNative,
    deleteContents,
    cloneFragment,
    getFirstRect,
    getBounds,
    isWithin,
    toString: toString$1
  };

  const adt$5 = $_dldkf4y5jfuw8tgp.generate([
    {
      ltr: [
        'start',
        'soffset',
        'finish',
        'foffset'
      ]
    },
    {
      rtl: [
        'start',
        'soffset',
        'finish',
        'foffset'
      ]
    }
  ]);
  const fromRange = (win, type, range) => type($_bwdnu0xijfuw8tdo.fromDom(range.startContainer), range.startOffset, $_bwdnu0xijfuw8tdo.fromDom(range.endContainer), range.endOffset);
  const getRanges = (win, selection) => selection.match({
    domRange(rng) {
      return {
        ltr: $_2vokfcwwjfuw8tb4.constant(rng),
        rtl: Option.none
      };
    },
    relative(startSitu, finishSitu) {
      return {
        ltr: $_ctj1zwx4jfuw8tbw.cached(() => $_90n0ki14wjfuw8uuk.relativeToNative(win, startSitu, finishSitu)),
        rtl: $_ctj1zwx4jfuw8tbw.cached(() => Option.some($_90n0ki14wjfuw8uuk.relativeToNative(win, finishSitu, startSitu)))
      };
    },
    exact(start, soffset, finish, foffset) {
      return {
        ltr: $_ctj1zwx4jfuw8tbw.cached(() => $_90n0ki14wjfuw8uuk.exactToNative(win, start, soffset, finish, foffset)),
        rtl: $_ctj1zwx4jfuw8tbw.cached(() => Option.some($_90n0ki14wjfuw8uuk.exactToNative(win, finish, foffset, start, soffset)))
      };
    }
  });
  const doDiagnose = (win, ranges) => {
    const rng = ranges.ltr();
    if (rng.collapsed) {
      const reversed = ranges.rtl().filter(rev => rev.collapsed === false);
      return reversed.map(rev => adt$5.rtl($_bwdnu0xijfuw8tdo.fromDom(rev.endContainer), rev.endOffset, $_bwdnu0xijfuw8tdo.fromDom(rev.startContainer), rev.startOffset)).getOrThunk(() => fromRange(win, adt$5.ltr, rng));
    } else {
      return fromRange(win, adt$5.ltr, rng);
    }
  };
  const diagnose = (win, selection) => {
    const ranges = getRanges(win, selection);
    return doDiagnose(win, ranges);
  };
  const asLtrRange = (win, selection) => {
    const diagnosis = diagnose(win, selection);
    return diagnosis.match({
      ltr(start, soffset, finish, foffset) {
        const rng = win.document.createRange();
        rng.setStart(start.dom(), soffset);
        rng.setEnd(finish.dom(), foffset);
        return rng;
      },
      rtl(start, soffset, finish, foffset) {
        const rng = win.document.createRange();
        rng.setStart(finish.dom(), foffset);
        rng.setEnd(start.dom(), soffset);
        return rng;
      }
    });
  };
  const $_dmfqjk14xjfuw8uuw = {
    ltr: adt$5.ltr,
    rtl: adt$5.rtl,
    diagnose,
    asLtrRange
  };

  const searchForPoint = (rectForOffset, x, y, maxX, length) => {
    if (length === 0)
      return 0;
    else if (x === maxX)
      return length - 1;
    let xDelta = maxX;
    for (let i = 1; i < length; i++) {
      const rect = rectForOffset(i);
      const curDeltaX = Math.abs(x - rect.left);
      if (y > rect.bottom) {
      } else if (y < rect.top || curDeltaX > xDelta) {
        return i - 1;
      } else {
        xDelta = curDeltaX;
      }
    }
    return 0;
  };
  const inRect = (rect, x, y) => x >= rect.left && x <= rect.right && y >= rect.top && y <= rect.bottom;
  const $_80479l150jfuw8uvg = {
    inRect,
    searchForPoint
  };

  const locateOffset = (doc, textnode, x, y, rect) => {
    const rangeForOffset = offset => {
      const r = doc.dom().createRange();
      r.setStart(textnode.dom(), offset);
      r.collapse(true);
      return r;
    };
    const rectForOffset = offset => {
      const r = rangeForOffset(offset);
      return r.getBoundingClientRect();
    };
    const length = $_18tyjl14pjfuw8utr.get(textnode).length;
    const offset = $_80479l150jfuw8uvg.searchForPoint(rectForOffset, x, y, rect.right, length);
    return rangeForOffset(offset);
  };
  const locate$1 = (doc, node, x, y) => {
    const r = doc.dom().createRange();
    r.selectNode(node.dom());
    const rects = r.getClientRects();
    const foundRect = $_e8fwikzljfuw8tp3.findMap(rects, rect => $_80479l150jfuw8uvg.inRect(rect, x, y) ? Option.some(rect) : Option.none());
    return foundRect.map(rect => locateOffset(doc, node, x, y, rect));
  };
  const $_17zjwv151jfuw8uvi = { locate: locate$1 };

  const searchInChildren = (doc, node, x, y) => {
    const r = doc.dom().createRange();
    const nodes = $_aff64dxmjfuw8tdx.children(node);
    return $_e8fwikzljfuw8tp3.findMap(nodes, n => {
      r.selectNode(n.dom());
      return $_80479l150jfuw8uvg.inRect(r.getBoundingClientRect(), x, y) ? locateNode(doc, n, x, y) : Option.none();
    });
  };
  var locateNode = (doc, node, x, y) => {
    const locator = $_74lhjaxjjfuw8tdt.isText(node) ? $_17zjwv151jfuw8uvi.locate : searchInChildren;
    return locator(doc, node, x, y);
  };
  const locate$2 = (doc, node, x, y) => {
    const r = doc.dom().createRange();
    r.selectNode(node.dom());
    const rect = r.getBoundingClientRect();
    const boundedX = Math.max(rect.left, Math.min(rect.right, x));
    const boundedY = Math.max(rect.top, Math.min(rect.bottom, y));
    return locateNode(doc, node, boundedX, boundedY);
  };
  const $_bvyyoa14zjfuw8uva = { locate: locate$2 };

  const first$3 = element => $_d0h9pzz3jfuw8tlv.descendant(element, $_8t9la614ojfuw8uto.isCursorPosition);
  const last$2 = element => descendantRtl(element, $_8t9la614ojfuw8uto.isCursorPosition);
  var descendantRtl = (scope, predicate) => {
    const descend = element => {
      const children = $_aff64dxmjfuw8tdx.children(element);
      for (let i = children.length - 1; i >= 0; i--) {
        const child = children[i];
        if (predicate(child))
          return Option.some(child);
        const res = descend(child);
        if (res.isSome())
          return res;
      }
      return Option.none();
    };
    return descend(scope);
  };
  const $_cihv40153jfuw8uvr = {
    first: first$3,
    last: last$2
  };

  const COLLAPSE_TO_LEFT = true;
  const COLLAPSE_TO_RIGHT = false;
  const getCollapseDirection = (rect, x) => x - rect.left < rect.right - x ? COLLAPSE_TO_LEFT : COLLAPSE_TO_RIGHT;
  const createCollapsedNode = (doc, target, collapseDirection) => {
    const r = doc.dom().createRange();
    r.selectNode(target.dom());
    r.collapse(collapseDirection);
    return r;
  };
  const locateInElement = (doc, node, x) => {
    const cursorRange = doc.dom().createRange();
    cursorRange.selectNode(node.dom());
    const rect = cursorRange.getBoundingClientRect();
    const collapseDirection = getCollapseDirection(rect, x);
    const f = collapseDirection === COLLAPSE_TO_LEFT ? $_cihv40153jfuw8uvr.first : $_cihv40153jfuw8uvr.last;
    return f(node).map(target => createCollapsedNode(doc, target, collapseDirection));
  };
  const locateInEmpty = (doc, node, x) => {
    const rect = node.dom().getBoundingClientRect();
    const collapseDirection = getCollapseDirection(rect, x);
    return Option.some(createCollapsedNode(doc, node, collapseDirection));
  };
  const search$1 = (doc, node, x) => {
    const f = $_aff64dxmjfuw8tdx.children(node).length === 0 ? locateInEmpty : locateInElement;
    return f(doc, node, x);
  };
  const $_g8y4zr152jfuw8uvn = { search: search$1 };

  const caretPositionFromPoint = (doc, x, y) => Option.from(doc.dom().caretPositionFromPoint(x, y)).bind(pos => {
    if (pos.offsetNode === null)
      return Option.none();
    const r = doc.dom().createRange();
    r.setStart(pos.offsetNode, pos.offset);
    r.collapse();
    return Option.some(r);
  });
  const caretRangeFromPoint = (doc, x, y) => Option.from(doc.dom().caretRangeFromPoint(x, y));
  const searchTextNodes = (doc, node, x, y) => {
    const r = doc.dom().createRange();
    r.selectNode(node.dom());
    const rect = r.getBoundingClientRect();
    const boundedX = Math.max(rect.left, Math.min(rect.right, x));
    const boundedY = Math.max(rect.top, Math.min(rect.bottom, y));
    return $_bvyyoa14zjfuw8uva.locate(doc, node, boundedX, boundedY);
  };
  const searchFromPoint = (doc, x, y) => $_bwdnu0xijfuw8tdo.fromPoint(doc, x, y).bind(elem => {
    const fallback = () => $_g8y4zr152jfuw8uvn.search(doc, elem, x);
    return $_aff64dxmjfuw8tdx.children(elem).length === 0 ? fallback() : searchTextNodes(doc, elem, x, y).orThunk(fallback);
  });
  const availableSearch = document.caretPositionFromPoint ? caretPositionFromPoint : document.caretRangeFromPoint ? caretRangeFromPoint : searchFromPoint;
  const fromPoint$1 = (win, x, y) => {
    const doc = $_bwdnu0xijfuw8tdo.fromDom(win.document);
    return availableSearch(doc, x, y).map(rng => $_cx764414rjfuw8uty.range($_bwdnu0xijfuw8tdo.fromDom(rng.startContainer), rng.startOffset, $_bwdnu0xijfuw8tdo.fromDom(rng.endContainer), rng.endOffset));
  };
  const $_g4cowo14yjfuw8uv6 = { fromPoint: fromPoint$1 };

  const withinContainer = (win, ancestor, outerRange, selector) => {
    const innerRange = $_90n0ki14wjfuw8uuk.create(win);
    const self = $_gem9gixxjfuw8tey.is(ancestor, selector) ? [ancestor] : [];
    const elements = self.concat($_951f03109jfuw8tt3.descendants(ancestor, selector));
    return $_efmt4zxbjfuw8tcj.filter(elements, elem => {
      $_90n0ki14wjfuw8uuk.selectNodeContentsUsing(innerRange, elem);
      return $_90n0ki14wjfuw8uuk.isWithin(outerRange, innerRange);
    });
  };
  const find$4 = (win, selection, selector) => {
    const outerRange = $_dmfqjk14xjfuw8uuw.asLtrRange(win, selection);
    const ancestor = $_bwdnu0xijfuw8tdo.fromDom(outerRange.commonAncestorContainer);
    return $_74lhjaxjjfuw8tdt.isElement(ancestor) ? withinContainer(win, ancestor, outerRange, selector) : [];
  };
  const $_4gqnn6154jfuw8uvv = { find: find$4 };

  const beforeSpecial = (element, offset) => {
    const name = $_74lhjaxjjfuw8tdt.name(element);
    if ('input' === name)
      return $_d45kr014sjfuw8uu3.after(element);
    else if (!$_efmt4zxbjfuw8tcj.contains([
        'br',
        'img'
      ], name))
      return $_d45kr014sjfuw8uu3.on(element, offset);
    else
      return offset === 0 ? $_d45kr014sjfuw8uu3.before(element) : $_d45kr014sjfuw8uu3.after(element);
  };
  const preprocessRelative = (startSitu, finishSitu) => {
    const start = startSitu.fold($_d45kr014sjfuw8uu3.before, beforeSpecial, $_d45kr014sjfuw8uu3.after);
    const finish = finishSitu.fold($_d45kr014sjfuw8uu3.before, beforeSpecial, $_d45kr014sjfuw8uu3.after);
    return $_cx764414rjfuw8uty.relative(start, finish);
  };
  const preprocessExact = (start, soffset, finish, foffset) => {
    const startSitu = beforeSpecial(start, soffset);
    const finishSitu = beforeSpecial(finish, foffset);
    return $_cx764414rjfuw8uty.relative(startSitu, finishSitu);
  };
  const preprocess = selection => selection.match({
    domRange(rng) {
      const start = $_bwdnu0xijfuw8tdo.fromDom(rng.startContainer);
      const finish = $_bwdnu0xijfuw8tdo.fromDom(rng.endContainer);
      return preprocessExact(start, rng.startOffset, finish, rng.endOffset);
    },
    relative: preprocessRelative,
    exact: preprocessExact
  });
  const $_3ib99q155jfuw8uw0 = {
    beforeSpecial,
    preprocess,
    preprocessRelative,
    preprocessExact
  };

  const doSetNativeRange = (win, rng) => {
    Option.from(win.getSelection()).each(selection => {
      selection.removeAllRanges();
      selection.addRange(rng);
    });
  };
  const doSetRange = (win, start, soffset, finish, foffset) => {
    const rng = $_90n0ki14wjfuw8uuk.exactToNative(win, start, soffset, finish, foffset);
    doSetNativeRange(win, rng);
  };
  const findWithin = (win, selection, selector) => $_4gqnn6154jfuw8uvv.find(win, selection, selector);
  const setRangeFromRelative = (win, relative) => $_dmfqjk14xjfuw8uuw.diagnose(win, relative).match({
    ltr(start, soffset, finish, foffset) {
      doSetRange(win, start, soffset, finish, foffset);
    },
    rtl(start, soffset, finish, foffset) {
      const selection = win.getSelection();
      if (selection.setBaseAndExtent) {
        selection.setBaseAndExtent(start.dom(), soffset, finish.dom(), foffset);
      } else if (selection.extend) {
        selection.collapse(start.dom(), soffset);
        selection.extend(finish.dom(), foffset);
      } else {
        doSetRange(win, finish, foffset, start, soffset);
      }
    }
  });
  const setExact = (win, start, soffset, finish, foffset) => {
    const relative = $_3ib99q155jfuw8uw0.preprocessExact(start, soffset, finish, foffset);
    setRangeFromRelative(win, relative);
  };
  const setRelative = (win, startSitu, finishSitu) => {
    const relative = $_3ib99q155jfuw8uw0.preprocessRelative(startSitu, finishSitu);
    setRangeFromRelative(win, relative);
  };
  const toNative = selection => {
    const win = $_cx764414rjfuw8uty.getWin(selection).dom();
    const getDomRange = (start, soffset, finish, foffset) => $_90n0ki14wjfuw8uuk.exactToNative(win, start, soffset, finish, foffset);
    const filtered = $_3ib99q155jfuw8uw0.preprocess(selection);
    return $_dmfqjk14xjfuw8uuw.diagnose(win, filtered).match({
      ltr: getDomRange,
      rtl: getDomRange
    });
  };
  const readRange = selection => {
    if (selection.rangeCount > 0) {
      const firstRng = selection.getRangeAt(0);
      const lastRng = selection.getRangeAt(selection.rangeCount - 1);
      return Option.some($_cx764414rjfuw8uty.range($_bwdnu0xijfuw8tdo.fromDom(firstRng.startContainer), firstRng.startOffset, $_bwdnu0xijfuw8tdo.fromDom(lastRng.endContainer), lastRng.endOffset));
    } else {
      return Option.none();
    }
  };
  const doGetExact = selection => {
    const anchorNode = $_bwdnu0xijfuw8tdo.fromDom(selection.anchorNode);
    const focusNode = $_bwdnu0xijfuw8tdo.fromDom(selection.focusNode);
    return $_7xrggl14ujfuw8uuf.after(anchorNode, selection.anchorOffset, focusNode, selection.focusOffset) ? Option.some($_cx764414rjfuw8uty.range($_bwdnu0xijfuw8tdo.fromDom(selection.anchorNode), selection.anchorOffset, $_bwdnu0xijfuw8tdo.fromDom(selection.focusNode), selection.focusOffset)) : readRange(selection);
  };
  const setToElement = (win, element) => {
    const rng = $_90n0ki14wjfuw8uuk.selectNodeContents(win, element);
    doSetNativeRange(win, rng);
  };
  const forElement = (win, element) => {
    const rng = $_90n0ki14wjfuw8uuk.selectNodeContents(win, element);
    return $_cx764414rjfuw8uty.range($_bwdnu0xijfuw8tdo.fromDom(rng.startContainer), rng.startOffset, $_bwdnu0xijfuw8tdo.fromDom(rng.endContainer), rng.endOffset);
  };
  const getExact = win => {
    const selection = win.getSelection();
    return selection.rangeCount > 0 ? doGetExact(selection) : Option.none();
  };
  const get$13 = win => getExact(win).map(range => $_cx764414rjfuw8uty.exact(range.start(), range.soffset(), range.finish(), range.foffset()));
  const getFirstRect$1 = (win, selection) => {
    const rng = $_dmfqjk14xjfuw8uuw.asLtrRange(win, selection);
    return $_90n0ki14wjfuw8uuk.getFirstRect(rng);
  };
  const getBounds$1 = (win, selection) => {
    const rng = $_dmfqjk14xjfuw8uuw.asLtrRange(win, selection);
    return $_90n0ki14wjfuw8uuk.getBounds(rng);
  };
  const getAtPoint = (win, x, y) => $_g4cowo14yjfuw8uv6.fromPoint(win, x, y);
  const getAsString = (win, selection) => {
    const rng = $_dmfqjk14xjfuw8uuw.asLtrRange(win, selection);
    return $_90n0ki14wjfuw8uuk.toString(rng);
  };
  const clear$1 = win => {
    const selection = win.getSelection();
    selection.removeAllRanges();
  };
  const clone$3 = (win, selection) => {
    const rng = $_dmfqjk14xjfuw8uuw.asLtrRange(win, selection);
    return $_90n0ki14wjfuw8uuk.cloneFragment(rng);
  };
  const replace = (win, selection, elements) => {
    const rng = $_dmfqjk14xjfuw8uuw.asLtrRange(win, selection);
    const fragment = $_1c2i9n14vjfuw8uuh.fromElements(elements, win.document);
    $_90n0ki14wjfuw8uuk.replaceWith(rng, fragment);
  };
  const deleteAt = (win, selection) => {
    const rng = $_dmfqjk14xjfuw8uuw.asLtrRange(win, selection);
    $_90n0ki14wjfuw8uuk.deleteContents(rng);
  };
  const isCollapsed = (start, soffset, finish, foffset) => $_4867a0xsjfuw8tej.eq(start, finish) && soffset === foffset;
  const $_3h0r8w14tjfuw8uu9 = {
    setExact,
    getExact,
    get: get$13,
    setRelative,
    toNative,
    setToElement,
    clear: clear$1,
    clone: clone$3,
    replace,
    deleteAt,
    forElement,
    getFirstRect: getFirstRect$1,
    getBounds: getBounds$1,
    getAtPoint,
    findWithin,
    getAsString,
    isCollapsed
  };

  const COLLAPSED_WIDTH = 2;
  const collapsedRect = rect => ({
    left: rect.left,
    top: rect.top,
    right: rect.right,
    bottom: rect.bottom,
    width: $_2vokfcwwjfuw8tb4.constant(COLLAPSED_WIDTH),
    height: rect.height
  });
  const toRect$1 = rawRect => ({
    left: $_2vokfcwwjfuw8tb4.constant(rawRect.left),
    top: $_2vokfcwwjfuw8tb4.constant(rawRect.top),
    right: $_2vokfcwwjfuw8tb4.constant(rawRect.right),
    bottom: $_2vokfcwwjfuw8tb4.constant(rawRect.bottom),
    width: $_2vokfcwwjfuw8tb4.constant(rawRect.width),
    height: $_2vokfcwwjfuw8tb4.constant(rawRect.height)
  });
  const getRectsFromRange = range => {
    if (!range.collapsed) {
      return $_efmt4zxbjfuw8tcj.map(range.getClientRects(), toRect$1);
    } else {
      const start_1 = $_bwdnu0xijfuw8tdo.fromDom(range.startContainer);
      return $_aff64dxmjfuw8tdx.parent(start_1).bind(parent => {
        const selection = $_cx764414rjfuw8uty.exact(start_1, range.startOffset, parent, $_8t9la614ojfuw8uto.getEnd(parent));
        const optRect = $_3h0r8w14tjfuw8uu9.getFirstRect(range.startContainer.ownerDocument.defaultView, selection);
        return optRect.map(collapsedRect).map($_efmt4zxbjfuw8tcj.pure);
      }).getOr([]);
    }
  };
  const getRectangles = cWin => {
    const sel = cWin.getSelection();
    return sel !== undefined && sel.rangeCount > 0 ? getRectsFromRange(sel.getRangeAt(0)) : [];
  };
  const $_1h6vvx14njfuw8utc = { getRectangles };

  const autocompleteHack = () => f => {
    setTimeout(() => {
      f();
    }, 0);
  };
  const resume = cWin => {
    cWin.focus();
    const iBody = $_bwdnu0xijfuw8tdo.fromDom(cWin.document.body);
    const inInput = $_f15fvwz1jfuw8tlo.active().exists(elem => $_efmt4zxbjfuw8tcj.contains([
      'input',
      'textarea'
    ], $_74lhjaxjjfuw8tdt.name(elem)));
    const transaction = inInput ? autocompleteHack() : $_2vokfcwwjfuw8tb4.apply;
    transaction(() => {
      $_f15fvwz1jfuw8tlo.active().each($_f15fvwz1jfuw8tlo.blur);
      $_f15fvwz1jfuw8tlo.focus(iBody);
    });
  };
  const $_655uvc156jfuw8uw4 = { resume };

  const EXTRA_SPACING = 50;
  const data = `data-${$_2fp9skztjfuw8tqe.resolve('last-outer-height')}`;
  const setLastHeight = (cBody, value) => {
    $_47adx7ywjfuw8tl3.set(cBody, data, value);
  };
  const getLastHeight = cBody => $_f77yow14mjfuw8ut9.safeParse(cBody, data);
  const getBoundsFrom = rect => ({
    top: $_2vokfcwwjfuw8tb4.constant(rect.top()),
    bottom: $_2vokfcwwjfuw8tb4.constant(rect.top() + rect.height())
  });
  const getBounds$2 = cWin => {
    const rects = $_1h6vvx14njfuw8utc.getRectangles(cWin);
    return rects.length > 0 ? Option.some(rects[0]).map(getBoundsFrom) : Option.none();
  };
  const findDelta = (outerWindow, cBody) => {
    const last = getLastHeight(cBody);
    const current = outerWindow.innerHeight;
    return last > current ? Option.some(last - current) : Option.none();
  };
  const calculate = (cWin, bounds, delta) => {
    const isOutside = bounds.top() > cWin.innerHeight || bounds.bottom() > cWin.innerHeight;
    return isOutside ? Math.min(delta, bounds.bottom() - cWin.innerHeight + EXTRA_SPACING) : 0;
  };
  const setup$1 = (outerWindow, cWin) => {
    const cBody = $_bwdnu0xijfuw8tdo.fromDom(cWin.document.body);
    const toEditing = () => {
      $_655uvc156jfuw8uw4.resume(cWin);
    };
    const onResize = $_6cl0bk14cjfuw8uqx.bind($_bwdnu0xijfuw8tdo.fromDom(outerWindow), 'resize', () => {
      findDelta(outerWindow, cBody).each(delta => {
        getBounds$2(cWin).each(bounds => {
          const cScrollBy = calculate(cWin, bounds, delta);
          if (cScrollBy !== 0) {
            cWin.scrollTo(cWin.pageXOffset, cWin.pageYOffset + cScrollBy);
          }
        });
      });
      setLastHeight(cBody, outerWindow.innerHeight);
    });
    setLastHeight(cBody, outerWindow.innerHeight);
    const destroy = () => {
      onResize.unbind();
    };
    return {
      toEditing,
      destroy
    };
  };
  const $_bbby4714ljfuw8usz = { setup: setup$1 };

  const getBodyFromFrame = frame => Option.some($_bwdnu0xijfuw8tdo.fromDom(frame.dom().contentWindow.document.body));
  const getDocFromFrame = frame => Option.some($_bwdnu0xijfuw8tdo.fromDom(frame.dom().contentWindow.document));
  const getWinFromFrame = frame => Option.from(frame.dom().contentWindow);
  const getSelectionFromFrame = frame => {
    const optWin = getWinFromFrame(frame);
    return optWin.bind($_3h0r8w14tjfuw8uu9.getExact);
  };
  const getFrame = editor => editor.getFrame();
  const getOrDerive = (name, f) => editor => {
    const g = editor[name].getOrThunk(() => {
      const frame = getFrame(editor);
      return () => f(frame);
    });
    return g();
  };
  const getOrListen = (editor, doc, name, type) => editor[name].getOrThunk(() => handler => $_6cl0bk14cjfuw8uqx.bind(doc, type, handler));
  const toRect$2 = rect => ({
    left: $_2vokfcwwjfuw8tb4.constant(rect.left),
    top: $_2vokfcwwjfuw8tb4.constant(rect.top),
    right: $_2vokfcwwjfuw8tb4.constant(rect.right),
    bottom: $_2vokfcwwjfuw8tb4.constant(rect.bottom),
    width: $_2vokfcwwjfuw8tb4.constant(rect.width),
    height: $_2vokfcwwjfuw8tb4.constant(rect.height)
  });
  const getActiveApi = editor => {
    const frame = getFrame(editor);
    const tryFallbackBox = win => {
      const isCollapsed = sel => $_4867a0xsjfuw8tej.eq(sel.start(), sel.finish()) && sel.soffset() === sel.foffset();
      const toStartRect = sel => {
        const rect = sel.start().dom().getBoundingClientRect();
        return rect.width > 0 || rect.height > 0 ? Option.some(rect).map(toRect$2) : Option.none();
      };
      return $_3h0r8w14tjfuw8uu9.getExact(win).filter(isCollapsed).bind(toStartRect);
    };
    return getBodyFromFrame(frame).bind(body => getDocFromFrame(frame).bind(doc => getWinFromFrame(frame).map(win => {
      const html = $_bwdnu0xijfuw8tdo.fromDom(doc.dom().documentElement);
      const getCursorBox = editor.getCursorBox.getOrThunk(() => () => $_3h0r8w14tjfuw8uu9.get(win).bind(sel => $_3h0r8w14tjfuw8uu9.getFirstRect(win, sel).orThunk(() => tryFallbackBox(win))));
      const setSelection = editor.setSelection.getOrThunk(() => (start, soffset, finish, foffset) => {
        $_3h0r8w14tjfuw8uu9.setExact(win, start, soffset, finish, foffset);
      });
      const clearSelection = editor.clearSelection.getOrThunk(() => () => {
        $_3h0r8w14tjfuw8uu9.clear(win);
      });
      return {
        body: $_2vokfcwwjfuw8tb4.constant(body),
        doc: $_2vokfcwwjfuw8tb4.constant(doc),
        win: $_2vokfcwwjfuw8tb4.constant(win),
        html: $_2vokfcwwjfuw8tb4.constant(html),
        getSelection: $_2vokfcwwjfuw8tb4.curry(getSelectionFromFrame, frame),
        setSelection,
        clearSelection,
        frame: $_2vokfcwwjfuw8tb4.constant(frame),
        onKeyup: getOrListen(editor, doc, 'onKeyup', 'keyup'),
        onNodeChanged: getOrListen(editor, doc, 'onNodeChanged', 'selectionchange'),
        onDomChanged: editor.onDomChanged,
        onScrollToCursor: editor.onScrollToCursor,
        onScrollToElement: editor.onScrollToElement,
        onToReading: editor.onToReading,
        onToEditing: editor.onToEditing,
        onToolbarScrollStart: editor.onToolbarScrollStart,
        onTouchContent: editor.onTouchContent,
        onTapContent: editor.onTapContent,
        onTouchToolstrip: editor.onTouchToolstrip,
        getCursorBox
      };
    })));
  };
  const $_9kqusv157jfuw8uwf = {
    getBody: getOrDerive('getBody', getBodyFromFrame),
    getDoc: getOrDerive('getDoc', getDocFromFrame),
    getWin: getOrDerive('getWin', getWinFromFrame),
    getSelection: getOrDerive('getSelection', getSelectionFromFrame),
    getFrame,
    getActiveApi
  };

  const attr = 'data-ephox-mobile-fullscreen-style';
  const siblingStyles = 'display:none!important;';
  const ancestorPosition = 'position:absolute!important;';
  const ancestorStyles = 'top:0!important;left:0!important;margin:0' + '!important;padding:0!important;width:100%!important;';
  const bgFallback = 'background-color:rgb(255,255,255)!important;';
  const isAndroid = $_5reqwox3jfuw8tbu.detect().os.isAndroid();
  const matchColor = editorBody => {
    const color = $_aag5ti106jfuw8tse.get(editorBody, 'background-color');
    return color !== undefined && color !== '' ? `background-color:${color}!important` : bgFallback;
  };
  const clobberStyles = (container, editorBody) => {
    const gatherSibilings = element => {
      const siblings = $_951f03109jfuw8tt3.siblings(element, '*');
      return siblings;
    };
    const clobber = clobberStyle => element => {
      const styles = $_47adx7ywjfuw8tl3.get(element, 'style');
      const backup = styles === undefined ? 'no-styles' : styles.trim();
      if (backup === clobberStyle) {
        return;
      } else {
        $_47adx7ywjfuw8tl3.set(element, attr, backup);
        $_47adx7ywjfuw8tl3.set(element, 'style', clobberStyle);
      }
    };
    const ancestors = $_951f03109jfuw8tt3.ancestors(container, '*');
    const siblings = $_efmt4zxbjfuw8tcj.bind(ancestors, gatherSibilings);
    const bgColor = matchColor(editorBody);
    $_efmt4zxbjfuw8tcj.each(siblings, clobber(siblingStyles));
    $_efmt4zxbjfuw8tcj.each(ancestors, clobber(ancestorPosition + ancestorStyles + bgColor));
    const containerStyles = isAndroid === true ? '' : ancestorPosition;
    clobber(containerStyles + ancestorStyles + bgColor)(container);
  };
  const restoreStyles = () => {
    const clobberedEls = $_951f03109jfuw8tt3.all(`[${attr}]`);
    $_efmt4zxbjfuw8tcj.each(clobberedEls, element => {
      const restore = $_47adx7ywjfuw8tl3.get(element, attr);
      if (restore !== 'no-styles') {
        $_47adx7ywjfuw8tl3.set(element, 'style', restore);
      } else {
        $_47adx7ywjfuw8tl3.remove(element, 'style');
      }
      $_47adx7ywjfuw8tl3.remove(element, attr);
    });
  };
  const $_ggb1il158jfuw8uwy = {
    clobberStyles,
    restoreStyles
  };

  const tag = () => {
    const head = $_c8lemt10bjfuw8tt8.first('head').getOrDie();
    const nu = () => {
      const meta = $_bwdnu0xijfuw8tdo.fromTag('meta');
      $_47adx7ywjfuw8tl3.set(meta, 'name', 'viewport');
      $_cwa5ncxljfuw8tdv.append(head, meta);
      return meta;
    };
    const element = $_c8lemt10bjfuw8tt8.first('meta[name="viewport"]').getOrThunk(nu);
    const backup = $_47adx7ywjfuw8tl3.get(element, 'content');
    const maximize = () => {
      $_47adx7ywjfuw8tl3.set(element, 'content', 'width=device-width, initial-scale=1.0, user-scalable=no, maximum-scale=1.0');
    };
    const restore = () => {
      if (backup !== undefined && backup !== null && backup.length > 0) {
        $_47adx7ywjfuw8tl3.set(element, 'content', backup);
      } else {
        $_47adx7ywjfuw8tl3.set(element, 'content', 'user-scalable=yes');
      }
    };
    return {
      maximize,
      restore
    };
  };
  const $_41kbg3159jfuw8ux8 = { tag };

  const create$5 = (platform, mask) => {
    const meta = $_41kbg3159jfuw8ux8.tag();
    const androidApi = $_bh7xqm133jfuw8uet.api();
    const androidEvents = $_bh7xqm133jfuw8uet.api();
    const enter = () => {
      mask.hide();
      $_6po7jxyujfuw8tl0.add(platform.container, $_2fp9skztjfuw8tqe.resolve('fullscreen-maximized'));
      $_6po7jxyujfuw8tl0.add(platform.container, $_2fp9skztjfuw8tqe.resolve('android-maximized'));
      meta.maximize();
      $_6po7jxyujfuw8tl0.add(platform.body, $_2fp9skztjfuw8tqe.resolve('android-scroll-reload'));
      androidApi.set($_bbby4714ljfuw8usz.setup(platform.win, $_9kqusv157jfuw8uwf.getWin(platform.editor).getOrDie('no')));
      $_9kqusv157jfuw8uwf.getActiveApi(platform.editor).each(editorApi => {
        $_ggb1il158jfuw8uwy.clobberStyles(platform.container, editorApi.body());
        androidEvents.set($_2zmd3p14hjfuw8uru.initEvents(editorApi, platform.toolstrip, platform.alloy));
      });
    };
    const exit = () => {
      meta.restore();
      mask.show();
      $_6po7jxyujfuw8tl0.remove(platform.container, $_2fp9skztjfuw8tqe.resolve('fullscreen-maximized'));
      $_6po7jxyujfuw8tl0.remove(platform.container, $_2fp9skztjfuw8tqe.resolve('android-maximized'));
      $_ggb1il158jfuw8uwy.restoreStyles();
      $_6po7jxyujfuw8tl0.remove(platform.body, $_2fp9skztjfuw8tqe.resolve('android-scroll-reload'));
      androidEvents.clear();
      androidApi.clear();
    };
    return {
      enter,
      exit
    };
  };
  const $_55cvbw14gjfuw8uro = { create: create$5 };

  const adaptable = (fn, rate) => {
    let timer = null;
    let args = null;
    const cancel = () => {
      if (timer !== null) {
        clearTimeout(timer);
        timer = null;
        args = null;
      }
    };
    const throttle = function () {
      args = arguments;
      if (timer === null) {
        timer = setTimeout(() => {
          fn(...args);
          timer = null;
          args = null;
        }, rate);
      }
    };
    return {
      cancel,
      throttle
    };
  };
  const first$4 = (fn, rate) => {
    let timer = null;
    const cancel = () => {
      if (timer !== null) {
        clearTimeout(timer);
        timer = null;
      }
    };
    const throttle = function () {
      let args = arguments;
      if (timer === null) {
        timer = setTimeout(() => {
          fn(...args);
          timer = null;
          args = null;
        }, rate);
      }
    };
    return {
      cancel,
      throttle
    };
  };
  const last$3 = (fn, rate) => {
    let timer = null;
    const cancel = () => {
      if (timer !== null) {
        clearTimeout(timer);
        timer = null;
      }
    };
    const throttle = function () {
      let args = arguments;
      if (timer !== null)
        clearTimeout(timer);
      timer = setTimeout(() => {
        fn(...args);
        timer = null;
        args = null;
      }, rate);
    };
    return {
      cancel,
      throttle
    };
  };
  const $_6hl53v15bjfuw8uxr = {
    adaptable,
    first: first$4,
    last: last$3
  };

  const sketch$10 = (onView, translate) => {
    const memIcon = record(Container.sketch({
      dom: dom$1('<div aria-hidden="true" class="${prefix}-mask-tap-icon"></div>'),
      containerBehaviours: derive$2([Toggling.config({
          toggleClass: $_2fp9skztjfuw8tqe.resolve('mask-tap-icon-selected'),
          toggleOnExecute: false
        })])
    }));
    const onViewThrottle = $_6hl53v15bjfuw8uxr.first(onView, 1);
    onViewThrottle.throttle();
    return Container.sketch({
      dom: dom$1('<div class="${prefix}-disabled-mask"></div>'),
      components: [Container.sketch({
          dom: dom$1('<div class="${prefix}-content-container"></div>'),
          components: [Button.sketch({
              dom: dom$1('<div class="${prefix}-content-tap-section"></div>'),
              components: [memIcon.asSpec()],
              action(button) {
                onViewThrottle.throttle();
              },
              buttonBehaviours: derive$2([Toggling.config({ toggleClass: $_2fp9skztjfuw8tqe.resolve('mask-tap-icon-selected') })])
            })]
        })]
    });
  };
  const $_d5dv5715ajfuw8uxg = { sketch: sketch$10 };

  const MobileSchema = objOf([
    strictObjOf('editor', [
      strict$1('getFrame'),
      option('getBody'),
      option('getDoc'),
      option('getWin'),
      option('getSelection'),
      option('setSelection'),
      option('clearSelection'),
      option('cursorSaver'),
      option('onKeyup'),
      option('onNodeChanged'),
      option('getCursorBox'),
      strict$1('onDomChanged'),
      defaulted$1('onTouchContent', $_2vokfcwwjfuw8tb4.noop),
      defaulted$1('onTapContent', $_2vokfcwwjfuw8tb4.noop),
      defaulted$1('onTouchToolstrip', $_2vokfcwwjfuw8tb4.noop),
      defaulted$1('onScrollToCursor', $_2vokfcwwjfuw8tb4.constant({ unbind: $_2vokfcwwjfuw8tb4.noop })),
      defaulted$1('onScrollToElement', $_2vokfcwwjfuw8tb4.constant({ unbind: $_2vokfcwwjfuw8tb4.noop })),
      defaulted$1('onToEditing', $_2vokfcwwjfuw8tb4.constant({ unbind: $_2vokfcwwjfuw8tb4.noop })),
      defaulted$1('onToReading', $_2vokfcwwjfuw8tb4.constant({ unbind: $_2vokfcwwjfuw8tb4.noop })),
      defaulted$1('onToolbarScrollStart', $_2vokfcwwjfuw8tb4.identity)
    ]),
    strict$1('socket'),
    strict$1('toolstrip'),
    strict$1('dropup'),
    strict$1('toolbar'),
    strict$1('container'),
    strict$1('alloy'),
    state$1('win', spec => $_aff64dxmjfuw8tdx.owner(spec.socket).dom().defaultView),
    state$1('body', spec => $_bwdnu0xijfuw8tdo.fromDom(spec.socket.dom().ownerDocument.body)),
    defaulted$1('translate', $_2vokfcwwjfuw8tb4.identity),
    defaulted$1('setReadOnly', $_2vokfcwwjfuw8tb4.noop),
    defaulted$1('readOnlyOnInit', $_2vokfcwwjfuw8tb4.constant(true))
  ]);

  const produce = raw => {
    const mobile = asRawOrDie('Getting AndroidWebapp schema', MobileSchema, raw);
    $_aag5ti106jfuw8tse.set(mobile.toolstrip, 'width', '100%');
    const onTap = () => {
      mobile.setReadOnly(true);
      mode.enter();
    };
    const mask = build$1($_d5dv5715ajfuw8uxg.sketch(onTap, mobile.translate));
    mobile.alloy.add(mask);
    const maskApi = {
      show() {
        mobile.alloy.add(mask);
      },
      hide() {
        mobile.alloy.remove(mask);
      }
    };
    $_cwa5ncxljfuw8tdv.append(mobile.container, mask.element());
    var mode = $_55cvbw14gjfuw8uro.create(mobile, maskApi);
    return {
      setReadOnly: mobile.setReadOnly,
      refreshStructure: $_2vokfcwwjfuw8tb4.noop,
      enter: mode.enter,
      exit: mode.exit,
      destroy: $_2vokfcwwjfuw8tb4.noop
    };
  };
  const $_6g5ji714fjfuw8urf = { produce };

  const schema$14 = $_2vokfcwwjfuw8tb4.constant([
    defaulted$1('shell', true),
    field$1('toolbarBehaviours', [Replacing])
  ]);
  const enhanceGroups = detail => ({
    behaviours: derive$2([Replacing.config({})])
  });
  const parts$2 = $_2vokfcwwjfuw8tb4.constant([optional({
      name: 'groups',
      overrides: enhanceGroups
    })]);
  const name$3 = $_2vokfcwwjfuw8tb4.constant('Toolbar');

  const factory$4 = (detail, components$$1, spec, _externals) => {
    const setGroups = (toolbar, groups) => {
      getGroupContainer(toolbar).fold(() => {
        console.error('Toolbar was defined to not be a shell, but no groups container was specified in components');
        throw new Error('Toolbar was defined to not be a shell, but no groups container was specified in components');
      }, container => {
        Replacing.set(container, groups);
      });
    };
    var getGroupContainer = component => detail.shell() ? Option.some(component) : getPart(component, detail, 'groups');
    const extra = detail.shell() ? {
      behaviours: [Replacing.config({})],
      components: []
    } : {
      behaviours: [],
      components: components$$1
    };
    return {
      uid: detail.uid(),
      dom: detail.dom(),
      components: extra.components,
      behaviours: $_3jctjywxjfuw8tb6.deepMerge(derive$2(extra.behaviours), get$5(detail.toolbarBehaviours())),
      apis: { setGroups },
      domModification: { attributes: { role: 'group' } }
    };
  };
  const Toolbar = composite$1({
    name: 'Toolbar',
    configFields: schema$14(),
    partFields: parts$2(),
    factory: factory$4,
    apis: {
      setGroups(apis, toolbar, groups) {
        apis.setGroups(toolbar, groups);
      }
    }
  });

  const schema$15 = $_2vokfcwwjfuw8tb4.constant([
    strict$1('items'),
    markers(['itemClass']),
    field$1('tgroupBehaviours', [Keying])
  ]);
  const parts$3 = $_2vokfcwwjfuw8tb4.constant([group({
      name: 'items',
      unit: 'item',
      overrides(detail) {
        return { domModification: { classes: [detail.markers().itemClass()] } };
      }
    })]);
  const name$4 = $_2vokfcwwjfuw8tb4.constant('ToolbarGroup');

  const factory$5 = (detail, components, spec, _externals) => $_3jctjywxjfuw8tb6.deepMerge({ dom: { attributes: { role: 'toolbar' } } }, {
    'uid': detail.uid(),
    'dom': detail.dom(),
    'components': components,
    'behaviours': $_3jctjywxjfuw8tb6.deepMerge(derive$2([Keying.config({
        mode: 'flow',
        selector: `.${detail.markers().itemClass()}`
      })]), get$5(detail.tgroupBehaviours())),
    'debug.sketcher': spec['debug.sketcher']
  });
  const ToolbarGroup = composite$1({
    name: 'ToolbarGroup',
    configFields: schema$15(),
    partFields: parts$3(),
    factory: factory$5
  });

  const dataHorizontal = `data-${$_2fp9skztjfuw8tqe.resolve('horizontal-scroll')}`;
  const canScrollVertically = container => {
    container.dom().scrollTop = 1;
    const result = container.dom().scrollTop !== 0;
    container.dom().scrollTop = 0;
    return result;
  };
  const canScrollHorizontally = container => {
    container.dom().scrollLeft = 1;
    const result = container.dom().scrollLeft !== 0;
    container.dom().scrollLeft = 0;
    return result;
  };
  const hasVerticalScroll = container => container.dom().scrollTop > 0 || canScrollVertically(container);
  const hasHorizontalScroll = container => container.dom().scrollLeft > 0 || canScrollHorizontally(container);
  const markAsHorizontal = container => {
    $_47adx7ywjfuw8tl3.set(container, dataHorizontal, 'true');
  };
  const hasScroll = container => $_47adx7ywjfuw8tl3.get(container, dataHorizontal) === 'true' ? hasHorizontalScroll : hasVerticalScroll;
  const exclusive = (scope, selector) => $_6cl0bk14cjfuw8uqx.bind(scope, 'touchmove', event => {
    $_c8lemt10bjfuw8tt8.closest(event.target(), selector).filter(hasScroll).fold(() => {
      event.raw().preventDefault();
    }, $_2vokfcwwjfuw8tb4.noop);
  });
  const $_22oqbo15ijfuw8uzk = {
    exclusive,
    markAsHorizontal
  };

  function ScrollingToolbar () {
    const makeGroup = gSpec => {
      const scrollClass = gSpec.scrollable === true ? '${prefix}-toolbar-scrollable-group' : '';
      return {
        dom: dom$1(`<div aria-label="${gSpec.label}" class="${prefix}-toolbar-group ${scrollClass}"></div>`),
        tgroupBehaviours: derive$2([config('adhoc-scrollable-toolbar', gSpec.scrollable === true ? [runOnInit((component, simulatedEvent) => {
              $_aag5ti106jfuw8tse.set(component.element(), 'overflow-x', 'auto');
              $_22oqbo15ijfuw8uzk.markAsHorizontal(component.element());
              $_3pnsue149jfuw8uqb.register(component.element());
            })] : [])]),
        components: [Container.sketch({ components: [ToolbarGroup.parts().items({})] })],
        markers: { itemClass: $_2fp9skztjfuw8tqe.resolve('toolbar-group-item') },
        items: gSpec.items
      };
    };
    const toolbar = build$1(Toolbar.sketch({
      dom: dom$1('<div class="${prefix}-toolbar"></div>'),
      components: [Toolbar.parts().groups({})],
      toolbarBehaviours: derive$2([
        Toggling.config({
          toggleClass: $_2fp9skztjfuw8tqe.resolve('context-toolbar'),
          toggleOnExecute: false,
          aria: { mode: 'none' }
        }),
        Keying.config({ mode: 'cyclic' })
      ]),
      shell: true
    }));
    const wrapper = build$1(Container.sketch({
      dom: { classes: [$_2fp9skztjfuw8tqe.resolve('toolstrip')] },
      components: [premade$1(toolbar)],
      containerBehaviours: derive$2([Toggling.config({
          toggleClass: $_2fp9skztjfuw8tqe.resolve('android-selection-context-toolbar'),
          toggleOnExecute: false
        })])
    }));
    const resetGroups = () => {
      Toolbar.setGroups(toolbar, initGroups.get());
      Toggling.off(toolbar);
    };
    var initGroups = Cell([]);
    const setGroups = gs => {
      initGroups.set(gs);
      resetGroups();
    };
    const createGroups = gs => $_efmt4zxbjfuw8tcj.map(gs, $_2vokfcwwjfuw8tb4.compose(ToolbarGroup.sketch, makeGroup));
    const refresh = () => {
    };
    const setContextToolbar = gs => {
      Toggling.on(toolbar);
      Toolbar.setGroups(toolbar, gs);
    };
    const restoreToolbar = () => {
      if (Toggling.isOn(toolbar)) {
        resetGroups();
      }
    };
    const focus = () => {
      Keying.focusIn(toolbar);
    };
    return {
      wrapper: $_2vokfcwwjfuw8tb4.constant(wrapper),
      toolbar: $_2vokfcwwjfuw8tb4.constant(toolbar),
      createGroups,
      setGroups,
      setContextToolbar,
      restoreToolbar,
      refresh,
      focus
    };
  }

  const makeEditSwitch = webapp => build$1(Button.sketch({
    dom: dom$1('<div class="${prefix}-mask-edit-icon ${prefix}-icon"></div>'),
    action() {
      webapp.run(w => {
        w.setReadOnly(false);
      });
    }
  }));
  const makeSocket = () => build$1(Container.sketch({
    dom: dom$1('<div class="${prefix}-editor-socket"></div>'),
    components: [],
    containerBehaviours: derive$2([Replacing.config({})])
  }));
  const showEdit = (socket, switchToEdit) => {
    Replacing.append(socket, premade$1(switchToEdit));
  };
  const hideEdit = (socket, switchToEdit) => {
    Replacing.remove(socket, switchToEdit);
  };
  const updateMode = (socket, switchToEdit, readOnly, root) => {
    const swap = readOnly === true ? Swapping.toAlpha : Swapping.toOmega;
    swap(root);
    const f = readOnly ? showEdit : hideEdit;
    f(socket, switchToEdit);
  };
  const $_9pcl2n15jjfuw8uzs = {
    makeEditSwitch,
    makeSocket,
    updateMode
  };

  const getAnimationRoot = (component, slideConfig) => slideConfig.getAnimationRoot().fold(() => component.element(), get => get(component));
  const getDimensionProperty = slideConfig => slideConfig.dimension().property();
  const getDimension = (slideConfig, elem) => slideConfig.dimension().getDimension()(elem);
  const disableTransitions = (component, slideConfig) => {
    const root = getAnimationRoot(component, slideConfig);
    $_c6ke2t13mjfuw8uku.remove(root, [
      slideConfig.shrinkingClass(),
      slideConfig.growingClass()
    ]);
  };
  const setShrunk = (component, slideConfig) => {
    $_6po7jxyujfuw8tl0.remove(component.element(), slideConfig.openClass());
    $_6po7jxyujfuw8tl0.add(component.element(), slideConfig.closedClass());
    $_aag5ti106jfuw8tse.set(component.element(), getDimensionProperty(slideConfig), '0px');
    $_aag5ti106jfuw8tse.reflow(component.element());
  };
  const measureTargetSize = (component, slideConfig) => {
    setGrown(component, slideConfig);
    const expanded = getDimension(slideConfig, component.element());
    setShrunk(component, slideConfig);
    return expanded;
  };
  var setGrown = (component, slideConfig) => {
    $_6po7jxyujfuw8tl0.remove(component.element(), slideConfig.closedClass());
    $_6po7jxyujfuw8tl0.add(component.element(), slideConfig.openClass());
    $_aag5ti106jfuw8tse.remove(component.element(), getDimensionProperty(slideConfig));
  };
  const doImmediateShrink = (component, slideConfig, slideState) => {
    slideState.setCollapsed();
    $_aag5ti106jfuw8tse.set(component.element(), getDimensionProperty(slideConfig), getDimension(slideConfig, component.element()));
    $_aag5ti106jfuw8tse.reflow(component.element());
    disableTransitions(component, slideConfig);
    setShrunk(component, slideConfig);
    slideConfig.onStartShrink()(component);
    slideConfig.onShrunk()(component);
  };
  const doStartShrink = (component, slideConfig, slideState) => {
    slideState.setCollapsed();
    $_aag5ti106jfuw8tse.set(component.element(), getDimensionProperty(slideConfig), getDimension(slideConfig, component.element()));
    $_aag5ti106jfuw8tse.reflow(component.element());
    const root = getAnimationRoot(component, slideConfig);
    $_6po7jxyujfuw8tl0.add(root, slideConfig.shrinkingClass());
    setShrunk(component, slideConfig);
    slideConfig.onStartShrink()(component);
  };
  const doStartGrow = (component, slideConfig, slideState) => {
    const fullSize = measureTargetSize(component, slideConfig);
    const root = getAnimationRoot(component, slideConfig);
    $_6po7jxyujfuw8tl0.add(root, slideConfig.growingClass());
    setGrown(component, slideConfig);
    $_aag5ti106jfuw8tse.set(component.element(), getDimensionProperty(slideConfig), fullSize);
    slideState.setExpanded();
    slideConfig.onStartGrow()(component);
  };
  const grow = (component, slideConfig, slideState) => {
    if (!slideState.isExpanded()) {
      doStartGrow(component, slideConfig, slideState);
    }
  };
  const shrink = (component, slideConfig, slideState) => {
    if (slideState.isExpanded()) {
      doStartShrink(component, slideConfig, slideState);
    }
  };
  const immediateShrink = (component, slideConfig, slideState) => {
    if (slideState.isExpanded()) {
      doImmediateShrink(component, slideConfig, slideState);
    }
  };
  const hasGrown = (component, slideConfig, slideState) => slideState.isExpanded();
  const hasShrunk = (component, slideConfig, slideState) => slideState.isCollapsed();
  const isGrowing = (component, slideConfig, slideState) => {
    const root = getAnimationRoot(component, slideConfig);
    return $_6po7jxyujfuw8tl0.has(root, slideConfig.growingClass()) === true;
  };
  const isShrinking = (component, slideConfig, slideState) => {
    const root = getAnimationRoot(component, slideConfig);
    return $_6po7jxyujfuw8tl0.has(root, slideConfig.shrinkingClass()) === true;
  };
  const isTransitioning = (component, slideConfig, slideState) => isGrowing(component, slideConfig, slideState) === true || isShrinking(component, slideConfig, slideState) === true;
  const toggleGrow = (component, slideConfig, slideState) => {
    const f = slideState.isExpanded() ? doStartShrink : doStartGrow;
    f(component, slideConfig, slideState);
  };


  const SlidingApis = Object.freeze({
    grow,
    shrink,
    immediateShrink,
    hasGrown,
    hasShrunk,
    isGrowing,
    isShrinking,
    isTransitioning,
    toggleGrow,
    disableTransitions
  });

  const exhibit$5 = (base, slideConfig) => {
    const expanded = slideConfig.expanded();
    return expanded ? nu$6({
      classes: [slideConfig.openClass()],
      styles: {}
    }) : nu$6({
      classes: [slideConfig.closedClass()],
      styles: wrap$2(slideConfig.dimension().property(), '0px')
    });
  };
  const events$9 = (slideConfig, slideState) => derive([run(transitionend(), (component, simulatedEvent) => {
      const raw = simulatedEvent.event().raw();
      if (raw.propertyName === slideConfig.dimension().property()) {
        disableTransitions(component, slideConfig);
        if (slideState.isExpanded()) {
          $_aag5ti106jfuw8tse.remove(component.element(), slideConfig.dimension().property());
        }
        const notify = slideState.isExpanded() ? slideConfig.onGrown() : slideConfig.onShrunk();
        notify(component, simulatedEvent);
      }
    })]);


  const ActiveSliding = Object.freeze({
    exhibit: exhibit$5,
    events: events$9
  });

  const SlidingSchema = [
    strict$1('closedClass'),
    strict$1('openClass'),
    strict$1('shrinkingClass'),
    strict$1('growingClass'),
    option('getAnimationRoot'),
    onHandler('onShrunk'),
    onHandler('onStartShrink'),
    onHandler('onGrown'),
    onHandler('onStartGrow'),
    defaulted$1('expanded', false),
    strictOf('dimension', choose$1('property', {
      width: [
        output$1('property', 'width'),
        output$1('getDimension', elem => `${$_dsj1h711zjfuw8u73.get(elem)}px`)
      ],
      height: [
        output$1('property', 'height'),
        output$1('getDimension', elem => `${$_sgteu105jfuw8tsc.get(elem)}px`)
      ]
    }))
  ];

  const init$4 = spec => {
    const state = Cell(spec.expanded());
    const readState = () => `expanded: ${state.get()}`;
    return BehaviourState({
      isExpanded() {
        return state.get() === true;
      },
      isCollapsed() {
        return state.get() === false;
      },
      setCollapsed: $_2vokfcwwjfuw8tb4.curry(state.set, false),
      setExpanded: $_2vokfcwwjfuw8tb4.curry(state.set, true),
      readState
    });
  };


  const SlidingState = Object.freeze({
    init: init$4
  });

  const Sliding = create$1({
    fields: SlidingSchema,
    name: 'sliding',
    active: ActiveSliding,
    apis: SlidingApis,
    state: SlidingState
  });

  const build$2 = (refresh, scrollIntoView) => {
    const dropup = build$1(Container.sketch({
      dom: {
        tag: 'div',
        classes: $_2fp9skztjfuw8tqe.resolve('dropup')
      },
      components: [],
      containerBehaviours: derive$2([
        Replacing.config({}),
        Sliding.config({
          closedClass: $_2fp9skztjfuw8tqe.resolve('dropup-closed'),
          openClass: $_2fp9skztjfuw8tqe.resolve('dropup-open'),
          shrinkingClass: $_2fp9skztjfuw8tqe.resolve('dropup-shrinking'),
          growingClass: $_2fp9skztjfuw8tqe.resolve('dropup-growing'),
          dimension: { property: 'height' },
          onShrunk(component) {
            refresh();
            scrollIntoView();
            Replacing.set(component, []);
          },
          onGrown(component) {
            refresh();
            scrollIntoView();
          }
        }),
        $_9de9iyzsjfuw8tqa.orientation((component, data) => {
          disappear($_2vokfcwwjfuw8tb4.noop);
        })
      ])
    }));
    const appear = (menu, update, component) => {
      if (Sliding.hasShrunk(dropup) === true && Sliding.isTransitioning(dropup) === false) {
        window.requestAnimationFrame(() => {
          update(component);
          Replacing.set(dropup, [menu()]);
          Sliding.grow(dropup);
        });
      }
    };
    var disappear = onReadyToShrink => {
      window.requestAnimationFrame(() => {
        onReadyToShrink();
        Sliding.shrink(dropup);
      });
    };
    return {
      appear,
      disappear,
      component: $_2vokfcwwjfuw8tb4.constant(dropup),
      element: dropup.element
    };
  };

  const isDangerous = event => event.raw().which === $_cy6bab10cjfuw8tt9.BACKSPACE()[0] && !$_efmt4zxbjfuw8tcj.contains([
    'input',
    'textarea'
  ], $_74lhjaxjjfuw8tdt.name(event.target()));
  const isFirefox = $_5reqwox3jfuw8tbu.detect().browser.isFirefox();
  const settingsSchema = objOfOnly([
    strictFunction('triggerEvent'),
    strictFunction('broadcastEvent'),
    defaulted$1('stopBackspace', true)
  ]);
  const bindFocus = (container, handler) => {
    if (isFirefox) {
      return $_6cl0bk14cjfuw8uqx.capture(container, 'focus', handler);
    } else {
      return $_6cl0bk14cjfuw8uqx.bind(container, 'focusin', handler);
    }
  };
  const bindBlur = (container, handler) => {
    if (isFirefox) {
      return $_6cl0bk14cjfuw8uqx.capture(container, 'blur', handler);
    } else {
      return $_6cl0bk14cjfuw8uqx.bind(container, 'focusout', handler);
    }
  };
  const setup$2 = (container, rawSettings) => {
    const settings = asRawOrDie('Getting GUI events settings', settingsSchema, rawSettings);
    const pointerEvents = $_5reqwox3jfuw8tbu.detect().deviceType.isTouch() ? [
      'touchstart',
      'touchmove',
      'touchend',
      'gesturestart'
    ] : [
      'mousedown',
      'mouseup',
      'mouseover',
      'mousemove',
      'mouseout',
      'click'
    ];
    const tapEvent = monitor(settings);
    const simpleEvents = $_efmt4zxbjfuw8tcj.map(pointerEvents.concat([
      'selectstart',
      'input',
      'contextmenu',
      'change',
      'transitionend',
      'dragstart',
      'dragover',
      'drop'
    ]), type => $_6cl0bk14cjfuw8uqx.bind(container, type, event => {
      tapEvent.fireIfReady(event, type).each(tapStopped => {
        if (tapStopped) {
          event.kill();
        }
      });
      const stopped = settings.triggerEvent(type, event);
      if (stopped) {
        event.kill();
      }
    }));
    const onKeydown = $_6cl0bk14cjfuw8uqx.bind(container, 'keydown', event => {
      const stopped = settings.triggerEvent('keydown', event);
      if (stopped) {
        event.kill();
      } else if (settings.stopBackspace === true && isDangerous(event)) {
        event.prevent();
      }
    });
    const onFocusIn = bindFocus(container, event => {
      const stopped = settings.triggerEvent('focusin', event);
      if (stopped) {
        event.kill();
      }
    });
    const onFocusOut = bindBlur(container, event => {
      const stopped = settings.triggerEvent('focusout', event);
      if (stopped) {
        event.kill();
      }
      setTimeout(() => {
        settings.triggerEvent(postBlur(), event);
      }, 0);
    });
    const defaultView = $_aff64dxmjfuw8tdx.defaultView(container);
    const onWindowScroll = $_6cl0bk14cjfuw8uqx.bind(defaultView, 'scroll', event => {
      const stopped = settings.broadcastEvent(windowScroll(), event);
      if (stopped) {
        event.kill();
      }
    });
    const unbind = () => {
      $_efmt4zxbjfuw8tcj.each(simpleEvents, e => {
        e.unbind();
      });
      onKeydown.unbind();
      onFocusIn.unbind();
      onFocusOut.unbind();
      onWindowScroll.unbind();
    };
    return { unbind };
  };

  const derive$3 = (rawEvent, rawTarget) => {
    const source = readOptFrom$1(rawEvent, 'target').map(getTarget => getTarget()).getOr(rawTarget);
    return Cell(source);
  };

  const fromSource = (event, source) => {
    const stopper = Cell(false);
    const cutter = Cell(false);
    const stop = () => {
      stopper.set(true);
    };
    const cut = () => {
      cutter.set(true);
    };
    return {
      stop,
      cut,
      isStopped: stopper.get,
      isCut: cutter.get,
      event: $_2vokfcwwjfuw8tb4.constant(event),
      setSource: source.set,
      getSource: source.get
    };
  };
  const fromExternal = event => {
    const stopper = Cell(false);
    const stop = () => {
      stopper.set(true);
    };
    return {
      stop,
      cut: $_2vokfcwwjfuw8tb4.noop,
      isStopped: stopper.get,
      isCut: $_2vokfcwwjfuw8tb4.constant(false),
      event: $_2vokfcwwjfuw8tb4.constant(event),
      setTarget: $_2vokfcwwjfuw8tb4.die('Cannot set target of a broadcasted event'),
      getTarget: $_2vokfcwwjfuw8tb4.die('Cannot get target of a broadcasted event')
    };
  };

  const adt$6 = $_dldkf4y5jfuw8tgp.generate([
    { stopped: [] },
    { resume: ['element'] },
    { complete: [] }
  ]);
  const doTriggerHandler = (lookup, eventType, rawEvent, target, source, logger) => {
    const handler = lookup(eventType, target);
    const simulatedEvent = fromSource(rawEvent, source);
    return handler.fold(() => {
      logger.logEventNoHandlers(eventType, target);
      return adt$6.complete();
    }, handlerInfo => {
      const descHandler = handlerInfo.descHandler();
      const eventHandler = getHandler(descHandler);
      eventHandler(simulatedEvent);
      if (simulatedEvent.isStopped()) {
        logger.logEventStopped(eventType, handlerInfo.element(), descHandler.purpose());
        return adt$6.stopped();
      } else if (simulatedEvent.isCut()) {
        logger.logEventCut(eventType, handlerInfo.element(), descHandler.purpose());
        return adt$6.complete();
      } else {
        return $_aff64dxmjfuw8tdx.parent(handlerInfo.element()).fold(() => {
          logger.logNoParent(eventType, handlerInfo.element(), descHandler.purpose());
          return adt$6.complete();
        }, parent => {
          logger.logEventResponse(eventType, handlerInfo.element(), descHandler.purpose());
          return adt$6.resume(parent);
        });
      }
    });
  };
  const doTriggerOnUntilStopped = (lookup, eventType, rawEvent, rawTarget, source, logger) => doTriggerHandler(lookup, eventType, rawEvent, rawTarget, source, logger).fold(() => true, parent => doTriggerOnUntilStopped(lookup, eventType, rawEvent, parent, source, logger), () => false);
  const triggerHandler = (lookup, eventType, rawEvent, target, logger) => {
    const source = derive$3(rawEvent, target);
    return doTriggerHandler(lookup, eventType, rawEvent, target, source, logger);
  };
  const broadcast = (listeners, rawEvent, logger) => {
    const simulatedEvent = fromExternal(rawEvent);
    $_efmt4zxbjfuw8tcj.each(listeners, listener => {
      const descHandler = listener.descHandler();
      const handler = getHandler(descHandler);
      handler(simulatedEvent);
    });
    return simulatedEvent.isStopped();
  };
  const triggerUntilStopped = (lookup, eventType, rawEvent, logger) => {
    const rawTarget = rawEvent.target();
    return triggerOnUntilStopped(lookup, eventType, rawEvent, rawTarget, logger);
  };
  var triggerOnUntilStopped = (lookup, eventType, rawEvent, rawTarget, logger) => {
    const source = derive$3(rawEvent, rawTarget);
    return doTriggerOnUntilStopped(lookup, eventType, rawEvent, rawTarget, source, logger);
  };

  const closest$4 = (target, transform, isRoot) => {
    const delegate = $_d0h9pzz3jfuw8tlv.closest(target, elem => transform(elem).isSome(), isRoot);
    return delegate.bind(transform);
  };

  const eventHandler = $_4xhupwxnjfuw8tea.immutable('element', 'descHandler');
  const messageHandler = (id, handler) => ({
    id: $_2vokfcwwjfuw8tb4.constant(id),
    descHandler: $_2vokfcwwjfuw8tb4.constant(handler)
  });
  function EventRegistry () {
    const registry = {};
    const registerId = (extraArgs, id, events) => {
      $_8qu224wzjfuw8tb9.each(events, (v, k) => {
        const handlers = registry[k] !== undefined ? registry[k] : {};
        handlers[id] = curryArgs(v, extraArgs);
        registry[k] = handlers;
      });
    };
    const findHandler = (handlers, elem) => read$2(elem).fold(() => Option.none(), id => {
      const reader = readOpt$1(id);
      return handlers.bind(reader).map(descHandler => eventHandler(elem, descHandler));
    });
    const filterByType = type => readOptFrom$1(registry, type).map(handlers => $_8qu224wzjfuw8tb9.mapToArray(handlers, (f, id) => messageHandler(id, f))).getOr([]);
    const find = (isAboveRoot, type, target) => {
      const readType = readOpt$1(type);
      const handlers = readType(registry);
      return closest$4(target, elem => findHandler(handlers, elem), isAboveRoot);
    };
    const unregisterId = id => {
      $_8qu224wzjfuw8tb9.each(registry, (handlersById, eventName) => {
        if (handlersById.hasOwnProperty(id)) {
          delete handlersById[id];
        }
      });
    };
    return {
      registerId,
      unregisterId,
      filterByType,
      find
    };
  }

  function Registry () {
    const events = EventRegistry();
    const components = {};
    const readOrTag = component => {
      const elem = component.element();
      return read$2(elem).fold(() => write('uid-', component.element()), uid => uid);
    };
    const failOnDuplicate = (component, tagId) => {
      const conflict = components[tagId];
      if (conflict === component) {
        unregister(component);
      } else {
        throw new Error(`The tagId "${tagId}" is already used by: ${element(conflict.element())}\nCannot use it for: ${element(component.element())}\nThe conflicting element is${$_8634tqxhjfuw8tdl.inBody(conflict.element()) ? ' ' : ' not '}already in the DOM`);
      }
    };
    const register = component => {
      const tagId = readOrTag(component);
      if (hasKey$1(components, tagId)) {
        failOnDuplicate(component, tagId);
      }
      const extraArgs = [component];
      events.registerId(extraArgs, tagId, component.events());
      components[tagId] = component;
    };
    var unregister = component => {
      read$2(component.element()).each(tagId => {
        components[tagId] = undefined;
        events.unregisterId(tagId);
      });
    };
    const filter = type => events.filterByType(type);
    const find = (isAboveRoot, type, target) => events.find(isAboveRoot, type, target);
    const getById = id => readOpt$1(id)(components);
    return {
      find,
      filter,
      register,
      unregister,
      getById
    };
  }

  const takeover = root => {
    const isAboveRoot = el => $_aff64dxmjfuw8tdx.parent(root.element()).fold(() => true, parent => $_4867a0xsjfuw8tej.eq(el, parent));
    const registry = Registry();
    const lookup = (eventName, target) => registry.find(isAboveRoot, eventName, target);
    const domEvents = setup$2(root.element(), {
      triggerEvent(eventName, event) {
        return monitorEvent(eventName, event.target(), logger => triggerUntilStopped(lookup, eventName, event, logger));
      },
      broadcastEvent(eventName, event) {
        const listeners = registry.filter(eventName);
        return broadcast(listeners, event);
      }
    });
    const systemApi = SystemApi({
      debugInfo: $_2vokfcwwjfuw8tb4.constant('real'),
      triggerEvent(eventName, target, data) {
        monitorEvent(eventName, target, logger => {
          triggerOnUntilStopped(lookup, eventName, data, target, logger);
        });
      },
      triggerFocus(target, originator) {
        read$2(target).fold(() => {
          $_f15fvwz1jfuw8tlo.focus(target);
        }, _alloyId => {
          monitorEvent(focus$1(), target, logger => {
            triggerHandler(lookup, focus$1(), {
              originator: $_2vokfcwwjfuw8tb4.constant(originator),
              target: $_2vokfcwwjfuw8tb4.constant(target)
            }, target, logger);
          });
        });
      },
      triggerEscape(comp, simulatedEvent) {
        systemApi.triggerEvent('keydown', comp.element(), simulatedEvent.event());
      },
      getByUid(uid) {
        return getByUid(uid);
      },
      getByDom(elem) {
        return getByDom(elem);
      },
      build: build$1,
      addToGui(c) {
        add(c);
      },
      removeFromGui(c) {
        remove(c);
      },
      addToWorld(c) {
        addToWorld(c);
      },
      removeFromWorld(c) {
        removeFromWorld(c);
      },
      broadcast(message) {
        broadcast$$1(message);
      },
      broadcastOn(channels, message) {
        broadcastOn(channels, message);
      }
    });
    var addToWorld = component => {
      component.connect(systemApi);
      if (!$_74lhjaxjjfuw8tdt.isText(component.element())) {
        registry.register(component);
        $_efmt4zxbjfuw8tcj.each(component.components(), addToWorld);
        systemApi.triggerEvent(systemInit(), component.element(), { target: $_2vokfcwwjfuw8tb4.constant(component.element()) });
      }
    };
    var removeFromWorld = component => {
      if (!$_74lhjaxjjfuw8tdt.isText(component.element())) {
        $_efmt4zxbjfuw8tcj.each(component.components(), removeFromWorld);
        registry.unregister(component);
      }
      component.disconnect();
    };
    var add = component => {
      attach(root, component);
    };
    var remove = component => {
      detach(component);
    };
    const destroy = () => {
      domEvents.unbind();
      $_138z6jxyjfuw8tf4.remove(root.element());
    };
    const broadcastData = data => {
      const receivers = registry.filter(receive());
      $_efmt4zxbjfuw8tcj.each(receivers, receiver => {
        const descHandler = receiver.descHandler();
        const handler = getHandler(descHandler);
        handler(data);
      });
    };
    var broadcast$$1 = message => {
      broadcastData({
        universal: $_2vokfcwwjfuw8tb4.constant(true),
        data: $_2vokfcwwjfuw8tb4.constant(message)
      });
    };
    var broadcastOn = (channels, message) => {
      broadcastData({
        universal: $_2vokfcwwjfuw8tb4.constant(false),
        channels: $_2vokfcwwjfuw8tb4.constant(channels),
        data: $_2vokfcwwjfuw8tb4.constant(message)
      });
    };
    var getByUid = uid => registry.getById(uid).fold(() => Result.error(new Error(`Could not find component with uid: "${uid}" in system.`)), Result.value);
    var getByDom = elem => {
      const uid = read$2(elem).getOr('not found');
      return getByUid(uid);
    };
    addToWorld(root);
    return {
      root: $_2vokfcwwjfuw8tb4.constant(root),
      element: root.element,
      destroy,
      add,
      remove,
      getByUid,
      getByDom,
      addToWorld,
      removeFromWorld,
      broadcast: broadcast$$1,
      broadcastOn
    };
  };

  const READ_ONLY_MODE_CLASS = $_2vokfcwwjfuw8tb4.constant($_2fp9skztjfuw8tqe.resolve('readonly-mode'));
  const EDIT_MODE_CLASS = $_2vokfcwwjfuw8tb4.constant($_2fp9skztjfuw8tqe.resolve('edit-mode'));
  function OuterContainer (spec) {
    const root = build$1(Container.sketch({
      dom: { classes: [$_2fp9skztjfuw8tqe.resolve('outer-container')].concat(spec.classes) },
      containerBehaviours: derive$2([Swapping.config({
          alpha: READ_ONLY_MODE_CLASS(),
          omega: EDIT_MODE_CLASS()
        })])
    }));
    return takeover(root);
  }

  function AndroidRealm (scrollIntoView) {
    const alloy = OuterContainer({ classes: [$_2fp9skztjfuw8tqe.resolve('android-container')] });
    const toolbar = ScrollingToolbar();
    const webapp = $_bh7xqm133jfuw8uet.api();
    const switchToEdit = $_9pcl2n15jjfuw8uzs.makeEditSwitch(webapp);
    const socket = $_9pcl2n15jjfuw8uzs.makeSocket();
    const dropup = build$2($_2vokfcwwjfuw8tb4.noop, scrollIntoView);
    alloy.add(toolbar.wrapper());
    alloy.add(socket);
    alloy.add(dropup.component());
    const setToolbarGroups = rawGroups => {
      const groups = toolbar.createGroups(rawGroups);
      toolbar.setGroups(groups);
    };
    const setContextToolbar = rawGroups => {
      const groups = toolbar.createGroups(rawGroups);
      toolbar.setContextToolbar(groups);
    };
    const focusToolbar = () => {
      toolbar.focus();
    };
    const restoreToolbar = () => {
      toolbar.restoreToolbar();
    };
    const init = spec => {
      webapp.set($_6g5ji714fjfuw8urf.produce(spec));
    };
    const exit = () => {
      webapp.run(w => {
        w.exit();
        Replacing.remove(socket, switchToEdit);
      });
    };
    const updateMode = readOnly => {
      $_9pcl2n15jjfuw8uzs.updateMode(socket, switchToEdit, readOnly, alloy.root());
    };
    return {
      system: $_2vokfcwwjfuw8tb4.constant(alloy),
      element: alloy.element,
      init,
      exit,
      setToolbarGroups,
      setContextToolbar,
      focusToolbar,
      restoreToolbar,
      updateMode,
      socket: $_2vokfcwwjfuw8tb4.constant(socket),
      dropup: $_2vokfcwwjfuw8tb4.constant(dropup)
    };
  }

  const input$1 = (parent, operation) => {
    const input = $_bwdnu0xijfuw8tdo.fromTag('input');
    $_aag5ti106jfuw8tse.setAll(input, {
      opacity: '0',
      position: 'absolute',
      top: '-1000px',
      left: '-1000px'
    });
    $_cwa5ncxljfuw8tdv.append(parent, input);
    $_f15fvwz1jfuw8tlo.focus(input);
    operation(input);
    $_138z6jxyjfuw8tf4.remove(input);
  };
  const $_e8m84k163jfuw8v59 = { input: input$1 };

  const refreshInput = input => {
    const start = input.dom().selectionStart;
    const end = input.dom().selectionEnd;
    const dir = input.dom().selectionDirection;
    setTimeout(() => {
      input.dom().setSelectionRange(start, end, dir);
      $_f15fvwz1jfuw8tlo.focus(input);
    }, 50);
  };
  const refresh = winScope => {
    const sel = winScope.getSelection();
    if (sel.rangeCount > 0) {
      const br = sel.getRangeAt(0);
      const r = winScope.document.createRange();
      r.setStart(br.startContainer, br.startOffset);
      r.setEnd(br.endContainer, br.endOffset);
      sel.removeAllRanges();
      sel.addRange(r);
    }
  };
  const $_5098ol165jfuw8v5p = {
    refreshInput,
    refresh
  };

  const resume$1 = (cWin, frame) => {
    $_f15fvwz1jfuw8tlo.active().each(active => {
      if (!$_4867a0xsjfuw8tej.eq(active, frame)) {
        $_f15fvwz1jfuw8tlo.blur(active);
      }
    });
    cWin.focus();
    $_f15fvwz1jfuw8tlo.focus($_bwdnu0xijfuw8tdo.fromDom(cWin.document.body));
    $_5098ol165jfuw8v5p.refresh(cWin);
  };
  const $_7ddnf2164jfuw8v5j = { resume: resume$1 };

  const stubborn = (outerBody, cWin, page, frame) => {
    const toEditing = () => {
      $_7ddnf2164jfuw8v5j.resume(cWin, frame);
    };
    const toReading = () => {
      $_e8m84k163jfuw8v59.input(outerBody, $_f15fvwz1jfuw8tlo.blur);
    };
    const captureInput = $_6cl0bk14cjfuw8uqx.bind(page, 'keydown', evt => {
      if (!$_efmt4zxbjfuw8tcj.contains([
          'input',
          'textarea'
        ], $_74lhjaxjjfuw8tdt.name(evt.target()))) {
        toEditing();
      }
    });
    const onToolbarTouch = () => {
    };
    const destroy = () => {
      captureInput.unbind();
    };
    return {
      toReading,
      toEditing,
      onToolbarTouch,
      destroy
    };
  };
  const timid = (outerBody, cWin, page, frame) => {
    const dismissKeyboard = () => {
      $_f15fvwz1jfuw8tlo.blur(frame);
    };
    const onToolbarTouch = () => {
      dismissKeyboard();
    };
    const toReading = () => {
      dismissKeyboard();
    };
    const toEditing = () => {
      $_7ddnf2164jfuw8v5j.resume(cWin, frame);
    };
    return {
      toReading,
      toEditing,
      onToolbarTouch,
      destroy: $_2vokfcwwjfuw8tb4.noop
    };
  };
  const $_8wqcx8162jfuw8v4y = {
    stubborn,
    timid
  };

  const initEvents$1 = (editorApi, iosApi, toolstrip, socket, dropup) => {
    const saveSelectionFirst = () => {
      iosApi.run(api => {
        api.highlightSelection();
      });
    };
    const refreshIosSelection = () => {
      iosApi.run(api => {
        api.refreshSelection();
      });
    };
    const scrollToY = (yTop, height) => {
      const y = yTop - socket.dom().scrollTop;
      iosApi.run(api => {
        api.scrollIntoView(y, y + height);
      });
    };
    const scrollToElement = target => {
      scrollToY(iosApi, socket);
    };
    const scrollToCursor = () => {
      editorApi.getCursorBox().each(box => {
        scrollToY(box.top(), box.height());
      });
    };
    const clearSelection = () => {
      iosApi.run(api => {
        api.clearSelection();
      });
    };
    const clearAndRefresh = () => {
      clearSelection();
      refreshThrottle.throttle();
    };
    const refreshView = () => {
      scrollToCursor();
      iosApi.run(api => {
        api.syncHeight();
      });
    };
    const reposition = () => {
      const toolbarHeight = $_sgteu105jfuw8tsc.get(toolstrip);
      iosApi.run(api => {
        api.setViewportOffset(toolbarHeight);
      });
      refreshIosSelection();
      refreshView();
    };
    const toEditing = () => {
      iosApi.run(api => {
        api.toEditing();
      });
    };
    const toReading = () => {
      iosApi.run(api => {
        api.toReading();
      });
    };
    const onToolbarTouch = event => {
      iosApi.run(api => {
        api.onToolbarTouch(event);
      });
    };
    const tapping = $_bz8sbn14ijfuw8usd.monitor(editorApi);
    var refreshThrottle = $_6hl53v15bjfuw8uxr.last(refreshView, 300);
    const listeners = [
      editorApi.onKeyup(clearAndRefresh),
      editorApi.onNodeChanged(refreshIosSelection),
      editorApi.onDomChanged(refreshThrottle.throttle),
      editorApi.onDomChanged(refreshIosSelection),
      editorApi.onScrollToCursor(tinyEvent => {
        tinyEvent.preventDefault();
        refreshThrottle.throttle();
      }),
      editorApi.onScrollToElement(event => {
        scrollToElement(event.element());
      }),
      editorApi.onToEditing(toEditing),
      editorApi.onToReading(toReading),
      $_6cl0bk14cjfuw8uqx.bind(editorApi.doc(), 'touchend', touchEvent => {
        if ($_4867a0xsjfuw8tej.eq(editorApi.html(), touchEvent.target()) || $_4867a0xsjfuw8tej.eq(editorApi.body(), touchEvent.target())) {
        }
      }),
      $_6cl0bk14cjfuw8uqx.bind(toolstrip, 'transitionend', transitionEvent => {
        if (transitionEvent.raw().propertyName === 'height') {
          reposition();
        }
      }),
      $_6cl0bk14cjfuw8uqx.capture(toolstrip, 'touchstart', touchEvent => {
        saveSelectionFirst();
        onToolbarTouch(touchEvent);
        editorApi.onTouchToolstrip();
      }),
      $_6cl0bk14cjfuw8uqx.bind(editorApi.body(), 'touchstart', evt => {
        clearSelection();
        editorApi.onTouchContent();
        tapping.fireTouchstart(evt);
      }),
      tapping.onTouchmove(),
      tapping.onTouchend(),
      $_6cl0bk14cjfuw8uqx.bind(editorApi.body(), 'click', event => {
        event.kill();
      }),
      $_6cl0bk14cjfuw8uqx.bind(toolstrip, 'touchmove', () => {
        editorApi.onToolbarScrollStart();
      })
    ];
    const destroy = () => {
      $_efmt4zxbjfuw8tcj.each(listeners, l => {
        l.unbind();
      });
    };
    return { destroy };
  };
  const $_6p8ia7166jfuw8v5u = { initEvents: initEvents$1 };

  function FakeSelection (win, frame) {
    const doc = win.document;
    const container = $_bwdnu0xijfuw8tdo.fromTag('div');
    $_6po7jxyujfuw8tl0.add(container, $_2fp9skztjfuw8tqe.resolve('unfocused-selections'));
    $_cwa5ncxljfuw8tdv.append($_bwdnu0xijfuw8tdo.fromDom(doc.documentElement), container);
    const onTouch = $_6cl0bk14cjfuw8uqx.bind(container, 'touchstart', event => {
      event.prevent();
      $_7ddnf2164jfuw8v5j.resume(win, frame);
      clear();
    });
    const make = rectangle => {
      const span = $_bwdnu0xijfuw8tdo.fromTag('span');
      $_c6ke2t13mjfuw8uku.add(span, [
        $_2fp9skztjfuw8tqe.resolve('layer-editor'),
        $_2fp9skztjfuw8tqe.resolve('unfocused-selection')
      ]);
      $_aag5ti106jfuw8tse.setAll(span, {
        left: `${rectangle.left()}px`,
        top: `${rectangle.top()}px`,
        width: `${rectangle.width()}px`,
        height: `${rectangle.height()}px`
      });
      return span;
    };
    const update = () => {
      clear();
      const rectangles = $_1h6vvx14njfuw8utc.getRectangles(win);
      const spans = $_efmt4zxbjfuw8tcj.map(rectangles, make);
      $_g8n2ewxzjfuw8tf7.append(container, spans);
    };
    var clear = () => {
      $_138z6jxyjfuw8tf4.empty(container);
    };
    const destroy = () => {
      onTouch.unbind();
      $_138z6jxyjfuw8tf4.remove(container);
    };
    const isActive = () => $_aff64dxmjfuw8tdx.children(container).length > 0;
    return {
      update,
      isActive,
      destroy,
      clear
    };
  }

  const nu$8 = baseFn => {
    let data = Option.none();
    let callbacks = [];
    const map = f => nu$8(nCallback => {
      get(data => {
        nCallback(f(data));
      });
    });
    var get = nCallback => {
      if (isReady())
        call(nCallback);
      else
        callbacks.push(nCallback);
    };
    const set = x => {
      data = Option.some(x);
      run(callbacks);
      callbacks = [];
    };
    var isReady = () => data.isSome();
    var run = cbs => {
      $_efmt4zxbjfuw8tcj.each(cbs, call);
    };
    var call = cb => {
      data.each(x => {
        setTimeout(() => {
          cb(x);
        }, 0);
      });
    };
    baseFn(set);
    return {
      get,
      map,
      isReady
    };
  };
  const pure$1 = a => nu$8(callback => {
    callback(a);
  });
  const LazyValue = {
    nu: nu$8,
    pure: pure$1
  };

  const bounce = f => function () {
    const args = Array.prototype.slice.call(arguments);
    const me = this;
    setTimeout(() => {
      f.apply(me, args);
    }, 0);
  };
  const $_6coh2216cjfuw8v7t = { bounce };

  const nu$9 = baseFn => {
    const get = callback => {
      baseFn($_6coh2216cjfuw8v7t.bounce(callback));
    };
    const map = fab => nu$9(callback => {
      get(a => {
        const value = fab(a);
        callback(value);
      });
    });
    const bind = aFutureB => nu$9(callback => {
      get(a => {
        aFutureB(a).get(callback);
      });
    });
    const anonBind = futureB => nu$9(callback => {
      get(a => {
        futureB.get(callback);
      });
    });
    const toLazy = () => LazyValue.nu(get);
    return {
      map,
      bind,
      anonBind,
      toLazy,
      get
    };
  };
  const pure$2 = a => nu$9(callback => {
    callback(a);
  });
  const Future = {
    nu: nu$9,
    pure: pure$2
  };

  const adjust = (value, destination, amount) => {
    if (Math.abs(value - destination) <= amount) {
      return Option.none();
    } else if (value < destination) {
      return Option.some(value + amount);
    } else {
      return Option.some(value - amount);
    }
  };
  const create$7 = () => {
    let interval = null;
    const animate = (getCurrent, destination, amount, increment, doFinish, rate) => {
      let finished = false;
      const finish = v => {
        finished = true;
        doFinish(v);
      };
      clearInterval(interval);
      const abort = v => {
        clearInterval(interval);
        finish(v);
      };
      interval = setInterval(() => {
        const value = getCurrent();
        adjust(value, destination, amount).fold(() => {
          clearInterval(interval);
          finish(destination);
        }, s => {
          increment(s, abort);
          if (!finished) {
            const newValue = getCurrent();
            if (newValue !== s || Math.abs(newValue - destination) > Math.abs(value - destination)) {
              clearInterval(interval);
              finish(destination);
            }
          }
        });
      }, rate);
    };
    return { animate };
  };
  const $_4d6on916djfuw8v7v = {
    create: create$7,
    adjust
  };

  const findDevice = (deviceWidth, deviceHeight) => {
    const devices = [
      {
        width: 320,
        height: 480,
        keyboard: {
          portrait: 300,
          landscape: 240
        }
      },
      {
        width: 320,
        height: 568,
        keyboard: {
          portrait: 300,
          landscape: 240
        }
      },
      {
        width: 375,
        height: 667,
        keyboard: {
          portrait: 305,
          landscape: 240
        }
      },
      {
        width: 414,
        height: 736,
        keyboard: {
          portrait: 320,
          landscape: 240
        }
      },
      {
        width: 768,
        height: 1024,
        keyboard: {
          portrait: 320,
          landscape: 400
        }
      },
      {
        width: 1024,
        height: 1366,
        keyboard: {
          portrait: 380,
          landscape: 460
        }
      }
    ];
    return $_e8fwikzljfuw8tp3.findMap(devices, device => deviceWidth <= device.width && deviceHeight <= device.height ? Option.some(device.keyboard) : Option.none()).getOr({
      portrait: deviceHeight / 5,
      landscape: deviceWidth / 4
    });
  };
  const $_fe8yws16gjfuw8v8s = { findDevice };

  const softKeyboardLimits = outerWindow => $_fe8yws16gjfuw8v8s.findDevice(outerWindow.screen.width, outerWindow.screen.height);
  const accountableKeyboardHeight = outerWindow => {
    const portrait = $_2v9f8x14bjfuw8uqn.get(outerWindow).isPortrait();
    const limits = softKeyboardLimits(outerWindow);
    const keyboard = portrait ? limits.portrait : limits.landscape;
    const visualScreenHeight = portrait ? outerWindow.screen.height : outerWindow.screen.width;
    return visualScreenHeight - outerWindow.innerHeight > keyboard ? 0 : keyboard;
  };
  const getGreenzone = (socket, dropup) => {
    const outerWindow = $_aff64dxmjfuw8tdx.owner(socket).dom().defaultView;
    const viewportHeight = $_sgteu105jfuw8tsc.get(socket) + $_sgteu105jfuw8tsc.get(dropup);
    const acc = accountableKeyboardHeight(outerWindow);
    return viewportHeight - acc;
  };
  const updatePadding = (contentBody, socket, dropup) => {
    const greenzoneHeight = getGreenzone(socket, dropup);
    const deltaHeight = $_sgteu105jfuw8tsc.get(socket) + $_sgteu105jfuw8tsc.get(dropup) - greenzoneHeight;
    $_aag5ti106jfuw8tse.set(contentBody, 'padding-bottom', `${deltaHeight}px`);
  };
  const $_m18jz16fjfuw8v8l = {
    getGreenzone,
    updatePadding
  };

  const fixture = $_dldkf4y5jfuw8tgp.generate([
    {
      fixed: [
        'element',
        'property',
        'offsetY'
      ]
    },
    {
      scroller: [
        'element',
        'offsetY'
      ]
    }
  ]);
  const yFixedData = `data-${$_2fp9skztjfuw8tqe.resolve('position-y-fixed')}`;
  const yFixedProperty = `data-${$_2fp9skztjfuw8tqe.resolve('y-property')}`;
  const yScrollingData = `data-${$_2fp9skztjfuw8tqe.resolve('scrolling')}`;
  const windowSizeData = `data-${$_2fp9skztjfuw8tqe.resolve('last-window-height')}`;
  const getYFixedData = element => $_f77yow14mjfuw8ut9.safeParse(element, yFixedData);
  const getYFixedProperty = element => $_47adx7ywjfuw8tl3.get(element, yFixedProperty);
  const getLastWindowSize = element => $_f77yow14mjfuw8ut9.safeParse(element, windowSizeData);
  const classifyFixed = (element, offsetY) => {
    const prop = getYFixedProperty(element);
    return fixture.fixed(element, prop, offsetY);
  };
  const classifyScrolling = (element, offsetY) => fixture.scroller(element, offsetY);
  const classify = element => {
    const offsetY = getYFixedData(element);
    const classifier = $_47adx7ywjfuw8tl3.get(element, yScrollingData) === 'true' ? classifyScrolling : classifyFixed;
    return classifier(element, offsetY);
  };
  const findFixtures = container => {
    const candidates = $_951f03109jfuw8tt3.descendants(container, `[${yFixedData}]`);
    return $_efmt4zxbjfuw8tcj.map(candidates, classify);
  };
  const takeoverToolbar = toolbar => {
    const oldToolbarStyle = $_47adx7ywjfuw8tl3.get(toolbar, 'style');
    $_aag5ti106jfuw8tse.setAll(toolbar, {
      position: 'absolute',
      top: '0px'
    });
    $_47adx7ywjfuw8tl3.set(toolbar, yFixedData, '0px');
    $_47adx7ywjfuw8tl3.set(toolbar, yFixedProperty, 'top');
    const restore = () => {
      $_47adx7ywjfuw8tl3.set(toolbar, 'style', oldToolbarStyle || '');
      $_47adx7ywjfuw8tl3.remove(toolbar, yFixedData);
      $_47adx7ywjfuw8tl3.remove(toolbar, yFixedProperty);
    };
    return { restore };
  };
  const takeoverViewport = (toolbarHeight, height, viewport) => {
    const oldViewportStyle = $_47adx7ywjfuw8tl3.get(viewport, 'style');
    $_3pnsue149jfuw8uqb.register(viewport);
    $_aag5ti106jfuw8tse.setAll(viewport, {
      position: 'absolute',
      height: `${height}px`,
      width: '100%',
      top: `${toolbarHeight}px`
    });
    $_47adx7ywjfuw8tl3.set(viewport, yFixedData, `${toolbarHeight}px`);
    $_47adx7ywjfuw8tl3.set(viewport, yScrollingData, 'true');
    $_47adx7ywjfuw8tl3.set(viewport, yFixedProperty, 'top');
    const restore = () => {
      $_3pnsue149jfuw8uqb.deregister(viewport);
      $_47adx7ywjfuw8tl3.set(viewport, 'style', oldViewportStyle || '');
      $_47adx7ywjfuw8tl3.remove(viewport, yFixedData);
      $_47adx7ywjfuw8tl3.remove(viewport, yScrollingData);
      $_47adx7ywjfuw8tl3.remove(viewport, yFixedProperty);
    };
    return { restore };
  };
  const takeoverDropup = (dropup, toolbarHeight, viewportHeight) => {
    const oldDropupStyle = $_47adx7ywjfuw8tl3.get(dropup, 'style');
    $_aag5ti106jfuw8tse.setAll(dropup, {
      position: 'absolute',
      bottom: '0px'
    });
    $_47adx7ywjfuw8tl3.set(dropup, yFixedData, '0px');
    $_47adx7ywjfuw8tl3.set(dropup, yFixedProperty, 'bottom');
    const restore = () => {
      $_47adx7ywjfuw8tl3.set(dropup, 'style', oldDropupStyle || '');
      $_47adx7ywjfuw8tl3.remove(dropup, yFixedData);
      $_47adx7ywjfuw8tl3.remove(dropup, yFixedProperty);
    };
    return { restore };
  };
  const deriveViewportHeight = (viewport, toolbarHeight, dropupHeight) => {
    const outerWindow = $_aff64dxmjfuw8tdx.owner(viewport).dom().defaultView;
    const winH = outerWindow.innerHeight;
    $_47adx7ywjfuw8tl3.set(viewport, windowSizeData, `${winH}px`);
    return winH - toolbarHeight - dropupHeight;
  };
  const takeover$1 = (viewport, contentBody, toolbar, dropup) => {
    const outerWindow = $_aff64dxmjfuw8tdx.owner(viewport).dom().defaultView;
    const toolbarSetup = takeoverToolbar(toolbar);
    const toolbarHeight = $_sgteu105jfuw8tsc.get(toolbar);
    const dropupHeight = $_sgteu105jfuw8tsc.get(dropup);
    const viewportHeight = deriveViewportHeight(viewport, toolbarHeight, dropupHeight);
    const viewportSetup = takeoverViewport(toolbarHeight, viewportHeight, viewport);
    const dropupSetup = takeoverDropup(dropup, toolbarHeight, viewportHeight);
    let isActive = true;
    const restore = () => {
      isActive = false;
      toolbarSetup.restore();
      viewportSetup.restore();
      dropupSetup.restore();
    };
    const isExpanding = () => {
      const currentWinHeight = outerWindow.innerHeight;
      const lastWinHeight = getLastWindowSize(viewport);
      return currentWinHeight > lastWinHeight;
    };
    const refresh = () => {
      if (isActive) {
        const newToolbarHeight = $_sgteu105jfuw8tsc.get(toolbar);
        const dropupHeight_1 = $_sgteu105jfuw8tsc.get(dropup);
        const newHeight = deriveViewportHeight(viewport, newToolbarHeight, dropupHeight_1);
        $_47adx7ywjfuw8tl3.set(viewport, yFixedData, `${newToolbarHeight}px`);
        $_aag5ti106jfuw8tse.set(viewport, 'height', `${newHeight}px`);
        $_aag5ti106jfuw8tse.set(dropup, 'bottom', `${-(newToolbarHeight + newHeight + dropupHeight_1)}px`);
        $_m18jz16fjfuw8v8l.updatePadding(contentBody, viewport, dropup);
      }
    };
    const setViewportOffset = newYOffset => {
      const offsetPx = `${newYOffset}px`;
      $_47adx7ywjfuw8tl3.set(viewport, yFixedData, offsetPx);
      refresh();
    };
    $_m18jz16fjfuw8v8l.updatePadding(contentBody, viewport, dropup);
    return {
      setViewportOffset,
      isExpanding,
      isShrinking: $_2vokfcwwjfuw8tb4.not(isExpanding),
      refresh,
      restore
    };
  };
  const $_a6i45416ejfuw8v83 = {
    findFixtures,
    takeover: takeover$1,
    getYFixedData
  };

  const animator = $_4d6on916djfuw8v7v.create();
  const ANIMATION_STEP = 15;
  const NUM_TOP_ANIMATION_FRAMES = 10;
  const ANIMATION_RATE = 10;
  const lastScroll = `data-${$_2fp9skztjfuw8tqe.resolve('last-scroll-top')}`;
  const getTop = element => {
    const raw = $_aag5ti106jfuw8tse.getRaw(element, 'top').getOr(0);
    return parseInt(raw, 10);
  };
  const getScrollTop = element => parseInt(element.dom().scrollTop, 10);
  const moveScrollAndTop = (element, destination, finalTop) => Future.nu(callback => {
    const getCurrent = $_2vokfcwwjfuw8tb4.curry(getScrollTop, element);
    const update = newScroll => {
      element.dom().scrollTop = newScroll;
      $_aag5ti106jfuw8tse.set(element, 'top', `${getTop(element) + ANIMATION_STEP}px`);
    };
    const finish = () => {
      element.dom().scrollTop = destination;
      $_aag5ti106jfuw8tse.set(element, 'top', `${finalTop}px`);
      callback(destination);
    };
    animator.animate(getCurrent, destination, ANIMATION_STEP, update, finish, ANIMATION_RATE);
  });
  const moveOnlyScroll = (element, destination) => Future.nu(callback => {
    const getCurrent = $_2vokfcwwjfuw8tb4.curry(getScrollTop, element);
    $_47adx7ywjfuw8tl3.set(element, lastScroll, getCurrent());
    const update = (newScroll, abort) => {
      const previous = $_f77yow14mjfuw8ut9.safeParse(element, lastScroll);
      if (previous !== element.dom().scrollTop) {
        abort(element.dom().scrollTop);
      } else {
        element.dom().scrollTop = newScroll;
        $_47adx7ywjfuw8tl3.set(element, lastScroll, newScroll);
      }
    };
    const finish = () => {
      element.dom().scrollTop = destination;
      $_47adx7ywjfuw8tl3.set(element, lastScroll, destination);
      callback(destination);
    };
    const distance = Math.abs(destination - getCurrent());
    const step = Math.ceil(distance / NUM_TOP_ANIMATION_FRAMES);
    animator.animate(getCurrent, destination, step, update, finish, ANIMATION_RATE);
  });
  const moveOnlyTop = (element, destination) => Future.nu(callback => {
    const getCurrent = $_2vokfcwwjfuw8tb4.curry(getTop, element);
    const update = newTop => {
      $_aag5ti106jfuw8tse.set(element, 'top', `${newTop}px`);
    };
    const finish = () => {
      update(destination);
      callback(destination);
    };
    const distance = Math.abs(destination - getCurrent());
    const step = Math.ceil(distance / NUM_TOP_ANIMATION_FRAMES);
    animator.animate(getCurrent, destination, step, update, finish, ANIMATION_RATE);
  });
  const updateTop = (element, amount) => {
    const newTop = `${amount + $_a6i45416ejfuw8v83.getYFixedData(element)}px`;
    $_aag5ti106jfuw8tse.set(element, 'top', newTop);
  };
  const moveWindowScroll = (toolbar, viewport, destY) => {
    const outerWindow = $_aff64dxmjfuw8tdx.owner(toolbar).dom().defaultView;
    return Future.nu(callback => {
      updateTop(toolbar, destY);
      updateTop(viewport, destY);
      outerWindow.scrollTo(0, destY);
      callback(destY);
    });
  };
  const $_ednzzl169jfuw8v7f = {
    moveScrollAndTop,
    moveOnlyScroll,
    moveOnlyTop,
    moveWindowScroll
  };

  function BackgroundActivity (doAction) {
    const action = Cell(LazyValue.pure({}));
    const start = value => {
      const future = LazyValue.nu(callback => doAction(value).get(callback));
      action.set(future);
    };
    const idle = g => {
      action.get().get(() => {
        g();
      });
    };
    return {
      start,
      idle
    };
  }

  const scrollIntoView = (cWin, socket, dropup, top, bottom) => {
    const greenzone = $_m18jz16fjfuw8v8l.getGreenzone(socket, dropup);
    const refreshCursor = $_2vokfcwwjfuw8tb4.curry($_5098ol165jfuw8v5p.refresh, cWin);
    if (top > greenzone || bottom > greenzone) {
      $_ednzzl169jfuw8v7f.moveOnlyScroll(socket, socket.dom().scrollTop - greenzone + bottom).get(refreshCursor);
    } else if (top < 0) {
      $_ednzzl169jfuw8v7f.moveOnlyScroll(socket, socket.dom().scrollTop + top).get(refreshCursor);
    } else {
    }
  };
  const $_76dc0f16ijfuw8v91 = { scrollIntoView };

  const par = (asyncValues, nu) => nu(callback => {
    const r = [];
    let count = 0;
    const cb = i => value => {
      r[i] = value;
      count++;
      if (count >= asyncValues.length) {
        callback(r);
      }
    };
    if (asyncValues.length === 0) {
      callback([]);
    } else {
      $_efmt4zxbjfuw8tcj.each(asyncValues, (asyncValue, i) => {
        asyncValue.get(cb(i));
      });
    }
  });
  const $_ggu2fw16ljfuw8v9g = { par };

  const par$1 = futures => $_ggu2fw16ljfuw8v9g.par(futures, Future.nu);
  const mapM = (array, fn) => {
    const futures = $_efmt4zxbjfuw8tcj.map(array, fn);
    return par$1(futures);
  };
  const compose$1 = (f, g) => a => g(a).bind(f);
  const $_6sz6216kjfuw8v9e = {
    par: par$1,
    mapM,
    compose: compose$1
  };

  const updateFixed = (element, property, winY, offsetY) => {
    const destination = winY + offsetY;
    $_aag5ti106jfuw8tse.set(element, property, `${destination}px`);
    return Future.pure(offsetY);
  };
  const updateScrollingFixed = (element, winY, offsetY) => {
    const destTop = winY + offsetY;
    const oldProp = $_aag5ti106jfuw8tse.getRaw(element, 'top').getOr(offsetY);
    const delta = destTop - parseInt(oldProp, 10);
    const destScroll = element.dom().scrollTop + delta;
    return $_ednzzl169jfuw8v7f.moveScrollAndTop(element, destScroll, destTop);
  };
  const updateFixture = (fixture, winY) => fixture.fold((element, property, offsetY) => updateFixed(element, property, winY, offsetY), (element, offsetY) => updateScrollingFixed(element, winY, offsetY));
  const updatePositions = (container, winY) => {
    const fixtures = $_a6i45416ejfuw8v83.findFixtures(container);
    const updates = $_efmt4zxbjfuw8tcj.map(fixtures, fixture => updateFixture(fixture, winY));
    return $_6sz6216kjfuw8v9e.par(updates);
  };
  const $_g2djjf16jjfuw8v95 = { updatePositions };

  const VIEW_MARGIN = 5;
  const register$2 = (toolstrip, socket, container, outerWindow, structure, cWin) => {
    const scroller = BackgroundActivity(y => $_ednzzl169jfuw8v7f.moveWindowScroll(toolstrip, socket, y));
    const scrollBounds = () => {
      const rects = $_1h6vvx14njfuw8utc.getRectangles(cWin);
      return Option.from(rects[0]).bind(rect => {
        const viewTop = rect.top() - socket.dom().scrollTop;
        const outside = viewTop > outerWindow.innerHeight + VIEW_MARGIN || viewTop < -VIEW_MARGIN;
        return outside ? Option.some({
          top: $_2vokfcwwjfuw8tb4.constant(viewTop),
          bottom: $_2vokfcwwjfuw8tb4.constant(viewTop + rect.height())
        }) : Option.none();
      });
    };
    const scrollThrottle = $_6hl53v15bjfuw8uxr.last(() => {
      scroller.idle(() => {
        $_g2djjf16jjfuw8v95.updatePositions(container, outerWindow.pageYOffset).get(() => {
          const extraScroll = scrollBounds();
          extraScroll.each(extra => {
            socket.dom().scrollTop = socket.dom().scrollTop + extra.top();
          });
          scroller.start(0);
          structure.refresh();
        });
      });
    }, 1000);
    const onScroll = $_6cl0bk14cjfuw8uqx.bind($_bwdnu0xijfuw8tdo.fromDom(outerWindow), 'scroll', () => {
      if (outerWindow.pageYOffset < 0) {
        return;
      }
      scrollThrottle.throttle();
    });
    $_g2djjf16jjfuw8v95.updatePositions(container, outerWindow.pageYOffset).get($_2vokfcwwjfuw8tb4.identity);
    return { unbind: onScroll.unbind };
  };
  const setup$3 = bag => {
    const cWin = bag.cWin();
    const ceBody = bag.ceBody();
    const socket = bag.socket();
    const toolstrip = bag.toolstrip();
    const toolbar = bag.toolbar();
    const contentElement = bag.contentElement();
    const keyboardType = bag.keyboardType();
    const outerWindow = bag.outerWindow();
    const dropup = bag.dropup();
    const structure = $_a6i45416ejfuw8v83.takeover(socket, ceBody, toolstrip, dropup);
    const keyboardModel = keyboardType(bag.outerBody(), cWin, $_8634tqxhjfuw8tdl.body(), contentElement, toolstrip, toolbar);
    const toEditing = () => {
      keyboardModel.toEditing();
      clearSelection();
    };
    const toReading = () => {
      keyboardModel.toReading();
    };
    const onToolbarTouch = event => {
      keyboardModel.onToolbarTouch(event);
    };
    const onOrientation = $_2v9f8x14bjfuw8uqn.onChange(outerWindow, {
      onChange: $_2vokfcwwjfuw8tb4.noop,
      onReady: structure.refresh
    });
    onOrientation.onAdjustment(() => {
      structure.refresh();
    });
    const onResize = $_6cl0bk14cjfuw8uqx.bind($_bwdnu0xijfuw8tdo.fromDom(outerWindow), 'resize', () => {
      if (structure.isExpanding()) {
        structure.refresh();
      }
    });
    const onScroll = register$2(toolstrip, socket, bag.outerBody(), outerWindow, structure, cWin);
    const unfocusedSelection = FakeSelection(cWin, contentElement);
    const refreshSelection = () => {
      if (unfocusedSelection.isActive()) {
        unfocusedSelection.update();
      }
    };
    const highlightSelection = () => {
      unfocusedSelection.update();
    };
    var clearSelection = () => {
      unfocusedSelection.clear();
    };
    const scrollIntoView = (top, bottom) => {
      $_76dc0f16ijfuw8v91.scrollIntoView(cWin, socket, dropup, top, bottom);
    };
    const syncHeight = () => {
      $_aag5ti106jfuw8tse.set(contentElement, 'height', `${contentElement.dom().contentWindow.document.body.scrollHeight}px`);
    };
    const setViewportOffset = newYOffset => {
      structure.setViewportOffset(newYOffset);
      $_ednzzl169jfuw8v7f.moveOnlyTop(socket, newYOffset).get($_2vokfcwwjfuw8tb4.identity);
    };
    const destroy = () => {
      structure.restore();
      onOrientation.destroy();
      onScroll.unbind();
      onResize.unbind();
      keyboardModel.destroy();
      unfocusedSelection.destroy();
      $_e8m84k163jfuw8v59.input($_8634tqxhjfuw8tdl.body(), $_f15fvwz1jfuw8tlo.blur);
    };
    return {
      toEditing,
      toReading,
      onToolbarTouch,
      refreshSelection,
      clearSelection,
      highlightSelection,
      scrollIntoView,
      updateToolbarPadding: $_2vokfcwwjfuw8tb4.noop,
      setViewportOffset,
      syncHeight,
      refreshStructure: structure.refresh,
      destroy
    };
  };
  const $_5bsj6g167jfuw8v6c = { setup: setup$3 };

  const create$8 = (platform, mask) => {
    const meta = $_41kbg3159jfuw8ux8.tag();
    const priorState = $_bh7xqm133jfuw8uet.value();
    const scrollEvents = $_bh7xqm133jfuw8uet.value();
    const iosApi = $_bh7xqm133jfuw8uet.api();
    const iosEvents = $_bh7xqm133jfuw8uet.api();
    const enter = () => {
      mask.hide();
      const doc = $_bwdnu0xijfuw8tdo.fromDom(document);
      $_9kqusv157jfuw8uwf.getActiveApi(platform.editor).each(editorApi => {
        priorState.set({
          socketHeight: $_aag5ti106jfuw8tse.getRaw(platform.socket, 'height'),
          iframeHeight: $_aag5ti106jfuw8tse.getRaw(editorApi.frame(), 'height'),
          outerScroll: document.body.scrollTop
        });
        scrollEvents.set({ exclusives: $_22oqbo15ijfuw8uzk.exclusive(doc, `.${$_3pnsue149jfuw8uqb.scrollable()}`) });
        $_6po7jxyujfuw8tl0.add(platform.container, $_2fp9skztjfuw8tqe.resolve('fullscreen-maximized'));
        $_ggb1il158jfuw8uwy.clobberStyles(platform.container, editorApi.body());
        meta.maximize();
        $_aag5ti106jfuw8tse.set(platform.socket, 'overflow', 'scroll');
        $_aag5ti106jfuw8tse.set(platform.socket, '-webkit-overflow-scrolling', 'touch');
        $_f15fvwz1jfuw8tlo.focus(editorApi.body());
        const setupBag = $_4xhupwxnjfuw8tea.immutableBag([
          'cWin',
          'ceBody',
          'socket',
          'toolstrip',
          'toolbar',
          'dropup',
          'contentElement',
          'cursor',
          'keyboardType',
          'isScrolling',
          'outerWindow',
          'outerBody'
        ], []);
        iosApi.set($_5bsj6g167jfuw8v6c.setup(setupBag({
          cWin: editorApi.win(),
          ceBody: editorApi.body(),
          socket: platform.socket,
          toolstrip: platform.toolstrip,
          toolbar: platform.toolbar,
          dropup: platform.dropup.element(),
          contentElement: editorApi.frame(),
          cursor: $_2vokfcwwjfuw8tb4.noop,
          outerBody: platform.body,
          outerWindow: platform.win,
          keyboardType: $_8wqcx8162jfuw8v4y.stubborn,
          isScrolling() {
            return scrollEvents.get().exists(s => s.socket.isScrolling());
          }
        })));
        iosApi.run(api => {
          api.syncHeight();
        });
        iosEvents.set($_6p8ia7166jfuw8v5u.initEvents(editorApi, iosApi, platform.toolstrip, platform.socket, platform.dropup));
      });
    };
    const exit = () => {
      meta.restore();
      iosEvents.clear();
      iosApi.clear();
      mask.show();
      priorState.on(s => {
        s.socketHeight.each(h => {
          $_aag5ti106jfuw8tse.set(platform.socket, 'height', h);
        });
        s.iframeHeight.each(h => {
          $_aag5ti106jfuw8tse.set(platform.editor.getFrame(), 'height', h);
        });
        document.body.scrollTop = s.scrollTop;
      });
      priorState.clear();
      scrollEvents.on(s => {
        s.exclusives.unbind();
      });
      scrollEvents.clear();
      $_6po7jxyujfuw8tl0.remove(platform.container, $_2fp9skztjfuw8tqe.resolve('fullscreen-maximized'));
      $_ggb1il158jfuw8uwy.restoreStyles();
      $_3pnsue149jfuw8uqb.deregister(platform.toolbar);
      $_aag5ti106jfuw8tse.remove(platform.socket, 'overflow');
      $_aag5ti106jfuw8tse.remove(platform.socket, '-webkit-overflow-scrolling');
      $_f15fvwz1jfuw8tlo.blur(platform.editor.getFrame());
      $_9kqusv157jfuw8uwf.getActiveApi(platform.editor).each(editorApi => {
        editorApi.clearSelection();
      });
    };
    const refreshStructure = () => {
      iosApi.run(api => {
        api.refreshStructure();
      });
    };
    return {
      enter,
      refreshStructure,
      exit
    };
  };
  const $_31v0ry161jfuw8v4j = { create: create$8 };

  const produce$1 = raw => {
    const mobile = asRawOrDie('Getting IosWebapp schema', MobileSchema, raw);
    $_aag5ti106jfuw8tse.set(mobile.toolstrip, 'width', '100%');
    $_aag5ti106jfuw8tse.set(mobile.container, 'position', 'relative');
    const onView = () => {
      mobile.setReadOnly(mobile.readOnlyOnInit());
      mode.enter();
    };
    const mask = build$1($_d5dv5715ajfuw8uxg.sketch(onView, mobile.translate));
    mobile.alloy.add(mask);
    const maskApi = {
      show() {
        mobile.alloy.add(mask);
      },
      hide() {
        mobile.alloy.remove(mask);
      }
    };
    var mode = $_31v0ry161jfuw8v4j.create(mobile, maskApi);
    return {
      setReadOnly: mobile.setReadOnly,
      refreshStructure: mode.refreshStructure,
      enter: mode.enter,
      exit: mode.exit,
      destroy: $_2vokfcwwjfuw8tb4.noop
    };
  };
  const $_b1mcl2160jfuw8v4c = { produce: produce$1 };

  function IosRealm (scrollIntoView) {
    const alloy = OuterContainer({ classes: [$_2fp9skztjfuw8tqe.resolve('ios-container')] });
    const toolbar = ScrollingToolbar();
    const webapp = $_bh7xqm133jfuw8uet.api();
    const switchToEdit = $_9pcl2n15jjfuw8uzs.makeEditSwitch(webapp);
    const socket = $_9pcl2n15jjfuw8uzs.makeSocket();
    const dropup = build$2(() => {
      webapp.run(w => {
        w.refreshStructure();
      });
    }, scrollIntoView);
    alloy.add(toolbar.wrapper());
    alloy.add(socket);
    alloy.add(dropup.component());
    const setToolbarGroups = rawGroups => {
      const groups = toolbar.createGroups(rawGroups);
      toolbar.setGroups(groups);
    };
    const setContextToolbar = rawGroups => {
      const groups = toolbar.createGroups(rawGroups);
      toolbar.setContextToolbar(groups);
    };
    const focusToolbar = () => {
      toolbar.focus();
    };
    const restoreToolbar = () => {
      toolbar.restoreToolbar();
    };
    const init = spec => {
      webapp.set($_b1mcl2160jfuw8v4c.produce(spec));
    };
    const exit = () => {
      webapp.run(w => {
        Replacing.remove(socket, switchToEdit);
        w.exit();
      });
    };
    const updateMode = readOnly => {
      $_9pcl2n15jjfuw8uzs.updateMode(socket, switchToEdit, readOnly, alloy.root());
    };
    return {
      system: $_2vokfcwwjfuw8tb4.constant(alloy),
      element: alloy.element,
      init,
      exit,
      setToolbarGroups,
      setContextToolbar,
      focusToolbar,
      restoreToolbar,
      updateMode,
      socket: $_2vokfcwwjfuw8tb4.constant(socket),
      dropup: $_2vokfcwwjfuw8tb4.constant(dropup)
    };
  }

  const global$3 = tinymce.util.Tools.resolve('tinymce.EditorManager');

  const derive$4 = editor => {
    const base = readOptFrom$1(editor.settings, 'skin_url').fold(() => `${global$3.baseURL}/skins/lightgray`, url => url);
    return {
      content: `${base}/content.mobile.min.css`,
      ui: `${base}/skin.mobile.min.css`
    };
  };
  const $_9zui4e16mjfuw8v9l = { derive: derive$4 };

  const fontSizes = [
    'x-small',
    'small',
    'medium',
    'large',
    'x-large'
  ];
  const fireChange$1 = (realm, command, state) => {
    realm.system().broadcastOn([$_9e19stz9jfuw8tmf.formatChanged()], {
      command,
      state
    });
  };
  const init$5 = (realm, editor) => {
    const allFormats = $_8qu224wzjfuw8tb9.keys(editor.formatter.get());
    $_efmt4zxbjfuw8tcj.each(allFormats, command => {
      editor.formatter.formatChanged(command, state => {
        fireChange$1(realm, command, state);
      });
    });
    $_efmt4zxbjfuw8tcj.each([
      'ul',
      'ol'
    ], command => {
      editor.selection.selectorChanged(command, (state, data) => {
        fireChange$1(realm, command, state);
      });
    });
  };
  const $_4i8ew016ojfuw8v9o = {
    init: init$5,
    fontSizes: $_2vokfcwwjfuw8tb4.constant(fontSizes)
  };

  const fireSkinLoaded = editor => {
    const done = () => {
      editor._skinLoaded = true;
      editor.fire('SkinLoaded');
    };
    return () => {
      if (editor.initialized) {
        done();
      } else {
        editor.on('init', done);
      }
    };
  };
  const $_gchh4h16pjfuw8v9u = { fireSkinLoaded };

  const READING = $_2vokfcwwjfuw8tb4.constant('toReading');
  const EDITING = $_2vokfcwwjfuw8tb4.constant('toEditing');
  global$2.add('mw', editor => {
    const renderUI = args => {
      const cssUrls = $_9zui4e16mjfuw8v9l.derive(editor);
      if (isSkinDisabled(editor) === false) {
        editor.contentCSS.push(cssUrls.content);
        global$1.DOM.styleSheetLoader.load(cssUrls.ui, $_gchh4h16pjfuw8v9u.fireSkinLoaded(editor));
      } else {
        $_gchh4h16pjfuw8v9u.fireSkinLoaded(editor)();
      }
      const doScrollIntoView = () => {
        editor.fire('scrollIntoView');
      };
      const wrapper = $_bwdnu0xijfuw8tdo.fromTag('div');
      const realm = $_5reqwox3jfuw8tbu.detect().os.isAndroid() ? AndroidRealm(doScrollIntoView) : IosRealm(doScrollIntoView);
      const original = $_bwdnu0xijfuw8tdo.fromDom(args.targetNode);
      $_cwa5ncxljfuw8tdv.after(original, wrapper);
      attachSystem(wrapper, realm.system());
      const findFocusIn = elem => $_f15fvwz1jfuw8tlo.search(elem).bind(focused => realm.system().getByDom(focused).toOption());
      const outerWindow = args.targetNode.ownerDocument.defaultView;
      const orientation = $_2v9f8x14bjfuw8uqn.onChange(outerWindow, {
        onChange() {
          const alloy = realm.system();
          alloy.broadcastOn([$_9e19stz9jfuw8tmf.orientationChanged()], { width: $_2v9f8x14bjfuw8uqn.getActualWidth(outerWindow) });
        },
        onReady: $_2vokfcwwjfuw8tb4.noop
      });
      const setReadOnly = (dynamicGroup, readOnlyGroups, mainGroups, ro) => {
        if (ro === false) {
          editor.selection.collapse();
        }
        const toolbars = configureToolbar(dynamicGroup, readOnlyGroups, mainGroups);
        realm.setToolbarGroups(ro === true ? toolbars.readOnly : toolbars.main);
        editor.setMode(ro === true ? 'readonly' : 'design');
        editor.fire(ro === true ? READING() : EDITING());
        realm.updateMode(ro);
      };
      var configureToolbar = (dynamicGroup, readOnlyGroups, mainGroups) => {
        const dynamic = dynamicGroup.get();
        const toolbars = {
          readOnly: dynamic.backToMask.concat(readOnlyGroups.get()),
          main: dynamic.backToMask.concat(mainGroups.get())
        };
        if (readOnlyOnInit(editor)) {
          toolbars.readOnly = dynamic.backToMask.concat(readOnlyGroups.get());
          toolbars.main = dynamic.backToReadOnly.concat(mainGroups.get());
        }
        return toolbars;
      };
      const bindHandler = (label, handler) => {
        editor.on(label, handler);
        return {
          unbind() {
            editor.off(label);
          }
        };
      };
      editor.on('init', () => {
        realm.init({
          editor: {
            getFrame() {
              return $_bwdnu0xijfuw8tdo.fromDom(editor.contentAreaContainer.querySelector('iframe'));
            },
            onDomChanged() {
              return { unbind: $_2vokfcwwjfuw8tb4.noop };
            },
            onToReading(handler) {
              return bindHandler(READING(), handler);
            },
            onToEditing(handler) {
              return bindHandler(EDITING(), handler);
            },
            onScrollToCursor(handler) {
              editor.on('scrollIntoView', tinyEvent => {
                handler(tinyEvent);
              });
              const unbind = () => {
                editor.off('scrollIntoView');
                orientation.destroy();
              };
              return { unbind };
            },
            onTouchToolstrip() {
              hideDropup();
            },
            onTouchContent() {
              const toolbar = $_bwdnu0xijfuw8tdo.fromDom(editor.editorContainer.querySelector(`.${$_2fp9skztjfuw8tqe.resolve('toolbar')}`));
              findFocusIn(toolbar).each(emitExecute);
              realm.restoreToolbar();
              hideDropup();
            },
            onTapContent(evt) {
              const target = evt.target();
              if ($_74lhjaxjjfuw8tdt.name(target) === 'img') {
                editor.selection.select(target.dom());
                evt.kill();
              } else if ($_74lhjaxjjfuw8tdt.name(target) === 'a') {
                const component = realm.system().getByDom($_bwdnu0xijfuw8tdo.fromDom(editor.editorContainer));
                component.each(container => {
                  if (Swapping.isAlpha(container)) {
                    $_5567t9z7jfuw8tmd.openLink(target.dom());
                  }
                });
              }
            }
          },
          container: $_bwdnu0xijfuw8tdo.fromDom(editor.editorContainer),
          socket: $_bwdnu0xijfuw8tdo.fromDom(editor.contentAreaContainer),
          toolstrip: $_bwdnu0xijfuw8tdo.fromDom(editor.editorContainer.querySelector(`.${$_2fp9skztjfuw8tqe.resolve('toolstrip')}`)),
          toolbar: $_bwdnu0xijfuw8tdo.fromDom(editor.editorContainer.querySelector(`.${$_2fp9skztjfuw8tqe.resolve('toolbar')}`)),
          dropup: realm.dropup(),
          alloy: realm.system(),
          translate: $_2vokfcwwjfuw8tb4.noop,
          setReadOnly(ro) {
            setReadOnly(dynamicGroup, readOnlyGroups, mainGroups, ro);
          },
          readOnlyOnInit() {
            return readOnlyOnInit(editor);
          }
        });
        var hideDropup = () => {
          realm.dropup().disappear(() => {
            realm.system().broadcastOn([$_9e19stz9jfuw8tmf.dropupDismissed()], {});
          });
        };
        const backToMaskGroup = {
          label: 'The first group',
          scrollable: false,
          items: [$_44weuozujfuw8tqh.forToolbar('back', () => {
              editor.selection.collapse();
              realm.exit();
            }, {})]
        };
        const backToReadOnlyGroup = {
          label: 'Back to read only',
          scrollable: false,
          items: [$_44weuozujfuw8tqh.forToolbar('readonly-back', () => {
              setReadOnly(dynamicGroup, readOnlyGroups, mainGroups, true);
            }, {})]
        };
        const readOnlyGroup = {
          label: 'The read only mode group',
          scrollable: true,
          items: []
        };
        const features = $_4419oszajfuw8tmi.setup(realm, editor);
        const items = $_4419oszajfuw8tmi.detect(editor.settings, features);
        const actionGroup = {
          label: 'the action group',
          scrollable: true,
          items
        };
        const extraGroup = {
          label: 'The extra group',
          scrollable: false,
          items: []
        };
        var mainGroups = Cell([
          actionGroup,
          extraGroup
        ]);
        var readOnlyGroups = Cell([
          readOnlyGroup,
          extraGroup
        ]);
        var dynamicGroup = Cell({
          backToMask: [backToMaskGroup],
          backToReadOnly: [backToReadOnlyGroup]
        });
        $_4i8ew016ojfuw8v9o.init(realm, editor);
      });
      return {
        iframeContainer: realm.socket().element().dom(),
        editorContainer: realm.element().dom()
      };
    };
    return {
      getNotificationManagerImpl() {
        return {
          open: $_2vokfcwwjfuw8tb4.identity,
          close: $_2vokfcwwjfuw8tb4.noop,
          reposition: $_2vokfcwwjfuw8tb4.noop,
          getArgs: $_2vokfcwwjfuw8tb4.identity
        };
      },
      renderUI
    };
  });
})()
